C CMS REPLACEMENT HISTORY, Element BACKEF.CDF
C *9    25-JUN-1991 11:43:48 RHARRIS "New efficiencies including Gas Saturation Effects"
C *8    21-JUN-1991 13:54:38 RHARRIS "New Efficiencies with eta/pi0=1.02 (see CDF1472)"
C *7    30-APR-1991 18:47:18 RHARRIS "New Background Chisquared Efficiencies using dT=.6 and pi/eta/ks=1/1.7/0.4"
C *6    26-MAR-1991 22:02:06 RHARRIS "Changing to new efficiencies from QFL Version 3.14 with default particle mix"
C *5     2-NOV-1990 19:30:33 RHARRIS "Putting in new high statistics efficiencies"
C *4    30-OCT-1990 15:35:00 RHARRIS "Relpacing with new efficiencies from QFL (preliminary, low statistics)"
C *3    15-APR-1990 12:37:35 RHARRIS "Changing for new cuts, and no longer smoothing low pt efficiencies"
C *2    10-APR-1990 17:35:40 RHARRIS "Replacing old efficiency with one for strip chisq<20 and new cuts"
C *1     9-APR-1990 11:16:08 RHARRIS "Returns chisquare efficiency for photon background including pi0s, etas and Kshorts"
C CMS REPLACEMENT HISTORY, Element BACKEF.CDF
C	========================
	Real Function BACKEF(PT)
C	========================
C
C	Author: Robert M Harris
C
C	History: Original Version April 9, 1990
C	         Modified April 10, 1990   New efficiency for new cuts
C		 Modifed  October 30, 1990 Preliminary QFL efficiencies,low stat
C		 Modifed  Nov 2, 1990 Hi Stat QFL Eff, 2nd clust cut = 1 GeV abs
C		 Modified March 31, 1991 QFL Version 3.14 Efficiencies with
C					 default particle mix (1,0.6,0.25).
C		 Modified April 30.1991 Made Routine more efficient (no looping)
C					New Efficiencies fro QFL Version 3.17 
C					with photon/electron differences and
C					new particle mix (1,1.7,0.4).
C		 Modified June 21, 1991 New Efficiencies from QFL Version 3.19
C					(same CES as 3.17) with a new particle
C					mix (1,1.02,0.4) documented in CDF1472.
C		 Modified June 25, 1991 New Efficiencies from QFL Version 3.19
C					including Gas Saturation (1.12).
C
C	Description:
C	------------
C	This function returns the efficiency for the photon background within
C	chisquare<20 to have chisquare<4 (i.e. N(Chisq<4)/N(Chisq<20) ).  The
C	efficiency was first calculated using QFL for a background that
C	contained Pi0s, etas, and kshorts with production ratio 1,1.02,0.4.
C	The cuts were:
C
C       Isolation: Less than 15% of the Et of EM cluster within cone of 0.7
C       Track:     No track as defined by ELES (3D tracks)
C       Fiducial:  14<|Z|<217, and |X|<17.5, for lead strip and wire clust resp.
C       Z_Vertex:  |Z_Vertex|<50 (Z vertex dist had mean of -2, sigma of 31)
C       Eta:       |Eta|<0.9, This is physics eta of lead strip cluster
C       2nd Clust: 2nd Strip Clust absolute Energy<1.00 GeV
C                  2nd Wire Clust<1.00 GeV or |2nd X - 1st X|<7 cm. (diff view)
C	Chisquare: Strip Chisquare<20, just like in electron stream.
C
C	The resulting efficiency was then smoothed using SMCTRL level 2.
C	SMCTRL is a subroutine in JETLIB used by topdrawer to 
C	smooth curves, to remove statistical fluctuations. 
C
C	The efficiencies are:
C	---------------------
C
C	Mean Pt         Err      Efficiency    Stat Err.     Smoothed Efficiency
C	-------      ----------  ---------     ---------     -------------------
C       5.9978805       0.011    0.5222654     0.0103861     0.5222654    
C       7.9951830       0.011    0.4387546     0.0100439     0.4693221    
C      10.0165625       0.011    0.4205046     0.0098787     0.4315549    
C      12.0148392       0.011    0.4056488     0.0099342     0.4049621    
C      14.0056887       0.011    0.3953298     0.0098959     0.3876600    
C      15.9756346       0.011    0.3566462     0.0096873     0.3811498    
C      17.9896278       0.011    0.3877791     0.0096432     0.3837475    
C      19.9920063       0.011    0.3913043     0.0095311     0.3938328    
C      21.9921265       0.011    0.4197871     0.0097982     0.4101248    
C      24.0194168       0.011    0.4356976     0.0097886     0.4325328    
C      25.9849548       0.011    0.4525714     0.0097150     0.4586802    
C      28.0096378       0.011    0.4847594     0.0095773     0.4841227    
C      29.9945927       0.011    0.5045771     0.0095673     0.5074323    
C      31.9946651       0.011    0.5421013     0.0096169     0.5289757    
C      33.9883194       0.011    0.5446623     0.0094896     0.5486055    
C      36.0095558       0.010    0.5789855     0.0093978     0.5665676    
C      38.0097542       0.011    0.5649161     0.0094677     0.5837817    
C      40.0143051       0.011    0.5925241     0.0094528     0.6001421    
C      42.0038185       0.011    0.6290323     0.0092487     0.6137991    
C      44.0104103       0.011    0.6238430     0.0093209     0.6233943    
C      46.0075226       0.011    0.6268436     0.0092871     0.6288191    
C      47.9859047       0.010    0.6404770     0.0089870     0.6306612    
C      49.9962082       0.010    0.6207635     0.0091645     0.6309066    
C      52.0044861       0.010    0.6244898     0.0089310     0.6316956    
C      53.9942513       0.010    0.6357143     0.0090944     0.6335500    
C      56.0117798       0.010    0.6450124     0.0090157     0.6355751    
C      57.9979095       0.010    0.6392046     0.0090497     0.6373885    
C      60.0031509       0.010    0.6310105     0.0090071     0.6394754    
C      61.9920464       0.010    0.6473073     0.0089643     0.6420847    
C      64.0003433       0.010    0.6375136     0.0091387     0.6443589    
C      65.9967422       0.010    0.6473570     0.0090913     0.6447049    
C      67.9907761       0.010    0.6472789     0.0088123     0.6420603    
C      70.0068817       0.010    0.6449115     0.0091891     0.6363189    
C      71.9785690       0.010    0.6186770     0.0091351     0.6279040    
C      74.0104980       0.010    0.6180727     0.0091282     0.6180727    
$$Implicit None
C
C	Local Declarations:
C	-------------------
	Integer    Num_Val,I
	Parameter (Num_Val = 35)
	Real Pt,Pt_Lo,Pt_Hi
	Real Pt_Max/74./
	Real Pt_Min/6.0/
	Real Pt_Bin/2.0/
C
C	Here are the efficiencies
C	-------------------------
        Real EFF(Num_Val)/
     *                    0.5222654,0.4693221,0.4315549,0.4049621,
     *                    0.3876600,0.3811498,0.3837475,0.3938328,
     *                    0.4101248,0.4325328,0.4586802,0.4841227,
     *                    0.5074323,0.5289757,0.5486055,0.5665676,
     *                    0.5837817,0.6001421,0.6137991,0.6233943,
     *                    0.6288191,0.6306612,0.6309066,0.6316956,
     *                    0.6335500,0.6355751,0.6373885,0.6394754,
     *                    0.6420847,0.6443589,0.6447049,0.6420603,
     *                    0.6363189,0.6279040,0.6180727/
C
C	Executable Code:
C	----------------
C
C	Branch on interpolation or exptrapolation
C	-----------------------------------------
	If( (Pt .ge. Pt_Min) .and. (Pt .lt. Pt_Max) )Then
C       
C	  Pt within our values, interpolate to find efficiency.
C	  -----------------------------------------------------
	  I = Int((Pt-Pt_Min)/Pt_Bin) + 1 
	  Pt_Lo = Pt_Min + (I-1)*Pt_Bin
	  Pt_Hi = Pt_Lo + Pt_Bin
	  BackEf=Eff(I)+(Eff(I+1)-Eff(I))*(Pt-Pt_Lo)/Pt_Bin
C       
	Else If(Pt .lt. Pt_Min)Then
C       
C	  Pt beneath our values, extrapolate to find efficiency.
C	  -----------------------------------------------------
	  BackEf=Eff(1)+(Eff(2)-Eff(1))*(Pt-Pt_Min)/Pt_Bin
	Else
C
C	  Pt above our values, extrapolate to find efficiency.
C	  Use 5 bins for extra lever arm.  The efficiency is pretty flat.
C	  --------------------------------------------------------------
	  BackEf=Eff(Num_Val)+(Eff(Num_Val)-Eff(Num_Val-5))*
     *     (Pt-Pt_Max)/(Pt_Bin*5)
C       
	End If	    
C
C	Protect against unphysical values
C	----------------------------------
 	If( BackEf.lt. 0.0 )BackEf=0.0
	If( BackEf.gt. 1.0 )BackEf=1.0
C
C	Return To Caller
C	----------------
	Return 
	End
