
c given a photon's energy in the CEM and the CES (and sin theta), 
c determines if the two energies are consistent
c returned value is (CES E - CEM E) / sigma
C
C routines cesef and cesphe are the electron versions
C routines cesf and cesph are the photon versions
C deshw and gamma are common to both

C *******************************************************************

      real function cesef(etot1,sth1,cese1)

      IMPLICIT NONE
c      include 'data.inc'

	real etot1,sth1,cese1

	real cesphe

      logical first
      save first
      real sigm,ces0
c ces factor for sigma from 1a data
      real sigm0
      cesef=cesphe(etot1,sth1,ces0)
      sigm0=sqrt(cesef*(1./(1.+.00729*cesef)**2+.00729**2/
     $ (1.+.00729*cesef)**4))
      sigm0=sigm0*(1.1+0.0184*etot1)
      cesef=cesef/(1.+.00729*cesef)
      cesef=(cese1-cesef)/(sigm0)
1000  continue
      END

C *******************************************************************

      real function cesphe(etot1,sth1,phraw)
      IMPLICIT NONE
      logical first
      save first
      real e10,xces,xcoil,xrad
c coil plus other stuff plus ALL of the CPR (not just half)
      parameter (xcoil=1.09)
c average X0 to CES in stack
      parameter (xces=4.86)

	real etot1,sth1,phraw
	real deshw

      phraw=deshw(etot1,xcoil/sth1+xces,1)
c      cesphe=phraw*8.33/(1.+.00729*8.33*phraw)
      cesphe=phraw*8.33
1000  continue
      END


C *******************************************************************

      real function cesf(etot1,sth1,cese1)
c      include 'data.inc'

	real etot1,sth1,cese1

      logical first
      save first
      real sigm,ces0
c ces factor for sigma from 1a data
      real sigm0
      cesf=cesph(etot1,sth1,ces0)
      sigm0=sqrt(cesf*(1./(1.+.00729*cesf)**2+.00729**2/
     $ (1.+.00729*cesf)**4))
      sigm0=sigm0*(1.1+0.0184*etot1)
      cesf=cesf/(1.+.00729*cesf)
      cesf=(cese1-cesf)/(sigm0)
1000  continue
      END

C *******************************************************************

      real function cesph(etot1,sth1,phraw)
      logical first
      save first
      real e10,xces,xcoil,xrad
c coil plus other stuff plus ALL of the CPR (not just half)
      parameter (xcoil=1.09)
c average X0 to CES in stack
      parameter (xces=4.86)
      real phraw
      phraw=deshw(etot1,xcoil/sth1+xces,0)
c      cesph=phraw*8.33/(1.+.00729*8.33*phraw)
      cesph=phraw*8.33
1000  continue
      END

C *******************************************************************

      real function deshw(e,x,ityp)
      IMPLICIT NONE
      real alph,bet,e,x,tmax,gamma,c
      real p1,p2,p3,ec
      real dtgam,dtpi0
      parameter (dtgam=.3)
      parameter (dtpi0=-.26)
      parameter (ec=.01244)
      integer ityp
c one parameter fit to b using PDG slope
      bet=.418+alog(e/ec)*.009
      tmax=-.5
      if( ityp .eq. 0 ) tmax=dtgam
      if( ityp .eq. 2) tmax=dtpi0
      tmax=tmax+alog(e/ec)
      alph=bet*tmax
      c=bet**(alph+1.)/gamma(alph+1.)
      deshw=e*c*x**alph*exp(-bet*x)
      return
      end

C *******************************************************************

      real function gamma(xxx)
c calculate gamma(xxx)
	parameter (xpi=3.1415927)
	dimension efact(6)
	data efact/-.422784335,.067352301,.007385551,.001192754,
     1 .000223155,.000044926/
c
c	gamma function approximation
c
      z=xxx-1.
      if( abs(z) .lt. 1. ) then
	coef=0.
	zn=z
	do 100 i=1,6
		coef=-efact(i)*zn+coef
		zn=zn*z**2
 100	continue
	if( z .eq. 0. ) then
		zn=1.
	else
		zn=xpi*z
		zn=zn/sin(zn)
	endif
	zn=zn*(1.-z)/(1.+z)
	zn=sqrt(zn)
	gam=zn*exp(coef)
      else
	zn=sqrt(2.*xpi*z)*z**z*exp(-z)
	gam=zn*(1.+1./(12.*z)+1./(288.*z**2)-139./(51840.*z**3))
      endif
      gamma=gam
      return
      end
