C------------------------------------------------------------------------------
C       CMUSBTC: Sacha's CMUS unpacker
C------------------------------------------------------------------------------
	SUBROUTINE CMUSBTC2(NCMUS,CMUSMAT,CMUSTYP,CMUSPHI,CMUSTNHI,CMUSANHI)
c
c	This routine searches the YBOS bank CMUS, which is the muon stub
c	bank.  A list of CMU and CMP stubs is returned, up to 100 stubs.
c	The CMX is not included in the list.
c	
c	This routine requires the CMUS bank, which requires the routines
c	CMDTE,CPDTE,CMETS,CPETS to be run on standard PADs.
c
c	1/9/95 PJW - Flag those stubs which are in a CMUO bank.
c
c-------------------------------------------------------------------------------
$$IMPLICIT NONE
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
$$INCLUDE 'C$INC:ANACTL.INC'
$$INCLUDE 'C$INC:BTMASK.INC'
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:CMUS92.INC'
$$INCLUDE 'C$INC:CMUO92.INC'
	INTEGER STATUS,BLOCAT,BNUMB,BDATA,BNEXT
	INTEGER IND,INDDAT,BNKNUM,INDNXT
	INTEGER MAXCMU
	PARAMETER (MAXCMU=25)
	INTEGER I, J, ID, NCMU, BANKNO
	INTEGER CMUS_CMU(MAXCMU), CMUS_CMP(MAXCMU), CMUS_TYP(MAXCMU) 
	INTEGER NCMUS,CMUSTYP(100),CMUSANHI(100),CMUSTNHI(100), CMUSMAT(100)
	INTEGER CMUSID(100), CMUSTOW(100)
	INTEGER TOWER, TOWER2
	REAL CMUSPHI(100)


C  First get CMUS banks from CMUOs
        BANKNO = 1
        NCMU = 0
        DO WHILE (BLOCAT(IW,'CMUO',BANKNO,IND,INDDAT).EQ.YESUCC)
          NCMU = NCMU + 1
          IF (NCMU.LE.MAXCMU) THEN
            CMUS_CMU(NCMU) = IAND(IW(INDDAT+MOCmus),MASK15)
            CMUS_CMP(NCMU) = IAND(IW(INDDAT+MOCmps),MASK15)
            CMUS_TYP(NCMU) = IW(INDDAT+MOSTYP)
          ENDIF                         !If < 25 cmuos found so far
          BANKNO = BANKNO + 1
        ENDDO
C
	NCMUS = 0
C
C  Stubs are in order of banks, fill CMUSID in order of bank number to
C  cross reference with CMUO bank information.
	STATUS=BLOCAT(IW,'CMUS',-1,IND,INDDAT)
	IF (STATUS .EQ. YESUCC) THEN

	   STATUS = BNUMB(IW, IND, BNKNUM)
100	   NCMUS = NCMUS + 1
	   CMUSTYP(NCMUS)  = IAND(IW(INDDAT+MSFitc),MASK3)
					! 1=CMU, 2=CMP, 3=?, 4=CMX
	   IF (CMUSTYP(NCMUS) .LE. 2) THEN
	      CMUSPHI(NCMUS)  = RW(INDDAT+MSPhi0)	! phi
	      CMUSANHI(NCMUS) = IW(INDDAT+MSNadc)	! # ADC hits
	      CMUSTNHI(NCMUS) = IW(INDDAT+MSNtdc)	! # TDC hits
	      CMUSTOW(NCMUS) = IW(INDDAT+MSTOW)		! # TDC hits
	      CMUSMAT(NCMUS) = 0	
	      CMUSID(BNKNUM) = NCMUS
	      IF (NCMUS .GE. 100) RETURN
	   ELSE
	      NCMUS = NCMUS - 1
	   ENDIF

	   STATUS = BNEXT(IW, IND, INDNXT)		! next bank
	   IF (INDNXT .GT. 0) THEN
	      STATUS = BNUMB(IW, INDNXT, BNKNUM)
              STATUS = BDATA(IW, INDNXT, inddat)
	      IND = INDNXT
	      GOTO 100
	   ENDIF		! able to get next bank number?

	ENDIF			! able to get a CMUS bank??
C  Loop through the CMUOs and flag stubs from CMUOs, also loop through
C	stubs and check for duplicates.
	IF (NCMUS.GT.0) THEN
	  DO I = 1, NCMU
	    TOWER=-1
	    TOWER2=-1
	    IF (IAND(CMUS_TYP(I),1).NE.0) THEN
	      ID = CMUSID(CMUS_CMU(I))
              CMUSMAT(ID) = 1 
	      TOWER = CMUSTOW(ID)
	    ENDIF
	    IF (IAND(CMUS_TYP(I),2).NE.0) THEN
	      ID = CMUSID(CMUS_CMP(I))
	      CMUSMAT(ID) = 1 
	      TOWER2 = CMUSTOW(ID)
	    ENDIF
C  Flag stubs in the same tower as CMUO stubs
	    DO J = 1, NCMUS
	      IF (CMUSTOW(J).EQ.TOWER.AND.CMUSTYP(J).EQ.1 
     +		.OR. CMUSTOW(J).EQ.TOWER2.AND.CMUSTYP(J).EQ.2)
     +		CMUSMAT(J) = 1 
	    ENDDO
	  ENDDO
	ENDIF

	RETURN 
	END
C------------------------------------------------------------------------------
C	CMUSBTCEND: end of CMUSBTC subroutine
C------------------------------------------------------------------------------
