c-------------------------------------------------------------------------------
	SUBROUTINE COSMIC_STUBS(IPHOT, NCMUS, NCOSTUB, NPHOSTUB)
c
c	This routine gets CMUS (CMU and CMP only) stubs and counts how many 
c	are not associated with a CMUO or a Jet.  If the Jet is photon
c 	identified by IPHOT then that jet is excluded.
c
c 	Must fill JETINFO and PHOINFO before calling.
c	Calls CMUSBTC2 to get stubs.
c
c-------------------------------------------------------------------------------
$$IMPLICIT NONE
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
$$INCLUDE 'C$INC:ANACTL.INC'
$$INCLUDE 'C$INC:BTMASK.INC'
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:CMUS92.INC'
$$INCLUDE 'C$INC:CMUO92.INC'
$$INCLUDE 'C$INC:JETINFO.INC'  ! JETS information
$$INCLUDE 'stNTUPLE$SOURCE:exo_phoinfo.inc'
C Arguments
	INTEGER IPHOT, NCOSTUB, NPHOSTUB

C Muon Segments 
	INTEGER NCMUS		! # CMU/P stubs in CMUS bank
	INTEGER CMUSTNHI(100),CMUSANHI(100) ! # ADC/TDC hits in each CMUS stub
	INTEGER CMUSTYP(100)	! = 1/2/4 for CMU/CMP/CMX stub. 3=unknown
	INTEGER CMUSMAT(100)	! = 0 no CMUO, = 1 CMUO associated
	REAL    CMUSPHI(100)	! phi of each CMUS stub
C Muon stub counter 
	INTEGER J, K, MUSTB
	REAL DPHICUT
	PARAMETER(DPHICUT=0.5236)
C
C----------------------------------------------------------------------------
C
	CALL CMUSBTC2(NCMUS,CMUSMAT,CMUSTYP,CMUSPHI,CMUSTNHI,CMUSANHI)
	NCOSTUB = 0
	NPHOSTUB = 0
	DO K = 1, NCMUS
	  MUSTB = 1
C Don't count photon associated with CMUO
	  IF (CMUSMAT(K) .EQ. 1) THEN
	    MUSTB = 0
	  ELSE
C Don't count stubs near Jet
            DO J = 1,ICLUS
	      IF ((ABS(ACOS(COS(ABS(CMUSPHI(K)-IJET_PHI(J)))))
     >		  .LT.DPHICUT) .AND. IJET_ET(J).GE.8.0) MUSTB = 0
	    ENDDO
C Count photon 
	    IF (IPHOT .GE. 1) THEN
	      IF (ABS(ACOS(COS(ABS(CMUSPHI(K)-PHOPHI(IPHOT)))))
     >		  .LT.DPHICUT) THEN
                MUSTB = 1
	        NPHOSTUB = NPHOSTUB + 1
	      ENDIF
	    ENDIF
	  ENDIF
	  IF (MUSTB .NE. 0) THEN
	    IF (CMUSTNHI(K).GE.2) NCOSTUB = NCOSTUB + 1
	  ENDIF
	ENDDO

	RETURN 
	END
C------------------------------------------------------------------------------
C	
C------------------------------------------------------------------------------
