      SUBROUTINE EGAMMA_GENP_FILL
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : This subroutine fills a common block with
C-              information about the photons and electrons.
C-
C-   Inputs  : 
C-   Outputs : 
C-   Controls: 
C-
C-   Created   7-FEB-1994   David A. Toback
C-             6-AUG-1996   R Culbertson put in protection for psycho GENP 
C-
C----------------------------------------------------------------------
      IMPLICIT NONE
        INCLUDE 'GENERATOR$LIBRARY:GENP.INC'
        INCLUDE 'GENERATOR$LIBRARY:GNPACK.INC'
        INCLUDE 'C$INC:OBS203.INC'
        INCLUDE 'stNTUPLE$SOURCE:EGAMMA_GENP_STUFF.INC'
C================================================================= 
C
        INTEGER I,J,K                   ! Dummy counter
        INTEGER ID                      ! ID of particle
        REAL EN,PX,PY,PZ,MASS           ! Intermediate eta & phi quantites
        REAL PHIP,PT                    !    More intermediate quantites
        INTEGER IERR                    ! Parameter for filling the GENP
                                        ! arrays
        REAL QIDETA                     ! Get Detector Eta...
        INTEGER PARENT                  ! PARENT ID for a particle
        INTEGER NTRIES                  ! Just in case counter...
C        
C
C=================================================================
C
C Unpack GENP to fill all the GENP commons...
C
        CALL GNPBTC(IERR)
        IF (IERR .NE. 0) RETURN
        CALL OBSBTC(IERR)
        IF (IERR .NE. 0) RETURN
C
C==============================================================
C
C
        CALL EGAMMA_GENP_INIT
        DO I = 1,NGEN                                   !Loop over particles
          ID = KGEN(1,I)                                !Particle type
C
C
C If this particle is an electron or a photon then check to see if it is a
C final state particle. We define finals state particles to be those which have
C a vertex i.e, We find it referenced in the KTOBS bank. If we find it, 
C save information about it...
C
C KTOBS(4,J) = The GENP particle number of the Jth entry in the OBSP bank. Note
C       that only the OBSERVABLE particles are in KTOBS
C KTOBS(2,J) = The OBSV vertex number of the Jth entry in the OBSP bank
C PVOBS(3,K) = The Z coordinate of the Kth entry in the OBSV bank
C

C                       ID      Object
C                       --      ------
C                       101     Photon
C                       203     E-
C                       204     E+
C
C
C Only look at this particle if it is a photon or electron  AND if it has 
C       PT>3.0
C
          PX=PGEN(1,I)
          PY=PGEN(2,I)
          PT=SQRT(PX**2 + PY**2)
          IF ((ID.EQ.101.OR.ID.EQ.203.OR.ID.EQ.204)
     &              .AND.PT.GT.3.0) THEN  
            K = -999
            DO J = 1, NTOBS
              IF (KTOBS(4,J) .EQ. I) THEN
                K = KTOBS(2,J)
              ENDIF ! Is this particle one of the final state particles?
            ENDDO ! Loop over all final state particles
C
C In special cases this doesn't work. For example, in Tau->enunu decays, the
C electron is not put into the OBSP bank (not really sure why), however the Tau
C IS!!!!  Loop backwards till we find the vertex for this beast...
C
C Start by finding the parent of this object just in case...If the PARENT = 0,
C then the problem is undetermined (KTOBS has a lot of entries at the end = 0,
C so we exit...)
C
            NTRIES = 0
            PARENT = KGEN(2,I)
            DO WHILE (K .LT. 0 .AND. NTRIES .LT. 40.AND.PARENT .NE. 0
	1	.AND.PARENT.LT.NGEN) 
C                           ^      PSYCHO GENP PROTECTION
              DO J = 1, NTOBS
                IF (KTOBS(4,J) .EQ. PARENT) THEN
                  K = KTOBS(2,J)
                ENDIF ! Is this particle one of the final state particles?
              ENDDO ! Loop over all final state particles
C
C If this parent isn't in the list, look for ITS parent and start again...
C
              PARENT = KGEN(2,PARENT)
              NTRIES = NTRIES + 1

            ENDDO
C
C Now only fill this object if it has move than 3 GeV of PT.
C
            PX=PGEN(1,I)
            PY=PGEN(2,I)
            PT=SQRT(PX**2 + PY**2)
            IF (K .GT. 0.AND.PT.GT.3.0) THEN 
                GENPS = GENPS + 1
                IF (GENPS .GT. 50) WRITE (6,*) 
     &            'More than 50 Electons or photons'
                GID(GENPS) = KGEN(1,I)
                PX=PGEN(1,I)
                PY=PGEN(2,I)
                PZ=PGEN(3,I)
                MASS=PGEN(4,I)
                EN=SQRT(PX**2 + PY**2 + PZ**2 + MASS**2)
                PT=SQRT(PX**2 + PY**2)
                GPX(GENPS)=PX
                GPY(GENPS)=PY
                GPZ(GENPS)=PZ
                GE(GENPS) =EN
                GPT(GENPS)=PT
                IF (((EN - PZ) .NE. 0.0) .AND. 
     &                ((EN + PZ) .NE. 0.0)) THEN
                  GETA(GENPS)=(LOG((EN + PZ)/(EN - PZ)))/2.
                  GDETA(GENPS)= QIDETA(GETA(GENPS),PVOBS(3,K))
                ELSE
                  WRITE (6,*) 'EGAMMA_GENP_FILL Eta FUCKED UP!!!'
                  GETA(GENPS) = -999.0
                  GDETA(GENPS)= -999.0
                ENDIF
                IF (PY.EQ.0.0.AND.PX.EQ.0) THEN
                                PHIP = -999
                        ELSE
                                PHIP=ATAN2(PY,PX)
                ENDIF
                GPHI(GENPS)=PHIP
            ENDIF ! Is this a final state particle??
          ENDIF ! Is this a photon or electron
        ENDDO ! Loop over all GENP Particles
  789   CONTINUE
C
C
C
C=====================================================================
C        PGEN(1,I) = PX of I-th particle
C        PGEN(2,I) = PY of I-th particle
C        PGEN(3,I) = PZ of I-th particle
C        PGEN(4,I) = mass of I-th particle
C       KGEN are the particle type and parent/daughter pointers
C       and G/T codes
C        KGEN(1,I) = particle code of I-th particle
C        KGEN(2,I) = parent pointer of I-th particle
C        KGEN(3,I) = daughter pointer of I-th particle
C        KGEN(4,I) = generation code for I-th particle
C        KGEN(5,I) = termination code for I-th particle
C       KPGEN are pointers for particles to exit from vertex point
C
C                       ID      Object
C                       --      ------
C                       101     Photon
C                       102     Z
C                       103     W+
C                       104     W-
C                       201     nuE
C                       202     nuEbar
C                       203     E-
C                       204     E+
C                       207     mu-
C                       208     mu+
C                       302     up
C                       303     ubar
C                       304     down
C                       305     dbar
C                       306     strange
C                       307     Sbar
C                       308     Charm
C                       309     Cbar
C                       310     bottom
C                       311     bbar
C                       312     top
C                       313     tbar
C
C----------------------------------------------------------------------
  999 RETURN
      END
C
C----------------------------------------------------------------------
C
      SUBROUTINE EGAMMA_GENP_INIT
C
      IMPLICIT NONE
      INCLUDE 'stNTUPLE$SOURCE:EGAMMA_GENP_STUFF.INC'
      INTEGER J

      GENPS = 0                         ! Number of particles 
      DO J = 1, 50 
         GID(J)   = -999                ! ID of particle
         GPHI(J)  = -999.               ! Phi of the Particle
         GETA(J)  = -999.               ! Eta of the Particle
         GDETA(J) = -999.               ! Detector Eta of the Particle
         GPT(J)   = -999.               ! Pt of the Particle
         GPX(J)   = -999.               ! PX of the Particle
         GPY(J)   = -999.               ! PY of the Particle
         GPZ(J)   = -999.               ! PZ of the Particle
         GE(J)    = -999.               ! E of the Particle
         GMASS(J) = -999.               ! Mass of the Particle
      ENDDO

  999 RETURN
      END
C
C----------------------------------------------------------------------
C
      SUBROUTINE EGAMMA_GENP_MATCH(GENP_VTXOCC)
C
      IMPLICIT NONE
      INCLUDE 'stNTUPLE$SOURCE:EGAMMA_GENP_STUFF.INC'
      INCLUDE 'C$INC:ELEINFO.INC'
      INCLUDE 'C$INC:JOBSTA.INC'           ! job status parameters
      INCLUDE 'C$INC:PIVALU.INC'           ! PI STUFF



      INTEGER I,J
      REAL DELTA_R
      REAL GENP_VTXOCC(MAXELES)

      IF (NRUN .GT. 1000) RETURN

      CALL EGAMMA_GENP_FILL
C
C First we initialize the occupancy variable....
C
      DO I = 1, MAXELES
        GENP_VTXOCC(I) = -1.0
      ENDDO
C
C Next we loop over the ELES banks and fill them. 
C       If the ELES bank matches within DeltaR=0.2 of a photon, 
C               we give it an GENP_VTXOCC = 0.0, unless it matches with an
C               electron also.
C       If the ELES bank matches within DeltaR=0.2 of an electon, 
C               we give it an GENP_VTXOCC = 1.0, 
C
      DO I = 1, NUMELES
        DO J = 1, GENPS
          DELTA_R = ABS(PHI_ELE(I)-GPHI(J))
          IF (DELTA_R .GT. PI) DELTA_R = TWOPI-DELTA_R
          DELTA_R = SQRT((DTETA_ELE(I)-GDETA(J))**2 + 
     &                   (DELTA_R)**2)
          IF (DELTA_R .LT. 0.2 .AND. GENP_VTXOCC(I) .LT. 0.5 .AND.
     &      GID(J).EQ. 101) GENP_VTXOCC(I) = 0.0
          IF (DELTA_R .LT. 0.2 .AND. GID(J).GT. 101) 
     &      GENP_VTXOCC(I) = 1.0
        ENDDO ! Loop over GENP particles
      ENDDO ! Loop over electrons
      


      


  999 RETURN
      END
