C DEC/CMS REPLACEMENT HISTORY, Element TREXRT.CDF
C *32   27-APR-1989 00:17:53 BLOCKER "Fix bug in extrapolation from solenoid to strip chambers."
C======================================================================
      SUBROUTINE EMXRT(CRV,DVX,PHIANGLE,CTH,ZVX,REGION,XEX)
C======================================================================
C
C===Description
C
C  THIS IS A COPY OF TREXRT.CDF WITH ALL THE CRAP REMOVED
C
C       This routine extrapolates tracks to the EM calorimeters.  
C   TRBANK is the name of the track bank (TRKS, CTCS, VTCS, FTCS, or ETRS).
C   ITRKS is the track bank number.
C   If the tracks exist and can be extrapolated, the XYZ coordinates at the
C   extrapolated region are returned in XEX.
C   The track is extrapolated in a helical fit till the radius sol_med_rad,
C   the mid-point of the solenoid and then as a straight line to the point
C   of extrapolation.
C
C       Future plans are to include FTC tracks as well.
C
C   Input Arguments
C   ===============
C	CRV		Curvature
C	DVX		Impact parameter	
C       PHIANGLE		Phi (!)
C	CTH		Cotangent theta
C	ZVX		Z of closest approach  (or vertex)
C	REGION		CEM-PEM-FEM (0,1,2)
C
C   Output Arguments
C   ================
C       XEX(3):          Extrapolated X,Y,Z position.
C
C===Author:
C
C    N. Giokaris (Rockefeller)
C    28-Jan-87
C
C
C====modifications:-
C    ===============
C
C
C   28-Jan-87   Original creation  ( Nikos Giokaris) 
C   ---------
C
C    1-JUN-87 ( U. Joshi ):-
C   ---------
C
C       Incorporated FITCODE parameters and selected tracks and regions
C       accordingly.
C 
C
C======================================================================
C
$$IMPLICIT
C
C    Argument declarations.
      INTEGER ITRKS,REGION
      REAL XEX(3),DXEX(3),COSEX(3),DCOSEX(3)
      CHARACTER*4 TRBANK
      LOGICAL LCONST
C
C===Global Declarations
C
$$INCLUDE 'YBOS$LIBRARY:BNKTYP.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'C$INC:BCS   .INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:DSCMPB.INC'
$$INCLUDE 'C$INC:DSFITP.INC'
$$INCLUDE 'C$INC:DSTRKS.INC'
$$INCLUDE 'C$INC:DSCTCS.INC'
$$INCLUDE 'C$INC:DSVTCS.INC'
C$$INCLUDE 'C$INC:DSFTCS.INC'
$$INCLUDE 'C$INC:TRFITC.INC'
$$INCLUDE 'C$INC:TREXPO.INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
C
C===Local Declarations
C
        REAL PI8
        PARAMETER (PI8=PI/8.)
        REAL    RPEM
        PARAMETER       ( RPEM = 33.5 )         ! inner PLUG radius in cm
        REAL    DPEM
        PARAMETER       ( DPEM = 138.0 )        ! outer PLUG radius in cm
        REAL    RFEM
        PARAMETER       ( RFEM = 22.4 )         ! inner limit of FEM in cm
        REAL    DFEM
        PARAMETER       ( DFEM = 113.2 )        ! outer limit of FEM in cm
        REAL    DYDZ,ZEFF,RXY
        REAL    SOINRA    ,SOOURA     ,SOMERA     
        REAL    XV,YV,R0,R1,DELR,SING
        INTEGER NVMAX
        PARAMETER (NVMAX=20)
        INTEGER NV,JV,JVGOOD,NVGOOD,KCLASS(NVMAX)
        INTEGER         FITCOD(3),IMSK
        INTEGER         ISTAT
        LOGICAL         LSTAT
        INTEGER         IND,INDDAT
        INTEGER         DEFVBN
        INTEGER         VERDID
        INTEGER         BASIND, NWVHED, BLKIND, FITIND
        INTEGER         MODE, IERR
        INTEGER         NR, NVERSN, NDBLKS, INDTEB, INDDTE
        INTEGER         VERINE, BLKINE
        INTEGER         IXYZ
        INTEGER         INDTXB, INDDTX
        INTEGER         JND,STATUS,FITPAL,FITCAL
        INTEGER         DVN,ULNAAL,ULNUAL,ULVNAL,JVRT,JDVRT
        INTEGER         VERVIN,BLKVIN
        INTEGER         J,JPHI
        REAL            ZVERT(NVMAX),XVERT(NVMAX),YVERT(NVMAX)
        REAL            CTH, CRV, ZVX, DVX, PHIANGLE
        REAL            MOMENT,PX,PY,PZ,Q,RHO, ZEXT,ZV
        REAL            ARG, XYZ(6), DXYZ(6), PARIN(5)
        REAL ZFTC,RFTC,DRDZ,DPHIDZ,PHIFTC,ALPHA
        REAL RCAL,PHICAL,PHISL,PHIWD,DMIN
	Real COSDEL,PHISOL
        LOGICAL LTMP
C
C===External Functions Declarations
C
        INTEGER         BLOCAT,MDROP,BRENAM
        REAL            CDFPHI
        LOGICAL         CBLOCD
        CHARACTER*4     BINTCH
C 
C===Data Statements
C
        DATA SOINRA / 141.6 /, SOMERA / 149.1 /, SOOURA / 167.6 /
C                                              solenoid radius in cm.
C
C===Start of Code
C
C
C    Intialize output arguments.
C
      XEX(1)=999.
      XEX(2)=999.
      XEX(3)=999.
      IERR=999

C****************************************************************
C*==========================================================	*
C*  Cut a lot of junk that was supposed to go here		*
C*  		Claudio 15-may-1989				*
C*=========================================================    	*
C****************************************************************

C
C  Now do the real work
C
      PARIN(1) = CRV
      PARIN(2) = DVX
      PARIN(3) = PHIANGLE
      PARIN(4) = CTH
      PARIN(5) = ZVX
C
C    Extrapolate the VTPC tracks assuming straight line fits to the PLUG EM.
C    Now use the VTPC tracks to extrapolate to the PLUG EM. Approximate a
C    straight line fit for now.
C    CTC fitting is done @ >= 42 deg and @ < 42 deg only VTPC fitting is done.
C    (at least at Version 4.3)
C
C    Check out to see if there are any tracks in the central EM first.
C
      IF ( CRV .NE. 0. ) THEN
C        Extrapolate in R to the midway between
C        the inner and outer radius of the solenoid.
C        To extrapolate the track to the strip chambers
C        @ TRPOEC start with a helical fit of the track
C        till the midpoint of the inner and outer radius
C        of the solenoid and a straight line fit from there
C        to the strip chambers.
C 
         R0 = SOMERA
      ELSE
C        Straight line extrapolation to the radius of
C        the strip chambers
C
          R0 = TRPOEC
      END IF
C
C    Extrapolate in Radius.
C    IERR = 0 if successful
C    IERR = non-zero if unsucc in trans by R0
C    IERR = 2 and mode = 1 trk cannot reach R0
C    IERR = 9 illegal mode.
C
      CALL TREXTP(1,PARIN,R0,XYZ,DXYZ,IERR)
C    Set XYZ to error values if IERR not zero.
      IF(IERR.NE.0) THEN
          XYZ(1)=999.
          XYZ(2)=999.
          XYZ(3)=999.
      ENDIF
C
C    Proceed if no error/
      IF(IERR.EQ.0 .AND. REGION.EQ.0) THEN
C        CEM extrapolation.
          IF( CRV .NE. 0. ) THEN
C            Now extrapolate a straight line to the STRIP CHAMBER radius.
	      PHISOL = PI + ATAN2(-XYZ(2),-XYZ(1))	! Phi at solenoid
              DELR=-SOMERA*COS(PHISOL-PHIANGLE) +
     +              SQRT(TRPOEC**2-(SOMERA*SIN(PHISOL-PHIANGLE))**2)
              SING = SQRT( 1. - XYZ(6)**2 )
              IF ( ABS(SING) .GT. 0.00001 ) THEN
                  DELR = DELR/SING
              ELSE
                  DELR=0.
              END IF
              XYZ(1) = XYZ(1) + DELR*XYZ(4)
              XYZ(2) = XYZ(2) + DELR*XYZ(5)
              XYZ(3) = XYZ(3) + DELR*XYZ(6)
          ENDIF
C
C        Extrapolate to plane of strip chambers.
C
          RCAL=SQRT(XYZ(1)**2+XYZ(2)**2)
          PHICAL=CDFPHI(ATAN2(XYZ(2),XYZ(1)))
          PHISL=CDFPHI(ATAN2(XYZ(5),XYZ(4)))
          DMIN=999.
          DO 500 J=1,3
              JPHI=INT(12.*PHICAL/PI) + J - 2
              IF(JPHI.LT.0) JPHI=JPHI+24
              IF(JPHI.GT.23) JPHI=JPHI-24
              PHIWD=(FLOAT(JPHI)+.5)*PI/12.
              IF(COS(PHISL-PHIWD).GT.0.) THEN
                  DMIN=MIN(RCAL*(1.-COS(PHICAL-PHIWD))/
     +                                COS(PHISL-PHIWD),DMIN)
              ENDIF
  500     CONTINUE
          SING=SQRT(1.-XYZ(6)**2)
          IF(SING.NE.0.) THEN
             DMIN=DMIN/SING
          ELSE
             DMIN=0.
          ENDIF
          XYZ(1)=XYZ(1)+DMIN*XYZ(4)
          XYZ(2)=XYZ(2)+DMIN*XYZ(5)
          XYZ(3)=XYZ(3)+DMIN*XYZ(6)
      ELSE IF(REGION.EQ.1) THEN
C        Extrapolate to PEM.  If track reachs radius of
C        solenoid before reaching PEM, we skip it.
          IF(ABS(XYZ(3)).LT.TRPOEP) GO TO 25
C        If this is a 2D track, we must give up.
          IF(CTH.EQ.0.) RETURN
          ZEXT = SIGN( TRPOEP, CTH )
          CALL TREXTP(2,PARIN,ZEXT,XYZ,DXYZ,IERR)
C        If there is an error, set XYZ to error values.
          IF(IERR.NE.0.) THEN
              XYZ(1)=999.
              XYZ(2)=999.
              XYZ(3)=999.
          ENDIF
C
      ELSE IF(REGION.EQ.2) THEN
C         Extrapolate to FEM
C         If this is a 2D track, we must give up.
           IF(CTH.EQ.0.) RETURN
           ZEXT = SIGN( TRPOEF, CTH )
           CALL TREXTP(2,PARIN,ZEXT,XYZ,DXYZ,IERR)
C
      END IF
   25 CONTINUE
C
C    Fill in extrapolated position.
C
      DO 50 IXYZ = 1,3
          XEX(IXYZ)=XYZ(IXYZ)
          DXEX(IXYZ)=0.
          COSEX(IXYZ)=XYZ(IXYZ+3)
          DCOSEX(IXYZ)=0.
   50 CONTINUE
C
C    Return to the caller:
C
        RETURN
        END
