C=======================================================================
      SUBROUTINE EXO_PHO
C=======================================================================
C===Description:  This routine unpacks the ELES banks and calculates
C                 the photon variables which will be cut on.  It
C                 fills a common block (PHOVAL.INC) with the photon
C                 variables.
C
C      Input variables:  None
C      Input Conditions: ELES bank present (Others??)
C      Output Variables: Fills PHOVAL.INC common block
C
C===Author:
C
C       Dave Toback 13-June-1996 Initial Construction
C
C=======================================================================
C
C Implicit none declaration:
C
$$IMPLICIT NONE
      SAVE    !FOR ACP
C
C===Global Declarations:
C
$$INCLUDE 'stntuple$source:EXO_PHOINFO.INC'
$$include 'stntuple$source:stntuple.inc'
$$include 'stntuple$source:stntuple_talk.inc'
C
C
C    External declarations:
C    ======================

C Define Local Variables
C ----------------------

        INTEGER J
        REAL ETCOR
C
C=======================================================================
C
C Zero All Arrays (This is currently done in PHOVAL)
C ---------------
C
C
C=======================================================================
C
C Fill central and plug photon Information
C ---------------------------------
      CALL EXO_PHOVAL
C
C This is where we would recalculate kinematic vectors if we had a specific
C   vertex we wanted to use. Perhaps we would change PHOVAL so that we could
C   pass it a vertex. I.e, 
C
C        CALL PHOVAL(-999.)     ! Nominal call
C        CALL PHOVAL(VXPRIMZ)   ! Calculate vectors with Vertex at VXPRIMZ
C
C Fill photon: perform cuts
C -----------------------------------
      CALL EXO_PHOFND
C
C Loop over photon candidates and determine their status:
C -------------------------------------------------------
C   Status              Desciption
C   ------              ----------
C   1000.0 + Et         a central or plug ELES bank
C   2000.0 + Et         a plug ELES bank passing the
C                        loose photon ID cuts in PHOFND 
C   3000.0 + Et         a plug ELES bank passing the
C                        loose photon ID cuts and the loose photon
C                        isolation cuts in PHOFND
C   4000.0 + Et         a central ELES bank passing the Photon Treaty ID cuts
C                        in PHOFND
C   5000.0 + Et         a central ELES bank passing the Photon Treaty ID cuts
C                        and the Photon Treaty isolation cuts in PHOFND
C
          numphoid = 0
          numphoiso = 0
          numphoidL = 0
          numphoisoL = 0
          npho = MIN(NCENCL+NPLUGCL,10)
          DO J = 1,npho
             ETCOR=PHOET(J)/PHOCOR(J)
             IF (ETCOR.GT.0.0) THEN
              STAT_PHO(J) = ETCOR +1000.0
C
C First Check Plug Photons
C
              IF (PHOIDL(J)) THEN
                NUMPHOIDL = NUMPHOIDL + 1
                STAT_PHO(J) = ETCOR + 2000.0
                IF (PHOISOL(J)) THEN
                 NUMPHOISOL = NUMPHOISOL + 1
                 STAT_PHO(J) = ETCOR + 3000.0
                ENDIF ! PLUG ID + ISO?
              ENDIF ! PLUG ID?

C
C Next Check Central Photons
C
              IF (PHOID(J)) THEN
                NUMPHOID = NUMPHOID + 1
                STAT_PHO(J) = ETCOR + 4000.0
                IF (PHOISO(J)) THEN
                  NUMPHOISO = NUMPHOISO + 1
                  STAT_PHO(J) = ETCOR + 5000.0
                  IF (PHOISOB(J)) THEN
                    STAT_PHO(J) = ETCOR + 6000.0
                  endif !box and cone iso
                endif ! cone iso
              ENDIF ! id
             ENDIF ! ET>0?
          ENDDO
C
C=======================================================================
C
C All done...
C
      RETURN
      END 
C
C=======================================================================
