
C 2/16/96 ADD 4-VECTOR BASED ON EVENT VERTEX
C 2/22/96 add plug
C 4/8/96 CHANGE PLUG ET FROM CORRECTED TO UNCORRECTED, ADD CORRECTION TO COMMON
C	REMOVE EXPLICIT .006 CENTRAL CORRECTION
C 6/26/96 - many changes from parent routine phofnd.  Photon Et, sintheta,
C eta are all now done with VTVZ vertex
C electron Pt is now not recalculated
C 3x3 box Et sum included
C ces and cpr weights added
C small correction to 4-vector values
C 10/8/96 PJW Make Photon treaty cuts the standards for turning on flags:
C Loose photon = PLUG
C Tight Photon = Photon Treaty Central
C Two types of central ISO: PHOISO has cone(0.4)<0.1, PHOISOB has cone cut
C above 50 GeV and box cut below 50 GeV.
C 21-feb-97 changed cessig code from electron version (wrong)
C     to photon version (right)

C ************************************************************************

	SUBROUTINE EXO_PHOFND

C        Central ID Cuts:
C
C        PHOID:  PN3D <= 1 or PPT<1.0 
C                PCHI<20
C                PHADEM<  0.055+0.00045*PE
C                14.0 < |PCESZ| 217.0 
C                |PCESX|< 21.5 
C                |PCESSIG| < 2.0
C
C        Central Iso Cuts:
C
C        PHOISO: 
C		PCESFLG = .TRUE. (no second CES cluster over sliding cut)  
C                PSUMPT4< 5.00
C                PCO4/PETC <0.1
C        PHOISOB:        
C		PCESFLG = .TRUE.  
C                PSUMPT4< 5.00
C              For PETC>50
C                PCO4/PETC <0.1
C              For PETC<50
C                PBOXISO<4.0
C
C        Plug ID:
C	  	PHO3X3<=5.0
C		PHOCHIE<=20.0
C		PHOCHIP<=20.0 
C		PHOVTX<=0.4
C		HAD/EM<SLIDE
C        Plug ISO:
C	  	PHOCO4(II)/PHOET(II)<0.15
C
        IMPLICIT NONE
	INCLUDE 'STNTUPLE$SOURCE:EXO_PHOINFO.INC'
	INTEGER II
	REAL ERATIO,SLIDE,ETCOR,coriso
	LOGICAL QCES


	DO II=1,10
	  PHOIDL(II)=.FALSE.
	  PHOID(II)=.FALSE.
	  PHOISOL(II)=.FALSE.
	  PHOISO(II)=.FALSE.
	  PHOISOB(II)=.FALSE.
	  PHOWRD(II)=-1
	ENDDO

	DO II=1,NCENCL
	  SLIDE=.055+.00045*PHOE(II)
	  ETCOR=PHOET(II)/PHOCOR(II)

	  ERATIO=999.
	  IF(ETCOR.GT.0.0) ERATIO=PHOCO4(II)/ETCOR

	  QCES=.FALSE.
	  IF (PHOSTRE2(II).LT.PHOCESSLIDE(II).AND.
	1	( PHOWIRE2(II).LT.PHOCESSLIDE(II) .OR. 
	1	ABS(PHOCESX(II)-PHOWIR2(II)).LT.7.0 )) QCES=.TRUE.


C Cut BITS
	  PHOWRD(II)=IBCLR(PHOWRD(II),0)  ! CENTRAL
	  IF(ABS(PHOPT(II)).LT.5.0) PHOWRD(II)=IBCLR(PHOWRD(II),1)
	  IF(PHOCHI(II).LT.20.0) PHOWRD(II)=IBCLR(PHOWRD(II),2)
	  IF(PHOLSHR(II).LT.0.2) PHOWRD(II)=IBCLR(PHOWRD(II),3)
	  IF(PHOHADEM(II).LT.SLIDE) PHOWRD(II)=IBCLR(PHOWRD(II),4)
	  IF(PHON3D(II).LE.0) PHOWRD(II)=IBCLR(PHOWRD(II),5)
	  IF(ERATIO.LT.0.15) PHOWRD(II)=IBCLR(PHOWRD(II),6)
	  IF(PHOSUMPT4(II).LT.10.0) PHOWRD(II)=IBCLR(PHOWRD(II),7)
	  IF(PHOSUMPT4(II).LT. 2.0) PHOWRD(II)=IBCLR(PHOWRD(II),8)
	  IF(PHOSTRE2(II).LT.1.0 ) PHOWRD(II)=IBCLR(PHOWRD(II),9)
	  IF(PHOFID(II).EQ.0) PHOWRD(II)=IBCLR(PHOWRD(II),15)
	  IF(QCES) PHOWRD(II)=IBCLR(PHOWRD(II),16)
	  IF(PHOBOXISO(II).LT.4.0) PHOWRD(II)=IBCLR(PHOWRD(II),17)
	  IF(ABS(PHOCESZ(II)).GT.14 .AND. ABS(PHOCESZ(II)).LT. 217.0 ) 
	1	PHOWRD(II)=IBCLR(PHOWRD(II),18)
	  IF(ABS(PHOCESX(II)).LT.21.5 ) PHOWRD(II)=IBCLR(PHOWRD(II),19)
	  IF(ABS(PHOPT(II)).LT.1.0) PHOWRD(II)=IBCLR(PHOWRD(II),20)
	  IF(ABS(PHOPT(II)).LT.2.0) PHOWRD(II)=IBCLR(PHOWRD(II),21)
	  IF(PHOCHI(II).LT.4.0) PHOWRD(II)=IBCLR(PHOWRD(II),22)
	  IF(ABS(PHOCESSIG(II)).LT.2.0) PHOWRD(II)=IBCLR(PHOWRD(II),23)
	  IF(ERATIO.LT.0.10) PHOWRD(II)=IBCLR(PHOWRD(II),24)
	  IF(NTRWD3(II).EQ.0) PHOWRD(II)=IBCLR(PHOWRD(II),25)
	  IF(PHOCPR5PHSEED(II).LT.500.0) PHOWRD(II)=IBCLR(PHOWRD(II),26)

C Id cuts for standard photon cuts
          if(ABS(PHOCESZ(II)).GT.14.AND.
     &       ABS(PHOCESZ(II)).LT.217.0) then
	  if(ABS(PHOCESX(II)).LT.21.0) then 
	  IF(PHON3D(II).EQ.0 .OR. 
     &    (PHON3D(II).EQ.1.AND.ABS(PHOPT(II)).LT.1.0)) THEN  
          IF(PHOCHI(II).LT.20.0) THEN          
          IF(PHOHADEM(II).LT.SLIDE) THEN
 	  if(iand(phowrd(ii),2**16).eq.0) then
	      PHOID(II)=.TRUE.
          endif
          endif
          endif
          endif
          endif
          endif

C iso cuts for standard photon cuts
          if (PHOSUMPT4(ii).lt.5.0) then
            coriso = phoco4(ii)-phovcor(ii)-
     &      pholcor(ii)*phoet(ii)/phocor(ii)
	  if (coriso.LT.2.0) THEN
	      PHOISO(II)=.TRUE.
              if (phoboxiso(ii).lt.4.0) then
              PHOISOB(II)=.TRUE.
              endif
	  endif
          endif
	    

	ENDDO !  loop over central clusters

C                  ****** PLUG *******

	DO II=NCENCL+1,NCENCL+NPLUGCL
	  SLIDE=0.028+0.00019*PHOE(II)
	  ETCOR=PHOET(II)/PHOCOR(II)

C LOOSE ID
	  IF( PHO3X3(II).LE.5.0 .AND.
	1	PHOCHIE(II).LE.20.0 .AND.
	1	PHOCHIP(II).LE.20.0 .AND.
	1	PHOVTX(II).LE.0.4 .AND.
	1	PHOHADEM(II).LT.SLIDE ) THEN
	    PHOIDL(II)=.TRUE.
	  ENDIF

	  ERATIO=999.
	  IF(ETCOR.GT.0.0) ERATIO=PHOCO4(II)/ETCOR

C LOOSE ISO
	  IF( ERATIO.LT.0.15 ) THEN
	    PHOISOL(II)=.TRUE.
	  ENDIF

C BITS
	  IF(PHO3X3(II).LE.5.0) PHOWRD(II)=IBCLR(PHOWRD(II),10)
	  IF(PHOCHIE(II).LE.20.0) PHOWRD(II)=IBCLR(PHOWRD(II),11)
	  IF(PHOCHIP(II).LE.20.0) PHOWRD(II)=IBCLR(PHOWRD(II),12)
	  IF(PHOVTX(II).LE.0.4) PHOWRD(II)=IBCLR(PHOWRD(II),13)
	  IF(PHOHADEM(II).LT.SLIDE) PHOWRD(II)=IBCLR(PHOWRD(II),14)
	  IF(ERATIO.LT.0.15) PHOWRD(II)=IBCLR(PHOWRD(II),6)
	  IF(PHOFID(II).EQ.0) PHOWRD(II)=IBCLR(PHOWRD(II),15)
	  IF(ERATIO.LT.0.10) PHOWRD(II)=IBCLR(PHOWRD(II),24)

	ENDDO ! loop over plug clusters

	RETURN
	END

C ************************************************************************

	SUBROUTINE EXO_PHOVAL

C===========================================================================
c
C	Originally by Steve Kuhlmann, minor modifications by R. Hamilton
C	and R. Culbertson
C
        IMPLICIT NONE
	INCLUDE 'C$INC:BCS   .INC'
	INCLUDE 'C$INC:BTMASK.INC'
	INCLUDE 'C$INC:ERLEVL.INC'
	INCLUDE 'C$INC:JOBSTA.INC'
	INCLUDE 'C$INC:PIVALU.INC'
	INCLUDE 'C$INC:DSELES.INC'
	INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
	INCLUDE 'STNTUPLE$SOURCE:EXO_PHOINFO.INC'

        real jwb_zvertex
	Integer Status,Blocat,Num_clusts,Eles_bank_number(10)
	INTEGER NPASS,PASSCL
	Integer I,Ind,Inddat,Nwir,Nstp,Ierr,Ncprcl,Ietas
	Real Etcut,Wir(10,3),Stp(10,3),Wr1,Wr2,St1,St2,SW
	Real Cpr16ph,Cpr16ps,Cpr3phn,Cpr3psn,Cpr5phn,Cpr5psn
	Real Corz
	Real Rces/184.15/
	Logical Badflg
	Real Pin(3),High
	Integer Itout

	REAL ZVERT,XVERT,YVERT,ZPHO,DETA,COT,ET,COR,E,R
	INTEGER NPRIM,KCL
	Integer Ncand,IVTX,FAILED,FIDELE
	INTEGER VEXPT,VACT
	LOGICAL LFID

	Real phoeff,baceff,Nphobac,cprsys1,cprsys2,cprsys3,cprsys4
	Real cesweight,Cesf
        integer nclass12

        real pakangle,pakDCTTH,pakPHIS,pakDPHI
        integer pakIVTX,pakVTSTAT,vtwdok


C VTX initialization: vtwdok = 0 means VTWD bank is here and we can 
C recompute vtx occupancy
        CALL VTEVIN(vtwdok)
C       call old routine to get nclass12
        call get_vxprim(zvert,nclass12)
C JWB 3/26/98 call new zvertex routine
        if (nrun.gt.10000) then
        zvert = jwb_zvertex()
        endif
c Do Initializations
	Badflg = .true.
	Ncencl = 0
	Nplugcl = 0
	NPASS = 0
	PASSCL = 0
	Do I=1,10
	  Phoet(I) = 0.
	  Phoe(I) = 0.
	  Phozv(I) = 0.
	  Phoeta(I) = 0.
	  Phodeta(I) = 0.
	  Phowed(I) = 0.
	  Phoco4(I) = 0.
	  Phoco7(I) = 0.
	  Phon3d(I) = 0.
	  Phopt(I) = 0.
	  Phopt2(I) = 0.
	  Phodelx(I) =-999.
	  Phodelz(I) =-999.
	  Phosth(I) = 1.
	  Phophi(I) = 999.
	  Phochi(I) = 999.
	  Phocese(I) = 0.
	  Phocesx(I) = -999.
	  Phocesz(I) = -999.

	  Phochistr(I) = 999.
	  Phochiwir(I) = 999.

	  Phocpr3ph(I) = 0.
	  Phocpr3ps(I) = -999.
	  Phocpr5ph(I) = 0.
	  Phocpr5ps(I) = -999.
	  Phocpr16ph(I) = 0.
	  Phocpr16ps(I) = -999.

	  Phocpr5phseed(I) = 0.

	  Phohadem(I) = 999.
	  Pholshr(I) = 999.
	  Phostr2(I) = -999.
	  Phostre2(I) = 0.
	  Phowir2(I) = -999.
	  Phowire2(I) = 0.
	  Phosumpt4(I) = 999.
	  Phosumpt7(I) = 999.

	  Phoboxiso(I) = 999.
	  PhoCESslide(I) = 999.
	  PhoCESsig(I) = 999.

	  PhoID(I) = .false.
	  Phoiso(I) = .false.

	  PhoIDL(I) = .false.
	  PhoisoL(I) = .false.

	  Phovtx(I) = 999.0
	  Pho3x3(I) = 0.0
	  Phochie(I) = 0.0
	  Phochip(I) = 0.0

	  Phocor(I) = 1.0
	  Phofid(I) = -1

	  Phoceswht(I) = 0.0
	  Phocprwht(I) = 0.0

	  Phocespg(I) = 0.0
	  Phocespb(I) = 0.0
	  Phocprpg(I) = 0.0
	  Phocprpb(I) = 0.0

	  Ntrwd(I) = 0
	  Ntrwd2(I) = 0
	  Ntrwd3(I) = 0
	  Cescprx(I) = 0.0
	  Tkcprx(I) = 0.0
          Photime(I) = -999.
          Phovcor(I) = 0.0
          Pholcor(I) = 0.0
	Enddo

	Call Cprbtc(Ierr)				! Dump Cpr bank

c Get Eles banks
        CALL GTELES(10,Num_Clusts,ELES_Bank_Number)
	If( Num_Clusts .Gt. 10 )Num_Clusts = 10

c Loop over eles clusters
        DO 10 I=1,Num_Clusts

	 STATUS = BLOCAT(IW,'ELES',ELES_Bank_Number(I),Ind,Inddat)
	 If(Iw(Inddat+Regele).ne.0) Goto 10   ! Central only for now
	 Ncencl = Ncencl + 1		      ! Number of central clusters
	 Phodetect(Ncencl) = 0

         call emtime(ELES_Bank_Number(I),Photime(Ncencl))
	 STATUS = FIDELE(ELES_Bank_Number(I),0,LFID,FAILED)
	 PHOFID(NCENCL)=FAILED

         ietas = iand(ishft(iw(inddat+stwele),-7),'7f'x) !Towe address of seed

	 Phobnk(Ncencl) = Eles_bank_number(I)
	 Phojet(Ncencl) = Iw(Inddat+Jetele)
C NOMINAL ZPHO
	 DEta=Rw(inddat+EdtEle)  
	 ZPHO=RCES*0.5*(EXP(DETA)-EXP(-DETA))

	 Call Elce92(Eles_Bank_Number(i),Nwir,Wir,Nstp,Stp) ! Ces clusters

C from "electron"
C	 Phozv(Ncencl) = Rw(inddat+zv_ele)	! Zvertex for this cluster
C from VTVZ vertex
	 Phozv(Ncencl) = ZVERT	! Zvertex for this cluster

	 If(Nstp.ge.1) Then                  !!!  Get Angles if Strip Cluster
	   if (ietas.le.42) stp(1,2)=-stp(1,2)  ! Correct sign on strip z
	   if (ietas.le.42) stp(2,2)=-stp(2,2)  ! Correct sign on strip z
	   CorZ = Stp(1,2) - Phozv(Ncencl)
	   ZPHO=STP(1,2)
C wir, stp order:
C WIR(I,J), I=energy, desc. order, J=1,2,3= energy, x (or z), chi**2
	   Phosth(Ncencl)=Sqrt(Rces**2.+Wir(1,2)**2.)/ 
     *      Sqrt(Rces**2.+Wir(1,2)**2.+CorZ**2.) !sintheta
	   Phodeta(Ncencl)=0.5*log((sqrt(Rces**2.+Wir(1,2)**2.
     *      +Stp(1,2)**2.)+Stp(1,2))/(sqrt(Rces**2.+Wir(1,2)**2.
     *      +Stp(1,2)**2.)-Stp(1,2)))
	   Phoeta(Ncencl)=0.5*log((sqrt(Rces**2.+CorZ**2.+
     *       Wir(1,2)**2.)+CorZ)/(sqrt(Rces**2.+CorZ**2.+
     *       Wir(1,2)**2.)-CorZ))
	 Endif

         Phoe(Ncencl) = Rw(Inddat+E__Ele)      ! Photon Energy
	 Phoet(Ncencl) = Phoe(Ncencl)*Phosth(Ncencl)  ! Photon et
	 Phocesz(Ncencl) = Stp(1,2)		! Ces Z position
	 Phocesx(Ncencl) = Wir(1,2)		! Ces X position
	 Phoco4(Ncencl) = Rw(Inddat+Er4ele)    ! Photon Cone Et
	 Phoco7(Ncencl) = Rw(Inddat+Er7ele)    ! Photon Cone Et
         Phon3d(Ncencl) = Iw(inddat+N3dEle)    ! Photon N3d tracks
CDT	 Phopt(Ncencl) = RW(Inddat+Ptrkele)*Phosth(Ncencl)   ! Track Pt
	 Phopt(Ncencl) = RW(Inddat+PT_ELE)   ! Track Pt
	 CALL GETPT2(Eles_Bank_Number(i),PHOPT2(NCENCL))
	 Phodelx(Ncencl) = Rw(Inddat+Xcesele)-Rw(Inddat+Xrwele) ! Tr-Ces xmat
	 Phodelz(Ncencl) = Rw(Inddat+Zcesele)-Rw(Inddat+Zrwele) ! Tr-Ces zmat
	 Phowed(Ncencl) = IAND(IW(Inddat+StwEle),MASK7) 
         Phophi(Ncencl) = (Phowed(Ncencl)+0.5)*(Pi/12.)
     *		-ATAN2(Wir(1,2),Rces)
	 If(Iand(Ishft(Iw(Inddat+Stwele),-7),MASK7).gt.42) 
     *		Phowed(Ncencl) = Phowed(Ncencl) + 24    ! Photon Wedge #

C CORRECTED EVENT-VERTEX 4-VECTOR
	 E=PHOE(NCENCL)
	 CALL get_corfac(Eles_Bank_Number(i),COR)
C	 CALL CEMFIX(Eles_Bank_Number(i),COR)
C	 IF(NRUN.GT.55000) COR=COR/1.006  ! NOW IN CEMFIX
	 IF(COR.LT.0.8.OR.COR.GT.1.2) COR=1.0
	 E=E/COR
	 PHOCOR(NCENCL)=COR
C	 COT=(ZPHO-ZVERT)/RCES
C	 ET=E/SQRT(1.0+COT**2)
	 COT=SIGN(1.0,ZPHO-ZVERT)*SQRT(1/PHOSTH(NCENCL)**2-1.0)
	 ET=E*PHOSTH(NCENCL)
	 PHO_P4(1,NCENCL)=ET*COS(PHOPHI(NCENCL))
	 PHO_P4(2,NCENCL)=ET*SIN(PHOPHI(NCENCL))
	 PHO_P4(3,NCENCL)=ET*COT
	 PHO_P4(4,NCENCL)=E
C 11-19-97 JWB added corrected photon isolation variables for Run 1b data
         if (nrun.gt.50000) then
         call iso_correct(Phocesx(Ncencl),Nclass12,
     &        Pholcor(Ncencl),Phovcor(Ncencl))
         endif
C variables added 26-OCT-1995

	 Phohadem(Ncencl)=RW(Inddat+Had3ele)
	 Pholshr(Ncencl)=RW(Inddat+Lshele)
C Variables added Junk-1996
         if (nrun.gt.50000.or.nrun.lt.40000) then
	 Phoboxiso(Ncencl)=RW(Inddat+EB3Ele)
         else
         phoboxiso(ncencl) = 0.0
         endif

C
C We change the seed position of the photon now that we have the best 4-vectors.
C   Pin(1)=RW(Inddat+EXVELE) is based on a track based algorithm which is not
C   appropriate for photons (D. Toback 7-18-1996)
C
CDT	 Pin(1)=RW(Inddat+EXVELE)
CDT	 Pin(2)=RW(Inddat+EYVELE)
CDT	 Pin(3)=RW(Inddat+EZVELE)
C
         PIN(1)=PHO_P4(1,NCENCL)
         PIN(2)=PHO_P4(2,NCENCL)
         PIN(3)=PHO_P4(3,NCENCL)
	 CALL TKISO1(Pin,0,0,0.4,Phosumpt4(Ncencl),High,ITOUT)
	 CALL TKISO1(Pin,0,0,0.7,Phosumpt7(Ncencl),High,ITOUT)
C
C variables added 26-OCT-1995 (more below)
C
C Cut #1
	 If(Nwir.eq.0.or.Nstp.eq.0) Goto 10	! Ask For a Ces cluster

C   Doesn't make sense to fill the following quantities without a 
C   strip or wire cluster...

C variables added 26-OCT-1995
	 If(Nstp.gt.1) then
	   Call GetSW(Nrun,Phowed(Ncencl)+1,Wir(1,2),Abs(Stp(2,2)),SW)
	   Phostr2(Ncencl)=Stp(2,2)
	   ! sin theta corrects for pathlength:
	   Phostre2(Ncencl)=Stp(2,1)*SW * Phosth(Ncencl)
C wir, stp order:
C WIR(I,J), I=energy, desc. order, J=1,2,3= energy, x (or z), chi**2
	 Endif
	 If(Nwir.gt.1) then
	   Phowir2(Ncencl)=Wir(2,2)
	   ! sin theta corrects for pathlength:
	   Phowire2(Ncencl)=Wir(2,1)  * Phosth(Ncencl)
	 Endif
C variables added 26-OCT-1995

	 Phochi(Ncencl) = (Wir(1,3)+Stp(1,3))/2.  ! Average Chisq 
	 Phochistr(I) = stp(1,3)		! strip chi**2
	 Phochiwir(I) = wir(1,3)                ! wire  chi**2
	 ! sin theta corrects for pathlength:
	 Phocese(Ncencl) = Wir(1,1) * Phosth(Ncencl) ! Ces Energy
	 If(Nwir.ge.1) then
C (CES-CEM)/sigma cut function
	   PhoCESsig(Ncencl)=Cesf( Phoe(Ncencl),
	1	Phosth(Ncencl), Phocese(Ncencl) )
	 Endif

C sliding second CES energy cluster cut
	  IF(PHOE(Ncencl).LT.17.88) THEN
	    PhoCESSLIDE(Ncencl) = -0.94544e-02 + 0.14433*PHOE(Ncencl)
	  ELSE
	    PhoCESSLIDE(Ncencl) = 2.3918 + 0.10018E-01*PHOE(Ncencl)
	  ENDIF

c CPR clustering around the CES seed
c	 Call Cprpcl(Phowed(Ncencl),Wir(1,2),Stp(1,2),3,Cpr3phn,Cpr3psn)
	 Call Cprpcl(Phowed(Ncencl),Wir(1,2),Stp(1,2),5,Cpr5phn,Cpr5psn)
	 Phocpr5phseed(Ncencl) = Cpr5phn
c	 Call Cprpcl(Phowed(Ncencl),Wir(1,2),Stp(1,2),16,Cpr16ph,Cpr16ps)
c Highest-energy CPR cluster, looking over the whole wedge
	Call Cprpcl(Phowed(Ncencl),30.,Stp(1,2),3,Cpr3phn,Cpr3psn)
	Call Cprpcl(Phowed(Ncencl),30.,Stp(1,2),5,Cpr5phn,Cpr5psn)
	Call Cprpcl(Phowed(Ncencl),30.,Stp(1,2),16,Cpr16ph,Cpr16ps)

	 Phocpr3ph(Ncencl) = Cpr3phn
	 Phocpr3ps(Ncencl) = Cpr3psn
	 Phocpr5ph(Ncencl) = Cpr5phn
	 Phocpr5ps(Ncencl) = Cpr5psn
	 Phocpr16ph(Ncencl) = Cpr16ph
	 Phocpr16ps(Ncencl) = Cpr16ps

C FIND CES AND CPR WEIGHTS

	Phoceswht(Ncencl) = cesweight(Phoet(Ncencl),Phochi(Ncencl),
	1	Phocespg(Ncencl),Phocespb(Ncencl))

	Call getcprweight(Phocpr5phseed(Ncencl),Phoet(Ncencl),
	1	Phosth(Ncencl),Phocprpg(Ncencl),Phocprpb(Ncencl),
	1	Nphobac,Phocprwht(Ncencl),
	1	cprsys1,cprsys2,cprsys3,cprsys4)

C Cpr Track cut

	 Call cprtrack(Phocesx(Ncencl),Phocesz(Ncencl),phowed(Ncencl),
  	1	ntrwd(Ncencl),ntrwd2(Ncencl),
   	1	ntrwd3(Ncencl),cescprx(Ncencl),tkcprx(Ncencl))

C VTX occupancy
         pakangle = (phocesz(ncencl)-zvert)/Rces
         pakdctth = 0.5/rces
         pakphis = phophi(ncencl)
         pakdphi = 0.5/rces
         if (vtwdok.eq.0) then
           CALL PAKVTX(zvert,pakangle,pakDCTTH,pakPHIS,
     &               pakDPHI,pakIVTX,pakVTSTAT)
	   VEXPT = IAND(pakIVTX,'1F'X)
	   VACT = IAND(ISHFT(pakIVTX,-5),'1F'X)
	   IF(VEXPT.NE.0.0) then
             PHOVTX(Ncencl) = real(VACT)/real(VEXPT)
           else
	     PHOVTX(Ncencl) = -1.0
           endif
         else           
           IVTX=Iw(Inddat+VtpEle)
           VEXPT = IAND(IVTX,'1F'X)
           VACT = IAND(ISHFT(IVTX,-5),'1F'X)
	   IF(VEXPT.NE.0.0) then
             PHOVTX(Ncencl) = real(VACT)/real(VEXPT)
           else
	     PHOVTX(Ncencl) = -1.0
           endif
         endif
                                              





 10	Continue  ! END OF Loop over eles clusters






C                    ***** Plug  ********



	Ncand=Ncencl

c Loop over eles clusters
        DO 20 I=1,Num_Clusts

	 STATUS = BLOCAT(IW,'ELES',ELES_Bank_Number(I),Ind,Inddat)
	 If(Iw(Inddat+Regele).ne.1) Goto 20   ! Plug
	 Ncand = Ncand + 1		      ! Number of photons
	 Nplugcl = Nplugcl + 1		      ! Number of plug photons
	 Phodetect(Ncand) = 1
         call emtime(ELES_Bank_Number(I),Photime(Ncand))
	 Phobnk(Ncand) = Eles_bank_number(I)

	 Pho3x3(Ncand)=Rw(Inddat+Ch3Ele)
C Strip chi**2.  If it was set to 999 to indicate a non-fiducial
C region, then set it to -1.0 so it will pass chi**2<x cuts.
	 Phochie(Ncand)=Rw(Inddat+CstEle)
	 If(Phochie(Ncand).gt.998.0) Phochie(Ncand)=-1.
	 Phochip(Ncand)=Rw(Inddat+CspEle)
	 If(Phochip(Ncand).gt.998.0) Phochip(Ncand)=-1.

	 Phocese(Ncand)=Rw(Inddat+EspEle)

	 IVTX=Iw(Inddat+VtpEle)
	 VEXPT = IAND(IVTX,'1F'X)
	 VACT = IAND(ISHFT(IVTX,-5),'1F'X)
	 IF(VEXPT.NE.0.0) PHOVTX(NCAND) = real(VACT/VEXPT)

         Phoe(Ncand) = Rw(Inddat+E__Ele)      ! Photon Energy
	 Phodeta(Ncand) = Rw(Inddat+Etsele)
	 Phophi(Ncand) = Rw(Inddat+Pspele)
	 Phozv(Ncand) = ZVERT

	 ZPHO=SIGN(190.0,PHODETA(I))
	 E=PHOE(NCAND)

	 CALL get_corfac(Eles_Bank_Number(i),COR)
C	 CALL PEMFIX(Eles_Bank_Number(i),COR)
	 IF(COR.LT.0.8.OR.COR.GT.1.2) COR=1.0
	 E=E/COR
	 PHOCOR(NCAND)=COR

	 COT=0.5*(EXP(PHODETA(NCAND))-EXP(-PHODETA(NCAND)))  ! COT FOR DET ETA
	 IF(COT.NE.0.0) R=ZPHO/COT
	 COT=(ZPHO-ZVERT)/R  ! COT CORRECTED TO EVENT VERTEX
	 Phoeta(Ncand)=log(sqrt(1.0+cot**2)+cot)  ! event eta
C PHOET IS NOT CORRECTED
	 Phoet(Ncand)=PHOE(NCAND)/SQRT(1.0+COT**2)
C FOUR VECTOR IS CORRECTED
	 ET=E/SQRT(1.0+COT**2)
	 PHO_P4(1,NCAND)=ET*COS(PHOPHI(NCAND))
	 PHO_P4(2,NCAND)=ET*SIN(PHOPHI(NCAND))
	 PHO_P4(3,NCAND)=ET*COT
	 PHO_P4(4,NCAND)=E
	 Phosth(Ncand)=ET/E

	 Phoco4(Ncand) = Rw(Inddat+Er4ele)    ! Photon Cone Et
	 Phoco7(Ncand) = Rw(Inddat+Er7ele)    ! Photon Cone Et
	 Phohadem(Ncand)=RW(Inddat+HadEle)

         pakangle = cot
         pakdctth = (EXP(phodeta(ncand))+
     &               EXP(-phodeta(ncand)))*.1/8.
         pakphis = phophi(ncand)
         pakdphi = pi/144.
         if (vtwdok.eq.0) then
           CALL PAKVTX(zvert,pakangle,pakDCTTH,pakPHIS,
     &               pakDPHI,pakIVTX,pakVTSTAT)
	   VEXPT = IAND(pakIVTX,'1F'X)
	   VACT = IAND(ISHFT(pakIVTX,-5),'1F'X)
	   IF(VEXPT.NE.0.0) then
             PHOVTX(Ncand) = real(VACT)/real(VEXPT)
           else
	     PHOVTX(Ncand) = -1.0
           endif
         else
           IVTX=Iw(Inddat+VtpEle)
           VEXPT = IAND(IVTX,'1F'X)
           VACT = IAND(ISHFT(IVTX,-5),'1F'X)
	   IF(VEXPT.NE.0.0) then
             PHOVTX(Ncand) = real(VACT)/real(VEXPT)
           else
	     PHOVTX(Ncand) = -1.0
           endif
         endif

 20	Continue  ! END OF Loop over Plug eles clusters


	Return
	End



c=======================================================================
	Subroutine GetSW(Nrun,Wedge,Ces_x,Ces_z,SW)
c=======================================================================
	Integer Nrun,Wedge
	Real Ces_x,Ces_z,Rx2,RZ2,MeanSW,SW

	 If( NRUN .GT. 1000 )Then	
	   Call CALCSW(Wedge,Ces_x,Ces_z,RX2,RZ2)   
	   MeanSW = RX2 + RZ2
	   If( MeanSW .gt. 0.0 )Then
	     SW = 1./MeanSW
	   Else
	     SW = 1.
	   End If
	 Else
	   SW = 1.
	 End If

	Return
	End

C DEC/CMS REPLACEMENT HISTORY, Element ELCE92.CDF
C *1    23-DEC-1992 15:19:27 KUHLMANN "Unpacks 92 version of elce"
C DEC/CMS REPLACEMENT HISTORY, Element ELCE92.CDF
C=======================================================================
	Subroutine Elce92(Elesbk,Num_wires,Wirarr,Num_strips,Stparr)
C=======================================================================
        IMPLICIT NONE
	INCLUDE 'C$INC:DSCASSFC.INC'
	INCLUDE 'C$INC:BCS   .INC'
	INCLUDE 'C$INC:ERLEVL.INC'
	INCLUDE 'C$INC:JOBSTA.INC'
	INCLUDE 'C$INC:DSELCE.INC'
	INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'

	Integer Status,Blocat,Elesbk,Ind_Elce,Inddat_Elce
	Integer Ces_clusters,Words_per_cluster,W_ind,S_ind
	Integer Fit_code,Pointer,I,J,K,Num_wires,Num_strips
	Integer W_order(10),S_order(10),Dummy
	Real Wirarr(10,3),Stparr(10,3)
	Real Wire_X(10),Wire_E(10),Wire_chisq(10)
	Real Strip_Z(10),Strip_E(10),Strip_chisq(10)
C
	Num_wires=0
	Num_strips=0
	Do i=1,10
	 Do j=1,3
	  Wirarr(i,j) = 0.
	  Stparr(i,j) = 0.
	 Enddo
	Enddo

	  STATUS=BLOCAT(IW,'ELCE',Elesbk,Ind_ELCE,Inddat_ELCE)
	  If( STATUS.NE.YESUCC ) Return
C
C	  Initilize for loop
C	  ------------------
	  CES_Clusters    = IW(Inddat_ELCE + NclEce)
	  Words_Per_Cluster = IW(Inddat_ELCE + NdtEce)  
	  S_Ind = 0
	  W_Ind = 0
	  If( CES_Clusters .eq. 0 ) Return
C
C	  Loop over CES clusters in ELCE bank
C	  -----------------------------------
	  Do J=1,CES_Clusters
	    Pointer = (J-1)*Words_Per_Cluster + 2
	    Fit_Code = IW(Inddat_ELCE + Pointer + FcdEce)
C
C	    Get wire cluster
C	    ----------------
	    If(	IAND(Fit_Code,CASS_FC_VIEW_MASK) .EQ. 0 )Then
	      W_Ind = W_Ind + 1
              Wire_E(W_Ind)    = RW( Inddat_ELCE + Pointer + EneEce) 
	      Wire_X(W_Ind)    = RW( Inddat_ELCE + Pointer + PosEce)
	      Wire_Chisq(W_Ind)= RW( Inddat_ELCE + Pointer + ChqEce)
	    Else 
              S_Ind = S_Ind + 1
	      Strip_E(S_Ind)    = RW(Inddat_ELCE + Pointer + EneEce)
	      Strip_Z(S_Ind)    = RW(Inddat_ELCE + Pointer + PosEce)
	      Strip_Chisq(S_Ind)= RW(Inddat_ELCE + Pointer + ChqEce)
            End If
	  End Do
C
C	  Order strip and wire clusters by energy
C	  ---------------------------------------
	  Num_Wires  = W_Ind
	  Num_Strips = S_Ind
	  If( Num_Wires .gt. 1 )Then
	    Call QDORDR( Num_Wires,Dummy,Wire_E,'Real',1.,.TRUE.,W_Order)
	  Else
	    W_Order(1) = 1
	  End If
	  If( Num_Strips .gt. 1 )Then
	    Call QDORDR(Num_Strips,Dummy,Strip_E,'Real',1.,.TRUE.,S_Order)
	  Else
	    S_Order(1) = 1
	  End If
C
C	  Loop Over The Two Highest Energy CES Clusters
C	  =============================================
	  Do K=1,10
C
C	    Get Strip Cluster Variables
C	    ---------------------------
	    If( Num_Strips .ge. K )Then
	      Stparr(K,1) = Strip_E(S_Order(K))
	      Stparr(K,2) = Strip_Z(S_Order(K))
	      Stparr(K,3) = Strip_chisq(S_Order(K))
	    End If
C           
C	    Get Wire Cluster Variables
C	    ---------------------------
	    If( Num_Wires .ge. K )Then
	      Wirarr(K,1) = Wire_E(W_Order(K))
	      Wirarr(K,2) = Wire_X(W_Order(K))
	      Wirarr(K,3) = Wire_chisq(W_Order(K))
	    End If
	  End Do !Loop over two highest energy clusters

	RETURN
	END
C DEC/CMS REPLACEMENT HISTORY, Element CALCSW.CDF
C *5     9-MAR-1995 13:49:28 KUHLMANN "add protection against translations"
C *4    11-JAN-1995 12:31:15 KUHLMANN "add $$mips"
C *3     5-JAN-1995 13:02:40 KUHLMANN "various unix changes"
C *2    15-SEP-1994 14:50:14 KUHLMANN "unix open"
C *1    14-NOV-1989 13:22:58 KUHLMANN "Gives the s/w ratio as a function of 
C                                      position"
C DEC/CMS REPLACEMENT HISTORY, Element CALCSW.CDF
C VAX/DEC CMS REPLACEMENT HISTORY, Element CALCSW.CDF
C *1    14-NOV-1989 13:22:58 KUHLMANN "Gives the s/w ratio as a function of posi
C      tion"                                                                    
C VAX/DEC CMS REPLACEMENT HISTORY, Element CALCSW.CDF
C===================================================================
      SUBROUTINE CALCSW(IC,X,Z,RX,RZ)
C===================================================================
C
C DESCRIPTION: CALCSW GIVES THE MEASURED S/W RATIO AS A FUNCTION
C              OF POSITION IN A WEDGE
C
C AUTHOR:  BARRY WICKLUND
C
C INPUT ARGUMENTS     IC = 1-24 (WEST), 25-48 (EAST)
C                     X= LOCAL X IN CES (-23<X<23CM)
C                     Z= LOCAL Z  IN CES (Z >0CM)
C OUTPUT ARGUMENTS    S/W= RX+RZ IS EXPECTED RATIO
C----------------------------------------------------------
	INCLUDE 'S_I$LIBRARY:SIERROR.INC'
      REAL PARMS(5,96),PARMW(5,96)
      Real Rx,Rz,X,Z
      Integer Ic,NCALL,Sigten,Sitrfn,Lenfil,Status,Lunit
      Integer Uigtlu,Uifrlu
      CHARACTER*20 LABEL
      Character*128 Infile,Outfile
      Data Infile/'photon$library:s_w_b0fit.dbt'/
      DATA NCALL/0/

      If(NCALL.NE.0)GO TO 10
      
      Status = Uigtlu(Lunit)
      OPEN(UNIT=Lunit,FILE=infile,STATUS='OLD',
     2     FORM='FORMATTED',READONLY,SHARED)

      READ (Lunit,1031)LABEL
      READ (Lunit,1010)PARMS
      READ (Lunit,1031)LABEL
 1031 FORMAT(A20)
      READ (Lunit,1010)PARMW
      CLOSE(UNIT=Lunit)
      Status = Uifrlu(Lunit)
      NCALL=1
 1010 FORMAT(5E12.5)
   10 CONTINUE
C
      IS=0
      IF(Z.GT.121.183)IS=1
      ZMIN=6.16
      ZMAX=121.183
      IF(IS.EQ.1)ZMIN=121.183
      IF(IS.EQ.1)ZMAX=121.183+59.*2.007
      ZL=(Z-ZMIN)/(ZMAX-ZMIN)
      IF(ZL.LT.0.)ZL=0.
      IF(ZL.GT.1.)ZL=1.
      XL=(X+23.27744)/(2.*23.27744)
      IF(XL.LT.0.)XL=0.
      IF(XL.GT.1.)XL=1.
      NPAR=5
      ICC=IC+IS*48
      RX=PARMW(1,ICC)
      RZ=PARMS(1,ICC)
      DO J=2,NPAR
      RX=RX+PARMW(J,ICC)*XL**(J-1)
      RZ=RZ+PARMS(J,ICC)*ZL**(J-1)
      END DO
      RETURN
      END

C **************************************************************************

	SUBROUTINE TKISO1(IN,ITSKIP1,ITSKIP2,RIN,SUM,HIGH,ITOUT)
C
C	Get transverse momentum of tracks inside cone
C	of radius R.
C
c	M.C. April 16, 1990.
C       Updated Oct 11, 1992.
$$IMPLICIT
C
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:BITMSK.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'YBOS$LIBRARY:BNKTYP.INC'
$$INCLUDE 'C$INC:DSTOWE.INC'
$$INCLUDE 'C$INC:DSELES.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:CLUST.INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
$$INCLUDE 'C$INC:LOGUNI.INC'
$$INCLUDE 'C$INC:DSCMPB.INC'
$$INCLUDE 'C$INC:DSFITP.INC'
$$INCLUDE 'C$INC:DSTRKS.INC'
$$INCLUDE 'C$INC:TRACKS.INC'
$$INCLUDE 'C$INC:DSCTCS.INC'
$$INCLUDE 'C$INC:DSCLSL.INC'
$$INCLUDE 'UIPACK$LIBRARY:UIERROR.INC'
$$INCLUDE 'UIPACK$LIBRARY:UIPARAM.INC'
$$INCLUDE 'UIPACK$LIBRARY:UINAMES.INC'
$$INCLUDE 'C$INC:TRFITC.INC'

	INTEGER STATUS
	INTEGER BLOCAT,IND
C	QTRK variables
	INTEGER QTRKUN
	Integer	INQTRK,IDQTRK,NTRAKS,Q,CTCSN,QNLAY,QTSCODE,HITLAY,IERR
	Real	QPX,QPY,QPZ,QZDIST,D0
	Logical	FLAG3D,VTC,SVX
	INTEGER I,ITSKIP1,ITSKIP2
        REAL IN(3),TEMP(3)
	REAL PTIN,PHIIN,ETAIN,PHITEMP,ETATEMP,DETA,DPHI,DR
        REAL RIN,SUM,HIGH
	REAL PRAPID,GETPHI
	REAL ZIN,PT
	INTEGER ITOUT
C
C	executable code
C
        SUM=0.
        HIGH=-1.0
        ITOUT=-99
C
C	------------------------
C	loop over tracks in QTRK
c	-------------------------
	NTRAKS = QTRKUN(0,1)
	IF(NTRAKS.LT.1) GO TO 995
	PTIN=SQRT(IN(1)**2+IN(2)**2)
	ETAIN=PRAPID(IN(1))
        PHIIN=GETPHI(IN(1))
	DO I=1,NTRAKS
          IF(I.EQ.ITSKIP1.OR.I.EQ.ITSKIP2)GOTO393
	  CALL QTRKCT(I,Q,QPX,QPY,QPZ,QZDIST,D0,
     &	  HITLAY,CTCSN,FLAG3D,VTC,SVX,IERR)
C	  3-d tracks only  with track selection
C	  -------------------------------------
	  IF(.NOT.(IERR.EQ.0.AND.HITLAY.GT.0.AND.FLAG3D))GOTO393
          PT=SQRT(QPX**2+QPY**2)
          TEMP(1)=QPX
          TEMP(2)=QPY
          TEMP(3)=QPZ
          ETATEMP=PRAPID(TEMP(1))
          PHITEMP=GETPHI(TEMP(1))
          DETA=ETAIN-ETATEMP
          DPHI=ABS(PHIIN-PHITEMP)
          IF(DPHI.GT.PI)DPHI=TWOPI-DPHI
          DR=SQRT(DETA**2+DPHI**2) 
          IF(DR.LT.RIN)THEN
	    SUM=SUM+PT
            IF(PT.GT.HIGH)THEN
	      HIGH=PT
              ITOUT=I
            ENDIF
	  ENDIF
393       CONTINUE
	END DO
C	successful return
c	------------------
995     CONTINUE
	RETURN
c
	END 	


C **************************************************************************

	SUBROUTINE GETPT2(IELES,PT2)

$$IMPLICIT
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'C$INC:DSCMPB.INC'
$$INCLUDE 'C$INC:DSELES.INC'
$$INCLUDE 'C$INC:DSCALS.INC'
$$INCLUDE 'C$INC:DSCLSL.INC'
$$INCLUDE 'C$INC:DSTOWE.INC'
$$INCLUDE 'C$INC:DSFITP.INC'
$$INCLUDE 'C$INC:DSTRKS.INC'
$$INCLUDE 'C$INC:TRFITC.INC'
$$INCLUDE 'C$INC:TRKSCO.INC'

	INTEGER STATUS,BLOCAT,IELES,JCATL,JDCATL,NUMTRK,JTRK
	INTEGER JTRKS,JDTRKS,VERIND,TRKSUN,IMSK
	REAL PT1,PT2,PT
	LOGICAL LSTAT,CBLOCD
	CHARACTER*4 BINTCH


	PT1=0.0
	PT2=0.0

	STATUS=BLOCAT(IW,'CATL',IELES,JCATL,JDCATL)
	IF(STATUS.EQ.YESUCC) THEN
	  NUMTRK=IW(JDCATL)
	ELSE
	  RETURN
	ENDIF

	DO 400 JTRK=1,NUMTRK
	  LSTAT=CBLOCD(IW,BINTCH(IW(JDCATL+2*JTRK-1)),
     +                IW(JDCATL+2*JTRK),DVNTRS,JTRKS,JDTRKS,VERIND)
	  IF (LSTAT) THEN 
	    STATUS = TRKSUN(IW(JDCATL+2*JTRK),1,0)
	    IMSK=IAND(TRKSPC,TPMFC)
	    IF (IMSK.EQ.TP02FC) THEN
	      PT= TRKSP4(5)
	      IF(PT.GT.PT1) THEN
	        PT2 = PT1
	        PT1 = PT
	      ELSEIF(PT.GT.PT2) THEN
	        PT2=PT
	      ENDIF
	    ENDIF
	  ENDIF
400	CONTINUE

	RETURN
	END

        subroutine get_vxprim(zvert,nclass12)




$$IMPLICIT
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'YBOS$LIBRARY:BNKTYP.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:DSEVTA.INC'
$$INCLUDE 'C$INC:VTCAUX.INC'
$$INCLUDE 'C$INC:DSCMPB.INC'
$$INCLUDE 'C$INC:DSVTXS.INC'
$$INCLUDE 'C$INC:VXPVIN.INC'
C       JWB local variables
        integer nvtx,bnknum,sindx,sdindx,istat,j,nclass12
        real xseed(20,3),cvseed(20,6),qint(20),dz0cut,qmax
        logical blinfo
        real zvert
        integer blocat
C---Locate the bank in YBOS:
C   JWB 7/5/97
      bnknum = 1
      istat = blocat(iw,'VTVZ',bnknum,sindx,sdindx)
      if (istat.ne.yesucc) then
         CALL ERLOGR('jwb_qdseta',EREROR,0,0,
     &               'unable to find VTVZ bank')
      else
         dz0cut = zmatch
         call jwb_vxpest(xseed,cvseed,nvtx,blinfo,qint,dz0cut)
         qmax = -1.0
         zvert = 0.0
         nclass12 = 0
         do j = 1,nvtx
            IF (IW(SDINDX+1).GE.J.and.
     &          IW(SDINDX+(J-1)*LVTVZ+5).ge.12) THEN
              nclass12 = nclass12 + 1
              if (qint(j).gt.qmax) then
               zvert = RW(SDINDX+(J-1)*LVTVZ+6)
               qmax = qint(j)
              endif
            ENDIF
         enddo
      endif
C     JWB 7/5/97


              RETURN
              END   
