C CMS REPLACEMENT HISTORY, Element GETCPRWEIGHT.CDF
C *3     9-JAN-1996 03:16:04 KUHLMANN "undefined variables"
C *2    10-MAR-1995 12:05:19 KUHLMANN "nphobac limit"
C *1    14-JUL-1994 12:31:13 KUHLMANN "duh"
C CMS REPLACEMENT HISTORY, Element GETCPRWEIGHT.CDF
C===================================================================
	Subroutine GetCprweight(Cprph,Pt,Sth,Phoeff,Baceff,Nphobac,
     +             Cprweight,Cprsys1,Cprsys2,Cprsys3,Cprsys4)
C===================================================================
$$IMPLICIT NONE	
	Real Cprph,Pt,Sth,Phoeff,Baceff,Cprcut,Epho,Backprob
	Data Cprcut/500./
        Real Cprweight,Cprsys1,Cprsys2,Pef2,Bef2
        Real Cprsys3,Cprsys4
	Real Truepp,Qprsgg,Ratpp,ExpPP/1.4564199/
	Real Mat/1.0748/
	Real Crack/.9812/,Chimney/.9896/,Dead/.9941/,Ue/.961/
	Real Allded/.96527/
        Real Nphobac,NphoA/.66641/,NphoB/.12889/,NphoC/-.48781E-2/
        Real NphoD/.95325E-4/,NphoE/-.97846E-6/,NphoF/.50027E-8/
        Real NphoG/-.10038E-10/
        Real Nphobac2
        Save Cprcut,ExpPP,Mat,Crack,Chimney,Dead,Ue,Allded
        Save Nphoa,Nphob,Nphoc,Nphod,NphoE,NphoF,NphoG,Epho,Backprob

c  Get photon efficiency:::
	  Epho = Pt/Sth
	  TruePP = Qprsgg(13.,Epho)
	  RatPP = TruePP/ExpPP
	  Phoeff = 1. - exp((-7.*Mat*RatPP)/(9.*Sth))
c  get background efficiency:::
          Nphobac = NphoA + NphoB*Pt + NphoC*Pt**2 + NphoD*Pt**3
     +              + NphoE*Pt**4 + NphoF*Pt**5 + NphoG*Pt**6
	  If(Pt.gt.125.) Nphobac = 2.24
	  Baceff = (1. - exp((-7.*Mat*Nphobac)/(9.*Sth)))

C Correct Photon and Background Effs for Cracks/UE
	Phoeff = (1. - ((1.-Phoeff)*Ue))*Allded
	Baceff = (1. - ((1.-Baceff)*Ue))*Allded

C Correct for Backscattered Showers
        Backprob = 7.4E-4*Pt/sth
	Phoeff = ((1. - Phoeff)*Backprob) + Phoeff
	Baceff = ((1. - Baceff)*Backprob) + Baceff

C   CPR	Photon weight
	If( Cprph .gt. Cprcut)Then
	    Cprweight =  (1. - BacEff)/(PhoEFF - BacEff)
	Else 
	    Cprweight = - BacEff/(PhoEFF - BacEff)
	End If

C Sys for Hit Rate Error
        Pef2 = Phoeff + .0078
        Bef2 = Baceff + .006
C   CPR	Photon weight
	If( Cprph .gt. Cprcut)Then
	    Cprsys1 =  (1. - Bef2)/(Pef2 - Bef2)
	Else 
	    Cprsys1 = - Bef2/(Pef2 - Bef2)
	End If

C Systematic for Backscattered Showers
        Backprob = -7.4E-4*Pt/sth
	Pef2 = ((1. - Phoeff)*Backprob) + Phoeff
	Bef2 = ((1. - Baceff)*Backprob) + Baceff

C   CPR	Photon weight
	If( Cprph .gt. Cprcut)Then
	    Cprsys2 =  (1. - Bef2)/(Pef2 - Bef2)
	Else 
	    Cprsys2 = - Bef2/(Pef2 - Bef2)
	End If


C Systematic #3 for eta/pi0 and ksh/pi0 and else
	Bef2 = Baceff - 0.008

C   CPR	Photon weight
	If( Cprph .gt. Cprcut)Then
	    Cprsys3 =  (1. - Bef2)/(Phoeff - Bef2)
	Else 
	    Cprsys3 = - Bef2/(Phoeff - Bef2)
	End If

C Systematic #4 for eta/pi0 and ksh/pi0 and else
	Bef2 = Baceff + 0.008

C   CPR	Photon weight
	If( Cprph .gt. Cprcut)Then
	    Cprsys4 =  (1. - Bef2)/(Phoeff - Bef2)
	Else 
	    Cprsys4 = - Bef2/(Phoeff - Bef2)
	End If

	Return
	End
C.    ******************************************************************
      Real Function QPRSGG(Z,E)
C.    ******************************************************************
C.
C.    ******************************************************************
C.    *                                                                *
C.    *  To calculate cross-section for e+e- production                *
C.    *  by photons (in barn/atom)                                     *
C.    *                                                                *
C.    *    ==>Called by : CASCAD                                       *
C.    *       Author    R.Blair rewritten to use Tsai cross sections   *
C.    *   $Revision: 1.1 $                                             *
C.    *                                                                *
C.    ******************************************************************
C.
      REAL    SIG,E,EMASS,Z,rad,xx
      parameter (rad=1.0093)
      INTEGER J,jz,je
      real xpl,xmn,sigpl,sigmn,edif,zdif,siginf
      real tsaidel(9,14),tsaiz(14),tsaisig(14),tsaie(9)
      save tsaidel,tsaiz,tsaisig,tsaie
c The tables below are basically a transcription of table III.5
c    in Rev. Mod. Phys., Vol. 46, No. 4 p815 (Oct. 1974)
c    which summarize the pair production cross section
c    The article was written by Yung-Su Tsai.
       data tsaidel/
     & 0.011,0.028,0.039,0.079,0.126,0.174,0.222,0.323,0.441
     &,0.012,0.023,0.030,0.058,0.091,0.128,0.166,0.253,0.367
     &,0.004,0.024,0.034,0.073,0.113,0.154,0.195,0.283,0.391
     &,0.003,0.020,0.029,0.064,0.101,0.139,0.178,0.263,0.370
     &,0.002,0.016,0.023,0.053,0.087,0.122,0.158,0.238,0.343
     &,0.002,0.015,0.022,0.050,0.082,0.116,0.151,0.230,0.334
     &,0.002,0.012,0.019,0.044,0.073,0.105,0.137,0.213,0.315
     &,0.002,0.011,0.017,0.040,0.068,0.098,0.129,0.202,0.302
     &,0.001,0.009,0.014,0.033,0.057,0.084,0.112,0.180,0.275
     &,0.001,0.009,0.013,0.032,0.056,0.082,0.110,0.177,0.272
     &,0.001,0.008,0.012,0.029,0.051,0.075,0.102,0.166,0.259
     &,0.001,0.007,0.011,0.028,0.049,0.073,0.099,0.162,0.256
     &,0.001,0.007,0.011,0.028,0.049,0.072,0.098,0.162,0.257
     &,0.001,0.007,0.011,0.028,0.048,0.072,0.098,0.162,0.258/
       data tsaiz/ 1, 2, 3, 4, 6, 7,10,13,26,29,50,74,82,92/
       data tsaisig/20.73,55.06,108.8,179.4,361.5,473.8,896.1,
     &  1443.,5182.,6343.,17276,34869,41720,50870/
       data tsaie/100.,10.,6.,2.,1.,0.6,0.4,0.2,0.1/
       parameter (emass=.000511)
c================================================= 

      SIG=0.
      QPRSGG=SIG
      IF(E.LE.2.*EMASS)return
c find the closest energies and Zs that the Tsai tble has to offer
      je=10
      do 100 j=9,1,-1
         if( e .lt. tsaie(j)) go to 101
         je=j
100   continue
      je=1
101   continue
c don't go past the end of the table
c on the low end (at the high end we have infinity)
      zdif=1.0e10
      do 200 j=1,14
         if( abs(tsaiz(j)-z) .lt. abs(zdif) ) then
            zdif=z-tsaiz(j)
            jz=j
         endif
200   continue
c Z<1 HUH?
      if( jz .lt. 2 .and. z .lt. tsaiz(1) ) jz=2
c Z>92 well maybe.
      if( jz .gt. 13 .and. z .gt. tsaiz(14) ) jz=13
c interpolate z if needed
      if( zdif .gt. .99 ) then
         siginf=tsaisig(jz)+(z**2-tsaiz(jz)**2)*(tsaisig(jz+1)-
     &    tsaisig(jz))/(tsaiz(jz+1)**2-tsaiz(jz)**2)
      elseif( zdif .lt. -.99 ) then
         siginf=tsaisig(jz)+(z**2-tsaiz(jz)**2)*(tsaisig(jz-1)-
     &    tsaisig(jz))/(tsaiz(jz-1)**2-tsaiz(jz)**2)
      else
         siginf=tsaisig(jz)
      endif
c interpolate in 1/log(e)  (at low energy vs. log(e))
      if(je .eq. 10 ) then
c at the low end interpolate between threshold and the first point
         sigpl=tsaidel(9,jz)
         sigmn=1.
         xpl=alog(tsaie(9)/emass)
         xmn=alog(2.)
         xx=alog(e/emass)
      elseif( je .eq. 1 ) then
c in the high energy end interpolate to infinity via 1/log(e)
         sigpl=0.
         sigmn=tsaidel(1,jz)
         xmn=1./alog(tsaie(1)/emass)
         xpl=0.
         xx=1./alog(e/emass)
      else
         sigpl=tsaidel(je-1,jz)
         sigmn=tsaidel(je,jz)
         xmn=1./alog(tsaie(je)/emass)
         xpl=1./alog(tsaie(je-1)/emass)
         xx=1./alog(e/emass)
      endif
c calculate adjustment to value at infinity
      sig=sigmn+(xx-xmn)*(sigpl-sigmn)/(xpl-xmn)
c include cross section at infinity and radiative correction (rad)
      sig=(1.-sig)*siginf*rad
      QPRSGG=SIG/1000.
      END
