C  DEC/CMS REPLACEMENT HISTORY, Element GTCLSL.CDF
C  *1    19-JUN-1991 19:11:00 FLAVIA "Generalized CLSL fetching routine"
C  DEC/CMS REPLACEMENT HISTORY, Element GTCLSL.CDF
      SUBROUTINE GTCLSL_NEW(NMAX,NAME,PARNAM,PARNUM,NCLST,JCLST)
C
C    This routine returns a list of cluster bank
C    number (CALS and ELES bank numbers) for
C    EM clusters or JETS clusters
C
C    INPUT:
C           NMAX       Size of JCLST array.
C           NAME       Name of the clustering algorithm (eg. "ETHAT CLUSTERING")
C	    PARNAM     Name of parameter bank (eg. $CLP)
C	    PARNUM     Parameter bank number
C
C    OUTPUT:
C           NCLST        Number of clusters (Maximum NMAX)
C           JCLST(J)     CALS bank number of Jth cluster
C
C    Craig Blocker                       July 1, 1988
C    Dave Gerdes  12/12/91 -- add argument PARNUM so user can specify
C                             parameter bank number
C
$$IMPLICIT
C
C    Argument declarations.
      INTEGER NMAX,NCLST,JCLST(NMAX),PARNUM
C
C    Global declarations.
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:DSCLSL.INC'
$$INCLUDE 'C$INC:ELCOMM.INC'
C
C    Local declarations.
      INTEGER STATUS,JNEXT,JCL,JCLSL,JDCLSL
C
C    External declarations.
      INTEGER BLOCAT,BNEXT,BCHINT,BDATA
	CHARACTER*16 NAME
	CHARACTER*4 PARNAM
C
C
C    Initialize number of clusters to 0.
C
      NCLST=0
C
C    Locate first CLSL bank.
C
      STATUS=BLOCAT(IW,'CLSL',-1,JCLSL,JDCLSL)
      IF(STATUS.NE.YESUCC) RETURN
C
C    Top of loop over CLSL banks.
C
  100 CONTINUE
C
C        Check algorithm name.
C
          IF(IW(JDCLSL+ALNASL).NE.BCHINT(NAME(1:4))) GO TO 500
          IF(IW(JDCLSL+ALNASL+1).NE.BCHINT(NAME(5:8))) GO TO 500
          IF(IW(JDCLSL+ALNASL+2).NE.BCHINT(NAME(9:12))) GO TO 500
          IF(IW(JDCLSL+ALNASL+3).NE.BCHINT(NAME(13:16))) GO TO 500
C
C        Check parameter bank name.
C
          IF(IW(JDCLSL+PANASL).NE.BCHINT(PARNAM)) GO TO 500
C
C    *** NEW *** Check parameter bank number:
C
	  IF(IW(JDCLSL+PANUSL).NE.PARNUM) GO TO 500
C
C        We have a match, so fill in list.
C
          NCLST=MIN(NMAX,IW(JDCLSL+NOCLSL))
          IF(NCLST.GT.0) THEN
             DO 300 JCL=1,NCLST
                 JCLST(JCL)=IW(JDCLSL+CALSSL+JCL-1)
  300        CONTINUE
          ENDIF
          RETURN
C
C    Get next CLSL bank.
C
  500 CONTINUE
      STATUS=BNEXT(IW,JCLSL,JNEXT)
      IF(JNEXT.NE.0) THEN
          JCLSL=JNEXT
          STATUS=BDATA(IW,JCLSL,JDCLSL)
          GO TO 100
      ENDIF
C
      RETURN
      END
