C
	SUBROUTINE ISO_CORRECT(XCES,NVERT,LEAK_CORRECT,VTX_CORRECT)
C
C   Correction for Isolation based on predicted shower leakage
C
C   This should be subtracted from the isolation energy to correct for
C   leakage into the adjacent wedge.
C   
C   Parameterization of shower leakage between wedges from testbeam data.
C   See Blue book pages 178-182 or NIM A267 (1988) 315-329.
C   z dependent effects are ignored.
C
C   Correction for Isolation for number of vertices
C
C  Inputs:
	REAL ET				! Corrected EM shower ET
	REAL XCES			! Local position of cluster from CES 
	INTEGER NVERT 			! Number of Vertices in the event
C  Outputs:
	REAL LEAK_CORRECT
	REAL VTX_CORRECT
C
C  Vertex correction from fit to W-> enu data (Run 1B) 11/11/97
	REAL VTX_ZERO, VTX_SLOPE	! N vertex fit
	REAL X
	PARAMETER(VTX_ZERO=0.3784)
	PARAMETER(VTX_SLOPE1=0.2325)
	PARAMETER(VTX_SLOPE2=0.0853)
C  Leakage correction factor
	REAL P10, P11			! Paramters from Blue Book
C  Blue book values
C	PARAMETER(P10=0.000896)
C	PARAMETER(P11=0.384)
C  From fit to z->ee data (Run 1B) 10/13/97
	PARAMETER(P10=0.000280)
	PARAMETER(P11=0.407)
C
C   Shower leakage correction
	LEAK_CORRECT = 1/(1+P10*EXP(P11*(48.4-ABS(XCES))))
C
C   Multiple vertex correction
	VTX_CORRECT = 0.0
	IF (NVERT.GT.1) THEN
	  X = FLOAT(MIN(NVERT,10))
 	  IF (NVERT.LE.5) THEN
	    VTX_CORRECT = VTX_SLOPE1 * (X-1)
	  ELSE
	    VTX_CORRECT = 4.5*VTX_SLOPE1 + (X-5.5)*VTX_SLOPE2 
	  ENDIF
	ENDIF
C	
	RETURN
	END
