       subroutine jet_vtx(z_jet,dz_jet,pt_out)
C
c
c     calculate mean z0 from tracks associated with jets
c        assumes jetinfo already called
c
C	Author - Carla Gross-Pilcher 1996
C
C
       implicit none
$$include 'c$inc:jobsta.inc'
$$include 'c$inc:bcs.inc'
$$include 'c$inc:jetinfo.inc'
$$include 'c$inc:trksco.inc'
$$include 'c$inc:dsfitp.inc'
c
       integer qtrkun
       integer ierr
       integer nst,nax
       integer ij,j,i,ii,k,n_track,nqtrk,n_track1
       real z_jet(20),dz_jet(20),pt_out(20)
       real pt,pt_trk,z2
       real phitr,dphi,tr_eta
       real cdfphi,prapid
       real parin(5),xyz(6),dxyz(6)
       real zt(100),pt_t(100),zbest,dz
       real eta_cut/2./
       real et1_cut/10./
       real pt_min/.5/


       nqtrk = qtrkun(0,1)
*       print *,nev,nrun,' ntrk ',nqtrk,' ncls ',iclus

       do ij = 1,min(20,iclus)
           z_jet(ij) = -999.
           pt_out(ij) = 0.
           z_jet(ij) = 0.
           pt_trk = 0.
           n_track = 0
c                          unpack qtrk...
           do j=1,nqtrk
            ierr = qtrkun(j,1)
C find tracks that match the jet
C Loop over layers, require 2 axial and 2 stereo superlayers
            If (Ierr .eq. 0) then
               Nst = 0
               Do I = 1, 7, 2
                  If (Ctnhqt(I) .ge. 2) Nst = Nst + 1
               Enddo
               Nax = 0
               Do I = 0, 8, 2
                  If (Ctnhqt(I) .ge. 4) Nax = Nax + 1
               Enddo
               If ((Nax .ge. 2) .and. (Nst .ge. 2)) then
                pt = sqrt(trksp4(1)**2+trksp4(2)**2)
                if(pt.gt.0.5) then 
                 phitr = cdfphi(atan2(trksp4(2),trksp4(1)))
                 dphi =phitr-ijet_phi(ij)
                 if(abs(dphi).gt.3.14) dphi = 6.28-abs(dphi)
                 if(sqrt(dphi**2+
     *            (trksp4(6)-ijet_deta(ij))**2).lt.0.4) then
C
                  n_track = n_track + 1
                  pt_t(n_track) = pt
                  zt(n_track) = trksfp(z0fp)
                  pt_trk = pt_trk+pt
                  z_jet(ij) = z_jet(ij) + trksfp(z0fp)*pt
*                  z2 = z2+trksfp(z0fp)**2
                 Endif              ! cone cut
                Endif               ! pt cut
               Endif                ! nlayers cut
              Endif                  ! ierr=0
            enddo                   ! end loop over tracks
            if(pt_trk.gt.2.) then
             z_jet(ij) = z_jet(ij)/pt_trk
             dz_jet(ij)=0.
             if(n_track.gt.1) then
               do k =1,n_track
                dz_jet(ij) = dz_jet(ij)+(zt(k)-z_jet(ij))**2
               enddo
             endif
             if(dz_jet(ij).gt.0.) 
     *                  dz_jet(ij) = sqrt(dz_jet(ij)/n_track)
c
c    if tracks come from probabily more then 1 vtx, try again
c
             if(dz_jet(ij).gt.5.) then
               zbest = z_jet(ij)
               z_jet(ij) = 0.
*               z2 = 0.
               pt_trk = 0.
               n_track1 = 0
               dz = dz_jet(ij) 
               do ii = 1, n_track
                if(abs(zbest-zt(ii)).lt.dz_jet(ij)) then 
                  n_track1 = n_track1 + 1
                  pt_trk = pt_trk+pt_t(ii)
                  z_jet(ij) = z_jet(ij) + zt(ii)*pt_t(ii)
*                  z2 = z2+zt(ii)**2
                 else
                   pt_out(ij) = pt_out(ij)+pt_t(ii)
                 endif
                enddo
                  if(pt_trk.gt.2.) then
                   z_jet(ij) = z_jet(ij)/pt_trk
*                   dz_jet(ij) = (z2/n_track1-z_jet(ij)**2)
                   dz_jet(ij)=0.
                   if(n_track1.gt.1) then
                    do k =1,n_track
                     if(abs(zbest-zt(k)).lt.dz)
     *               dz_jet(ij) = dz_jet(ij)+(zt(k)-z_jet(ij))**2
                    enddo
                    if(dz_jet(ij).gt.0.)
     *                  dz_jet(ij) = sqrt(dz_jet(ij)/n_track1)
                   endif
                  else
                     z_jet(ij) = -999.
                     dz_jet(ij) = -999.
                 endif
               endif
         else
            z_jet(ij) = -999.
            dz_jet(ij) = -999.
         endif                   ! pt_trk cut
*        print *,ij,ijet_et(ij),n_track,pt_trk,z_jet(ij)
       enddo                     ! end loop over clusters
       return
       end
