C DEC/CMS REPLACEMENT HISTORY, Element JETINFO.CDF
C *6    26-APR-1995 02:35:19 UNAL "use correct jetc90s version"
C *5    11-APR-1995 11:32:54 UNAL "corrected cone_size definition"
C *4    28-MAR-1995 01:10:09 UNAL "new version for TOPFND"
C *3    15-DEC-1993 11:52:10 UNAL "Add unpacking of Jet Moments"
C *2     4-NOV-1993 17:53:55 UNAL "updated for new Jetvtx version"
C *1    28-FEB-1993 09:07:34 PEKKA "Fetches JET info for JETVTX module."
C DEC/CMS REPLACEMENT HISTORY, Element JETINFO.CDF
C======================================================================
C  File:  JETINFO.CDF
C======================================================================
C
C===Description: This module fills a common block (JETINFO.INC) with
c                various parameters for JETS.  
C
C===Author:
c
c       Brian Winer, 1-Sep-1992        Original Version
c       Brian Winer, 1-Nov-1994        Modified. Drop unused information
c                                      and added information about jet
c                                      corrections.
c	Alexis Amadon, Aug-1996        UC Version. 
c				       Modified. Provide for 96 corrections.
c	Peter J. Wilson, 8-Nov-1996    Modified. Reorganize different
c				       corrections.  Add MY_JETINFO.INC
c				       to allow choice of corrections and add 
c				       more variables.
C
C======================================================================

C==============================
      SUBROUTINE JETINFO(CPNUM)
C==============================
C
C
$$IMPLICIT
      SAVE    !FOR ACP
C
C===Global Declarations:
C
$$INCLUDE 'A_C$LIBRARY:ANCOMP_EXP_ID.INC'
$$INCLUDE 'C$INC:ANACTL.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:DSJETS.INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
$$INCLUDE 'C$INC:BTMASK.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'UIPACK$LIBRARY:UIPARAM.INC'
$$INCLUDE 'UIPACK$LIBRARY:UIERROR.INC'
$$INCLUDE 'C$INC:JETINFO.INC'
$$INCLUDE 'stntuple$source:MY_JETINFO.INC'
$$INCLUDE 'c$inc:ELEINFO.INC'
$$INCLUDE 'UC$ANA:TRAKCM.INC'

c Local Jet variables.
c -------------------
      INTEGER NMCLSL,INDCLS,INDWBK,IDJET,INDBNK
      INTEGER NCLUS,CPNUM,JETBNK(20)
      REAL CONE_SIZE
      INTEGER DATA_TYPE
      REAL TINY/0.0001/,COS_TH,MAX_CTH

c Local general Variables
c -----------------------
      INTEGER I,J,STATUS
      INTEGER NB,INDVERT
C    other variables 
      REAL THETA,ETA,DIST,PMAX,DPHI

C External Functions
c ------------------
      INTEGER BLOCAT,JTC90S,JTC96S,BCOPY,BDROP

C Include Files for JETS stuff
c ----------------------------

$$INCLUDE 'C$INC:DSjetssf.inc'

C Initialize Variables
c --------------------
      ICLUS = 0
      CALL VZERO(IJET_ET,20)
      CALL VZERO(IJET_M,20)
      CALL VZERO(IJET_P,80)
      CALL VZERO(IJET_EMF,20)
      CALL VZERO(IJET_DETA,20)
      CALL VZERO(IJET_ETA,20)
      CALL VZERO(IJET_PHI,20)
      CALL VZERO(IDLTR,20)
      CALL VZERO(IJETCHF,20)
      CALL VZERO(IJET_EEM,20)
      CALL VZERO(IJET_PPM,20)
      CALL VZERO(IJET_EPM,20)
      CALL VZERO(JCORF,40)
      CALL VZERO(IJET_NTR,20)
      CALL VZERO(IJET_EP,20)
      call vzero(ijet_egrd,20)
      DO I=1,20
         IJET_GOOD(I)=.FALSE.
      ENDDO
    
C Determine the type of data we are looking at (data or Monte Carlo)
c ------------------------------------------------------------------
      IF (LMONTE) THEN
        DATA_TYPE=4
      ELSEIF(EXPTYP.EQ.RUN1A) THEN
        DATA_TYPE=5
      ELSEIF(EXPTYP.EQ.RUN1B.and.cor_version.eq.0) THEN
        DATA_TYPE=6
      ELSEIF(EXPTYP.EQ.RUN1B.and.cor_version.eq.1) THEN
        DATA_TYPE=7
      ENDIF  
      CONE_SIZE = 0.4 
      IF(CPNUM.EQ.1) CONE_SIZE = 0.7
      IF(CPNUM.EQ.3) CONE_SIZE = 1.0
   
C Get the Jet Quantities in the Event 
c ===================================
      CALL QIGTCL(CPNUM,'ETHAT CLUSTERING',20,NCLUS,JETBNK)
      IF(NCLUS.LE.0) GOTO 200

C Get track variables from TRAKCM.INC
      CALL UNPTRK(1)
C Loop over the number of clusters and find the number over threshold
C --------------------------------------------------------------------
      DO I=1,NCLUS

C Locate the bank
C ---------------
        STATUS = BLOCAT(IW,'JETS',JETBNK(I),INDBNK,IDJET)
        IF (STATUS.NE.YESUCC)THEN
          CALL ERLOGR('JETINFO',ERWARN,0,STATUS,
     &     'Unable to locate JETS bank when CLSL says it is there')
          GO TO 250
        ENDIF

C Make a minimum Et cut
c ---------------------
	IF ((ET_JT(IDJET) .GE. 0.01).AND.(ICLUS.LT.20)) THEN
	  ICLUS = ICLUS + 1    

c Fill Variables for Jet quantities
c ---------------------------------
          IJET_ET(ICLUS)  = ET_JT(IDJET)
          IJET_P(1,ICLUS) = PX_JT(IDJET)
          IJET_P(2,ICLUS) = PY_JT(IDJET)
          IJET_P(3,ICLUS) = PZ_JT(IDJET)
          IJET_P(4,ICLUS) = E__JT(IDJET)
          IJET_EMF(ICLUS) = EMFRJT(IDJET) 
          IJET_DETA(ICLUS)= DETAJT(IDJET)
          IJET_ETA(ICLUS) = ETA_JT(IDJET) 
          IJET_PHI(ICLUS) = PHI_JT(IDJET) 
          IJET_M(ICLUS)   = MASSJT(IDJET)
	  IJETBNK(ICLUS)  = JETBNK(I)
          IDLTR(ICLUS) = SQRT(EEMoJT(IDJET)**2 
     &                        + PPMoJT(IDJET)**2)
          IJETTRK(ICLUS)  = NTRKJT(IDJET)
          IJETCHF(ICLUS)  = CHFRJT(IDJET)
          IJET_EEM(ICLUS) = EEMOJT(IDJET)
          IJET_PPM(ICLUS) = PPMOJT(IDJET)
          IJET_EPM(ICLUS) = EPMOJT(IDJET)
          IJET_NTR(ICLUS) = NTRKJT(IDJET)
          ijet_egrd(iclus) = EgrdJt(idjet)

c Make a work Bank to hold Corrected Jet Energies
c -----------------------------------------------
          STATUS = BCOPY(IW,'JETS',JETBNK(I),'WORK',1,INDBNK,INDWBK)
          IF (STATUS.NE.YESUCC)THEN
            CALL ERLOGR('JETINFO',ERWARN,0,STATUS,
     &       'JETINFO unable to make work bank...NO JET CORRECTION')
             GOTO 250
          ENDIF
          
c Get the correction factors for the jets (first just the relative correction)
c ----------------------------------------------------------------------------
	  STATUS = 1
	  IF (COR_VERSION .EQ. 0) THEN
            STATUS = JTC90S(IDJET,INDWBK,CONE_SIZE,'NN','DD',DATA_TYPE)
	  ELSEIF (COR_VERSION .EQ. 1) THEN
            STATUS = JTC96S(IDJET,INDWBK,CONE_SIZE,'NN','DD',DATA_TYPE)
          ENDIF
	
          IF(STATUS.EQ.0) THEN
             JCORF(ICLUS,1) = E__JT(INDWBK)/E__JT(IDJET)  
          ELSE
             JCORF(ICLUS,1) = -1.
          ENDIF

C Get the correction factors using the full correction
c ----------------------------------------------------
	  STATUS = 1
	  IF (COR_VERSION .EQ. 0) THEN
            STATUS = JTC90S(IDJET,INDWBK,CONE_SIZE,'YY','DD',DATA_TYPE)
	  ELSEIF (COR_VERSION .EQ. 1) THEN
            STATUS = JTC96S(IDJET,INDWBK,CONE_SIZE,'EY','DD',DATA_TYPE)
          ENDIF
                  
          IF(STATUS.EQ.0) THEN
             JCORF(ICLUS,2) = E__JT(INDWBK)/E__JT(IDJET)  
          ELSE
             JCORF(ICLUS,2) = -1.
          ENDIF

          STATUS = BDROP(IW,'WORK') 

	ENDIF
250   ENDDO

C If cone size = 0.4 (CPNUM=2) we must do the electron-jet association
c --------------------------------------------------------------------
      DO I=1,NUMELES
         IF(CPNUM.NE.1.OR.JTS_ELE(I).EQ.0) THEN

             JTS_ELE(I) = 0
             MAX_CTH = -999.
             DO J=1,ICLUS
                IF(P4E_ELE(4,I)*SQRT(IJET_P(1,J)**2+IJET_P(2,J)**2+
     &                               IJET_P(3,J)**2).GT.TINY) THEN
                   COS_TH = (IJET_P(1,J)*P4E_ELE(1,I)+IJET_P(2,J)*
     &                      P4E_ELE(2,I)+IJET_P(3,J)*P4E_ELE(3,I))/
     &                      (P4E_ELE(4,I)*SQRT(IJET_P(1,J)**2+
     &                      IJET_P(2,J)**2+IJET_P(3,J)**2))
                ENDIF
                IF(COS_TH.GT.MAX_CTH.AND.
     &             IJET_ET(J).GT.0.50*ET_ELE(I)) THEN
                      MAX_CTH = COS_TH
                      JTS_ELE(I) = IJETBNK(J)
                ENDIF
             ENDDO
         ENDIF  !Different Clustering or Jet not found
      ENDDO
C            
C  find the highest p track inside a cone of 0.4
C    
      DO I = 1,ICLUS
        PMAX = 0.0
        DO J = 1,N_TRACK
          IF (CTANTR(J) .NE. 0.0) THEN
            THETA = ATAN(1/CTANTR(J))      ! Theta of track
          ELSE
            THETA = PI / 2.0
          ENDIF
          IF (THETA.LT.0.) THETA = THETA + PI
          ETA = -LOG(TAN(THETA/2.))      ! Eta track
          DPHI = ABS(IJET_PHI(I)-PHITR(J))
          IF (DPHI .GT. PI) DPHI = TWOPI - DPHI
          DIST = SQRT( DPHI**2 +
     &      (IJET_DETA(I)-ETA)**2)   ! Distance in eta-phi space
c                                               !   of track from jet axis
          IF (DIST .LE. CONE_SIZE) THEN          ! Track belongs to jet
            IF (PTR(J).GT.PMAX) PMAX = PTR(J)
          ENDIF
        ENDDO  !N_TRACK
        IF (PMAX.GT.0.0.AND.IJET_P(4,I).GT.0.0) THEN
          IJET_EP(I) = IJET_P(4,I)/PMAX
        ELSE
          IJET_EP(I) = -999.0
        ENDIF
      ENDDO  !ICLUS

200   CONTINUE
      RETURN
      END
