
          real function jwb_zvertex()

$$IMPLICIT NONE
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'YBOS$LIBRARY:BNKTYP.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:DSEVTA.INC'
$$INCLUDE 'C$INC:DSCMPB.INC'
$$INCLUDE 'C$INC:DSVTXS.INC'
$$INCLUDE 'C$INC:VTCAUX.INC'
$$INCLUDE 'C$INC:VXPVIN.INC'
$$INCLUDE 'STNTUPLE$SOURCE:stntuple_talk.inc'

      integer nvtx,bnknum,sindx,sdindx,istat,j
      integer inddat,ind,blkind,verind,stat
      real xseed(20,3),cvseed(20,6),qint(20),dz0cut,qmax
      logical blinfo                                                                          
      real default_zvertex,lepton_zvertex,vtxs_zvertex,
     &     old_zvertex
C external functions
      real zlepvtx,evtx_zvertex
      integer blocat

      jwb_zvertex = 0.0
      default_zvertex = 0.0
      lepton_zvertex = -999.0
      vtxs_zvertex = -999.0
      old_zvertex = -999.0

C     first make high sumpt vertex
      if (vertexing.eq.1.or.vertexing.eq.2) then
C
C---Locate the bank in YBOS:
      bnknum = 1
      istat = blocat(iw,'VTVZ',bnknum,sindx,sdindx)
      if (istat.ne.yesucc) then
         CALL ERLOGR('jwb_qdseta',EREROR,0,0,
     &               'unable to find VTVZ bank')
      else
         dz0cut = zmatch
         call jwb_vxpest(xseed,cvseed,nvtx,blinfo,qint,dz0cut)
         qmax = -1.0
C find class 12 with the highest track pt
         do j = 1,nvtx
              IF (IW(SDINDX+1).GE.J.and.
     &          IW(SDINDX+(J-1)*LVTVZ+5).ge.12) THEN
              if (qint(j).gt.qmax) then
               default_zvertex = RW(SDINDX+(J-1)*LVTVZ+6)
               qmax = qint(j)
              endif
              endif
         enddo
C if no class12, find class11 with the highest track pt
         if (default_zvertex.eq.-999.0) then
         do j = 1,nvtx
              IF (IW(SDINDX+1).GE.J.and.
     &          IW(SDINDX+(J-1)*LVTVZ+5).ge.11) THEN
              if (qint(j).gt.qmax) then
               default_zvertex = RW(SDINDX+(J-1)*LVTVZ+6)
               qmax = qint(j)
              endif
              endif
         enddo
         endif
      endif
      jwb_zvertex = default_zvertex

C     add in 'leptocentric' option for vertexing
      if (vertexing.eq.2) then
        lepton_zvertex = zlepvtx()
        if (lepton_zvertex.lt.-900.0) then
          jwb_zvertex = default_zvertex
        else
          jwb_zvertex = lepton_zvertex
        endif        
      endif
  
      endif

C     add in VXPRIM option for vertexing (from VTXS bank)
      if (vertexing.eq.3) then

C             ---Locate the bank in YBOS:

              istat = BLOCAT(IW,'VTXS',1,IND,INDDAT)
              if (istat.ne.yesucc) then
                 CALL ERLOGR('jwb_zvertex',ERINFO,0,istat,
     1           'Unable to locate VXPRIM info in bank VTXS')
C             default to EVTX if VTXS is unavailable
                vtxs_zvertex = evtx_zvertex()
              else
C               shift past DAIS header in VTXS to 1st version header
                verind = INDDAT + dhsvxs
C               shift past 1st version header to 1st data block
                blkind = verind + vhsvxs
C               zvert has the offset z0vx relative to the beginning of the 1st data block
                vtxs_zvertex = rw(blkind+z0vx)
              endif
        jwb_zvertex = vtxs_zvertex
      endif
      
C     old-fashioned method used during production...
      if (vertexing.eq.0) then
         old_zvertex = evtx_zvertex()
         jwb_zvertex = old_zvertex         
      endif

      return
      end

***************************************************************************

      real function zlepvtx()

c     Locates the lepton with highest status among the ELES and CMUO banks.
c     Returns the z of its vertex.
c
C Implicit none declaration:
      IMPLICIT NONE
C
C Production variables...
C
$$INCLUDE 'C$INC:ELEINFO.INC'            ! ELES banks
$$include 'c$inc:muoinfo.inc'            ! CMUO banks
$$include 'stntuple$source:stntuple.inc'
$$INCLUDE 'C$INC:EVTINFO.INC'            ! cuts on leptons for dilep,lep+jets

      INTEGER J,K,bestele,bestmu
      INTEGER BLOCAT,INDBNK,INDELE,istat
      INTEGER ind,inddat,nel,nmu
      real corfac(10),helim,maxstatel,maxstatmu
      integer cem_ele,cmu_muon
      real ezlepvtx,muzlepvtx
      DATA CEM_ELE /'3FF'X/
      DATA CMU_MUON /'DFE'X/

C   First clear out all old values...
C
        CALL VZERO(STAT_ELES,MAXELES)
        CALL VZERO(STAT_CMUO,MAXCMUO)
C        CALL TOPFND(.TRUE.,.TRUE.,.TRUE.)
        CALL MUOVAL(.TRUE.)
        CALL ELEVAL(.TRUE.)
        CALL MY_ELEINFO
                                                
C loop over ELES banks and compute their status

        nel = MIN(MAXELES,NUMELES)
        DO J = 1,nel
           CALL GET_CORFAC(BNK_ELE(J),CORFAC(J))
           IF (DET_ELE(J).EQ.0.AND.ET_ELE(J)/CORFAC(J).GT.10.0)
     &         STAT_ELES(J) = 2000.0 + ET_ELE(J)/CORFAC(J)

C  satisfying loose R paper cuts gets 3000...

             IF (DET_ELE(J) .EQ. 0) THEN
               IF (ET_ELE(J)/CORFAC(J).GT.20.0) THEN
                 IF (CON_ELE(J).EQ.0) THEN
                   IF (EP_ELE(J).LE.2.0) THEN
                     IF (HADEM_ELE(J).LE.0.1) THEN
C                      IF (ISOL_ELE(J) .LE. 0.1) THEN
                       IF (FID_ELE(J).EQ.0) THEN
                       STAT_ELES(J)=3000.0+ET_ELE(J)/CORFAC(J)
                       ENDIF
C                       ENDIF
                     ENDIF
                   ENDIF
                 ENDIF
               ENDIF
             ENDIF

C  loose central events get 5000....
             DO K = 1,MIN(MAXELES,NUM_LOOSE_E)
                IF (IND_LOOSE_E(K).EQ.J)
     &            STAT_ELES(J) =5000.0+ET_ELE(J)/CORFAC(J)
             ENDDO  !NUM_LOOSE_E
C   satisfying tight R paper cuts gets 6000....
          IF (DET_ELE(J) .EQ. 0) THEN
             HELIM=0.045+0.055*P4E_ELE(4,J)/CORFAC(J)/100.0
             IF (ET_ELE(J)/CORFAC(J) .GT. 20.0) THEN
               IF (EP_ELE(J) .LT. 2.0 .AND. EP_ELE(J) .GT. 0.5) THEN
                 IF (LSHR_ELE(J) .LE. 0.2) THEN
                   IF (CHIS_ELE(J) .LE. 10.0) THEN
                     IF (ABS(DELX_ELE(J)) .LE. 1.5) THEN
                       IF (ABS(DELZ_ELE(J)) .LE. 3.0) THEN
                         IF (ABS(ELEZV_ELE(J)) .LE. 60.0) THEN
                           IF (HADEM_ELE(J) .LE. HELIM) THEN
C                             IF (ISOL_ELE(J) .LE. 0.1) THEN
                               IF (FID_ELE(J).EQ.0) THEN
                                IF (CON_ELE(J).EQ.0) THEN
                       STAT_ELES(J)=6000.0+ET_ELE(J)/CORFAC(J)
                                ENDIF
                               ENDIF
C                             ENDIF
                           ENDIF
                         ENDIF
                       ENDIF
                     ENDIF
                   ENDIF
                 ENDIF
               ENDIF
             ENDIF
           ENDIF
                    


C   tight central nonfiducial get 7000....
           IF (DET_ELE(J).EQ.0) THEN
              IF (IAND(CEM_WRD(J),CEM_ELE).EQ.512)
     &           STAT_ELES(J)=7000.0+ET_ELE(J)/CORFAC(J)
           ENDIF  !DET_ELE
C    tight central fiducial get 8000....
           DO K = 1, MIN(MAXELES,NUM_HPTE)
              IF (IND_HPTE(K).EQ.J) THEN
                 STAT_ELES(J) = 8000.0 + ET_ELE(J)/CORFAC(J)
C     tight central fiducial isolated get 9000....
                 IF (IAND(CEM_ISO(IND_HPTE(K)),2).EQ.0)
     &           STAT_ELES(J) = 9000.0 + ET_ELE(J)/CORFAC(J)
              ENDIF !IND_HPTE
           ENDDO !NUM_HPTE   
        ENDDO !Nel



C   MUONS

        DO J = 1, MIN(15,NUMCMUO)
C      passes tight dilepton cuts except for fiducial cut gets 5000....
          IF (IAND(MUO_WRD(J),CMU_MUON).EQ.0)
     &      STAT_CMUO(J) = 5000.0 + PT_CMUO(J)
          IF (IAND(MUO_WRD(J),CMU_MUON).EQ.0.AND.PT_CMUO(J).GT.999.0)
     &      STAT_CMUO(J) = 5999.0
C      passes tight dilepton cuts gets 6000....
          DO K = 1, MIN(15,NUM_HPTM)
            IF (IND_HPTM(K).EQ.J) THEN
              STAT_CMUO(J) = 6000.0 + PT_CMUO(J)
              IF (PT_CMUO(J).GT.999.0) STAT_CMUO(J) = 6999.0
C      passes tight dilepton cuts + isolation cut gets 7000....
              IF (IAND(MUO_ISO(IND_HPTM(K)),2).EQ.0)
     &          STAT_CMUO(J) = 7000.0 + PT_CMUO(J)
              IF (IAND(MUO_ISO(IND_HPTM(K)),2).EQ.0
     &  .AND.PT_CMUO(J).GT.999.0) STAT_CMUO(J) = 7999.0
            ENDIF !IND_HPTM
          ENDDO !NUM_HPTM  
        ENDDO !NUMCMUO


        nmu = min(15,NUMCMUO)
  
C  If a TOPFND tight electron or muon is found, determine which one is the
C  best lepton (take higher pt)

        zlepvtx = -999.0
        ezlepvtx = -999.0
        muzlepvtx = -999.0
        if (nel.gt.0) then
          maxstatel = 0.0
          bestele = 1
          do j = 1,nel
            if (stat_eles(j).gt.maxstatel) then
              maxstatel = stat_eles(j)
              if (stat_eles(j).gt.3020.) then
                ezlepvtx = elezv_ele(j)
                bestele = j
              endif
            endif
          enddo
        endif
        if (nmu.gt.0) then
          maxstatmu = 0.0
          bestmu = 1
          do j = 1,nmu
            if (stat_cmuo(j).gt.maxstatmu) then
              maxstatmu = stat_cmuo(j)
              if (stat_cmuo(j).gt.5020.) then
                muzlepvtx = muzv_cmuo(j)
                bestmu = j
              endif
            endif
          enddo
        endif

C       choose between electron and muon vertices (highest pt wins)
        if (ezlepvtx.gt.-990.0) then
          zlepvtx = ezlepvtx
        endif
        if (muzlepvtx.gt.-990.0) then
          zlepvtx = muzlepvtx
        endif
        if (ezlepvtx.gt.-990.0.and.muzlepvtx.gt.-990.0) then
          if (pt_cmuo(bestmu).gt.
     &        et_ele(bestele)/corfac(bestele) ) then
            zlepvtx = muzlepvtx
          else
            zlepvtx = ezlepvtx
          endif
        endif

      return
      end

C*******************************************************************************

          real function evtx_zvertex()

$$IMPLICIT
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'YBOS$LIBRARY:BNKTYP.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:DSEVTA.INC'
$$INCLUDE 'C$INC:DSEVTX.INC'

          integer istat,ind,inddat
          integer blocat
C---Locate the bank in YBOS:
          istat = BLOCAT(IW,'EVTX',1,IND,INDDAT)
C
C---Report errors here:
          IF (istat.NE.YESUCC) THEN
             CALL ERLOGR('jwb_zvertex',ERINFO,0,istat,
     1       'Unable to locate EVTX bank')
             evtx_ZVERTEX = 0.0
          ELSE
             evtx_ZVERTEX = RW(INDDAT + Z0EVX)   ! event Z vertex
          ENDIF
          
          return 
          end 
