C======================================================================
      SUBROUTINE METJET
     &(NSKIP1,NSKIP2,ETCUT,ETACUT,METX,METY,METXP,METYP,PHIMET,
     & NJ,PARNUM)
C======================================================================
C
C===Description:
C
C
C	This routine corrects missing et for clustered energy using
C       QDJSCO.
C	
C	M.Contreras, Dec.  10, 1992
C
C 
C======================================================================
C
C
$$IMPLICIT 
C
C===Argument Decalarations:
C
C
C       Input
	INTEGER NSKIP1,NSKIP2	! JETS bank numbers to skip corrections
        REAL METX,METY		! initial MET values - uncorrected
	REAL ETCUT		! ET for jets above which we correct
	REAL ETACUT		! ETA for jets below which we correct

C       Output
        REAL METXP,METYP	! corrected MET values
C
C===Global Parameter Declarations:
C
$$INCLUDE 'A_C$LIBRARY:ANCOMP_EXP_ID.INC'
$$INCLUDE 'C$INC:ANACTL.INC'
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:BTMASK.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
C
C===Local Parameter Declarations:
C
$$INCLUDE 'C$INC:DSJETS.INC'
C
C===Global Variable Declartions:
C
$$INCLUDE 'C$INC:BCS   .INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
C
C===Local Variable Declarations:
C
	REAL ETX,ETY,ETXP,ETYP,PHIMET
	INTEGER KK
C
	CHARACTER*80 STRING
        INTEGER STATUS, INDBNK, INDDAT, ILOCAT
        INTEGER BNKNUM, SAVIND
C
	INTEGER IFIRST,INEXT
C
	INTEGER NMAX
	PARAMETER (NMAX=10)
	REAL ET_TEMP(NMAX),ETA_TEMP(NMAX),PHI_TEMP(NMAX)
	INTEGER I,ISORT(NMAX)
	INTEGER NCLST,JCLST(100)
	INTEGER NJ
	REAL SAV1,SAV2,SAV3,SAV4,SAV5,SAV6,SAV7
C                       
	INTEGER JTC90S
	INTEGER PARNUM,OFFVER
C
	REAL CONE
	CHARACTER*2 CODE/'NN'/
	CHARACTER*2 ERRORS/'DD'/
C
C===External Function Declarations:
C
	REAL CDFPHI
        INTEGER BLOCAT, JZEXT
        INTEGER BNUMB,  BNEXT, BCHINT, BDATA
        CHARACTER*4  BINTCH
C
C===Data Statements:
C
C		None
C
C======================================================================
$$INCLUDE 'C$INC:DSJETSSF.INC'
C
C===Start of Code:
C
C
C----------------------------------------------------------------------


c--- OFFLINE version to pass to jet correction routine:
        IF (LMONTE) THEN
          OFFVER=4
        ELSEIF(EXPTYP.EQ.RUN1A) THEN
          OFFVER=3
        ELSEIF(EXPTYP.EQ.RUN1B) THEN
          OFFVER=6
        ENDIF
C
	IF(PARNUM.EQ.1)THEN
	  CONE=0.7
	ELSE
	  CONE=0.4
	ENDIF
C---First get a list of legal clusters 
C
	CALL GTJETS(100,NCLST,JCLST,PARNUM)	
C
C---Initialize
	NJ=0
        ETX=0.
        ETY=0.
        ETXP=0.
        ETYP=0.
        METXP=METX
        METYP=METY
C
C---Loop thru the banks
C
C
c	if(metx.eq.0.and.mety.eq.0.) return
C
	DO KK=1,MIN(100,NCLST)
	  BNKNUM=JCLST(KK)
          STATUS = BLOCAT(IW,'JETS',BNKNUM,INDBNK,INDDAT)
C
C
C---Report errors here:
C JWB 3/27/98 shut off error reporting for this error  
C          IF (STATUS.NE.YESUCC) THEN
C    	    WRITE(STRING,992) 'JETS',BNKNUM
C992	    FORMAT('Unable to locate YBOS jet ',
C     $      'segment bank ',A,2X,I6)
C
C---Look at this jet
C          ELSE
          IF (STATUS.EQ.YESUCC) THEN
C---Jet characteristics parameters:
C
	    IF(BNKNUM.NE.NSKIP1.AND.BNKNUM.NE.NSKIP2.AND.
     &	      ABS(DETAJT(INDDAT)).LT.ETACUT.AND.
     &	      ET_JT(INDDAT).GT.ETCUT)THEN
C
	      NJ=NJ+1
C
C             Uncorrected
C
              ETX=ETX+ET_JT(INDDAT)*COS(PHI_JT(INDDAT))
              ETY=ETY+ET_JT(INDDAT)*SIN(PHI_JT(INDDAT))
C
C	      Save uncorrected JETS values befor calling QDJSCO
c             since QDJSCO overwrites the JETS bank

	      SAV1=RW(INDDAT+HDSJET+PX_JET)
	      SAV2=RW(INDDAT+HDSJET+PY_JET)
	      SAV3=RW(INDDAT+HDSJET+PZ_JET)
	      SAV4=RW(INDDAT+HDSJET+E__JET)
	      SAV5=RW(INDDAT+HDSJET+EEMJET)
	      SAV6=RW(INDDAT+HDSJET+PPMJET)
	      SAV7=RW(INDDAT+HDSJET+EPMJET)
C
C             Corrected
C
	      STATUS=JTC90S(INDDAT,INDDAT,CONE,CODE,ERRORS,OFFVER)
C
              ETXP=ETXP+ET_JT(INDDAT)*COS(PHI_JT(INDDAT))
              ETYP=ETYP+ET_JT(INDDAT)*SIN(PHI_JT(INDDAT))
C
C             Restore original JETS values
C
	      RW(INDDAT+HDSJET+PX_JET)=SAV1
	      RW(INDDAT+HDSJET+PY_JET)=SAV2
	      RW(INDDAT+HDSJET+PZ_JET)=SAV3
	      RW(INDDAT+HDSJET+E__JET)=SAV4
	      RW(INDDAT+HDSJET+EEMJET)=SAV5
	      RW(INDDAT+HDSJET+PPMJET)=SAV6
	      RW(INDDAT+HDSJET+EPMJET)=SAV7
	    ENDIF
	  END IF
C
        ENDDO
C
C	Before leaving, recalculate missing et
C       --------------------------------------
        METXP=METX+ETX-ETXP
        METYP=METY+ETY-ETYP
	if((metxp.ne.0).and.(metyp.ne.0)) then
          PHIMET=CDFPHI(ATAN2(METYP,METXP))
	else
	  phimet=0.
	endif
cx      PHIMET=CDFPHI(ATAN2(METYP,METXP))*RADDEG
C
C
C===Return to Caller:
C
      RETURN
      END
