C======================================================================
      SUBROUTINE MY_METJET
     &(NSKIP1,NSKIP2,ETCUT,ETACUT,METX,METY,METXP,METYP,PHIMET,
     & NJ,PARNUM)
C======================================================================
C
C===Description:
C
C
C	This routine corrects missing et for clustered energy using
C       QDJSCO.
C	
C	M.Contreras, Dec.  10, 1992
C
C	Modified to use jets from JETINFO.	J. Berryhill, 1995
C
C	Modified to have name MY_METJET.	P. Wilson, Nov 20, 1996
C
C 
C======================================================================
C
C
$$IMPLICIT 
C
C===Argument Decalarations:
C
C
C       Input
	INTEGER NSKIP1,NSKIP2	! JETS bank numbers to skip corrections
        REAL METX,METY		! initial MET values - uncorrected
	REAL ETCUT		! ET for jets above which we correct
	REAL ETACUT		! ETA for jets below which we correct

C       Output
        REAL METXP,METYP	! corrected MET values
C
C===Global Parameter Declarations:
C
$$INCLUDE 'A_C$LIBRARY:ANCOMP_EXP_ID.INC'
$$INCLUDE 'C$INC:ANACTL.INC'
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:BTMASK.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
C
C===Local Parameter Declarations:
C
$$INCLUDE 'C$INC:jetinfo.inc'
C
C===Global Variable Declartions:
C
$$INCLUDE 'C$INC:BCS   .INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
C
C===Local Variable Declarations:
C
	REAL ETX,ETY,ETXP,ETYP,PHIMET
	INTEGER KK
C
	CHARACTER*80 STRING
        INTEGER STATUS, INDBNK, INDDAT, ILOCAT
        INTEGER BNKNUM, SAVIND
C
	INTEGER IFIRST,INEXT
C
	INTEGER NMAX
	PARAMETER (NMAX=10)
	REAL ET_TEMP(NMAX),ETA_TEMP(NMAX),PHI_TEMP(NMAX)
	INTEGER I,ISORT(NMAX)
	INTEGER NCLST,JCLST(100)
	INTEGER NJ
	REAL SAV1,SAV2,SAV3,SAV4,SAV5,SAV6,SAV7
C                       
	INTEGER JTC90S
	INTEGER PARNUM,OFFVER
C
	REAL CONE
	CHARACTER*2 CODE/'NN'/
	CHARACTER*2 ERRORS/'DD'/
C
C===External Function Declarations:
C
	REAL CDFPHI
        INTEGER BLOCAT, JZEXT
        INTEGER BNUMB,  BNEXT, BCHINT, BDATA
        CHARACTER*4  BINTCH
C
C===Data Statements:
C
C		None
C
C
C===Start of Code:
C
C
C----------------------------------------------------------------------



C---Initialize
	NJ=0
        ETX=0.
        ETY=0.
        ETXP=0.
        ETYP=0.
        METXP=METX
        METYP=METY

C
        DO KK = 1,ICLUS
	    IF(IJETBNK(KK).NE.NSKIP1.AND.
     &        IJETBNK(KK).NE.NSKIP2.AND.
     &	      ABS(IJET_DETA(KK)).LT.ETACUT.AND.
     &	      IJET_ET(KK).GT.ETCUT)THEN
C
	      NJ=NJ+1
C
C             Uncorrected
C
              ETX=ETX+IJET_ET(KK)*COS(IJET_PHI(KK))
              ETY=ETY+IJET_ET(KK)*SIN(IJET_PHI(KK))
C
              ETXP=ETXP+IJET_ET(KK)*COS(IJET_PHI(KK))*JCORF(KK,1)
              ETYP=ETYP+IJET_ET(KK)*SIN(IJET_PHI(KK))*JCORF(KK,1)
	    ENDIF
	 
C
        ENDDO
C
C	Before leaving, recalculate missing et
C       --------------------------------------
        METXP=METX+ETX-ETXP
        METYP=METY+ETY-ETYP
	if((metxp.ne.0).and.(metyp.ne.0)) then
          PHIMET=CDFPHI(ATAN2(METYP,METXP))
	else
	  phimet=0.
	endif
cx      PHIMET=CDFPHI(ATAN2(METYP,METXP))*RADDEG
C
C
C===Return to Caller:
C
      RETURN
      END
