C======================================================================
	SUBROUTINE SVRUNI
C======================================================================
C
C===Description:
C
C	SVRUNI is called at the beginning of each run.
C	Run dependent quantities should be initialized here.
C
$$IMPLICIT
C
C===Global Declarations:
C
$$INCLUDE 'C$INC:EFLAGS.INC'
$$INCLUDE 'C$INC:VSSIMC.INC'
$$INCLUDE 'C$INC:ANACTL.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
$$INCLUDE 'C$INC:LOGUNI.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'C$INC:SIMH.INC'
$$INCLUDE 'C$INC:SVXAUX.INC'
$$INCLUDE 'C$INC:SVXCUT.INC'
$$INCLUDE 'C$INC:GEOMVR.INC'
C
C===Local Declarations:
C
	INTEGER STATUS,IND,INDDAT
C
C===External Functions Referenced:
C
	INTEGER BLOCAT
C
C===Data Statements:
C
C		None
C
C===Start of Code:
C
C
C---Report this routine to the user:
	IF (SVXRUN.LT.0) CALL SVXINI		! do a global init if not done
C
C  CHECK FOR INIT...BE CAREFUL ABOUT SIM WITH RUN 0!!! 
C
	IF (SVXRUN.NE.MAX(NRUN,1)) THEN 	! do the run inits now 
C
C	INITIALIZE SIMULATION FLAGS
C
	  IF (SVXRUN.NE.1) THEN
	    CALL SETMCS			! FIND MS FLAGS
            ELOSS = ELOSVS.NE.0         ! DE/DX
	    MUSC=MSCFVS			! MULTIPLE SCATTERING
	    SVXRUN = 1		
C
C  Tell the world that you've done this...
C
C	    WRITE(LUPRT,1000)
	  ENDIF
c
c  do database initialization
c
	  IF (IAND(SVXENA,1).NE.0) THEN
	    SVXRUN = MAX(NRUN,1) ! update the run number but only when you 
				 ! do something that uses it...
	    CALL SVDBIN				! ALIGNMENT CONSTANTS
C
C   check if d to e being done - separate run inits but only for data, not sim
C    only do these if have already done DB inits above.
C
	    IF (IAND(SVXENA,2).NE.0) THEN
C
C  do d to e run inits only for data
C
	      IF (.NOT.SIMFVS.AND..NOT.LMONTE) THEN
	        CALL SVDTER		! Run init entrypoint for D to E module
	      ENDIF
C
C  make $SVC for this run
C
	      CALL SVCSDF	
	    ENDIF		 ! end of d to e if
	  ENDIF
	ENDIF
c
c --- check whether geometry has changed, do new initialization (MP) 
c
        IF ((GEOMVR.NE.CHKGEO).OR.(ExpTyp.NE.ChkExp)) THEN 
	   CALL SVDBIN
	   CALL LAYINI 
	ENDIF
C
C===Return to Caller:
C
1000	FORMAT(' SVRUNI: SVX Run dependent initialization performed')
	RETURN
	END
