	SUBROUTINE my_TRKISO(CONE,NT,IT)
C
C Pirated from TRKCLUS ; returns the number of tracks within a 
C cone of a given track
C
C
C Input:	CONE     :== cone size for track to be associated with tracks
C Output:	NT(I)    :== # of tracks associated with track I; it inludes I
C	 	IT(I,J)  :== index in TRAKCM of the Jth track associated with I
C
C
C FIXED BUG WITH PHI STUFF	
C ALSO FIXED BUG WITH ETA STUFF    CLAUDIO 4-JUN-1990
C
$$IMPLICIT NONE
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'UC$ANA:TRAKCM.INC'
C
	REAL CONE
	INTEGER NT(MAX_TRACK)
	INTEGER IT(MAX_TRACK,MAX_TRACK)
	INTEGER I,J
	REAL THETA,ETA_TR,DIST,THIS_ETA,THIS_PHI,DPHI
C
C-- Initialize
C
	DO I=1,MAX_TRACK
	   NT(I) = 0
	END DO
C
C-- Loop over TRACKS
C
	DO I=1,N_TRACK			! Loop over tracks
	   IF (CTANTR(I) .NE. 0.0) THEN
	      THETA = ATAN(1/CTANTR(I))
	   ELSE
	      THETA = PI / 2.0
	   ENDIF
	   IF (THETA .LT. 0.) THETA = THETA + PI
	   THIS_ETA = -LOG(TAN(THETA/2.))
	   THIS_PHI = PHITR(I)
	   DO J=1,N_TRACK			! Loop over tracks
	      IF (CTANTR(J) .NE. 0.0) THEN
	         THETA = ATAN(1/CTANTR(J)) 	! Theta of track
	      ELSE
		 THETA = PI / 2.0
	      ENDIF
	      IF (THETA.LT.0.) THETA = THETA + PI
	      ETA_TR = -LOG(TAN(THETA/2.))	! Eta track
	      DPHI = ABS(THIS_PHI-PHITR(J))
	      IF (DPHI .GT. PI) DPHI = TWOPI - DPHI
	      DIST = SQRT( DPHI**2 +
	1		(THIS_ETA-ETA_TR)**2)	! Distance in eta-phi space
c						!   of track from jet axis
	      IF (DIST .LE. CONE) THEN		! Track belongs to jet
		 NT(I) = NT(I) + 1	! Bump counter
		 IT(I,NT(I)) = J	! Store index
	      END IF
	   END DO
	END DO
	RETURN
	END
