C DEC/CMS REPLACEMENT HISTORY, Element FINDTAU.CDF
C *35   19-OCT-1994 12:00:30 EKUNS "Protect against COS(ANGLE) > 1.0"
C *34   24-FEB-1994 13:57:52 EKUNS "Clean up regional tracking banks"
C *33   23-FEB-1994 16:48:59 EKUNS "Fix another regional tracking bug"
C *32   23-FEB-1994 13:31:04 EKUNS "Increment TAU_COUNT for regional tracking!"
C *31    3-FEB-1994 14:34:40 EKUNS "Add MET cut plut finish regional tracking"
C *30   17-JAN-1994 14:56:34 EKUNS "Calculate MET from tau vertex"
C *29   10-JAN-1994 12:18:35 EKUNS "Long-name -> Short name conversion"
C *28    6-JAN-1994 18:37:09 EKUNS "Add filter=.TRUE. if defining a region"
C *27    6-JAN-1994 16:20:14 EKUNS "Add run-1b regional tracking"
C *26   14-JUL-1993 22:36:54 EKUNS "Fix 30 degree cone to really go out to 30 degrees"
C *25   14-JUL-1993 21:49:38 EKUNS "Add option to delete old tau banks"
C *24   13-JUL-1993 16:28:53 EKUNS "Add missing comma"
C *23   13-JUL-1993 15:48:28 EKUNS "Fix 10/30 degree angle calculation (again!)"
C *22    8-APR-1993 10:16:10 EKUNS "Fix 10,30 degree angle calculation"
C *21    9-FEB-1993 17:09:22 EKUNS "Correct filling of jet histograms"
C *20   20-DEC-1992 18:08:56 EKUNS "Remove TOW_OFF array"
C *19   13-DEC-1992 20:42:48 EKUNS "Avoid calling TAUTRK if no tracks"
C *18   11-DEC-1992 19:51:16 EKUNS "Add call to TAUVTX + new tracking counts"
C *17   26-NOV-1992 01:51:48 EKUNS "Add JETS bank #, new clustering"
C *16   17-NOV-1992 15:43:38 EKUNS "Fix N-Tower cut to be on L2NTOW, not NTOWER"
C *15   13-NOV-1992 22:33:21 EKUNS "Add more talk-to options & adjustable thresholds"
C *14    8-SEP-1992 14:10:21 EKUNS "Stop non-useful error message"
C *13   19-AUG-1992 12:03:42 LAMMEL "TEDH: intrinsic function"
C *12   29-JUL-1992 19:24:55 EKUNS "Implement L3TO creation"
C *11   25-JUL-1992 04:20:24 EKUNS "Fix Et cut; Make SETA w/ right vertex; get 0.4 JETCLU clust"
C *10   16-JUL-1992 17:48:51 EKUNS "Add Leslie's fix to check all GENP taus"
C *9    14-APR-1992 02:12:34 EKUNS "Clean up histogram booking ranges"
C *8    14-APR-1992 00:39:39 EKUNS "Bring up to spec requirements, redo histograms"
C *7    27-MAR-1992 18:02:44 EKUNS "Oops, forgot to remove debug call to TAUOPT"
C *6    27-MAR-1992 17:14:29 EKUNS "Add TTRS, TCAE banks, finish filling TAUO"
C *5    21-MAR-1992 23:38:12 LAMMEL "port to rs6000: ANGPAR use"
C *4    12-MAR-1992 17:53:17 EKUNS "Add call to regional tracking, fix other small things"
C *3    27-FEB-1992 22:50:07 EKUNS "Create CALS,CLSL,CALL (really)"
C *2    27-FEB-1992 22:48:11 EKUNS "Create CALS,CLSL,CALL"
C *1    24-FEB-1992 18:18:55 EKUNS "Tau reconstruction module"
C DEC/CMS REPLACEMENT HISTORY, Element FINDTAU.CDF
C       ===================================================
C       FINDTAU -- the production tau reconstruction module
C       ===================================================
C
C       Language:-
C       ==========
C       CDF Fortran
C       
C       Modulename:-
C       ============
C       FINDTAU.CDF
C
C       Description:-
C       =============
C	This module searches for tau-like jets and creates TAUO banks
C	for those which pass the cuts, based on tracking, calorimetry,
C	and missing Et information.
C
C	It contains the following subroutines:
C
C	FINDTAU_TALK		Talk-To			FTAUTLK.CDF
C	FINDTAU_RINI		Begin Run (Run Init)	FTAURUN.CDF
C	FINDTAU_RFIN		End Run			FTAURUN.CDF
C	FINDTAU_BOOK		Booking			FTAURUN.CDF
C	FINDTAU_EVENT		Event			--this file--
C	FINDTAU_INIT		Grand Init		FTAUINI.CDF
C	FINDTAU_FIN		Grand End		FTAUINI.CDF
C
C	Author:-
C	========
C	E. Kuns, Rutgers/CDF
C
C	Creation Date:- 
C	===============
C	September 1991
C
C==============================================================================
	SUBROUTINE FINDTAU_EVENT()
C	==========================
C
C	Description:-
C	=============
C	Event entry point for FINDTAU
C
C	Default cuts/parameters:
C
C	Test ALL clusters (not just ones matching a GENP tau)
C	Do NOT regional track
C	Tower Et threshold of 1 GeV to be included in cluster
C	Look in hardware TL2D for level 2 tau information (not a cut, tho)
C	Z vertex: +/- 10 cm from seed track
C	% energy in top tower cut OFF
C	% energy in top 2 towers (rho) cut OFF
C	Max number of tracks (over 1 GeV) in .4 cone cut OFF
C	No MET cut
C
C	To pass, require any cluster satisfying:
C		Minimum cluster Et of 10 GeV
C		6 calorimeter towers max passing above counting threshold
C		At least one seed track (Pt above threshold)
C
C	Events which pass have the following banks created and added
C	to the 'A' bankset:  CLSL CALL CALS TAUO TCAE TTRS TOPA
C		Also, L3TO and TAUR for events where they are made
C
C	A work bank is used via the ZVSETA() call so FINDTAU can use the
C	correct Z vertex when calculating calorimetry information.
C
C	Call Parameters:-
C	=================
C	None
C
C	Global Declarations:-
C	=====================
$$IMPLICIT
$$Include 'A_C$Library:AnError.Inc'
$$Include 'YBos$Library:ErrCod.Inc'
$$Include 'YBos$Library:BnkTyp.Inc'
$$Include 'C$Inc:ErLevl.Inc'		!Error Logger include
$$Include 'C$Inc:BCS.Inc'		!IW/RW
$$Include 'C$Inc:DSTAUO.Inc'		!TAUO bank
$$Include 'C$Inc:DSJETS.Inc'		!JETS bank
$$Include 'C$Inc:PiValu.Inc'
$$Include 'C$Inc:FindTau.Inc'
$$Include 'C$Inc:TRKSCo.Inc'		!unpacked TRKS common
$$Include 'C$Inc:DSFitP.Inc'		!TRKS common fit parameter offsets
C
C	External Functions:-
C	====================
	INTEGER ANGPAR
	LOGICAL ANGHBO, ANGHAC
	INTEGER BLOCAT, BTYMAK, BLIST, BIGEST, BMAKE
	INTEGER BNUMB, BNEXT, BDATA, MDROP
	INTEGER TRSORT, TRKSUN
	INTEGER GET_GENTAU, MKTAUCLST, TAUTRK, TAUCALOR
	REAL	PHIDIF, PRTHET
C
C	Local Declarations:-
C	====================
	LOGICAL	PASS			!.TRUE. if we find a TAU
	INTEGER STATUS, IERR		!Status returns
	INTEGER PARSET			!Parameter set number
	INTEGER I, J, K			!Random loop indices
	INTEGER	TAU_COUNT		!Number of taus in this event
	REAL	COT, THETA
	REAL	DPHI
	REAL	CUT			!Temp cut variable
	LOGICAL	NEW_CLUST		!Use new clustering algorithm?
	LOGICAL HIST			!Fill histograms?

!=== TL2D tau information ===
	INTEGER BNKL2D			!TL2D bank number to use
	REAL	CLPTAU(1:5,1:2)		!tau info from TL2D
	LOGICAL	TL2D_MATCH		!.TRUE. if this cluster matches TL2D tau
	REAL	L2TAU_PHI		!Phi of L2 tau cluster from TL2D
	REAL	L2TAU_ETA		!Eta of L2 tau cluster from TL2D
	REAL	MYP, MYPHI, MYETA	!Used to reapply TL2D match for .PASS.

!=== GENP generated tau information ===
	LOGICAL	GENTAU_ONLY		!.TRUE. if we only look at gen tau clst
	INTEGER MAXNOTAUS		!Max number of taus to be found in GENP 
	PARAMETER (MAXNOTAUS = 5)
	INTEGER NOTAUS			!# of taus found in GENP
	REAL	TAUETA(MAXNOTAUS)
        REAL	TAUPHI(MAXNOTAUS)	!eta & phi of generated taus

!=== Bank info ===
	INTEGER IND			!Random bank indices
	INTEGER	ID$TAU			!$TAU data index
	INTEGER TAUODT			!TAUO bank data index
	LOGICAL	MKTTRS			!.T. if make TTRS bank, .F. otherwise
	LOGICAL	MKTCAE			!.T. if make TCAE bank, .F. otherwise

!=== Info from JETCLU ===
	INTEGER NCLST			!Number of JETCLU clusters found
	INTEGER JCLST(MAX_NCLST)	!Bank number of each cluster
	REAL	JETETA(MAX_NCLST)	!Jet eta
	REAL	JETPHI(MAX_NCLST)	!Jet phi
	REAL	JETCHF(MAX_NCLST)	!Jet charge fraction (for hist)
	REAL	ANGLE			!Angle of jet from GENP tau

!=== Calorimetry information ===
	INTEGER NTOWER			!# towers over lim in the tau cluster
	INTEGER L2NTOW			!L2-like repeat of # towers cut
	REAL	TETEM			!Total EM Et in tau cluster
	REAL	TETHAD			!Total HAD Et in tau cluster
	REAL	ETTOT			!Total Et in tau cluster
	REAL	ET2TOW(2)		!Et in 2 highest towers
	INTEGER TOW_LIST(MAX_TOWER)	!List of towers (packed eta/phi)
	REAL	P(5)			!Px,Py,Pz,E,Invariant mass
	REAL	TPHI2			!Phi-Phi moment of calorimetry cluster
	REAL	TETA2			!Eta-Eta moment of calorimetry cluster
	REAL	T1CUT, T2CUT		!% Et in top 1, top 2 towers

!=== Missing Et information ===
	REAL	ESUM, ETSUM		!Total E, Et in event (tau z vertex)
	REAL	MET			!Missing Et in event (tau z vertex)
	REAL	EXSUM, EYSUM		!Missing Ex,Ey (using tau z vertex)

!=== Tracking information ===
	LOGICAL	REG_TRACK		!Define regional tracking regions only?
	LOGICAL POST_REG		!Finish up after regional tracking?
	REAL	TPHI, TETA		!Track/track-cluster direction
	REAL	TPT			!Track Pt
	INTEGER	NTRKSHLD		!# shoulder tracks in 0.4 cone
	INTEGER NTRKSEED		!# seed tracks in 0.4 cone
	INTEGER NTRK10			!# track in 10 degree cone
	INTEGER NTRK30			!# track in 10-30 degree cone
	INTEGER NTRKOUT			!# tracks in 0.4 cone from wrong vertex
	LOGICAL EXTRAP			!.TRUE. if this track hits cluster
	INTEGER NTCLSH			!# tracks extrapolating to clust in 0.4
	INTEGER NTCL10			!     # in 10 degree cone
	INTEGER NTCL30			!     # in 10-30 degree cone
	INTEGER TRKS_LIST(MAX_TRACK)	!List of TRKS bank numbers of tracks
	REAL	HITPT			!Highest track Pt in our cone
	REAL	HITANGLE		!Angle between HiPt track & cal clst
	REAL	ZVTX			!Z Vertex of seed track
	REAL	TAU_ZV			!Z Vertex of tau cluster
	REAL	TPSUM			!|P| of track cluster
	REAL	TMASS			!Invarient mass of track cluster
	LOGICAL VTVZ_VERTX		!.TRUE. if vertex used is from VTVZ
	INTEGER TOTCHG			!Total charge of tracks in 10 deg cone
	INTEGER REG_FAIL		!# of reg.trk.regions which fail cuts

!=== TAUO information ===
	CHARACTER*20	BNKTYP		!$TAU bank type string
	INTEGER TOSIZE			!TAUO bank size
	INTEGER TAUO_CODE		!Code word to be placed in TAUO
	INTEGER MYCLSL			!Bank number for my CLSL
	INTEGER TAUO_LIST(MAX_NCLST)	!List of bank numbers for TAUO banks
	INTEGER TAUO_NUM		!Number of current TAUO bank

!=== L3TO information ===
	INTEGER L3TODT			!L3TO bank data index
	LOGICAL	PASS_THIS1		!Did this cluster pass?
	INTEGER	BNUM			!L3TO bank number
C
C	Statement Functions:-
C	=====================
	REAL	T1, T2, P1, P2, DOT_AB
	DOT_AB(T1,T2,P1,P2) = ACOS( MIN(MAX(COS(P1-P2)*SIN(T1)*SIN(T2) +
     &					    COS(T1)*COS(T2), -1.), 1.) )

$$Include 'C$Inc:DSJETSSF.Inc'
$$Include 'C$Inc:DSTAUOSF.Inc'	!For filling histos at end
C
C	Executable Code:-
C=======================================
C	Get the parameter set
C	---------------------
	PARSET = ANGPAR()
	STATUS = BLOCAT(IW, TAU$NM, PARSET, IND, ID$TAU)

C	Fill histograms?
C	----------------
	HIST = (ANGHBO() .AND. ANGHAC())

C	Delete old tau banks if specified
C	---------------------------------
	IF (BTEST(IW(ID$TAU+TAU_MASK), TAU_DROP_BANKS)) THEN

  30	   CONTINUE

C	   Get list of tau clusters from one CLSL bank
C	   -------------------------------------------
	   CALL GET_TAU_CLUSTERS(TAU_COUNT, TAUO_LIST, MAX_NCLST)

	   IF (TAU_COUNT .GT. 0) THEN
C	      From the first tau cluster, get the CLSL bank number
C	      and delete the tau cluster list bank
C	      ----------------------------------------------------
	      STATUS = BLOCAT(IW, 'TAUO', TAUO_LIST(1), IND, TAUODT)
   	      IF (STATUS .NE. YENOBK)THEN ! found a bank -- MH change
              IF (IND .NE. 0)
     &		 STATUS = MDROP(IW, 'CLSL', IW(TAUODT+TaOCls))

	      DO I=1, TAU_COUNT
		 STATUS = MDROP(IW, 'CALL', TAUO_LIST(I))
		 STATUS = MDROP(IW, 'CALS', TAUO_LIST(I))
		 STATUS = MDROP(IW, 'L3TO', TAUO_LIST(I))
		 STATUS = MDROP(IW, 'TAUO', TAUO_LIST(I))
		 STATUS = MDROP(IW, 'TCAE', TAUO_LIST(I))
		 STATUS = MDROP(IW, 'TTRS', TAUO_LIST(I))
		 STATUS = MDROP(IW, 'TAUR', TAUO_LIST(I))
	      ENDDO

	      GOTO 30
              ENDIF
	   ENDIF
	ENDIF

C	Assume we don't find a tau
C	--------------------------
	MYCLSL    = -1
	TAUO_NUM  = -1
	TAU_COUNT =  0
	PASS = .FALSE.

C	Are we only to check generated tau clusters?
C	--------------------------------------------
	GENTAU_ONLY = BTEST(IW(ID$TAU+TAU_MASK), TAU_SIM)
	IF (GENTAU_ONLY) THEN
	   STATUS = GET_GENTAU(TAUETA, TAUPHI, MAXNOTAUS, NOTAUS)
	   IF (STATUS .NE. 0) GOTO 95	!Skip event if no tau
	ENDIF

C	New or old clustering?
C	----------------------
	NEW_CLUST = BTEST(IW(ID$TAU+TAU_MASK), TAU_NEW_CLUST)

C	Define regional track regions, only?
C	------------------------------------
	REG_TRACK = BTEST(IW(ID$TAU+TAU_MASK), TAU_PRE_REGN)
	POST_REG  = BTEST(IW(ID$TAU+TAU_MASK), TAU_POST_REGN)

C	Read Level 2 tau cluster information from TL2D if we have it
C	------------------------------------------------------------
	BNKL2D = IW(ID$TAU + TL2D_BNUM)
	IF (BNKL2D .NE. -1) THEN
	   CALL TAUTRG(BNKL2D, CLPTAU, IERR)
	   IF (IERR .NE. 0)  THEN
	      BNKL2D = -1	!Flag "no TL2D tau" if error
	   ELSE
	      L2TAU_ETA = CLPTAU(2,1)
	      L2TAU_PHI = CLPTAU(3,1)
	   ENDIF
	ENDIF

C	If we're finishing up after regional tracking, then read
C	information from the TAUR bank.  Otherwise, get information
C	from JETS banks to cluster from
C	-----------------------------------------------------------
	IF (POST_REG) THEN
	   NCLST = 0
	   CALL TAUGREG(NCLST, MYCLSL, JCLST, JETETA, JETPHI, JETCHF)
	ELSE
	   CALL TAUGJETS(ID$TAU, NCLST, JCLST, JETETA, JETPHI, JETCHF)
	ENDIF

C	+++++++++++++++++++++++++++++++
C	+ Start of loop over clusters +
C	+++++++++++++++++++++++++++++++

C	Now check each cluster to see if it passes the tau cuts
C	-------------------------------------------------------
	DO I=1, NCLST

C	   Assume the cluster fails a cut
C	   ------------------------------
	   PASS_THIS1 = .FALSE.

C	   See if this tau matches a TL2D tau (not a cut, just a check)
C	   ------------------------------------------------------------
	   TL2D_MATCH = .FALSE.
	   IF (BNKL2D .NE. -1) THEN
	      DPHI  = PHIDIF(JETPHI(I), L2TAU_PHI)
	      ANGLE = SQRT((JETETA(I) - L2TAU_ETA)**2 + DPHI**2)
	      IF (ANGLE .LT. 0.4)  TL2D_MATCH = .TRUE.
	   ENDIF

C	   If we're only to check generated taus, first reject other clusters
C	   ------------------------------------------------------------------
	   IF (GENTAU_ONLY) THEN
	      DO J = 1, NOTAUS		!Loop over all GENP taus
	         DPHI  = PHIDIF(TAUPHI(J), JETPHI(I))
	         ANGLE = SQRT((TAUETA(J) - JETETA(I))**2 + DPHI**2)
		 IF (HIST)  CALL HFILL(SIMTAU_HIST_NUM, ANGLE, 0., 1.)
	         IF (ANGLE .LE. 0.4)  GOTO 17	
	      ENDDO
	      GOTO 15			!No generated taus matched clusters
					!Don't generate any histograms
 17	      CONTINUE
	   ENDIF


C	   Start off our hist to keep track of rejection
C	   ---------------------------------------------
	   IF (HIST)  CALL HFILL(TAU_HIST_NUM+1, 0., 0., 1.)

C	   Zero all variables we apply cuts on (except variables
C	   given values before cutting -- don't need to zero those)
C	   --------------------------------------------------------
	   NTRKSEED = 0
	   NTRKSHLD = 0

C	   If finishing up FINDTAU after regional tracking, read
C	   pre-region quantities from TAUR/CALL.  Then jump to
C	   just after the tau region definitions and continue
C	   -----------------------------------------------------
	   IF (POST_REG) THEN
	      CALL TAUGRCL(I, MYPHI, MYETA, TAUO_NUM, L2NTOW,
     &			   NTOWER, TOW_LIST)
	      TAU_COUNT = I
	      TAUO_LIST(TAU_COUNT) = TAUO_NUM
	      GOTO 105
	   ENDIF

C	   ++++++++++++++++++++++++++++++++++++++++++++++
C	   + Skip ahead if doing post-regional tracking +
C	   ++++++++++++++++++++++++++++++++++++++++++++++

C	   Verify L2 Ntower cut for this cluster.  Also form
C	   list of towers which are in our cluster for later use
C	   -----------------------------------------------------
	   CALL TAUCLST(JCLST(I), ID$TAU, L2NTOW, NTOWER, TOW_LIST)
	   IF (NTOWER .EQ. 0)  GOTO 10		!On error, try next cluster

C	   Make # towers cut
C	   -----------------
	   IF (L2NTOW .GT. IW(ID$TAU + MAX_N_TOW))  GOTO 10
	   IF (HIST)  CALL HFILL(TAU_HIST_NUM+1, 1., 0., 1.)

C	   Calculate calorimetry quantities from tau cluster including
C	   calorimetry 4-vector -- need this to calculate tau eta, phi
C	   -----------------------------------------------------------
	   STATUS = TAUCALOR(NTOWER, TOW_LIST, TETEM, TETHAD,
     &			     ET2TOW, TPHI2, TETA2, P)
	   ETTOT = TETEM + TETHAD

C	   Calculate Eta, Phi of tau cluster, used below
C	   ---------------------------------------------
	   MYP = SQRT(P(1)*P(1) + P(2)*P(2) + P(3)*P(3))
	   MYPHI = ATAN2(-P(2), -P(1)) + PI
	   MYETA = 0.5 * LOG((MYP + P(3))/(MYP - P(3)))

	   IF (NEW_CLUST)  GOTO 100

C	   ==============================
C	   == Some OLD CLUSTERING cuts ==
C	   ==============================

C	   Calculate % energy in top 1 and top 2 towers
C	   --------------------------------------------
	   IF (ETTOT .GT. 0) THEN
	      T1CUT = ET2TOW(1) / ETTOT
	      T2CUT = (ET2TOW(1)+ET2TOW(2)) / ETTOT
	   ELSE
	      T1CUT = -1
	      T2CUT = -1
	   ENDIF

C	   Cut on total cluster Et
C	   -----------------------
	   IF (ETTOT .LT. RW(ID$TAU + MIN_ET))  GOTO 10
	   IF (HIST)  CALL HFILL(TAU_HIST_NUM+1, 2., 0., 1.)

C	   Cut on % Et in top tower
C	   ------------------------
	   CUT = RW(ID$TAU + HITOW_OVER_REST)
	   IF ((CUT .NE. 0) .AND. (T1CUT .LT. CUT))  GOTO 10
	   IF (HIST)  CALL HFILL(TAU_HIST_NUM+1, 3., 0., 1.)

C	   Cut on % Et in top 2 towers
C	   ---------------------------
	   CUT = RW(ID$TAU + HI2TOW_OVER_REST)
	   IF ((CUT .NE. 0) .AND. (T2CUT .LT. CUT))  GOTO 10
	   IF (HIST)  CALL HFILL(TAU_HIST_NUM+1, 4., 0., 1.)

C	   +++++++++++++++++++++++++++++++++++++++
C	   + Set up regional tracking if desired +
C	   +++++++++++++++++++++++++++++++++++++++

 100	   CONTINUE

C	   Set up tracking region if cluster passes cuts and regional
C	   tracking is enabled.  FINDTAU passes if we define a region.
C	   -----------------------------------------------------------
	   IF (REG_TRACK) THEN
	      PASS = .TRUE.
	      PASS_THIS1 = .TRUE.

C	      Find out my CLSL number
C	      -----------------------
	      IF (MYCLSL .EQ. -1)  THEN
		 STATUS = BIGEST(IW, 'CLSL', MYCLSL)
		 MYCLSL = MYCLSL + 1
	      ENDIF

C	      Find out my TAUO/CALS/etc number
C	      --------------------------------
	      IF (TAUO_NUM .EQ. -1)  THEN
		 STATUS = BIGEST(IW, 'CALS', TAUO_NUM)
	      ENDIF
	      TAUO_NUM  = TAUO_NUM + 1		!Bank number
	      TAU_COUNT = TAU_COUNT + 1		!Array index & counter
	      TAUO_LIST(TAU_COUNT) = TAUO_NUM

C	      Make CALL, CALS banks
C	      ---------------------
	      STATUS = MKTAUCLST(NTOWER, TOW_LIST, TAUO_NUM, MYCLSL,
     &				 .FALSE.)

C	      Finally define tau region, make TAUR bank
C	      -----------------------------------------
	      CALL TAU_REGN(MYPHI, MYETA, TAU_COUNT, TAUO_NUM, MYCLSL,
     &			    L2NTOW, JCLST(I), PARSET)

	      GOTO 15		!Do next cluster
	   ENDIF

C	   +++++++++++++++++++++++++++++++++++++++++
C	   + Start here for post-regional tracking +
C	   +++++++++++++++++++++++++++++++++++++++++

 105	   CONTINUE

C	   Select TRKS 3-d tracks, sorted in descending Pt, no vertex const.
C	   -----------------------------------------------------------------
	   STATUS = TRSORT(1,0,0,0,0)
	   IF (STATUS .EQ. YENOBK)  STATUS = 0	!Don't complain if no tracks
	   IF (STATUS .NE. 0) THEN		!If real error, complain first
	      CALL ERLOGR('FINDTAU', ERWARN, 0, STATUS,
     &			  'TRSORT returns error')
	      GOTO 10	!Try next cluster if track error
	   ENDIF

C	   Find seed track
C	   ---------------
	   NTRKSEED = 0		!# seed tracks in cluster
	   HITPT    = 0.	!Hi Track Pt
	   HITANGLE = 0.	!Hi Track Pt's Angle from cluster
	   DO J=1, NTRKSU
	      STATUS = TRKSUN(-J, 1, 1)		!Unpack Jth sorted track
	      IF (STATUS .EQ. 0) THEN		!  into TRKSCO common
		 TPHI = ATAN2(TRKSP4(2), TRKSP4(1))	!Phi of track
		 IF (TPHI .LT. 0)  TPHI = TPHI + TWOPI	!  0 <= phi <= 2pi
		 TETA = TRKSP4(6)			!Eta of track
		 TPT  = TRKSP4(5)			!Pt of track

C		 Is this track inside our cone?
C		 ------------------------------
		 DPHI  = PHIDIF(MYPHI, TPHI)
		 ANGLE = SQRT((MYETA - TETA)**2 + DPHI**2)

C		 If within the cone and over seed threshold, count it
C		 ----------------------------------------------------
		 IF ((ANGLE .LT. 0.4) .AND.
     &		     (TPT .GT. RW(ID$TAU + SEED_TRK_PT))) THEN
		    NTRKSEED = NTRKSEED + 1

C		    Find stiffest track in our cone
C		    -------------------------------
		    IF (TPT .GT. HITPT) THEN
		       HITPT    = TPT
		       HITANGLE = DOT_AB(PRTHET(MYETA), PRTHET(TETA),
     &					 MYPHI, TPHI)
		       ZVTX     = TRKSFP(Z0FP)	!From TRKSCO common
		    ENDIF
		 ENDIF
	      ENDIF
	   ENDDO

C	   Make sure we have a seed track -- one over Seed track Pt
C	   --------------------------------------------------------
	   IF (NTRKSEED .LT. 1)  GOTO 10	!Try next cluster
	   IF (HIST)  CALL HFILL(TAU_HIST_NUM+1, 5., 0., 1.)

C	   If NEW CLUSTERING algorithm, get best Z vertex from VTVZ
C	   --------------------------------------------------------
	   IF (NEW_CLUST) THEN
	      CALL TAUVTX(ZVTX, TAU_ZV, VTVZ_VERTX)
	   ELSE
	      VTVZ_VERTX = .FALSE.
	      TAU_ZV     = ZVTX
	   ENDIF

C	   Recalculate calorimetry quantities from tau cluster
C	   including calorimetry 4-vector, using correct Z vertex
C	   ------------------------------------------------------
	   CALL ZVSETA(TAU_ZV, 1, IERR)
	   STATUS = TAUCALOR(NTOWER, TOW_LIST, TETEM, TETHAD,
     &			     ET2TOW, TPHI2, TETA2, P)
	   CALL ZVSETA(TAU_ZV, 0, IERR)

C	   Calculate Eta, Phi of tau cluster, used below
C	   ---------------------------------------------
	   MYP = SQRT(P(1)*P(1) + P(2)*P(2) + P(3)*P(3))
	   MYPHI = ATAN2(-P(2), -P(1)) + PI
	   MYETA = 0.5 * LOG((MYP + P(3))/(MYP - P(3)))

C	   If NEW CLUSTERING algorithm, apply cuts skipped above
C	   -----------------------------------------------------
	   IF (.NOT. NEW_CLUST)  GOTO 110

C	   Calculate % energy in top 1 and top 2 towers
C	   --------------------------------------------
	   ETTOT = TETEM + TETHAD
	   IF (ETTOT .GT. 0) THEN
	      T1CUT = ET2TOW(1) / ETTOT
	      T2CUT = (ET2TOW(1)+ET2TOW(2)) / ETTOT
	   ELSE
	      T1CUT = -1
	      T2CUT = -1
	   ENDIF

C	   Cut on total cluster Et
C	   -----------------------
	   IF (ETTOT .LT. RW(ID$TAU + MIN_ET))  GOTO 10
	   IF (HIST)  CALL HFILL(TAU_HIST_NUM+1, 2., 0., 1.)

C	   Cut on % Et in top tower
C	   ------------------------
	   CUT = RW(ID$TAU + HITOW_OVER_REST)
	   IF ((CUT .NE. 0) .AND. (T1CUT .LT. CUT))  GOTO 10
	   IF (HIST)  CALL HFILL(TAU_HIST_NUM+1, 3., 0., 1.)

C	   Cut on % Et in top 2 towers
C	   ---------------------------
	   CUT = RW(ID$TAU + HI2TOW_OVER_REST)
	   IF ((CUT .NE. 0) .AND. (T2CUT .LT. CUT))  GOTO 10
	   IF (HIST)  CALL HFILL(TAU_HIST_NUM+1, 4., 0., 1.)

 110	   CONTINUE

C	   Count tracks with same vertex as seed pointing at cluster
C	   ---------------------------------------------------------
	   CUT = RW(ID$TAU + ZVTX_RESOL)
	   NTRKSHLD = 0		!# shoulder tracks
	   NTRK10   = 0		!# tracks in 10 degree cone
	   NTRK30   = 0		!# tracks in 10-30 degree cone
	   NTRKOUT  = 0		!# tracks in .4 cone from wrong vertex
	   NTCLSH   = 0		!# tracks extrap to cluster in 0.4 cone
	   NTCL10   = 0		!   # in 10 degree cone
	   NTCL30   = 0		!   # in 10-30 degree cone
	   TOTCHG   = 0		!Total charge of tracks in 10 degree cone
	   DO J=1, NTRKSU
	      STATUS = TRKSUN(-J, 1, 1)
	      IF (STATUS .EQ. 0) THEN
		 TPHI = ATAN2(TRKSP4(2), TRKSP4(1))	!Phi of track
		 IF (TPHI .LT. 0)  TPHI = TPHI + TWOPI	!  0 <= phi <= 2pi
		 TETA = TRKSP4(6)			!Eta of track
		 TPT  = TRKSP4(5)			!Pt of track

C		 Is this track inside our cone?
C		 ------------------------------
		 DPHI  = PHIDIF(MYPHI, TPHI)
		 ANGLE = DOT_AB(PRTHET(MYETA), PRTHET(TETA), MYPHI, TPHI)
		 IF (HIST)  CALL HFILL(TAU_HIST_NUM+2, ANGLE, 0., 1.)

C		 If so & track is over shoulder thresh, continue
C		 -----------------------------------------------
		 IF ((ANGLE*RADDEG .LE. 30) .AND.
     &		     (TPT .GT. RW(ID$TAU + SHLD_TRK_PT))) THEN
C		    Is track from same vertex?
C		    --------------------------
		    IF (ABS(TAU_ZV - TRKSFP(Z0FP)) .GE. CUT) THEN
		       NTRKOUT = NTRKOUT + 1
		    ELSE
		       NTRKSHLD = NTRKSHLD + 1
		       TRKS_LIST(NTRKSHLD) = -J

C		       Does this track extrapolate out to cluster?
C		       -------------------------------------------
		       EXTRAP = .FALSE.
		       DO K=1, NTOWER		!TRKSTO is from C$INC:TRKSCO
			  IF (TRKSTO .EQ. TOW_LIST(K))  EXTRAP = .TRUE.
		       END DO

		       IF (EXTRAP)  NTCLSH = NTCLSH + 1

C		       Count tracks within 10 degree and 10-30 degree cones
C		       ----------------------------------------------------
		       IF (ANGLE*RADDEG .LT. 10) THEN
			  NTRK10 = NTRK10 + 1
			  IF (EXTRAP)  NTCL10 = NTCL10 + 1
			  TOTCHG = TOTCHG + SIGN(1.0, TRKSFP(CuFP))
		       ELSE IF (ANGLE*RADDEG .LT. 30) THEN
			  NTRK30 = NTRK30 + 1
			  IF (EXTRAP)  NTCL30 = NTCL30 + 1
		       ENDIF
		    ENDIF
		 ENDIF
	      ENDIF
	   ENDDO

C	   Now cut on total number of tracks in cone
C	   -----------------------------------------
	   CUT = IW(ID$TAU+MAX_N_TRK)
	   IF ((CUT .GT. -1.) .AND. (NTRKSHLD .GT. CUT))  GOTO 10

C	   Just in case changing the Z vertex removes all tracks
C	   from the cone, make sure we have AT LEAST one track!
C	   -----------------------------------------------------
	   IF (NTRKSHLD .LE. 0)  GOTO 10
	   IF (HIST)  CALL HFILL(TAU_HIST_NUM+1, 6., 0., 1.)

C	   +---------------------------------------------+
C	   | If still here, we have a tau candidate      |
C	   | Set PASS and PASS_THIS1 below after MET cut |
C	   +---------------------------------------------+

C	   Find out my CLSL number
C	   -----------------------
	   IF (MYCLSL .EQ. -1)  THEN
	      STATUS = BIGEST(IW, 'CLSL', MYCLSL)
	      MYCLSL = MYCLSL + 1
	   ENDIF

C	   If doing post-regional tracking work, then delete the
C	   CALL and CALS banks from before regional tracking.
C	   Otherwise find out my TAUO/CALS/etc number.
C	   -----------------------------------------------------
	   IF (POST_REG) THEN
	      STATUS = MDROP(IW, 'CALL', TAUO_LIST(I))
	      STATUS = MDROP(IW, 'CALS', TAUO_LIST(I))
	   ELSE
	      IF (TAUO_NUM .EQ. -1)  THEN
		 STATUS = BIGEST(IW, 'CALS', TAUO_NUM)
	      ENDIF
	      TAU_COUNT = TAU_COUNT + 1		!Yes, one more tau
	      TAUO_NUM = TAUO_NUM + 1		!Increment bank number
	      TAUO_LIST(TAU_COUNT) = TAUO_NUM
	   ENDIF

C	   +---------------------------------------------------------+
C	   | Make calorimetry cluster banks (CLSL, CALL, CALS, TCAE) |
C	   +---------------------------------------------------------+

C	   Make CALL, CALS, & TCAE banks, calculating (again)
C	   a new SETA bank with our chosen Z vertex, saving
C	   old SETA in a work bank and restoring it when done.
C	   Also recalculate MET from tau's Z vertex.
C	   ---------------------------------------------------
	   CALL ZVSETA(TAU_ZV, 1, IERR)
	   MKTCAE = BTEST(IW(ID$TAU+TAU_MASK), TAU_TCAE_MAKE)
	   STATUS = MKTAUCLST(NTOWER, TOW_LIST, TAUO_NUM, MYCLSL, MKTCAE)
	   CALL TAUMET(ESUM, ETSUM, MET, EXSUM, EYSUM)
	   CALL ZVSETA(TAU_ZV, 0, IERR)

C	   Apply minimum MET cut
C	   ---------------------
	   IF (MET .GE. RW(ID$TAU + MIN_MET)) THEN
	      PASS       = .TRUE.		!Filter passes
	      PASS_THIS1 = .TRUE.		!This cluster passes
	   ENDIF

C	   +--------------------------------+
C	   | Make track cluster bank (TTRS) |
C	   +--------------------------------+

C	   Make TTRS and calculate track sums
C	   ----------------------------------
	   MKTTRS = BTEST(IW(ID$TAU+TAU_MASK), TAU_TTRS_MAKE)
	   STATUS = TAUTRK(TAUO_NUM, NTRKSHLD, TRKS_LIST, 
     &			   TPSUM, TETA, TPHI, TMASS, MKTTRS)

C	   +-----------------------------+
C	   | Make tau object bank (TAUO) |
C	   +-----------------------------+

C	   Recheck TL2D tau match w/ new calorimetry info
C	   ----------------------------------------------
	   TL2D_MATCH = .FALSE.
	   IF (BNKL2D .NE. -1) THEN
	      DPHI  = PHIDIF(MYPHI, L2TAU_PHI)
	      ANGLE = SQRT((MYETA - L2TAU_ETA)**2 + DPHI**2)
	      IF (ANGLE .LT. 0.4)  TL2D_MATCH = .TRUE.
	   ENDIF

C	   Make next TAUO bank
C	   -------------------
	   WRITE (BNKTYP, 25) TaONIn, TaONRe
 25	   FORMAT(I3, 'I4,',		! Header/Integer block
     &		  I3, 'R4,')		! Real block
	   STATUS = BTYMAK(IW, TaONam, TAUO_NUM, BNKTYP, TOSIZE,
     &			   IND, TAUODT)
	   IF (STATUS .NE. YESUCC) THEN
	      CALL ERLOGR('FINDTAU', EREROR, 0, STATUS,
     &			  'Cannot create TAUO bank')
	      GOTO 15	!No histos
	   ENDIF

C	   Fill code word
C	   --------------
	   TAUO_CODE = 0
	   IF (TL2D_MATCH)   TAUO_CODE = IBSET(TAUO_CODE, TaOL2T)
	   IF (GENTAU_ONLY)  TAUO_CODE = IBSET(TAUO_CODE, TaOGEN)
	   IF (NEW_CLUST)    TAUO_CODE = IBSET(TAUO_CODE, TaONEW)
	   IF (VTVZ_VERTX)   TAUO_CODE = IBSET(TAUO_CODE, TaOVTV)

C	   Fill TAUO bank
C	   --------------
	   IW(TAUODT+TaOLHd) = TaOHLe		!Length of header
	   IW(TAUODT+TaONVr) = TaOVrs		!Bank version
	   IW(TAUODT+TaOCod) = TAUO_CODE	!Code word

	   IW(TAUODT+TaOCls) = MYCLSL		!# CLSL bank number (up link)
	   IW(TAUODT+TaONTw) = L2NTOW		!L2-like # towers over thresh.
	   IW(TAUODT+TaONTr) = NTRKSHLD		!# tracks in .4 cone
	   IW(TAUODT+TaOR1T) = NTRK10		!# tracks in 10 degree cone
	   IW(TAUODT+TaOR3T) = NTRK30		!# tracks in 10-30 cone
	   IW(TAUODT+TaOOTr) = NTRKOUT		!# tracks with wrong vertex
	   IW(TAUODT+TaOJTS) = JCLST(I)		!JETCLU JETS bank number
	   IW(TAUODT+TaOXNT) = NTCLSH		!# extrap. tracks in .4 cone
	   IW(TAUODT+TaOX10) = NTCL10		!   # in 10 degree cone
	   IW(TAUODT+TaOX30) = NTCL30		!   # in 10-30 degree cone
	   IW(TAUODT+TaOChg) = TOTCHG		!Total charge, 10 deg cone

	   RW(TAUODT+TaOHi2)   = ET2TOW(1)	!Total Et of seed tower
	   RW(TAUODT+TaOHi2+1) = ET2TOW(2)	!  of next highest tower
	   RW(TAUODT+TaOEtE) = TETEM		!Total EM  Et in cal cluster
	   RW(TAUODT+TaOEtH) = TETHAD		!Total HAD Et in cal cluster
	   RW(TAUODT+TaOPh2) = TPHI2		!Phi-Phi moment of cal cluster
	   RW(TAUODT+TaOEt2) = TETA2		!Eta-Eta moment of cal cluster
	   RW(TAUODT+TaOEPx) = P(1)		!Px (cal)
	   RW(TAUODT+TaOEPy) = P(2)		!Py (cal)
	   RW(TAUODT+TaOEPz) = P(3)		!Pz (cal)
	   RW(TAUODT+TaOEPE) = P(4)		!E  (cal)
	   RW(TAUODT+TaOVtx) = TAU_ZV		!Z vertex of tau cluster
	   RW(TAUODT+TaOTPt) = HITPT		!Pt of seed track
	   RW(TAUODT+TaOTAn) = HITANGLE		!Delta-R (seed trk & cal clst)
	   RW(TAUODT+TaOPTo) = TPSUM		!|P| of track cluster
	   RW(TAUODT+TaOTEt) = TETA		!Eta of track cluster
	   RW(TAUODT+TaOTPh) = TPHI		!Phi of track cluster
	   RW(TAUODT+TaOMas) = TMASS		!Inv mass of track cluster
	   RW(TAUODT+TaOMEt) = MET		!MEt using tau Z vertex

	   IF (HIST) THEN
	      CALL HFILL(TAU_HIST_NUM+10, TETEM+TETHAD, 0., 1.)	  !Jet Et
	      CALL HFILL(TAU_HIST_NUM+11, FLOAT(NTOWER), 0., 1.)  !# towers
	      CALL HFILL(TAU_HIST_NUM+12, Rho_Ta(TAUODT), 0., 1.) !Rho
	      CALL HFILL(TAU_HIST_NUM+13, ChFrTa(TAUODT), 0., 1.) !charge fract
	      CALL HFILL(TAU_HIST_NUM+14, Eta_Ta(TAUODT), 0., 1.) !cluster eta
	      CALL HFILL(TAU_HIST_NUM+15, TMASS, 0., 1.)	  !trk clst mass
	   ENDIF

	   GOTO 15

C	   Come here when we fail a cut
C	   ----------------------------
 10	   CONTINUE

C	   If we're doing post-regional tracking cleanup, then
C	   we have to remove a TAUO bank from the list of TAUOs!
C	   -----------------------------------------------------
	   IF (POST_REG)  THEN
	      STATUS = MDROP(IW, 'CALL', TAUO_LIST(TAU_COUNT))
	      STATUS = MDROP(IW, 'CALS', TAUO_LIST(TAU_COUNT))
	      TAUO_LIST(TAU_COUNT) = 0
	   ENDIF

	   IF (HIST) THEN
	      CALL HFILL(TAU_HIST_NUM+20, ETTOT, 0., 1.)	!Jet Et
	      CALL HFILL(TAU_HIST_NUM+21, FLOAT(NTOWER), 0., 1.)!# towers
	      IF (ETTOT .GT. 0.)				!Rho
     &	         CALL HFILL(TAU_HIST_NUM+22,
     &			    (ET2TOW(1)+ET2TOW(2))/ETTOT, 0., 1.)
	      CALL HFILL(TAU_HIST_NUM+23, JETCHF(I), 0., 1.)	!charge fract
	      CALL HFILL(TAU_HIST_NUM+24, JETEta(I), 0., 1.)	!cluster eta
	   ENDIF

C	   End of DO loop over clusters, try next cluster
C	   ----------------------------------------------
 15	   CONTINUE

C	   Make L3TO bank to store cut results, if turned on
C	   -------------------------------------------------
	   IF (BTEST(IW(ID$TAU+TAU_MASK), TAU_L3TO_MAKE)) THEN
	      STATUS = BIGEST(IW, 'L3TO', BNUM)
	      BNUM = BNUM + 1

	      STATUS = BMAKE(IW, 'L3TO', BNUM, 8, BNKTR4, IND, L3TODT)
	      IF (STATUS .EQ. YESUCC) THEN
                 RW(L3TODT+0) = 0.
                 IF (PASS_THIS1) RW(L3TODT+0)=1.        !Did this cluster pass?
		 RW(L3TODT+1) = FLOAT(NTOWER)		!# physical towers
		 RW(L3TODT+2) = ETTOT			!ET total, towers>1Gev
		 RW(L3TODT+3) = T1CUT			!% Et in top tower
		 RW(L3TODT+4) = T2CUT			!% Et in top 2 towers
		 RW(L3TODT+5) = FLOAT(NTRKSEED)		!# seed tracks
		 RW(L3TODT+6) = FLOAT(NTRKSHLD)		!# tracks > shoulder
		 RW(L3TODT+7) = 0.
		 IF (TL2D_MATCH) RW(L3TODT+7)=1.        !Match a L2 tau?
	      ENDIF
	   ENDIF
	ENDDO

 95	CONTINUE

C	We're done, perform cleanup if any TAUO banks made
C	--------------------------------------------------
	IF (TAUO_NUM .GT. 0)  THEN
C	   Add our banks to analysis bank list
C	   -----------------------------------
	   STATUS = BLIST(IW, 'A+', 'CLSLCALLCALSTAUOTTRSTCAE')

C	   Add L3TO to analysis bank list if we're making it
C	   -------------------------------------------------
	   IF (BTEST(IW(ID$TAU+TAU_MASK), TAU_L3TO_MAKE))
     &	      STATUS = BLIST(IW, 'A+', 'L3TO')

C	   For regional tracking, collapse list of TAUO banks
C	   in case some regions failed later cuts
C	   --------------------------------------------------
	   IF (POST_REG) THEN
	      REG_FAIL = 0
	      DO I=1, TAU_COUNT
	         IF (TAUO_LIST(I) .EQ. 0) THEN
		    REG_FAIL = REG_FAIL + 1
		 ELSE
		    TAUO_LIST(I-REG_FAIL) = TAUO_LIST(I)
		 ENDIF
	      ENDDO
	      TAU_COUNT = TAU_COUNT - REG_FAIL
	   ENDIF

C	   Make CLSL bank to keep track of our TAUO (etc) banks
C	   This routine updates TOPA to the correct algorithm number
C	   and adds TOPA to the 'A' list so we don't have to, above
C	   ---------------------------------------------------------
	   CALL MKCLSL(TAU_COUNT, TAUO_LIST, MYCLSL, TAUALG, TaOVrs,
     &		       PARSET, TAU$NM)

C	   Fill histogram if more than one tau
C	   -----------------------------------
	   IF (HIST .AND. TAU_COUNT .GT. 1)
     &	      CALL HFILL(TAU_HIST_NUM, FLOAT(TAU_COUNT), 0., 1.)
	ENDIF

	IF (REG_TRACK)  STATUS = BLIST(IW, 'A+', 'TAUR')

C	Set filter result
C	-----------------
	CALL ANPTRG(PASS)

C	Return to Caller
C	================
	RETURN
	END
C==============================================================================
