c-------------------------------------------------------------------------------
	SUBROUTINE NTUPLE_TRIGGER_STUFF
c-------------------------------------------------------------------------------
C
C This subroutine loops over all the triggers in the TAGC bank and sees if any
C  of the triggers we asked for pass.  It works by specifying the first N
C  letters of the trigger name. If any triggers with that name pass we say that
C  the "Trigger passed". If not, it failed.
C
C   We allow up to 10 triggers to be checked. The number being checked is
C     NTRIG_CHECK
C
c-------------------------------------------------------------------------------
c	Variable Declarations:
c-------------------------------------------------------------------------------
$$IMPLICIT

$$INCLUDE 'UC$ANA:TAGCCM.INC'
$$INCLUDE 'stNTUPLE$SOURCE:TRIGGER_STUFF.INC'

	INTEGER I,J,N		! Loop control variable
C        INTEGER NTRIG_CHECK        ! Number of triggers being checked
C        CHARACTER*32 TRIG_NAME(10) ! Name of trigger being checked
C        INTEGER NLETTERS(10)       ! Number of letters in TRIG_NAME to check
C        INTEGER TRIG_STATUS(10)    ! Pass bit: 1=pass, 2=not-pass or not checked

c-------------------------------------------------------------------------------
c	Start of Code:
c-------------------------------------------------------------------------------
C
C First fill the TAGCCM common block with the TAGC information
C
        CALL TAGBTC(1)
C
C Next initialize the status word...Set to not pass as the default
C

       IF (NTRIG_CHECK .GT. 32) THEN
        WRITE (6,*) 'Only allowed to check on 32 triggers!!!!'
        NTRIG_CHECK = 32
       ENDIF
       DO J = 1, NTRIG_CHECK
        TRIG_STATUS(J) = 2
       ENDDO

	TRIGBITS=0

C
C Next loop over all triggers to see which pass...
C        
       DO I = 1, TAGC_NTRIG
        IF (TAGC_PASS(I).EQ.3) THEN
C
C If the trigger passed, see if this is one of the triggers we are interested
C   in.
C
         DO J = 1, NTRIG_CHECK

	    N=INDEX( TRIG_NAME(J)(1:NLETTERS(J)) , '*' )
	    IF(N.EQ.0) THEN
C IF THERE IS NO * IN THE NAME, CHECK THAT ALL THE REQUESTED
C LETTERS MATCH AND THE NEXT LETTER IS A BLANK
              IF (TAGC_NAME(I)(1:NLETTERS(J)).EQ.
     &                TRIG_NAME(J)(1:NLETTERS(J)) .AND.
     &            TAGC_NAME(I)(NLETTERS(J)+1:NLETTERS(J)+1).EQ.
     &            ' ') THEN
                TRIG_STATUS(J) = 1
	        TRIGBITS=IBSET(TRIGBITS,J-1)
              ENDIF ! The trigger we want? 

	    ELSE ! A * IN THE NAME
C IF THERE IS A * IN THE NAME, CHECK THAT ALL THE REQUESTED
C LETTERS MATCH 

              IF (TAGC_NAME(I)(1:N-1).EQ.
     &                TRIG_NAME(J)(1:N-1) ) THEN
                TRIG_STATUS(J) = 1
	        TRIGBITS=IBSET(TRIGBITS,J-1)
              ENDIF ! The trigger we want? 

            ENDIF ! A * IN THE NAME
         ENDDO ! Loop over all the triggers to be checked...
C
C
C
        ENDIF ! Pass the trigger
      ENDDO ! Loop over all triggers...



c-------------------------------------------------------------------------------
c	End of routine 
c-------------------------------------------------------------------------------
	RETURN
        END
