	SUBROUTINE STN_GENP
C
C MATCH PARTICLE SIN GENP TO THE REQUESTED PARTICLES IN STNTUPLE_TALK.INC
C STORE MATCHES IN STNTUPLE_VAR.INC
C
	IMPLICIT NONE
	$$INCLUDE 'C$INC:PIVALU.INC'
	$$INCLUDE 'GENERATOR$LIBRARY:GENP.INC'
	$$INCLUDE 'GENERATOR$LIBRARY:GNPACK.INC'
	$$INCLUDE 'C$INC:ERLEVL.INC'
	$$INCLUDE 'STNTUPLE$SOURCE:STNTUPLE_VAR.INC'
	$$INCLUDE 'STNTUPLE$SOURCE:STNTUPLE_TALK.INC'
	INTEGER IERR,IGEN,ID,IPAR,IPARID,IASK,I,J
	REAL PTOT,CT,THETA,TT,ETA,ET

	NGENP=0
	IF(NGASK.LE.0) RETURN

	IERR = 6
	CALL GNPBTC(IERR)
	IF (IERR.NE.0) THEN
	  CALL ERLOGR('STN_GENP',ERWARN,0,0,
	1	'Unable to unpack GENP bank')
	  RETURN
	ENDIF

	DO IGEN = 1,NGEN  ! LOOP OVER GENERATED PARTICLES

	  ID=KGEN(1,IGEN)  ! THIS PARTICLES ID
	  IPAR=MOD(KGEN(2,IGEN),NKGPAK)   ! ITS PARENT'S GENP NUMBER
	  IF(IPAR.GT.0.AND.IPAR.LE.NGEN) THEN
	    IPARID=KGEN(1,IPAR)   ! ITS PARENT'S ID
	  ELSE
	    IPARID=0
	  ENDIF

	  DO IASK=1,NGASK   !  LOOP OVER REQUESTED PARTICLES
	    IF(IGASK(IASK).EQ.ID) THEN       ! ID MATCHES 
	      IF(  IPGASK(IASK).EQ.0 .OR.
	1	IPGASK(IASK).EQ.IPARID ) THEN  ! PARENT ID MATCHES

	        PTOT=SQRT( PGEN(1,IGEN)**2+
	1	     PGEN(2,IGEN)**2+PGEN(3,IGEN)**2 )
	        CT=PGEN(3,IGEN)/PTOT
	        THETA=ACOS(CT)
	        TT=TAN(0.5*THETA)
	        IF(TT.LE.0.0) TT=1.E-10
	        ETA=-1.0*LOG(TT)
	        ET=SQRT(PGEN(1,IGEN)**2+PGEN(2,IGEN)**2)

	        IF( ET.GT.GNET(IASK).AND.
	1	     ABS(ETA).LT.GNETA(IASK) .AND.
	1               NGENP.LT.100) THEN        !  PASSES KINEMATIC CUTS
	          NGENP=NGENP+1
	          NGID(NGENP)=ID
	          NGN(NGENP)=IGEN
	          NGNP(NGENP)=IPAR
	          NGPID(NGENP)=IPARID
	          GNP4(1,NGENP)=PGEN(1,IGEN)
	          GNP4(2,NGENP)=PGEN(2,IGEN)
	          GNP4(3,NGENP)=PGEN(3,IGEN)
	          GNP4(4,NGENP)=PGEN(4,IGEN)
	        ENDIF  !  PASSES KINEMATIC CUTS

	      ENDIF  ! PARENT ID MATCHES
	    ENDIF  ! ID MATCHES
	  ENDDO ! LOOP OVER REQUESTED PARTICLES

	ENDDO ! LOOP OVER GENERATED PARTICLES

C FIND DUPLICATES
	DO I=1,NGENP-1
	DO J=I+1,NGENP
	  IF(NGID(I).EQ.NGID(J).AND.GNP4(1,I).EQ.GNP4(1,J).AND.
	1	GNP4(2,I).EQ.GNP4(2,J).AND.
        1       GNP4(3,I).EQ.GNP4(3,J) ) NGID(J)=0
	ENDDO
	ENDDO
C COMPRESS LIST
	J=0
	DO I=1,NGENP
	  IF(NGID(I).NE.0) THEN
	    J=J+1
	    NGID(J)=NGID(I)
	    NGN(J)=NGN(I)
	    NGNP(J)=NGNP(I)
	    NGPID(J)=NGPID(I)
	    GNP4(1,J)=GNP4(1,I)
	    GNP4(2,J)=GNP4(2,I)
	    GNP4(3,J)=GNP4(3,I)
	    GNP4(4,J)=GNP4(4,I)
	  ENDIF
	ENDDO
	NGENP=J

	RETURN
	END

C ***************************************************************************
	SUBROUTINE STN_GENPBAR
C CHECK IF THE PARTICLE IN POSITION NGASK OR ITS PARENT
C HAVE ANTI-PARTICLES.  IF SO, ADD THEN TO THE LIST
	IMPLICIT NONE
	INCLUDE 'UIPACK$LIBRARY:UINAMES.INC'
        INCLUDE 'C$INC:ERLEVL.INC'
	INCLUDE 'STNTUPLE_TALK.INC'
	INTEGER I,NP,IB,IPB,NGASK0,STATUS,LUN,IERR,
	1	IPA(1000),IPBA(1000),NP0
	INTEGER ID,IDB,IDP,IDPB
	LOGICAL FIRST
	DATA FIRST /.TRUE./

C IN THIS IF BLOCK READ IN THE APPROPRIATE CVTABLE.DBT FILE
	IF(FIRST) THEN
	  IF(MCGEN.EQ.1) THEN

	    STATUS=UIGTLU(LUN)
	    OPEN(LUN,FILE='CDFISAC',STATUS='OLD',READONLY,IOSTAT=IERR)
	    IF(IERR.NE.0) THEN
	      CALL ERLOGR('STN_GENP',ERWARN,IERR,0,
	1	'Error while attempting to open CDFISAC input file')
	      RETURN
	    ENDIF

	    NP=1
100	    READ(LUN,110,END=101) IPA(NP),IPBA(NP)
110	FORMAT(40X,2I8)
	      IF(IPA(NP).GT.0) NP=NP+1
	    GOTO 100
101	CONTINUE
	    NP=NP-1

	  ELSE ! PYTHIA IS DEFAULT

	    STATUS=UIGTLU(LUN)
	    OPEN(LUN,FILE='CDFISAC',STATUS='OLD',READONLY,IOSTAT=IERR)
	    IF(IERR.NE.0) THEN
	      CALL ERLOGR('STN_GENP',ERWARN,IERR,0,
	1	'Error while attempting to open  input file')
	      RETURN
	    ENDIF

	    NP=1
200	    READ(LUN,210,END=201) IPA(NP),IPBA(NP)
210	FORMAT(66X,2I7)
	      IF(IPA(NP).GT.0) NP=NP+1
	    GOTO 200
201	CONTINUE
	    NP=NP-1

	  ENDIF  ! BIG IF FOR PYTHIA/ISAJET

C MAKE ONE LIST OF PARTICLES AND ANTI-PARTICLES
	    NP0=NP
	    DO I=1,NP0
	      IF(IPBA(I).LE.0) THEN
	        IPBA(I)=IPA(I)
	      ELSEIF(IPBA(I).NE.IPA(I)) THEN
	        NP=NP+1
	        IPA(NP)=IPBA(I)
	        IPBA(NP)=IPA(I)
	      ENDIF
	    ENDDO

	  FIRST=.FALSE.
	ENDIF


C FIND THE ANTI-PARTICLES
	ID=IGASK(NGASK)
	IDB=ID
	IDP=IPGASK(NGASK)
	IDPB=IDP
	DO I=1,NP
	  IF(IPA(I).EQ.ID) IDB=IPBA(I)
	  IF(IPA(I).EQ.IDP) IDPB=IPBA(I)
	ENDDO

C ADD THE ANTI-PARTICLES TO THE ASK LIST
	NGASK0=NGASK
C IF THE REQUESTED PART HAS AN ANTI-P, ADD THAT TO THE LIST
	IF(IDB.NE.ID) THEN
	  NGASK=NGASK+1
	  IGASK(NGASK)=IDB
	  IPGASK(NGASK)=IPGASK(NGASK0)
	ENDIF
C IF THE REQUESTED PARENT PART HAS AN ANTI-P, ADD THAT TO THE LIST TOO
	IF(IDPB.NE.IDP) THEN
	  NGASK=NGASK+1
	  IGASK(NGASK)=IGASK(NGASK0)
	  IPGASK(NGASK)=IDPB
	  IF(IDB.NE.ID) THEN ! AND THE ANIT-P ANTI-P COMBINATION
	    NGASK=NGASK+1
	    IGASK(NGASK)=IDB
	    IPGASK(NGASK)=IDPB
	  ENDIF
	ENDIF
	DO I=NGASK0+1,NGASK
	  GNET(I)=GNET(NGASK0)
	  GNETA(I)=GNETA(NGASK0)
	ENDDO

	RETURN
	END
