c 
c     11/20/96 Version 4_2 Peter Wilson
c	Make jet_filter = 0 default.  This means the default is to not
c 	remove any jets from the list.
c
c-------------------------------------------------------------------------------
        SUBROUTINE stntuple_EVENT
c-------------------------------------------------------------------------------
c
c       This is the event routine for the STNTUPLE module.
c
c-------------------------------------------------------------------------------
c       Variable Declarations:
c-------------------------------------------------------------------------------
$$IMPLICIT

        CALL FILL_STNTUPLE
c-------------------------------------------------------------------------------
c       End of routine stntuple_EVENT
c-------------------------------------------------------------------------------
        RETURN
        END

c-------------------------------------------------------------------------------
        SUBROUTINE stntuple_FINISH
c-------------------------------------------------------------------------------
c
c       This is the finish routine for the STNTUPLE module.  This routine is
c       called once per execution of the program and is used to print final
c       statistics for this execution of the program, and to print out the
c       PAW file.
c
c-------------------------------------------------------------------------------
c       Variable Declarations:
c-------------------------------------------------------------------------------
$$IMPLICIT
c-------------------------------------------------------------------------------
c       Start of Code:
c-------------------------------------------------------------------------------
C
c-------------------------------------------------------------------------------
c       End of STNTUPLE_FINISH.  Return to caller:
c-------------------------------------------------------------------------------
        RETURN
        END
c-------------------------------------------------------------------------------
        SUBROUTINE STNTUPLE_INIT
c-------------------------------------------------------------------------------
c
c       This is the grand initialization routine for the STNTUPLE module.
c       This routine is called once per execution of the program and is
c       used to set counters.
c
c-------------------------------------------------------------------------------
c       Variable Declarations:
c-------------------------------------------------------------------------------
$$IMPLICIT NONE
$$INCLUDE 'stntuple$source:stntuple_talk.inc'
$$INCLUDE 'stntuple$source:trigger_stuff.inc'    
$$INCLUDE 'stntuple$source:my_jetinfo.inc'    
$$INCLUDE 'C$INC:ERLEVL.INC'
        integer i,STATUS,IUNIT,IERR
        real*8 dummy4(4),dummy 
        CHARACTER*80 FILNAM
C.....External function
        INTEGER UIGTLU        
C
C
C
c-------------------------------------------------------------------------------
c       Start of Code:
c-------------------------------------------------------------------------------
C
        call tmcorr_aa(0,dummy4,dummy,dummy,dummy)
        big_cone = 1
        jtc_version = 1
	cor_version = 1
        jet_filter =  0
        NTRIG_CHECK = 0
	phoiso_type = 0
        no_jt = .false.
        no_j1 = .false.
        no_met = .false.
        no_el = .false.
        no_mu = .false.
        no_tau = .false.
        no_dil = .false.
        no_pho = .false.
        no_tag = .false.
        no_vtx = .false.
        NO_GENP = .false.
        no_trk = .false.
	NGASK=0
	MCGEN=0

        vertexing = 0
        do i = 1,200000
          mcweight(i) = 0.0
        enddo

C
C-----Open table
C.....Check if conversion table exists
      CALL CHKLOG('mcweights',
     &     'stntuple$source:mcweights.dat',FILNAM,IERR)
      IF(IERR.NE.0) THEN
         CALL ERLOGR('STNTUPLE_INIT',ERWARN,0,0
     &        ,'Error while attempting to open MCWEIGHTS input file')
         RETURN
      ELSE
C
C........Get a free LOGICAL unit and open the file
         STATUS=UIGTLU(IUNIT)
C
         OPEN(UNIT=IUNIT,FILE=FILNAM
     &       ,READONLY,SHARED
     &       ,STATUS='OLD',IOSTAT=IERR)
C
         IF(IERR.NE.0) THEN
            CALL ERLOGR('STNTUPLE_INIT',ERWARN,IERR,0,
     &          'Error while attempting to open MCWEIGHTS input file')
            RETURN
         ENDIF
      ENDIF
      DO WHILE (.TRUE.)
        READ (iunit,*,END=19) i,dummy
        mcweight(i) = dummy
        ENDDO
  19  CLOSE (unit=iunit)
      mcweight(i) = dummy

c-------------------------------------------------------------------------------
c       End of STNTUPLE_INIT. Return to caller:
c-------------------------------------------------------------------------------
        RETURN
        END
c-------------------------------------------------------------------------------
        SUBROUTINE STNTUPLE_TALK
c-------------------------------------------------------------------------------
c
c-------------------------------------------------------------------------------
c       Variable Declarations:
c-------------------------------------------------------------------------------
$$IMPLICIT NONE
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'UIPACK$LIBRARY:UINAMES.INC'
$$INCLUDE 'UIPACK$LIBRARY:UIERROR.INC'
$$INCLUDE 'S_I$LIBRARY:NOARGINC.INC'
$$INCLUDE 'stntuple$source:STNTUPLE_TALK.INC'    
$$INCLUDE 'stntuple$source:trigger_stuff.inc'    
$$INCLUDE 'stntuple$source:my_jetinfo.inc'    
c-------------------------------------------------------------------------------
c       Start of Code:
c-------------------------------------------------------------------------------
        INTEGER GROUP,STATUS,I,N,LENSTR
        CHARACTER*20 VERB,STR
        DATA GROUP /0/

        
        IF(GROUP.EQ.0) THEN
          STATUS=UIASGP(GROUP)          ! get uipack verb group assigned
          STATUS=UIDFGP(GROUP)          ! define verb group
          STATUS=UIDFVB('EXIT')         ! here are the known verbs
          STATUS=UIDFVB('BIG_CONE')
          STATUS=UIDFVB('JTC_VERSION')
          status=uidfvb('JET_FILTER')
          status=uidfvb('PHOISO_TYPE')
          status=uidfvb('TRIGGER')
          status=uidfvb('vertexing')
          status=uidfvb('NO_JT')
          status=uidfvb('NO_J1')
          status=uidfvb('NO_MET')
          status=uidfvb('NO_EL')
          status=uidfvb('NO_MU')
          status=uidfvb('NO_TAU')
          status=uidfvb('NO_DIL')
          status=uidfvb('NO_PHO')
          status=uidfvb('NO_TAG')
          status=uidfvb('NO_VTX')
          status=uidfvb('GENP')
          status=uidfvb('MCGEN')
          status=uidfvb('PARTICLE')
          STATUS=UILKGP(GROUP)          ! lock the group
        ENDIF
        STATUS=UIUSGP(GROUP,N$A)

        VERB=' '
        DO WHILE(STATUS.NE.UIABRT) ! keep going unles user ctrl-c or something
          IF (VERB(1:4) .EQ. 'EXIT') RETURN  ! here is the way out of the loop
          IF (VERB(1:8) .EQ. 'BIG_CONE') THEN
C An integer input - last arguments are the allowed range of the input integer
            STATUS=UIGTIN('Big jet cone radius? (1=0.7,2=0.4,3=1.0): '
     &        ,big_cone,1,3)
          ELSEIF (VERB(1:11) .EQ. 'JTC_VERSION') THEN
             STATUS=UIGTIN('Version of JTC corrections?'//
     &'(1=JTC96S, 0=JTC90S):',jtc_version,0,1)
             cor_version = jtc_version
          else if (verb(1:10) .eq. 'JET_FILTER') then
             status = uigtin('Bit-packed word for jet filtering :',
c     +'(see stntuple_v4.cdf for definition of bits in jet_filter)',
     + jet_filter,0,127)
          else if (verb(1:11) .eq. 'PHOISO_TYPE') then
             status = uigtin('Photon Isolation Type'//
     +' (0=Cone, 1=Cone/Box):',phoiso_type,0,1)
          elseif (verb(1:5) .eq. 'NO_JT') then
             no_jt = .true.
          elseif (verb(1:5) .eq. 'NO_J1') then
             no_j1 = .true.
          elseif (verb(1:6) .eq. 'NO_MET') then
             no_met = .true.
          elseif (verb(1:5) .eq. 'NO_EL') then
             no_el = .true.
          elseif (verb(1:5) .eq. 'NO_MU') then
             no_mu = .true.
          elseif (verb(1:6) .eq. 'NO_TAU') then
             no_TAU = .true.
          elseif (verb(1:6) .eq. 'NO_DIL') then
             no_DIL = .true.
          elseif (verb(1:6) .eq. 'NO_PHO') then
             no_PHO = .true.
          elseif (verb(1:6) .eq. 'NO_TAG') then
             no_TAG = .true.
          elseif (verb(1:6) .eq. 'NO_VTX') then
             no_VTX = .true.
          elseif (verb(1:6) .eq. 'NO_GEN') then
             no_GENP = .true.
          elseif (verb(1:6) .eq. 'NO_TRK') then
             no_trk = .true.
        
          ELSEIF (VERB(1:4) .EQ. 'TRIG') THEN

            NTRIG_CHECK = NTRIG_CHECK + 1
            STATUS=UIGTLI('Trigger name?  ',
     &      TRIG_NAME(NTRIG_CHECK),
	1	NLETTERS(NTRIG_CHECK))

            DO I = 1, NTRIG_CHECK
	       N=INDEX( TRIG_NAME(I)(1:NLETTERS(I)) , '*')
	       IF(N.EQ.0) THEN
                  WRITE (6,100) I-1,TRIG_NAME(I)(1:NLETTERS(I))
100	FORMAT(1X,'TRIGBITS, bit ',I2,' is ',A)
	       ELSE
                  WRITE (6,101) I-1,TRIG_NAME(I)(1:N-1)
101	FORMAT(1X,'TRIGBITS, bit ',I2,' is any trigger starting with ',A)
	       ENDIF
            ENDDO


          ELSEIF (VERB(1:4) .EQ. 'VERT') THEN
            STATUS=UIGTIN('Primary vertex selection method'//
     &      '(0=1st VTVZ bank, 1=high sumpt 2=leptocentric, 3=VXPRIM):',
     &      vertexing,0,3)
                              
          ELSEIF (VERB(1:4) .EQ. 'GENP') THEN

C AFTER "GENP" VERB, ENTER "MCGEN X" OR "PARTICLE ID PARENT ET ETA"
C OR "EXIT"
	    DO WHILE(VERB(1:4) .NE. 'EXIT')
              STATUS = UIGTVB('STN_GENP>> ',VERB)  ! the talk-to prompt
	      IF(VERB(1:4) .EQ. 'MCGE') THEN
                STR = 'PYTHIA'
                STATUS = UIGTTX('GENERATOR> ',STR,LENSTR,0,20)
	        IF(STR(1:1).EQ.'P'.OR.STR(1:1).EQ.'p') THEN
	          MCGEN=0
	        ELSEIF(STR(1:1).EQ.'I'.OR.STR(1:1).EQ.'i') THEN
	          MCGEN=1
	        ELSE
	          PRINT*,'Choice PYTHIA or ISAJET not recognized'
	        ENDIF
	      ELSEIF(VERB(1:4) .EQ. 'PART') THEN
	        NGASK=NGASK+1
	        IGASK(NGASK)=1
	        IPGASK(NGASK)=0
	        GNET(NGASK)=0.0
	        GNETA(NGASK)=999.0
                STATUS = UIGTIN('ID> ',IGASK(NGASK),1,10000000)
                STATUS = UIGTIN('ID PARENT> ',IPGASK(NGASK),0,10000000)
                STATUS = UIGTRE('ET CUT> ',GNET(NGASK),0.0,10000.0)
                STATUS = UIGTRE('ETA CUT> ',GNETA(NGASK),0.0,10000.0)
C ALSO ADD THE ANTI-PARTICLES TO THE ASK LIST
	        CALL STN_GENPBAR
	      ELSE
	        PRINT*,'Unrecognized verb in GENP submenu'
	      ENDIF
	    ENDDO  ! LOOP IN GENP SUBMENU

          ENDIF  ! BIG VERB IF

          STATUS = UIGTVB('STNTUPLE>> ',VERB)  ! the talk-to prompt

        ENDDO  !UIABRT
        
    

c-------------------------------------------------------------------------------
c       End of STNTUPLE_TALK. Return to caller:
c-------------------------------------------------------------------------------
        RETURN
        END

c-------------------------------------------------------------------------------
        SUBROUTINE STNTUPLE_BOOK
c-------------------------------------------------------------------------------
c
c-------------------------------------------------------------------------------
c       Variable Declarations:
c-------------------------------------------------------------------------------
$$IMPLICIT NONE
C
C
c-------------------------------------------------------------------------------
c       Start of Code:
c-------------------------------------------------------------------------------
C
        CALL BOOK_STNTUPLE
c
c-------------------------------------------------------------------------------
c       End of STNTUPLE_BOOK. Return to caller:
c-------------------------------------------------------------------------------
        RETURN
        END

