      INTEGER FUNCTION ANSTUP(MODE,INLUN,OUTLUN,DEVICE)
C     =================================================
C
C       Description:-
C       =============
C       This Function is used by Analysis_Control
C       to setup and allocate work space for the
C       standard Utilities used by this program.
C       These standard utilities are:-
C
C       Analysis_Control Configuration
C       UIPack Configuration
C       Database Work Area
C       Primary YBOS Array
C       Primary YHIST Array
C       HBOOK PAWC Common Array
C
C       where only those utilities used in this program
C       are initialised.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER MODE, INLUN,OUTLUN,DEVICE
C
      COMMON/ANCOMM/ANPKI4
      INTEGER       ANPKI4
      DIMENSION     ANPKI4(    131072)
      COMMON/MENUCO/MENUI4
      INTEGER       MENUI4
      DIMENSION     MENUI4(    131072)
      COMMON/KALI  /CALII4
      INTEGER       CALII4
      DIMENSION     CALII4(    500000)
      COMMON/BCS   /YBOSI4
      INTEGER       YBOSI4
      DIMENSION     YBOSI4(    800000)
      INTEGER NKW,KW
      PARAMETER (NKW=50000)
      COMMON/DETECT/KW(NKW)
      COMMON/PAWC  /HBK4I4
      INTEGER       HBK4I4
      DIMENSION     HBK4I4(   2000000)
      INTEGER       ANPKIN, ANSTIN
      INTEGER       UIINIT
      INTEGER       BOSAR
      INTEGER       DBKAIN
      INTEGER       BOS77
C
C
      INTEGER       DBINIT
C
$$Include 'Cdfdb$Library:Errcod.Inc'
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'UIPack$Library:UIError.Inc'
$$Include 'YBOS$Library:ErrCod.Inc'
$$Include 'C$Inc:Erlevl.Inc'
      EXTERNAL ANFIN
C
C       Executable Code:-
C       =================
C
      ANSTUP = ANSUCC
C
C
C       Initialise Analysis_Control
C       ===========================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = ANPKIN(ANPKI4,    131072,'/ANCOMM/', 128)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise UIPack
C       =================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = UIINIT(MODE,INLUN,OUTLUN,DEVICE,    131072, 256)
         IF (ANSTUP .EQ. UISUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Calibration Database YBOS Array
C       ==========================================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBKAIN(CALII4,    500000,'/KALI  /',128)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Primary YBOS Array
C       =============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = BOS77(    800000, 256)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise HBOOK Histogram Package
C       ==================================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         CALL HLIMIT(   2000000)
      ENDIF
C
C       Initialise    CALIB Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','CALIB')
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise GEOMETRY Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','GEOMETRY')
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise RUN_COND Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','RUN_COND')
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise CDF_COND Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','CDF_COND')
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Analysis_Control Status Bank
C       =======================================
C
      ANSTUP = ANSTIN(INLUN,OUTLUN)
C
C       Initialise Offline Commons
C       ==========================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         CALL ANOFFI
      ENDIF
C
C       Return to Caller
C       ================
C
      IF(ANSTUP.NE.ANSUCC)   CALL ANEROR(ANSTUP)
      RETURN
      END
      SUBROUTINE ANLGEO
C     =================
C
C       Description:-
C       =============
C       This Routine is used by Analysis_Control
C       to Load the geometry data base when needed.
C       If offline is not enabled it is dummied.
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
C
        CALL FILGEO
C
C       Return to Caller
C       ================
C
        RETURN
        END
      INTEGER FUNCTION ANFIN(DUMMY)
C     =============================
C
C       Description:-
C       =============
C       This Function is used by Analysis_Control
C       to close the standard  databases upon program
C       termination
C       These standard database are:-
C
C       Calibration Database
C       Geometry Database
C       Run Conditions Database
C       Cdf Conditions Database
C
C       where only those databases used in this program
C       are closed.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
C
      INTEGER DBTERM
C
$$Include 'Cdfdb$Library:ErrCod.Inc'
C
      INTEGER ANHCCL
C
$$Include 'A_C$Library:ANError.Inc'
C
C       Executable Code:-
C       =================
C
      ANFIN = ANSUCC
C
C
C       Close Calibration databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('CALIB')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close Geometry databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('GEOMETRY')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close Run Conditions databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('RUN_COND')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close CDF Conditions databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('CDF_COND')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Cleanup (close) HBOOK4 Histogram Files
C       ======================================
C
      IF (ANFIN .EQ. ANSUCC)
     &   ANFIN = ANHCCL(-1)
C
C       Save status of R_N interface package
C       ====================================
        CALL RNGEND
C
C       Return to Caller
C       ================
C
      IF(ANFIN.NE.ANSUCC)   CALL ANEROR(ANFIN)
      RETURN
      END
      INTEGER FUNCTION ANMDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Subprogram is called by Analysis_Control to
C       declare the Modules in the current Executable
C       Program
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
$$Include 'A_C$Library:ANError.Inc'
C
      INTEGER GQUNDEC
      INTEGER DSQDEC
      INTEGER stntuple_declare
      INTEGER PREPAD
      INTEGER VXTSTD
      INTEGER SECVDC
      INTEGER Jetvdc
      INTEGER JPDECL
      INTEGER BTGSDC
      INTEGER FINDTAU_DEC
      INTEGER QDJCDL
      INTEGER CMCODC
      INTEGER ONEDEC
      INTEGER CMUDEC
      INTEGER TRFIXD
      INTEGER SVXQDE
      INTEGER MKSVDE
      INTEGER METSER_DEC
C
C       Executable Code:-
C       =================
C
      ANMDEC = ANSUCC
C
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = GQUNDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = DSQDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = stntuple_declare(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = PREPAD(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = VXTSTD(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = SECVDC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = Jetvdc(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = JPDECL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = BTGSDC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = FINDTAU_DEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = QDJCDL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = CMCODC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = ONEDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = CMUDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = TRFIXD(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = SVXQDE(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = MKSVDE(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = METSER_DEC(DUMMY)
      ENDIF
C
C       Return to Caller
C       ================
      IF(ANMDEC.NE.ANSUCC)   CALL ANEROR(ANMDEC)
C
      RETURN
      END
      INTEGER FUNCTION GQUNDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module GQUN. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL GQUNINI
      EXTERNAL GQUNEVE
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      GQUNDEC = ANSUCC
C
      IF (GQUNDEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            GQUNDEC = ANDMOD('GQUN',
     &      'GENP Bank Decompression Module (GENQ->GENP)')
            DONE = .TRUE.
         ELSE
            GQUNDEC = ANUMOD('GQUN')
         ENDIF
      ENDIF
      IF (GQUNDEC .EQ. ANSUCC) THEN
         GQUNDEC = ANDENT(GQUNINI,ANMEIN)
      ENDIF
      IF (GQUNDEC .EQ. ANSUCC) THEN
         GQUNDEC = ANDENT(GQUNEVE,ANMEEV)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION DSQDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module DATSQZ. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL DSQGIN
      EXTERNAL DSQEVT
      EXTERNAL DSQFIN
      EXTERNAL DSQTLK
      EXTERNAL DSQBOO
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      DSQDEC = ANSUCC
C
      IF (DSQDEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            DSQDEC = ANDMOD('DATSQZ',
     &      'D-BANK squeezing module/filter')
            DONE = .TRUE.
         ELSE
            DSQDEC = ANUMOD('DATSQZ')
         ENDIF
      ENDIF
      IF (DSQDEC .EQ. ANSUCC) THEN
         DSQDEC = ANDFIL(DUMMY)
      ENDIF
      IF (DSQDEC .EQ. ANSUCC) THEN
         DSQDEC = ANDENT(DSQGIN,ANMEIN)
      ENDIF
      IF (DSQDEC .EQ. ANSUCC) THEN
         DSQDEC = ANDENT(DSQEVT,ANMEEV)
      ENDIF
      IF (DSQDEC .EQ. ANSUCC) THEN
         DSQDEC = ANDENT(DSQFIN,ANMEFI)
      ENDIF
      IF (DSQDEC .EQ. ANSUCC) THEN
         DSQDEC = ANDENT(DSQTLK,ANMETA)
      ENDIF
      IF (DSQDEC .EQ. ANSUCC) THEN
         DSQDEC = ANDENT(DSQFIN,ANMETE)
      ENDIF
      IF (DSQDEC .EQ. ANSUCC) THEN
         DSQDEC = ANDBOO(DSQBOO,   770,   780)
      ENDIF
      IF (DSQDEC .EQ. ANSUCC) THEN
         DSQDEC = ANDMPA( 99)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION stntuple_declare(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module STNTUPLE. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL stntuple_INIT
      EXTERNAL stntuple_EVENT
      EXTERNAL stntuple_FINISH
      EXTERNAL stntuple_TALK
      EXTERNAL stntuple_BOOK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      stntuple_declare = ANSUCC
C
      IF (stntuple_declare .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            stntuple_declare = ANDMOD('STNTUPLE',
     &      'Creates Standard Ntuples')
            DONE = .TRUE.
         ELSE
            stntuple_declare = ANUMOD('STNTUPLE')
         ENDIF
      ENDIF
      IF (stntuple_declare .EQ. ANSUCC) THEN
         stntuple_declare = ANDFIL(DUMMY)
      ENDIF
      IF (stntuple_declare .EQ. ANSUCC) THEN
         stntuple_declare = ANDENT(stntuple_INIT,ANMEIN)
      ENDIF
      IF (stntuple_declare .EQ. ANSUCC) THEN
         stntuple_declare = ANDENT(stntuple_EVENT,ANMEEV)
      ENDIF
      IF (stntuple_declare .EQ. ANSUCC) THEN
         stntuple_declare = ANDENT(stntuple_FINISH,ANMEFI)
      ENDIF
      IF (stntuple_declare .EQ. ANSUCC) THEN
         stntuple_declare = ANDENT(stntuple_TALK,ANMETA)
      ENDIF
      IF (stntuple_declare .EQ. ANSUCC) THEN
         stntuple_declare = ANDBOO(stntuple_BOOK,     0,     0)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION PREPAD(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module PREPAD. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL PREPAD_INIT
      EXTERNAL PREPAD_RINIT
      EXTERNAL PREPAD_EVENT
      EXTERNAL PREPAD_TALK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      PREPAD = ANSUCC
C
      IF (PREPAD .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            PREPAD = ANDMOD('PREPAD',
     &      'Use to expand compressed PADs data.')
            DONE = .TRUE.
         ELSE
            PREPAD = ANUMOD('PREPAD')
         ENDIF
      ENDIF
      IF (PREPAD .EQ. ANSUCC) THEN
         PREPAD = ANDENT(PREPAD_INIT,ANMEIN)
      ENDIF
      IF (PREPAD .EQ. ANSUCC) THEN
         PREPAD = ANDENT(PREPAD_RINIT,ANMERI)
      ENDIF
      IF (PREPAD .EQ. ANSUCC) THEN
         PREPAD = ANDENT(PREPAD_EVENT,ANMEEV)
      ENDIF
      IF (PREPAD .EQ. ANSUCC) THEN
         PREPAD = ANDENT(PREPAD_TALK,ANMETA)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION VXTSTD(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module VXPRIM. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL VXGINI
      EXTERNAL VXRINI
      EXTERNAL VXTSEV
      EXTERNAL VXRFIN
      EXTERNAL VXRTLK
      EXTERNAL VXTSBK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      VXTSTD = ANSUCC
C
      IF (VXTSTD .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            VXTSTD = ANDMOD('VXPRIM','Primary vertex finder')
            DONE = .TRUE.
         ELSE
            VXTSTD = ANUMOD('VXPRIM')
         ENDIF
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDENT(VXGINI,ANMEIN)
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDENT(VXRINI,ANMERI)
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDENT(VXTSEV,ANMEEV)
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDENT(VXRFIN,ANMERF)
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDENT(VXRTLK,ANMETA)
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDBOO(VXTSBK,     0,     0)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION SECVDC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module SECVTX. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL SVTXIN
      EXTERNAL SECVTX
      EXTERNAL SVTXTK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      SECVDC = ANSUCC
C
      IF (SECVDC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            SECVDC = ANDMOD('SECVTX','Seed Vertexing Analysis')
            DONE = .TRUE.
         ELSE
            SECVDC = ANUMOD('SECVTX')
         ENDIF
      ENDIF
      IF (SECVDC .EQ. ANSUCC) THEN
         SECVDC = ANDFIL(DUMMY)
      ENDIF
      IF (SECVDC .EQ. ANSUCC) THEN
         SECVDC = ANDENT(SVTXIN,ANMEIN)
      ENDIF
      IF (SECVDC .EQ. ANSUCC) THEN
         SECVDC = ANDENT(SECVTX,ANMEEV)
      ENDIF
      IF (SECVDC .EQ. ANSUCC) THEN
         SECVDC = ANDENT(SVTXTK,ANMETA)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION Jetvdc(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module JETVTX. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL Jetvin
      EXTERNAL Jetvri
      EXTERNAL Jetvev
      EXTERNAL Jetvtk
      EXTERNAL Jetvbk
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      Jetvdc = ANSUCC
C
      IF (Jetvdc .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            Jetvdc = ANDMOD('JETVTX','Jet Vertexing Algorithm')
            DONE = .TRUE.
         ELSE
            Jetvdc = ANUMOD('JETVTX')
         ENDIF
      ENDIF
      IF (Jetvdc .EQ. ANSUCC) THEN
         Jetvdc = ANDFIL(DUMMY)
      ENDIF
      IF (Jetvdc .EQ. ANSUCC) THEN
         Jetvdc = ANDENT(Jetvin,ANMEIN)
      ENDIF
      IF (Jetvdc .EQ. ANSUCC) THEN
         Jetvdc = ANDENT(Jetvri,ANMERI)
      ENDIF
      IF (Jetvdc .EQ. ANSUCC) THEN
         Jetvdc = ANDENT(Jetvev,ANMEEV)
      ENDIF
      IF (Jetvdc .EQ. ANSUCC) THEN
         Jetvdc = ANDENT(Jetvtk,ANMETA)
      ENDIF
      IF (Jetvdc .EQ. ANSUCC) THEN
         Jetvdc = ANDBOO(Jetvbk,     1,    10)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION JPDECL(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module JPBTAG. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL JPBINI
      EXTERNAL JPBEVT
      EXTERNAL JPTALK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      JPDECL = ANSUCC
C
      IF (JPDECL .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            JPDECL = ANDMOD('JPBTAG','Jet Probability B-Tagger')
            DONE = .TRUE.
         ELSE
            JPDECL = ANUMOD('JPBTAG')
         ENDIF
      ENDIF
      IF (JPDECL .EQ. ANSUCC) THEN
         JPDECL = ANDENT(JPBINI,ANMEIN)
      ENDIF
      IF (JPDECL .EQ. ANSUCC) THEN
         JPDECL = ANDENT(JPBEVT,ANMEEV)
      ENDIF
      IF (JPDECL .EQ. ANSUCC) THEN
         JPDECL = ANDENT(JPTALK,ANMETA)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION BTGSDC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module BTGSMK. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL BTGSIN
      EXTERNAL BTGSEV
      EXTERNAL BTGSFI
      EXTERNAL BTGSTK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      BTGSDC = ANSUCC
C
      IF (BTGSDC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            BTGSDC = ANDMOD('BTGSMK',
     &      'Make combined Btag bank, BTGS')
            DONE = .TRUE.
         ELSE
            BTGSDC = ANUMOD('BTGSMK')
         ENDIF
      ENDIF
      IF (BTGSDC .EQ. ANSUCC) THEN
         BTGSDC = ANDENT(BTGSIN,ANMEIN)
      ENDIF
      IF (BTGSDC .EQ. ANSUCC) THEN
         BTGSDC = ANDENT(BTGSEV,ANMEEV)
      ENDIF
      IF (BTGSDC .EQ. ANSUCC) THEN
         BTGSDC = ANDENT(BTGSFI,ANMEFI)
      ENDIF
      IF (BTGSDC .EQ. ANSUCC) THEN
         BTGSDC = ANDENT(BTGSTK,ANMETA)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION FINDTAU_DEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module FINDTAU. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL FINDTAU_INIT
      EXTERNAL FINDTAU_RINI
      EXTERNAL FINDTAU_EVENT
      EXTERNAL FINDTAU_RFIN
      EXTERNAL FINDTAU_FIN
      EXTERNAL FINDTAU_TALK
      EXTERNAL FINDTAU_BOOK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      FINDTAU_DEC = ANSUCC
C
      IF (FINDTAU_DEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            FINDTAU_DEC = ANDMOD('FINDTAU',
     &      'Production TAU Reconstruction module')
            DONE = .TRUE.
         ELSE
            FINDTAU_DEC = ANUMOD('FINDTAU')
         ENDIF
      ENDIF
      IF (FINDTAU_DEC .EQ. ANSUCC) THEN
         FINDTAU_DEC = ANDFIL(DUMMY)
      ENDIF
      IF (FINDTAU_DEC .EQ. ANSUCC) THEN
         FINDTAU_DEC = ANDENT(FINDTAU_INIT,ANMEIN)
      ENDIF
      IF (FINDTAU_DEC .EQ. ANSUCC) THEN
         FINDTAU_DEC = ANDENT(FINDTAU_RINI,ANMERI)
      ENDIF
      IF (FINDTAU_DEC .EQ. ANSUCC) THEN
         FINDTAU_DEC = ANDENT(FINDTAU_EVENT,ANMEEV)
      ENDIF
      IF (FINDTAU_DEC .EQ. ANSUCC) THEN
         FINDTAU_DEC = ANDENT(FINDTAU_RFIN,ANMERF)
      ENDIF
      IF (FINDTAU_DEC .EQ. ANSUCC) THEN
         FINDTAU_DEC = ANDENT(FINDTAU_FIN,ANMEFI)
      ENDIF
      IF (FINDTAU_DEC .EQ. ANSUCC) THEN
         FINDTAU_DEC = ANDENT(FINDTAU_TALK,ANMETA)
      ENDIF
      IF (FINDTAU_DEC .EQ. ANSUCC) THEN
         FINDTAU_DEC = ANDBOO(FINDTAU_BOOK,     0,     0)
      ENDIF
      IF (FINDTAU_DEC .EQ. ANSUCC) THEN
         FINDTAU_DEC = ANDMPA( 99)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION QDJCDL(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module JETCLU. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL QDJCIN
      EXTERNAL QDJCEV
      EXTERNAL QDJCTA
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      QDJCDL = ANSUCC
C
      IF (QDJCDL .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            QDJCDL = ANDMOD('JETCLU','Jet clustering module')
            DONE = .TRUE.
         ELSE
            QDJCDL = ANUMOD('JETCLU')
         ENDIF
      ENDIF
      IF (QDJCDL .EQ. ANSUCC) THEN
         QDJCDL = ANDENT(QDJCIN,ANMEIN)
      ENDIF
      IF (QDJCDL .EQ. ANSUCC) THEN
         QDJCDL = ANDENT(QDJCEV,ANMEEV)
      ENDIF
      IF (QDJCDL .EQ. ANSUCC) THEN
         QDJCDL = ANDENT(QDJCTA,ANMETA)
      ENDIF
      IF (QDJCDL .EQ. ANSUCC) THEN
         QDJCDL = ANDMPA(  5)
      ENDIF
      IF (QDJCDL .EQ. ANSUCC) THEN
         QDJCDL = ANDHLP(
     &   'C$JET:QDJETC.UIH')
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION CMCODC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module CMCOS. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL CMCOSI
      EXTERNAL CMCOSA
      EXTERNAL CMCOSF
      EXTERNAL CMCOST
      EXTERNAL CMCOSB
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      CMCODC = ANSUCC
C
      IF (CMCODC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            CMCODC = ANDMOD('CMCOS',
     &      'Central Muon Cosmic Ray Identifier')
            DONE = .TRUE.
         ELSE
            CMCODC = ANUMOD('CMCOS')
         ENDIF
      ENDIF
      IF (CMCODC .EQ. ANSUCC) THEN
         CMCODC = ANDFIL(DUMMY)
      ENDIF
      IF (CMCODC .EQ. ANSUCC) THEN
         CMCODC = ANDENT(CMCOSI,ANMEIN)
      ENDIF
      IF (CMCODC .EQ. ANSUCC) THEN
         CMCODC = ANDENT(CMCOSA,ANMEEV)
      ENDIF
      IF (CMCODC .EQ. ANSUCC) THEN
         CMCODC = ANDENT(CMCOSF,ANMEFI)
      ENDIF
      IF (CMCODC .EQ. ANSUCC) THEN
         CMCODC = ANDENT(CMCOST,ANMETA)
      ENDIF
      IF (CMCODC .EQ. ANSUCC) THEN
         CMCODC = ANDENT(CMCOSF,ANMETE)
      ENDIF
      IF (CMCODC .EQ. ANSUCC) THEN
         CMCODC = ANDBOO(CMCOSB,     0,     0)
      ENDIF
      IF (CMCODC .EQ. ANSUCC) THEN
         CMCODC = ANDMPA( 15)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION ONEDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module ONEEVT. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL ONEEVT
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      ONEDEC = ANSUCC
C
      IF (ONEDEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            ONEDEC = ANDMOD('ONEEVT',
     &      'check to see if event was seen')
            DONE = .TRUE.
         ELSE
            ONEDEC = ANUMOD('ONEEVT')
         ENDIF
      ENDIF
      IF (ONEDEC .EQ. ANSUCC) THEN
         ONEDEC = ANDFIL(DUMMY)
      ENDIF
      IF (ONEDEC .EQ. ANSUCC) THEN
         ONEDEC = ANDENT(ONEEVT,ANMEEV)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION CMUDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module CENMUO. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL CMMUOI
      EXTERNAL CMMUBE
      EXTERNAL CMMUOA
      EXTERNAL CMMUOE
      EXTERNAL CMMUOF
      EXTERNAL CMMUOT
      EXTERNAL CMMUBO
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      CMUDEC = ANSUCC
C
      IF (CMUDEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            CMUDEC = ANDMOD('CENMUO','Finds Central Muons')
            DONE = .TRUE.
         ELSE
            CMUDEC = ANUMOD('CENMUO')
         ENDIF
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDFIL(DUMMY)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOI,ANMEIN)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUBE,ANMERI)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOA,ANMEEV)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOE,ANMERF)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOF,ANMEFI)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOT,ANMETA)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOF,ANMETE)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDBOO(CMMUBO,  8700,  8799)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION TRFIXD(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module TRKFIX. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL TRFIXE
      EXTERNAL TRFIXT
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      TRFIXD = ANSUCC
C
      IF (TRFIXD .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            TRFIXD = ANDMOD('TRKFIX','Post-tracking fixup')
            DONE = .TRUE.
         ELSE
            TRFIXD = ANUMOD('TRKFIX')
         ENDIF
      ENDIF
      IF (TRFIXD .EQ. ANSUCC) THEN
         TRFIXD = ANDENT(TRFIXE,ANMEEV)
      ENDIF
      IF (TRFIXD .EQ. ANSUCC) THEN
         TRFIXD = ANDENT(TRFIXT,ANMETA)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION SVXQDE(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module DO_SVX_PAD. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL SVXQGI
      EXTERNAL SVXQRI
      EXTERNAL SVXQEV
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      SVXQDE = ANSUCC
C
      IF (SVXQDE .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            SVXQDE = ANDMOD('DO_SVX_PAD',
     &      'SVX PATTERN RECOGNITION AND FITS FROM PADS')
            DONE = .TRUE.
         ELSE
            SVXQDE = ANUMOD('DO_SVX_PAD')
         ENDIF
      ENDIF
      IF (SVXQDE .EQ. ANSUCC) THEN
         SVXQDE = ANDENT(SVXQGI,ANMEIN)
      ENDIF
      IF (SVXQDE .EQ. ANSUCC) THEN
         SVXQDE = ANDENT(SVXQRI,ANMERI)
      ENDIF
      IF (SVXQDE .EQ. ANSUCC) THEN
         SVXQDE = ANDENT(SVXQEV,ANMEEV)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION MKSVDE(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module SVXSMAKE. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL MKSVGI
      EXTERNAL MKSVRI
      EXTERNAL MKSVXS
      EXTERNAL MKSVTK
      EXTERNAL MKBOOK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      MKSVDE = ANSUCC
C
      IF (MKSVDE .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            MKSVDE = ANDMOD('SVXSMAKE','SVXS FROM QTRK')
            DONE = .TRUE.
         ELSE
            MKSVDE = ANUMOD('SVXSMAKE')
         ENDIF
      ENDIF
      IF (MKSVDE .EQ. ANSUCC) THEN
         MKSVDE = ANDENT(MKSVGI,ANMEIN)
      ENDIF
      IF (MKSVDE .EQ. ANSUCC) THEN
         MKSVDE = ANDENT(MKSVRI,ANMERI)
      ENDIF
      IF (MKSVDE .EQ. ANSUCC) THEN
         MKSVDE = ANDENT(MKSVXS,ANMEEV)
      ENDIF
      IF (MKSVDE .EQ. ANSUCC) THEN
         MKSVDE = ANDENT(MKSVTK,ANMETA)
      ENDIF
      IF (MKSVDE .EQ. ANSUCC) THEN
         MKSVDE = ANDBOO(MKBOOK,     1,    10)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION METSER_DEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module METSER. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL METSER_GINIT
      EXTERNAL METSER_INIT
      EXTERNAL METSER
      EXTERNAL METSER_TALK
      EXTERNAL METSER_BOOK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      METSER_DEC = ANSUCC
C
      IF (METSER_DEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            METSER_DEC = ANDMOD('METSER',
     &      'Module for making METS Bank (Missing Et)')
            DONE = .TRUE.
         ELSE
            METSER_DEC = ANUMOD('METSER')
         ENDIF
      ENDIF
      IF (METSER_DEC .EQ. ANSUCC) THEN
         METSER_DEC = ANDENT(METSER_GINIT,ANMEIN)
      ENDIF
      IF (METSER_DEC .EQ. ANSUCC) THEN
         METSER_DEC = ANDENT(METSER_INIT,ANMERI)
      ENDIF
      IF (METSER_DEC .EQ. ANSUCC) THEN
         METSER_DEC = ANDENT(METSER,ANMEEV)
      ENDIF
      IF (METSER_DEC .EQ. ANSUCC) THEN
         METSER_DEC = ANDENT(METSER_TALK,ANMETA)
      ENDIF
      IF (METSER_DEC .EQ. ANSUCC) THEN
         METSER_DEC = ANDBOO(METSER_BOOK,   200,   250)
      ENDIF
      IF (METSER_DEC .EQ. ANSUCC) THEN
         METSER_DEC = ANDMPA( 99)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
