	   SUBROUTINE UNPTRK(BANK_FLAG)
C==================================================
C MUCH REVISED TRACK-UNPACK ROUTINE FOR 1992 DATA
C
C ==================================================================
C   BANK_FLAG is used to determine how the common block is
C   supposed to be unpacked.  
C   If bit 0 is set, then the SVXS information is used wherever possible.
C   For those tracks that have no SVXS information, or for all tracks if
C   bit 0 is not set, we will use TRKS, if TRKS is present.  
C   If TRKS is not present, but there is CTCS, then we
C   will make TRKS using CTCS.  And if there is no CTCS either, then 
C   we will use QTRK.  It is possible to FORCE the use of QTRK by
C   setting bit 1 = 1.  The default is that both bits are off.
C   NB This assumes that you have TRKS banks and QTRK banks made
C       without SVX information.  If this is not the case, you are
C       on your own.
C
C				REVISED, 30 NOVEMBER 1992
C ===================================================================
	IMPLICIT NONE

	INCLUDE 'UC$ANA:TRAKCM.INC'
      	INCLUDE 'C$INC:CTCALB.INC'              ! contains beam position info
        INCLUDE 'C$INC:TVRTEX.inc'              ! tvdist common
	INCLUDE 'C$INC:CTCGEO.INC'
        INCLUDE 'C$INC:TRKAUX.INC'
        INCLUDE 'C$INC:TRKSCO.INC'
        INCLUDE 'C$INC:ERLEVL.INC'
	INCLUDE 'C$INC:DSFITP.INC'
        INCLUDE 'C$INC:BCS.INC'
	INCLUDE 'C$INC:TRFITC.INC'
	INCLUDE 'C$INC:BTMASK.INC'
        INCLUDE 'uc$ana:vtvzcm.inc'
        INCLUDE 'UC$ANA:UNFLAGS.INC'
	INCLUDE 'C$INC:JOBSTA.INC'
	INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
	INCLUDE 'C$INC:DSCMPB.INC'
	INCLUDE 'C$INC:DSSVXS.INC'
 	INCLUDE 'C$INC:CTCAUX.INC'
	INCLUDE 'C$INC:SVXAUX.INC'
	INCLUDE 'C$INC:DSCTCS.INC'
CCCC	INCLUDE 'C$INC:DSTRKS.INC'
	INCLUDE 'C$INC:CTCNTL.INC'
	INCLUDE 'C$INC:CTCCOM.INC'

	INTEGER NUMINP,CHARGE,HITLAY,NUMOUT,QTRLUN,blkins,VERIND
	integer basins,lcode,count,code,hicins,fitcod,BLKIND
	REAL PX,PY,PZ,ZZVERT,IMPACT,XT(3),PRAPID
	INTEGER HITS(0:NSL-1),LAYER,BNKIND
	LOGICAL FLAG3D,VTC,SVX,IERR,VERINS
	INTEGER QTKIN,QTKIND,NLOOP,imsk
	INTEGER STATUS,BLOCAT,INSBNK,ICTCS,TRKSEL,CTCSEL
	INTEGER ITDVIST,TDVIST,VERTEX,BLKSVX
	INTEGER ITRK,TRKSUN,QTRKUN,STATUS_SVXS
	INTEGER INDDAT,I,J,K,IBEST
	INTEGER NUM_QTRK,TVDIST
	INTEGER I_TRACK
	LOGICAL TRACK_DONE
	REAL DBEST,PT_MOM_CUT
	REAL PAR(5),COV(15),CHI2,RLOW,RHIGH,CHICTC,CHIVTX
	INTEGER STATUS_CTCS,STATUS_QTRK,STATUS_TRKS
	INTEGER EXPAT,NEXT,FT_CODE,FTHIST,FTHIS2,N_DOF
	INTEGER VER_NUM,SVX_HIT,CTC_HIT,VTX_HIT,TOWNR,PATTERN
	LOGICAL USE_QTRK
	INTEGER BANK_FLAG,MODE,SAVENA
	LOGICAL GVER(10)
	LOGICAL FIRST
	INTEGER OLDRUN
	DATA FIRST /.TRUE./
	DATA OLDRUN /-1/

C---------------------------------------------------------
C INITIALIZATION JUNK (Aseet says we don't need it...)
C---------------------------------------------------------
c	IF (FIRST) THEN
c	   FIRST = .FALSE.
c	   CALL TRKINI
c	END IF
c	IF (OLDRUN .NE. NRUN) THEN
c	   OLDRUN = NRUN
c	   CALL TRKRIN
c	END IF
C-----------------------------------------------
C SVX DEPENDENT INITIALIZATION
C------------------------------------------------
	IF (BTEST(BANK_FLAG,0)) THEN
           savena = ctcena
           ctcena = 0
           call ctevin(IERR)
           ctcena = savena
           savena = svxena
           svxena = 0
           call svevin(IERR)
           svxena = savena
        END IF
C------------------
C ZERO OUT COUNTER
C------------------
	N_TRACK = 0
C-------------
C SET PT CUT 
C-------------
      PT_MOM_CUT = PT_MIN        !set pt cut for unpacking
C-----------------------------
C GET VERTEX INFORMATION
C-----------------------------
      DO I=1,NVPRM
        IF(VCLAS(I).GT.0) THEN
          IF(ABS(ZVTV(I)).LT.ZVCUT) THEN
            GVER(I)=.TRUE.           !a good vertex
          ELSE
            GVER(I)=.FALSE.          !not a good vertex
          ENDIF
        ENDIF
      ENDDO
      IF(NVPRM.gt.10) THEN
        CALL ERLOGR('UNPTRK_92',ERWARN,0,STATUS,
     &        '# vertices gt 10: may loose some good tracks')
      ENDIF
C---------------------------
C get true beam position
C---------------------------
      CALL CTVTVZ
C-----------------------------------------------------------------------
C adjust true beam position, if Monte Carlo...(this will need work...)
C-----------------------------------------------------------------------
      if(nrun.lt.100) then
        xbeam=0.
        ybeam=0.
        bmxlin=0.
        bmylin=0.
      endif
C-----------------------------------------
C FIGURE OUT WHICH BANKS ARE AVAILABLE
C----------------------------------------
      status_CTCS = BLOCAT(IW,'CTCS',-1,INSBNK,ICTCS) 
      status_QTRK = BLOCAT(IW,'QTRK',-1,INSBNK,ICTCS) 
      status_TRKS = BLOCAT(IW,'TRKS',-1,INSBNK,ICTCS) 
      status_SVXS = BLOCAT(IW,'SVXS',-1,INSBNK,ICTCS) 
C--------------------------------------------
C IF NO BANKS ARE AVAILABLE, THEN QUIT
C--------------------------------------------
	IF (STATUS_CTCS .NE. YESUCC .AND.
	1   STATUS_QTRK .NE. YESUCC .AND.
	1   STATUS_TRKS .NE. YESUCC ) THEN
		RETURN
	END IF
C---------------------------------
C FIGURE OUT IF WE ARE USING QTRK
C---------------------------------
	USE_QTRK = .FALSE.
	IF (BTEST(BANK_FLAG,1)) USE_QTRK=.TRUE.
	IF (STATUS_CTCS .NE. YESUCC 
	1	.AND. STATUS_TRKS .NE. YESUCC) USE_QTRK = .TRUE.
C--------------------------------------------------------
C THE FIRST TIME AROUND TELL THE USER WHAT WE ARE DOING
C--------------------------------------------------------
	IF (FIRST) THEN
	   FIRST = .FALSE.
	   PRINT *,'    '
	   PRINT *,' ************************************************'
	   PRINT *,' TRACK COMMON BLOCK WILL BE FILLED AS FOLLOWS :'
	   IF (BTEST(BANK_FLAG,0)) THEN
	      PRINT *,' WE WILL USE SVXS BANK WHEREVER POSSIBLE'
	      PRINT *,' AND FOR THOSE TRACKS WITH NO SVXS FIT'
	   END IF
	   IF (USE_QTRK) THEN
	      PRINT *,' WE WILL USE THE QTRK BANK'
	   ELSE IF (STATUS_QTRK .EQ. YESUCC) THEN
	      PRINT *,' WE WILL USE THE EXISTING TRKS BANK'
	   ELSE
	      PRINT *,' WE WILL USE THE TRKS BANK MADE FROM CTCS'
	   END IF
	   PRINT *,' ************************************************'
	END IF
C-----------------------------------------------------------------------
C IF WE HAVE NO QTRK BANK, LET'S MAKE IT..WE'LL NEED IT NO MATTER WHAT
C------------------------------------------------------------------------
	IF (STATUS_QTRK .NE. YESUCC) THEN
	   IF (STATUS_TRKS .NE. YESUCC) THEN
                 MODE = 6
                 CALL TRKMAK(mode)
		 STATUS_TRKS = YESUCC
	   END IF	      
           CALL QTRKMK                                 ! MAKE QTRK
           CALL QTRLCR                                 ! AND THE LINK BANKS
	END IF
C----------------------------------------------------
C let us also make the trks bank, if it is needed
C-----------------------------------------------------
	IF (.NOT.USE_QTRK) THEN
	   IF (STATUS_TRKS .NE. YESUCC) THEN
                 MODE = 6
                 CALL TRKMAK(mode)
		 STATUS_TRKS = YESUCC
	   END IF
	END IF
C---------------------------------
C SET THE CTCSTR FLAG
C---------------------------------
	CTCSTR = .FALSE.
	IF (USE_QTRK) THEN
	   CTCSTR = .FALSE.
	ELSE IF (STATUS_CTCS .EQ. YESUCC) THEN
	   CTCSTR = .TRUE.
	END IF
C--------------------------------------------------
C  NOW LOOP OVER TRKS/QTRK/SVXS BANKS
C  START FILLING THE COMMON BLOCK...FIRST LOOK AT THE SVXS BANKS
C----------------------------------------------------------------
65	CONTINUE
	DO I=1,MAX_TRACK
	   SVXSBNK(I)  = 0
	   SVX_USED(I) = .FALSE.
	END DO
	IF (.NOT.BTEST(BANK_FLAG,0)) GOTO 555
	DO 554 ITRK=1,NSVXS
	   IF (IW(WSVXS+ITRK) .LE. 0) GOTO 554	
	   N_TRACK = N_TRACK + 1
	   IF (N_TRACK .GT. MAX_TRACK) THEN
             CALL ERLOGR('UNPTRK',ERWARN,0,STATUS,
     &                       'too many tracks!!!')
              N_TRACK = MAX_TRACK
              RETURN
           ENDIF
	   SVXSBNK(N_TRACK) = ITRK
	   BNKIND = IW(WSVXS+ITRK)
           CALL SVXSRD(BNKIND,MODE,PAR,COV,VER_NUM,
     1			SVX_HIT,CTC_HIT,VTX_HIT,TOWNR,
     1			PATTERN,RLOW,RHIGH,EXPAT,NEXT,FT_CODE,
     1			FTHIST,FTHIS2,N_DOF,CHI2,CHICTC,CHIVTX)
	   CTANTR(N_TRACK) = PAR(1)
	   CURVTR(N_TRACK) = PAR(2)
	   Z0TR(N_TRACK)   = PAR(3)
	   IMPTR(N_TRACK)  = PAR(4)
	   PHITR(N_TRACK)  = PAR(5)
	   TOWETR(N_TRACK) = TOWNR
	   PTTR(N_TRACK) = 1.49898E-4 * BMAGNT / ABS(PAR(2))
	   IF (PTTR(N_TRACK) .LT. PT_MOM_CUT) THEN
	      N_TRACK = N_TRACK - 1
	      GOTO 554
	   END IF
	   PXTR(N_TRACK) = PTTR(N_TRACK) * COS(PAR(5))
	   PYTR(N_TRACK) = PTTR(N_TRACK) * SIN(PAR(5))
	   PZTR(N_TRACK) = PTTR(N_TRACK) * CTANTR(N_TRACK)
	   PTR(N_TRACK)  = SQRT(PZTR(N_TRACK)**2+PTTR(N_TRACK)**2)
	   THETTR(N_TRACK) = ACOS(PZTR(N_TRACK)/PTR(N_TRACK))
	   XT(1) = PXTR(N_TRACK)
	   XT(2) = PYTR(N_TRACK)
	   XT(3) = PZTR(N_TRACK)
	   ETATR(N_TRACK)  = PRAPID(XT)
	   CTCSBNK(N_TRACK) = NEXT
	   IF (CURVTR(N_TRACK) .GT. 0.0) THEN
		CHTR(N_TRACK) = +1
	   ELSE
	        CHTR(N_TRACK) = -1
	   END IF
	   NSVX_HIT(N_TRACK) = SVX_HIT
	   SVX_LAY_FOUND(N_TRACK) = PATTERN
	   SVX_LAY_EXPEC(N_TRACK) = EXPAT
	   SVX_CHI(N_TRACK) = CHI2
	   DO J=1,15
	      COVTR(J,N_TRACK) = COV(J)
	   END DO
	   RLOWTR(N_TRACK) = RLOW
	   RUPTR(N_TRACK)  = RHIGH
	   DCURV(N_TRACK)  = SQRT(ABS(COV(6)))
	   DPHITR(N_TRACK)  = SQRT(ABS(COV(15)))
	   DCTHTR(N_TRACK)  = SQRT(ABS(COV(1)))
	   DPTTR(N_TRACK)   = PTTR(N_TRACK) * 
	1		      ABS(DCURV(N_TRACK)/CURVTR(N_TRACK))
	   CHI2TR(N_TRACK)  = CHI2 + CHICTC
	   NDOFTR(N_TRACK)  = N_DOF
	   BLKIND = BNKIND + BSVXS
	   QTRKBNK(N_TRACK) = IW(BLKIND+TRCRSV+1) .AND. (MASK32-MASK16)
	   QTRKBNK(N_TRACK) = QTRKBNK(N_TRACK) / 2**16
	   SVX_USED(N_TRACK) = .TRUE.
554	CONTINUE
555	CONTINUE
C-----------------------------------------------
C  NOW LOOP OVER QTRK/TRKS
C-----------------------------------------------
	IF (USE_QTRK) THEN      
	    NUM_QTRK = QTRKUN(0,1)
	    NLOOP    = NUM_QTRK
	ELSE
	    NLOOP    = NTRKS
	END IF

	DO 800 ITRK=1,NLOOP
	   IF (USE_QTRK) THEN
	      STATUS = QTRKUN(ITRK,1)
	   ELSE
	      STATUS = TRKSUN(ITRK,1,0)
	   END IF
	   IF (STATUS .NE. 0) GOTO 800
           IMSK=IAND(TRKSPC,TPMFC)
	   IF (IMSK.NE.TP02FC) GOTO 800		! Not a 3-d track
C- 
C- NB we will set a logical if the track was already unpacked through svxs
c-
	   I_TRACK = 0
	   TRACK_DONE = .FALSE.
	   DO J=1,N_TRACK
	      IF (QTRKBNK(J) .EQ. ITRK) I_TRACK = J
	   END DO
	   IF (I_TRACK .NE. 0) TRACK_DONE = .TRUE.
C-
C- BUMP THE TRACK NUMBER IF NECESSARY...CURRENT TRACK = I_TRACK
C-
	   IF (.NOT.TRACK_DONE) THEN
	    N_TRACK = N_TRACK + 1
	    IF (N_TRACK .GT. MAX_TRACK) THEN
             CALL ERLOGR('UNPTRK',ERWARN,0,STATUS,
     &                       'too many tracks!!!')
              N_TRACK = MAX_TRACK
              RETURN
            ENDIF
	    I_TRACK = N_TRACK         
	   END IF
C-
C- THESE ONLY NEED TO BE FILLED IF IT IS A NEW TRACK
C-
	   IF (.NOT.TRACK_DONE) THEN
CCCC	      IF (USE_QTRK) QTRKBNK(I_TRACK) = ITRK
	      QTRKBNK(I_TRACK) = ITRK
	      CTCSBNK(I_TRACK) = QTRLUN(TRKSBN,'TRK','CTC')
	      IF (CTCSBNK(I_TRACK) .EQ. 0) THEN		! Not a CTC track
	        N_TRACK = N_TRACK - 1
	        GOTO 800
	      END IF 
       	      PXTR(I_TRACK)    = TRKSP4(1)
      	      PYTR(I_TRACK)    = TRKSP4(2)
      	      PZTR(I_TRACK)    = TRKSP4(3)
      	      PTTR(I_TRACK)    = TRKSP4(5)
      	      PTR(I_TRACK)     = TRKSP4(4)
	      IF (PTTR(I_TRACK) .LT. PT_MOM_CUT) THEN
                 N_TRACK = N_TRACK - 1
                 GOTO 800
              END IF
	      CTANTR(I_TRACK)  = TRKSFP(CTFP)
	      CURVTR(I_TRACK)  = TRKSFP(CUFP)
	      Z0TR(I_TRACK)    = TRKSFP(Z0FP)
     	      IMPTR(I_TRACK)   = TRKSFP(D0FP)
	      PHITR(I_TRACK)   = TRKSFP(P0FP)
	      TOWETR(I_TRACK)  = TRKSTO
              IF (TRKSFP(CUFP).GT.0) THEN
                CHTR(I_TRACK) = +1
              ELSE
                CHTR(I_TRACK) = -1
              END IF
	      THETTR(I_TRACK)   = ACOS(PZTR(I_TRACK)/PTR(I_TRACK))
	      ETATR(I_TRACK)   = TRKSP4(6)
	      RLOWTR(I_TRACK)  = TRKSRH(2)
	      RUPTR(I_TRACK)   = TRKSRH(3)
	      DO J=1,15
	         COVTR(J,I_TRACK) = TRKSCV(J)
	      END DO
	      DCURV(I_TRACK)   = SQRT(ABS(TRKSCV(6)))
	      DPHITR(I_TRACK)  = SQRT(ABS(TRKSCV(15)))
	      DCTHTR(I_TRACK)  = SQRT(ABS(TRKSCV(1)))
	      DPTTR(I_TRACK)   = PTTR(I_TRACK) * 
	1		      ABS(DCURV(I_TRACK)/CURVTR(I_TRACK))

	      NDOFTR(I_TRACK)  = TRKSND
	      CHI2TR(I_TRACK)  = TRKSFQ
	   END IF
C--
C- THIS STUFF WILL ONLY WORK WITH CTCS..................
C--
	   IF (USE_QTRK .OR. STATUS_CTCS .NE. YESUCC) THEN	    
	      IGOOD(I_TRACK) = 0  ! NB all QTRK/TRKS banks have to pass TRKSEL
	      DO I=1,3
	         MPTR(I,I_TRACK)  = -100	! NOT FILLED
	      END DO
      	      IGDA(I_TRACK)    = -100	! NOT FILLED
	      CHIAXTR(I_TRACK) = -100	! NOT FILLED
	      CHISTTR(I_TRACK) = -100	! NOT FILLED
	      NAXHTR(I_TRACK)  = -100	! NOT FILLED
	      NSTHTR(I_TRACK)  = -100	! NOT FILLED
	   ELSE			   
              STATUS = BLOCAT(IW,'CTCS',CTCSBNK(I_TRACK),INSBNK,INDDAT) 
	      IF (STATUS .NE. YESUCC) THEN
	          IGOOD(I_TRACK) = 20
CCCC		  PRINT *,' **********************************'
CCCC		  PRINT *,' RUN-EVENT =',NRUN,NEV
CCCC		  PRINT *,' CANNOT FIND CTCS BANK #',CTCSBNK(I_TRACK)
CCCC		  PRINT *,' SUBROUTINE UNPTRK.........'
CCCC		  PRINT *,' **********************************'
	          DO I=1,3
	             MPTR(I,I_TRACK)  = -100	! NOT FILLED
	          END DO
	          CHIAXTR(I_TRACK) = -100	! NOT FILLED
	          CHISTTR(I_TRACK) = -100	! NOT FILLED
	          NAXHTR(I_TRACK)  = -100	! NOT FILLED
	          NSTHTR(I_TRACK)  = -100	! NOT FILLED
	      ELSE
	         IGOOD(I_TRACK)   = TRKSEL('CTC',INDDAT)
	         IGDA(I_TRACK)    = CTCSEL(CTCSBNK(I_TRACK),HITS)
	         VERINS	          = INDDAT + IW(INDDAT)
	         MPTR(1,I_TRACK)  = IW(VERINS+BITMCT) 
	         MPTR(2,I_TRACK)  = IW(VERINS+BITMCT+1) 
	         MPTR(3,I_TRACK)  = IW(VERINS+BITMCT+2)
C- following lines are stolen from CTSDAT ...........
		BASINS		  = INDDAT
	        LCODE             = 0
                BLKINS            = VERINS+IW(BASINS+NWVHCB)
		FITCOD            = -1
                DO COUNT = 1,IW(VERINS+NBLKCB)
                    CODE = ISHFT(IAND(IW(BLKINS+FITCCT+1),CTFLFC)
	1				,-CTSHFC)
                    IF (CODE.GT.LCODE) THEN
                       HICINS = BLKINS
                       LCODE = CODE
                    END IF
                    BLKINS = BLKINS + IW(BASINS+NWBLCB)
                 END DO
                 FITCOD = LCODE
                 BLKINS = HICINS
C- end of stolen section
	         CHIAXTR(I_TRACK) = RW(BLKINS+FITQCT+1)	      
	         CHISTTR(I_TRACK) = RW(BLKINS+FITQCT+2)	      
	         NAXHTR(I_TRACK)  = 0
	         NSTHTR(I_TRACK)  = 0
	         DO LAYER=0,8,2
	            NAXHTR(I_TRACK) = NAXHTR(I_TRACK) + HITS(LAYER)
	         END DO
	         DO LAYER=1,7,2
	            NSTHTR(I_TRACK) = NSTHTR(I_TRACK) + HITS(LAYER)
	         END DO
	      END IF

	   END IF
C-
C- NOW CUT ON TRKSEL, BUT ONLY FOR NEW TRACKS 
C-
765        IF (.NOT.TRACK_DONE) THEN
	      IF (IGOOD(I_TRACK) .NE. 0 .AND. ONLY_TRKSEL) THEN
                 N_TRACK = N_TRACK - 1
	         GOTO 800
              END IF
	   END IF
C-
C- TVDIST JUNK
C-
	   IF (.NOT.USE_QTRK) THEN
	      IGOODV(I_TRACK)  = TVDIST(CTCSBNK(I_TRACK),VTXTR(I_TRACK))
              UTSTTR(I_TRACK)  = UTEST(VTXTR(I_TRACK))
              ZTSTTR(I_TRACK)  = ZDIST(VTXTR(I_TRACK))
	   END IF
C-
C- HITLAY STUFF
C-
	   IF (USE_QTRK) THEN
	      NUMINP = ITRK
	      CALL QTRKCT(NUMINP,CHARGE,PX,PY,PZ,ZZVERT,IMPACT,
	1		  HITLAY,NUMOUT,FLAG3D,VTC,SVX,IERR)
CCC	      SVX_USED(I_TRACK) = SVX
	   ELSE
	      NUMINP = TRKSBN
	      CALL QTRKCT(NUMINP,CHARGE,PX,PY,PZ,ZZVERT,IMPACT,
	1		  HITLAY,NUMOUT,FLAG3D,VTC,SVX,IERR)
	   END IF
	   HITMASK(I_TRACK) = HITLAY
	   K = ISHFT(IAND(TRKSFC,TALGFC),-TASHFC)
	   IF (MOD(K,2).EQ.0) THEN		! even = berge
	      ALGORTR(I_TRACK) = 1
	   ELSE
	      ALGORTR(I_TRACK) = 2
	   END IF
	   FITTR(1,I_TRACK) = TRKSPC
	   FITTR(2,I_TRACK) = TRKSFC
	   FITTR(3,I_TRACK) = 0
C-
C- NOW IT TURNS OUT THAT SOME VTX TRACKS CAN STILL SNEAK THROUGH.
C- LET'S REJECT THEM AT THIS STAGE
C-
	IF (HITLAY .EQ. 0 .AND. (.NOT.TRACK_DONE)) THEN
		N_TRACK = N_TRACK - 1
		GOTO 800
	END IF

800	CONTINUE         
C-----------------------------------------------------------
c  correct all impact parameters
C-----------------------------------------------------------
	do i=1,n_track
           IMPTRR(I)  = IMPTR(I) - (YBEAM + BMYLIN*
     &         Z0TR(I))*COS(PHITR(I)) +
     &         (XBEAM + BMXLIN*Z0TR(I))*SIN(PHITR(I))
	end do
C-----------------------------------------------------------
C Good vertex, iperfect selection
C-----------------------------------------------------------
        IBEST=0
        DBEST=99999.
	do i=1,n_track
           DO J=1,NVPRM
c*******          IF(GVER(J)) THEN         !see if track attaches to good vertex
              IF(ABS(Z0TR(i)-ZVTV(J)).LT.DBEST) THEN
                 IBEST=J
                 DBEST=ABS(Z0TR(i)-ZVTV(J))
              ENDIF
c*******          ENDIF
           ENDDO
           IF(DBEST.LT.VATTCH) THEN
             VTTRA(i)=IBEST
           ELSE
             VTTRA(i)=0
           ENDIF
	   IF (IGOOD(i).EQ.0 .AND. ABS(IMPTRR(i)) .LT. 0.15
	1	.AND.VTTRA(i) .NE. 0) THEN
		    IPERFT_NOVTX(i) = .TRUE.
	   ELSE
		    IPERFT_NOVTX(i) = .FALSE.
	   END IF
	   IF (IPERFT_NOVTX(i) .AND. GVER(VTTRA(i))) THEN
		    IPERFT(i) = .TRUE.
	   ELSE
		    IPERFT(i) = .FALSE.
	   END IF
	end do
C-----------------------------------------------------------
C IF WE ARE NOT USING QTRK, FIGURE OUT THE QTRK NUMBERS
C--------------------------------------------------------
C	IF (.NOT.USE_QTRK) THEN
C	    NUM_QTRK = QTRKUN(0,1)
C	    DO 900 I=1,NUM_QTRK
C	      STATUS = QTRKUN(I,1)
C	      ICTCS = QTRLUN(TRKSBN,'TRK','CTC') 
C---- for debugging purposes
C	      NUMINP = TRKSBN
C	      CALL QTRKCT(NUMINP,CHARGE,PX,PY,PZ,ZZVERT,IMPACT,
C	1		  HITLAY,NUMOUT,FLAG3D,VTC,SVX,IERR)
c---------------------------------------------
C	      DO J=1,N_TRACK
C		 IF (CTCSBNK(J) .EQ. ICTCS) THEN
C			QTRKBNK(J) = I
C			GOTO 900
C		 END IF
C	       END DO
C900	    CONTINUE
C	END IF 
		
	RETURN
	END

