C----------------------------------------------------------------------
C-
C-   Created  16-JAN-1997   David A. Toback
C-      This include file is for use with the Standard NTuple .FOR file
C-      WWGG_ACCEPT to be used in PAW.
C-
C----------------------------------------------------------------------
C
      INTEGER NENTRIES
C
C First we do the logicals for use to identify what sets of this event passes
C
      LOGICAL GOODRUN_VERT
      LOGICAL GOOD_PHO
      LOGICAL GOOD_PLUG_E
      LOGICAL GOOD_E
      LOGICAL GOOD_MU
      LOGICAL GOLD_LEPTON
      LOGICAL GOOD_DIPHO
      LOGICAL GOOD_GG3JET
      LOGICAL GOOD_TRIPHO
      LOGICAL GOOD_LOOSEG ! A second photon?? 
C       This implies that there is already a good photon.
      LOGICAL GOOD_LL
      INTEGER GOOD_ZEE_CC
      INTEGER GOOD_DY_CC
      LOGICAL GOOD_MM
      LOGICAL GOOD_LG
      LOGICAL GOOD_LGM
      LOGICAL GOOD_LLGGMET
      LOGICAL GOOD_EEGGMET
      LOGICAL GOOD_MMLGG
      LOGICAL GOOD_COSDELPHI(10)
C
C Next we do integers which identify what sets of this cuts event passes
C
      INTEGER LEP_STAT
      INTEGER TAG_STAT
      INTEGER NCENTPHO
      INTEGER NCENTPHO25
      INTEGER NCENTPHO25ID
      INTEGER NCENTPHO25IDISO 
      INTEGER NGOODJET
      INTEGER NGOODLEP
      INTEGER NGOODPHO
      INTEGER NGOODTAG
      INTEGER NGOODCE
      INTEGER NEL_N_NPHO
      INTEGER NJNOCOR
C
C Next we do integers and logicals which tell us about individual objects...
C
      INTEGER LEP_ID(10)
      INTEGER WHICH_LEP(10)
      INTEGER PHO_ID(10)
      INTEGER WHICH_PHO(10)
      INTEGER JET_ID(20)
      INTEGER WHICH_JET(20)
      LOGICAL GOODJET(20)
      INTEGER PHO_STAT(10), LPHO_STAT(10), HPHO_STAT(10)
      INTEGER LEPTON_STATUS(30)
      REAL PHO_WHT(10) ! This is referenced to WHICH_PHO
C
C Next we do reals which give object kinematic quantities
C
      REAL LEP_ET(10)
      REAL PHO_ET(10)  ! Note that this is refenced via WHICH_PHO
      REAL GOODJET_ET(20)
      REAL CORR_MET(10),CORR_METPHI(10),COSDELPHI(10)
      REAL HT_EVENT
C
C Next we do reals which give object pair kinematic quantities
C
      REAL LL_MASS,LG_MASS
      REAL DELTA_RPHI(3)   ! 1=Delta R (Lepton-photon), 2=Delta
C                          ! Phi(Lepton-Met), 3=DeltaPhi (Gamma-Met)
C
C Next we do the counters for the number of events which pass the different 
C       sets events.
C
      INTEGER EVENT_TOT(0:30)
      INTEGER LGM_EVENT_TOT(0:30)
      INTEGER EE_CONFIG(0:20,2)
      INTEGER WJET_CONFIG(0:20,2)
C
C Reals used to figure out what type of event this is...
C
      REAL ET_THRESH, ET_THRESH2, LEP_THRESH,EE_THRESH
C
C Logicas used to figure out what type of event this is...
C
      LOGICAL USEHIGH,USELOW,USEREG
C
C Next we do the WUNIT stuff...
C
      INTEGER IPRINT

      INTEGER WUNIT27 ! LgammaMet and Gammagamma table file...
      INTEGER WUNIT31 ! LgammaMet interesting event output file...
      INTEGER WUNIT32 ! LgammaMet electron table file...
      INTEGER WUNIT33 ! LgammaMet muon table file...
      INTEGER WUNIT34 ! Lgamma Summary table 
      INTEGER WUNIT35 ! ???
      INTEGER WUNIT36 ! Secondary LGamma summary table
      INTEGER WUNIT40 ! WJET summary table

      INTEGER WUNIT59 ! diphoton table file
      INTEGER WUNIT60 ! diphoton table file for large met events...
      INTEGER WUNIT61 ! EE_CONFIG results...
      INTEGER WUNIT80 ! Diphoton interesting events table (Long version)
      INTEGER WUNIT81 ! Diphoton interesting events table (Short version)
      INTEGER WUNIT82 ! Z->ee events
      INTEGER WUNIT83 ! Diphoton Purity calculation table
      INTEGER WUNIT95 ! Diphoton summary table
      INTEGER WUNIT96 ! Diphoton interesting events list...
C
C----------------------------------------------------------------------
C
      COMMON /WWGG_ACCEPT/
     &  NENTRIES,
C
C Event Type Logicals
C 
     &  GOODRUN_VERT,GOOD_E,GOOD_MU,GOLD_LEPTON,
     &  GOOD_PHO, GOOD_PLUG_E,
     &  GOOD_DIPHO,GOOD_GG3JET,GOOD_TRIPHO,GOOD_LOOSEG,
     &  GOOD_LL, GOOD_ZEE_CC, GOOD_DY_CC,GOOD_MM,
     &  GOOD_LG,GOOD_LGM,
     &  GOOD_LLGGMET,
     &  GOOD_EEGGMET,
     &  GOOD_MMLGG,
     &  GOOD_COSDELPHI,
C
C Event Type Integers
C
     &  LEP_STAT, TAG_STAT,
     &  NCENTPHO, NCENTPHO25, NCENTPHO25ID, NCENTPHO25IDISO,
     &  PHO_STAT,LPHO_STAT,HPHO_STAT,LEPTON_STATUS,
     &  NGOODJET,NGOODLEP,NGOODPHO,NGOODTAG,NGOODCE,NEL_N_NPHO,NJNOCOR,
C
C Object ID Integers...
C
     &  LEP_ID,WHICH_LEP,
     &  PHO_ID,WHICH_PHO,
     &  JET_ID,WHICH_JET,
     &  GOODJET,PHO_WHT,
C
C Object Kinematic variables
C
     &  LEP_ET,
     &  PHO_ET,
     &  GOODJET_ET,
     &  CORR_MET, CORR_METPHI, COSDELPHI,
     &  HT_EVENT,
C
C Pair kinematic varibles...
C
     &  LL_MASS,LG_MASS,
C
C Event Counters
C
     &  EVENT_TOT,LGM_EVENT_TOT,EE_CONFIG,WJET_CONFIG,
C
C Helpful reals
C
     &  ET_THRESH, ET_THRESH2, LEP_THRESH,EE_THRESH,
C
C Helpful Logicals
C
     & USEHIGH,USELOW,USEREG, 
C
C WUNIT NUMBERS
C
     &  IPRINT,
     &  WUNIT27, WUNIT31, WUNIT32, WUNIT33, 
     &  WUNIT34, WUNIT35, WUNIT36, 
     &  WUNIT40, 
     &  WUNIT59, WUNIT60, WUNIT61,
     &  WUNIT80, WUNIT81, WUNIT82, WUNIT83,
     &  WUNIT95, WUNIT96
C
