      INTEGER FUNCTION ANSTUP(MODE,INLUN,OUTLUN,DEVICE)
C     =================================================
C
C       Description:-
C       =============
C       This Function is used by Analysis_Control
C       to setup and allocate work space for the
C       standard Utilities used by this program.
C       These standard utilities are:-
C
C       Analysis_Control Configuration
C       UIPack Configuration
C       Database Work Area
C       Primary YBOS Array
C       Primary YHIST Array
C       HBOOK PAWC Common Array
C
C       where only those utilities used in this program
C       are initialised.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER MODE, INLUN,OUTLUN,DEVICE
C
      COMMON/ANCOMM/ANPKI4
      INTEGER       ANPKI4
      DIMENSION     ANPKI4(    131072)
      COMMON/MENUCO/MENUI4
      INTEGER       MENUI4
      DIMENSION     MENUI4(    131072)
      COMMON/KALI  /CALII4
      INTEGER       CALII4
      DIMENSION     CALII4(    200000)
      COMMON/BCS   /YBOSI4
      INTEGER       YBOSI4
      DIMENSION     YBOSI4(   1000000)
      INTEGER NKW,KW
      PARAMETER (NKW=50000)
      COMMON/DETECT/KW(NKW)
      COMMON/PAWC  /HBK4I4
      INTEGER       HBK4I4
      DIMENSION     HBK4I4(    131072)
      INTEGER       ANPKIN, ANSTIN
      INTEGER       UIINIT
      INTEGER       BOSAR
      INTEGER       DBKAIN
      INTEGER       BOS77
C
C
      INTEGER       DBINIT
C
$$Include 'Cdfdb$Library:Errcod.Inc'
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'UIPack$Library:UIError.Inc'
$$Include 'YBOS$Library:ErrCod.Inc'
$$Include 'C$Inc:Erlevl.Inc'
      EXTERNAL ANFIN
C
C       Executable Code:-
C       =================
C
      ANSTUP = ANSUCC
C
C
C       Initialise Analysis_Control
C       ===========================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = ANPKIN(ANPKI4,    131072,'/ANCOMM/', 128)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise UIPack
C       =================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = UIINIT(MODE,INLUN,OUTLUN,DEVICE,    131072, 256)
         IF (ANSTUP .EQ. UISUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Calibration Database YBOS Array
C       ==========================================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBKAIN(CALII4,    200000,'/KALI  /',128)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Primary YBOS Array
C       =============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = BOS77(   1000000, 256)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise HBOOK Histogram Package
C       ==================================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         CALL HLIMIT(    131072)
      ENDIF
C
C       Initialise    CALIB Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','CALIB')
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise GEOMETRY Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','GEOMETRY')
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise RUN_COND Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','RUN_COND')
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise CDF_COND Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','CDF_COND')
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Analysis_Control Status Bank
C       =======================================
C
      ANSTUP = ANSTIN(INLUN,OUTLUN)
C
C       Initialise Offline Commons
C       ==========================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         CALL ANOFFI
      ENDIF
C
C       Return to Caller
C       ================
C
      IF(ANSTUP.NE.ANSUCC)   CALL ANEROR(ANSTUP)
      RETURN
      END
      SUBROUTINE ANLGEO
C     =================
C
C       Description:-
C       =============
C       This Routine is used by Analysis_Control
C       to Load the geometry data base when needed.
C       If offline is not enabled it is dummied.
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
C
        CALL FILGEO
C
C       Return to Caller
C       ================
C
        RETURN
        END
      INTEGER FUNCTION ANFIN(DUMMY)
C     =============================
C
C       Description:-
C       =============
C       This Function is used by Analysis_Control
C       to close the standard  databases upon program
C       termination
C       These standard database are:-
C
C       Calibration Database
C       Geometry Database
C       Run Conditions Database
C       Cdf Conditions Database
C
C       where only those databases used in this program
C       are closed.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
C
      INTEGER DBTERM
C
$$Include 'Cdfdb$Library:ErrCod.Inc'
C
      INTEGER ANHCCL
C
$$Include 'A_C$Library:ANError.Inc'
C
C       Executable Code:-
C       =================
C
      ANFIN = ANSUCC
C
C
C       Close Calibration databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('CALIB')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close Geometry databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('GEOMETRY')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close Run Conditions databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('RUN_COND')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close CDF Conditions databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('CDF_COND')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Cleanup (close) HBOOK4 Histogram Files
C       ======================================
C
      IF (ANFIN .EQ. ANSUCC)
     &   ANFIN = ANHCCL(-1)
C
C       Save status of R_N interface package
C       ====================================
        CALL RNGEND
C
C       Return to Caller
C       ================
C
      IF(ANFIN.NE.ANSUCC)   CALL ANEROR(ANFIN)
      RETURN
      END
      INTEGER FUNCTION ANMDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Subprogram is called by Analysis_Control to
C       declare the Modules in the current Executable
C       Program
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
$$Include 'A_C$Library:ANError.Inc'
C
      INTEGER PREPAD
      INTEGER GETRDE
      INTEGER CMUDEC
      INTEGER SVXQDE
      INTEGER MKSVDE
      INTEGER VXTSTD
      INTEGER SECVDC
      INTEGER W4DECL
      INTEGER LJDECL
      INTEGER GQUNDEC
      INTEGER TRFIXD
      INTEGER BTGSDC
      INTEGER CALDEC
      INTEGER QTOWUN_DECLARE
      INTEGER brdecl
      INTEGER PRDECL
C
C       Executable Code:-
C       =================
C
      ANMDEC = ANSUCC
C
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = PREPAD(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = GETRDE(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = CMUDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = SVXQDE(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = MKSVDE(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = VXTSTD(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = SECVDC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = W4DECL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = LJDECL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = GQUNDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = TRFIXD(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = BTGSDC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = CALDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = QTOWUN_DECLARE(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = brdecl(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = PRDECL(DUMMY)
      ENDIF
C
C       Return to Caller
C       ================
      IF(ANMDEC.NE.ANSUCC)   CALL ANEROR(ANMDEC)
C
      RETURN
      END
      INTEGER FUNCTION PREPAD(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module PREPAD. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL PREPAD_INIT
      EXTERNAL PREPAD_RINIT
      EXTERNAL PREPAD_EVENT
      EXTERNAL PREPAD_TALK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      PREPAD = ANSUCC
C
      IF (PREPAD .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            PREPAD = ANDMOD('PREPAD',
     &      'Use to expand compressed PADs data.')
            DONE = .TRUE.
         ELSE
            PREPAD = ANUMOD('PREPAD')
         ENDIF
      ENDIF
      IF (PREPAD .EQ. ANSUCC) THEN
         PREPAD = ANDENT(PREPAD_INIT,ANMEIN)
      ENDIF
      IF (PREPAD .EQ. ANSUCC) THEN
         PREPAD = ANDENT(PREPAD_RINIT,ANMERI)
      ENDIF
      IF (PREPAD .EQ. ANSUCC) THEN
         PREPAD = ANDENT(PREPAD_EVENT,ANMEEV)
      ENDIF
      IF (PREPAD .EQ. ANSUCC) THEN
         PREPAD = ANDENT(PREPAD_TALK,ANMETA)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION GETRDE(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module TRKSMAKE. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL GETRKS
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      GETRDE = ANSUCC
C
      IF (GETRDE .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            GETRDE = ANDMOD('TRKSMAKE','TRKS MAKING MODULE')
            DONE = .TRUE.
         ELSE
            GETRDE = ANUMOD('TRKSMAKE')
         ENDIF
      ENDIF
      IF (GETRDE .EQ. ANSUCC) THEN
         GETRDE = ANDENT(GETRKS,ANMEEV)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION CMUDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module CENMUO. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL CMMUOI
      EXTERNAL CMMUBE
      EXTERNAL CMMUOA
      EXTERNAL CMMUOE
      EXTERNAL CMMUOF
      EXTERNAL CMMUOT
      EXTERNAL CMMUBO
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      CMUDEC = ANSUCC
C
      IF (CMUDEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            CMUDEC = ANDMOD('CENMUO','Finds Central Muons')
            DONE = .TRUE.
         ELSE
            CMUDEC = ANUMOD('CENMUO')
         ENDIF
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDFIL(DUMMY)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOI,ANMEIN)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUBE,ANMERI)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOA,ANMEEV)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOE,ANMERF)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOF,ANMEFI)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOT,ANMETA)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOF,ANMETE)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDBOO(CMMUBO,  8700,  8799)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION SVXQDE(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module DO_SVX_PAD. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL SVXQGI
      EXTERNAL SVXQRI
      EXTERNAL SVXQEV
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      SVXQDE = ANSUCC
C
      IF (SVXQDE .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            SVXQDE = ANDMOD('DO_SVX_PAD',
     &      'SVX PATTERN RECOGNITION AND FITS FROM PADS')
            DONE = .TRUE.
         ELSE
            SVXQDE = ANUMOD('DO_SVX_PAD')
         ENDIF
      ENDIF
      IF (SVXQDE .EQ. ANSUCC) THEN
         SVXQDE = ANDENT(SVXQGI,ANMEIN)
      ENDIF
      IF (SVXQDE .EQ. ANSUCC) THEN
         SVXQDE = ANDENT(SVXQRI,ANMERI)
      ENDIF
      IF (SVXQDE .EQ. ANSUCC) THEN
         SVXQDE = ANDENT(SVXQEV,ANMEEV)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION MKSVDE(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module SVXSMAKE. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL MKSVGI
      EXTERNAL MKSVRI
      EXTERNAL MKSVXS
      EXTERNAL MKSVTK
      EXTERNAL MKBOOK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      MKSVDE = ANSUCC
C
      IF (MKSVDE .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            MKSVDE = ANDMOD('SVXSMAKE','SVXS FROM QTRK')
            DONE = .TRUE.
         ELSE
            MKSVDE = ANUMOD('SVXSMAKE')
         ENDIF
      ENDIF
      IF (MKSVDE .EQ. ANSUCC) THEN
         MKSVDE = ANDENT(MKSVGI,ANMEIN)
      ENDIF
      IF (MKSVDE .EQ. ANSUCC) THEN
         MKSVDE = ANDENT(MKSVRI,ANMERI)
      ENDIF
      IF (MKSVDE .EQ. ANSUCC) THEN
         MKSVDE = ANDENT(MKSVXS,ANMEEV)
      ENDIF
      IF (MKSVDE .EQ. ANSUCC) THEN
         MKSVDE = ANDENT(MKSVTK,ANMETA)
      ENDIF
      IF (MKSVDE .EQ. ANSUCC) THEN
         MKSVDE = ANDBOO(MKBOOK,     1,    10)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION VXTSTD(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module VXPRIM. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL VXGINI
      EXTERNAL VXRINI
      EXTERNAL VXTSEV
      EXTERNAL VXRFIN
      EXTERNAL VXRTLK
      EXTERNAL VXTSBK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      VXTSTD = ANSUCC
C
      IF (VXTSTD .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            VXTSTD = ANDMOD('VXPRIM','Primary vertex finder')
            DONE = .TRUE.
         ELSE
            VXTSTD = ANUMOD('VXPRIM')
         ENDIF
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDENT(VXGINI,ANMEIN)
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDENT(VXRINI,ANMERI)
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDENT(VXTSEV,ANMEEV)
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDENT(VXRFIN,ANMERF)
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDENT(VXRTLK,ANMETA)
      ENDIF
      IF (VXTSTD .EQ. ANSUCC) THEN
         VXTSTD = ANDBOO(VXTSBK,     0,     0)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION SECVDC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module SECVTX. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL SVTXIN
      EXTERNAL SECVTX
      EXTERNAL SVTXTK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      SECVDC = ANSUCC
C
      IF (SECVDC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            SECVDC = ANDMOD('SECVTX','Seed Vertexing Analysis')
            DONE = .TRUE.
         ELSE
            SECVDC = ANUMOD('SECVTX')
         ENDIF
      ENDIF
      IF (SECVDC .EQ. ANSUCC) THEN
         SECVDC = ANDFIL(DUMMY)
      ENDIF
      IF (SECVDC .EQ. ANSUCC) THEN
         SECVDC = ANDENT(SVTXIN,ANMEIN)
      ENDIF
      IF (SECVDC .EQ. ANSUCC) THEN
         SECVDC = ANDENT(SECVTX,ANMEEV)
      ENDIF
      IF (SECVDC .EQ. ANSUCC) THEN
         SECVDC = ANDENT(SVTXTK,ANMETA)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION W4DECL(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module W4JFLT. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL W4JFLT_IN
      EXTERNAL W4JFLT_EV
      EXTERNAL W4JFLT_FI
      EXTERNAL W4JFLT_TK
      EXTERNAL W4JFLT_BK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      W4DECL = ANSUCC
C
      IF (W4DECL .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            W4DECL = ANDMOD('W4JFLT','Standard W+jet filter')
            DONE = .TRUE.
         ELSE
            W4DECL = ANUMOD('W4JFLT')
         ENDIF
      ENDIF
      IF (W4DECL .EQ. ANSUCC) THEN
         W4DECL = ANDFIL(DUMMY)
      ENDIF
      IF (W4DECL .EQ. ANSUCC) THEN
         W4DECL = ANDENT(W4JFLT_IN,ANMEIN)
      ENDIF
      IF (W4DECL .EQ. ANSUCC) THEN
         W4DECL = ANDENT(W4JFLT_EV,ANMEEV)
      ENDIF
      IF (W4DECL .EQ. ANSUCC) THEN
         W4DECL = ANDENT(W4JFLT_FI,ANMEFI)
      ENDIF
      IF (W4DECL .EQ. ANSUCC) THEN
         W4DECL = ANDENT(W4JFLT_TK,ANMETA)
      ENDIF
      IF (W4DECL .EQ. ANSUCC) THEN
         W4DECL = ANDBOO(W4JFLT_BK,     0,     0)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION LJDECL(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module LJETFIT. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL LJETFIT_IN
      EXTERNAL LJETFIT_EV
      EXTERNAL LJETFIT_FI
      EXTERNAL LJETFIT_TK
      EXTERNAL LJETFIT_BK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      LJDECL = ANSUCC
C
      IF (LJDECL .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            LJDECL = ANDMOD('LJETFIT','MINUIT top mass fitter')
            DONE = .TRUE.
         ELSE
            LJDECL = ANUMOD('LJETFIT')
         ENDIF
      ENDIF
      IF (LJDECL .EQ. ANSUCC) THEN
         LJDECL = ANDENT(LJETFIT_IN,ANMEIN)
      ENDIF
      IF (LJDECL .EQ. ANSUCC) THEN
         LJDECL = ANDENT(LJETFIT_EV,ANMEEV)
      ENDIF
      IF (LJDECL .EQ. ANSUCC) THEN
         LJDECL = ANDENT(LJETFIT_FI,ANMEFI)
      ENDIF
      IF (LJDECL .EQ. ANSUCC) THEN
         LJDECL = ANDENT(LJETFIT_TK,ANMETA)
      ENDIF
      IF (LJDECL .EQ. ANSUCC) THEN
         LJDECL = ANDBOO(LJETFIT_BK,     0,     0)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION GQUNDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module GQUN. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL GQUNINI
      EXTERNAL GQUNEVE
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      GQUNDEC = ANSUCC
C
      IF (GQUNDEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            GQUNDEC = ANDMOD('GQUN',
     &      'GENP Bank Decompression Module (GENQ->GENP)')
            DONE = .TRUE.
         ELSE
            GQUNDEC = ANUMOD('GQUN')
         ENDIF
      ENDIF
      IF (GQUNDEC .EQ. ANSUCC) THEN
         GQUNDEC = ANDENT(GQUNINI,ANMEIN)
      ENDIF
      IF (GQUNDEC .EQ. ANSUCC) THEN
         GQUNDEC = ANDENT(GQUNEVE,ANMEEV)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION TRFIXD(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module TRKFIX. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL TRFIXE
      EXTERNAL TRFIXT
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      TRFIXD = ANSUCC
C
      IF (TRFIXD .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            TRFIXD = ANDMOD('TRKFIX','Post-tracking fixup')
            DONE = .TRUE.
         ELSE
            TRFIXD = ANUMOD('TRKFIX')
         ENDIF
      ENDIF
      IF (TRFIXD .EQ. ANSUCC) THEN
         TRFIXD = ANDENT(TRFIXE,ANMEEV)
      ENDIF
      IF (TRFIXD .EQ. ANSUCC) THEN
         TRFIXD = ANDENT(TRFIXT,ANMETA)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION BTGSDC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module BTGSMK. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL BTGSIN
      EXTERNAL BTGSEV
      EXTERNAL BTGSFI
      EXTERNAL BTGSTK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      BTGSDC = ANSUCC
C
      IF (BTGSDC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            BTGSDC = ANDMOD('BTGSMK',
     &      'Make combined Btag bank, BTGS')
            DONE = .TRUE.
         ELSE
            BTGSDC = ANUMOD('BTGSMK')
         ENDIF
      ENDIF
      IF (BTGSDC .EQ. ANSUCC) THEN
         BTGSDC = ANDENT(BTGSIN,ANMEIN)
      ENDIF
      IF (BTGSDC .EQ. ANSUCC) THEN
         BTGSDC = ANDENT(BTGSEV,ANMEEV)
      ENDIF
      IF (BTGSDC .EQ. ANSUCC) THEN
         BTGSDC = ANDENT(BTGSFI,ANMEFI)
      ENDIF
      IF (BTGSDC .EQ. ANSUCC) THEN
         BTGSDC = ANDENT(BTGSTK,ANMETA)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION CALDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module CALORIMETRY. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL CAINIT
      EXTERNAL CALBEG
      EXTERNAL CALEVE
      EXTERNAL CALEND
      EXTERNAL CALTLK
      EXTERNAL CALOBK
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      CALDEC = ANSUCC
C
      IF (CALDEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            CALDEC = ANDMOD('CALORIMETRY',
     &      'Create calorimetry TOWE and wire E-banks')
            DONE = .TRUE.
         ELSE
            CALDEC = ANUMOD('CALORIMETRY')
         ENDIF
      ENDIF
      IF (CALDEC .EQ. ANSUCC) THEN
         CALDEC = ANDFIL(DUMMY)
      ENDIF
      IF (CALDEC .EQ. ANSUCC) THEN
         CALDEC = ANDENT(CAINIT,ANMEIN)
      ENDIF
      IF (CALDEC .EQ. ANSUCC) THEN
         CALDEC = ANDENT(CALBEG,ANMERI)
      ENDIF
      IF (CALDEC .EQ. ANSUCC) THEN
         CALDEC = ANDENT(CALEVE,ANMEEV)
      ENDIF
      IF (CALDEC .EQ. ANSUCC) THEN
         CALDEC = ANDENT(CALEND,ANMERF)
      ENDIF
      IF (CALDEC .EQ. ANSUCC) THEN
         CALDEC = ANDENT(CALTLK,ANMETA)
      ENDIF
      IF (CALDEC .EQ. ANSUCC) THEN
         CALDEC = ANDBOO(CALOBK,  2100,  2110)
      ENDIF
      IF (CALDEC .EQ. ANSUCC) THEN
         CALDEC = ANDHLP(
     &   'C$CAL:CALORIMETRY.UIH')
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION QTOWUN_DECLARE(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module QTOWUN. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL QTOWUI
      EXTERNAL QTOWURI
      EXTERNAL QTOWUN
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      QTOWUN_DECLARE = ANSUCC
C
      IF (QTOWUN_DECLARE .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            QTOWUN_DECLARE = ANDMOD('QTOWUN',
     &      'QTOW Unpacking Module')
            DONE = .TRUE.
         ELSE
            QTOWUN_DECLARE = ANUMOD('QTOWUN')
         ENDIF
      ENDIF
      IF (QTOWUN_DECLARE .EQ. ANSUCC) THEN
         QTOWUN_DECLARE = ANDENT(QTOWUI,ANMEIN)
      ENDIF
      IF (QTOWUN_DECLARE .EQ. ANSUCC) THEN
         QTOWUN_DECLARE = ANDENT(QTOWURI,ANMERI)
      ENDIF
      IF (QTOWUN_DECLARE .EQ. ANSUCC) THEN
         QTOWUN_DECLARE = ANDENT(QTOWUN,ANMEEV)
      ENDIF
      IF (QTOWUN_DECLARE .EQ. ANSUCC) THEN
         QTOWUN_DECLARE = ANDMPA(  2)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION brdecl(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module BRANA. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL branev
      EXTERNAL branbk
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      brdecl = ANSUCC
C
      IF (brdecl .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            brdecl = ANDMOD('BRANA','pull mass stuff out')
            DONE = .TRUE.
         ELSE
            brdecl = ANUMOD('BRANA')
         ENDIF
      ENDIF
      IF (brdecl .EQ. ANSUCC) THEN
         brdecl = ANDENT(branev,ANMEEV)
      ENDIF
      IF (brdecl .EQ. ANSUCC) THEN
         brdecl = ANDBOO(branbk,     0,     0)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION PRDECL(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module DUMP_EVENTS. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  3.01
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'A_C$Library:ANError.Inc'
$$Include 'A_C$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL PRINIT
      EXTERNAL PRRINI
      EXTERNAL PREVT
      EXTERNAL PROTHR
      EXTERNAL PRRFIN
      EXTERNAL PRFINI
      EXTERNAL PRTALK
      EXTERNAL PRABTM
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      PRDECL = ANSUCC
C
      IF (PRDECL .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            PRDECL = ANDMOD('DUMP_EVENTS',
     &      'Dump detector and DAIS YBOS banks')
            DONE = .TRUE.
         ELSE
            PRDECL = ANUMOD('DUMP_EVENTS')
         ENDIF
      ENDIF
      IF (PRDECL .EQ. ANSUCC) THEN
         PRDECL = ANDENT(PRINIT,ANMEIN)
      ENDIF
      IF (PRDECL .EQ. ANSUCC) THEN
         PRDECL = ANDENT(PRRINI,ANMERI)
      ENDIF
      IF (PRDECL .EQ. ANSUCC) THEN
         PRDECL = ANDENT(PREVT,ANMEEV)
      ENDIF
      IF (PRDECL .EQ. ANSUCC) THEN
         PRDECL = ANDENT(PROTHR,ANMEOT)
      ENDIF
      IF (PRDECL .EQ. ANSUCC) THEN
         PRDECL = ANDENT(PRRFIN,ANMERF)
      ENDIF
      IF (PRDECL .EQ. ANSUCC) THEN
         PRDECL = ANDENT(PRFINI,ANMEFI)
      ENDIF
      IF (PRDECL .EQ. ANSUCC) THEN
         PRDECL = ANDENT(PRTALK,ANMETA)
      ENDIF
      IF (PRDECL .EQ. ANSUCC) THEN
         PRDECL = ANDENT(PRABTM,ANMETE)
      ENDIF
      IF (PRDECL .EQ. ANSUCC) THEN
         PRDECL = ANDHLP(
     &   'C$BNK:Prdump.Uih')
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
