	SUBROUTINE DID_MUON_TRIGGER(IBANK,TRIGGER,PASS,IERR)
C--------------------------------------------------
C SUBROUTINE TO DECIDE IF CMU BANK NUMBER IBANK COULD HAVE PASSED 
C A GIVEN CMU/CMX TRIGGER (TO SEE IF THE TRIGGER WAS REALLY PASSED,
C YOU SHOULD CHECK TAGC.  BECAUSE OF THE PRESCALE FACTORS, THAT'S
C THE ONLY WAY TO GET THAT INFORMATION FROM THE PADS)
C
C THE WAY TO USE THIS CODE IS TO FIRST GO INTO TAGC AND SEE WHICH L2 TRIGGERS
C PASSED.  THEN FOR EACH TRIGGER THAT WAS PASSED, CALL THIS SUBROUTINE
C WITH THE APPROPRIATE TRIGGER NUMBER (=TRIGGER IN THE CALLING SEQUENCE). 
C NB : STRICTLY SPEAKING IT IS POSSIBLE FOR A GIVEN LEVEL 2 TRIGGER TO
C      BE PASSED EVEN IF THE LEVEL 1 TRIGGER WAS NOT PASSED (DON'T ASK).
C      HOWEVER, THIS CODE ALSO CHECKS THAT THE INCLUSIVE MUON LEVEL 1
C      TRIGGER WAS PASSED.  ALSO THIS CODE IS NOT PERFECT, IT IS MISSING
C      THE 5 DEGREE MATCHING INFORMATION.  FOR "GOOD" OFFLINE MUONS, 
C      ONE WOULD HOPE THAT THIS EFFECT IS NEGLIGIBLE
C----------------------------------------------------------
C
C	INPUT IBANK     = CMUO BANK NUMBER
C	      TRIGGER   = WHICH TRIGGER YOU CARE ABOUT
C			  1 : CMNP_CFT_12_5DEG_V*
C			  2 : CMUP_CFT_12_5DEG_V*
C			  3 : CMNP_JET*
C			  4 : CMUP_JET*
C			  5 : CMU_CMP_JET*
C			  6 : CMNP_CFT_12_5DEG_M*
C			  7 : CMUP_CFT_12_5DEG_M*
C			  8 : CMX_CFT_12_5DEG_V*
C			  9 : CMX_JET*
C			 10 : CMX_CFT_12_5DEG_M*
C			 11 : CMX_CFT_12_5DEG_E*
C
C	    OUTPUT   PASS = .TRUE./.FALSE. IF TRIGGER COULD HAVE BEEN PASSED
C		     IERR = 0  IF OKAY
C
$$IMPLICIT
$$INCLUDE 'C$INC:JOBSTA.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:CMUO92.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'

	INTEGER IBANK,TRIGGER,IERR
	LOGICAL PASS
        INTEGER STATUS,BLOCAT,IND,IDAT
	INTEGER OLDNRUN,OLDNEV,OLDIBANK
	INTEGER JERR
        LOGICAL L1HIGH,TRACK,CMUP,CMNP,ETAGAP
        REAL E,ETJET

	DATA OLDNRUN /-1/
	DATA OLDNEV /-1/
	DATA OLDIBANK /-1/
C--------------------------------------
C INITIALIZE
C---------------------------------------
	PASS = .FALSE.
	IERR = 0
C----------------------------------------
C MUST BE RUN 1B DATA
C-----------------------------------------
	IF (NRUN .LT. 50000) THEN
	   IERR = 77
	   GOTO 999
	END IF
C-----------------------
C CHECK INPUT PARAMETER
C-----------------------
	IF (TRIGGER .LT. 1 .OR. TRIGGER .GT. 11) THEN
	   IERR = 78
	   GOTO 999
	END IF	
C------------------------------
C MAKE SURE THE BANK IS THERE
C------------------------------
	STATUS = BLOCAT(IW,'CMUO',IBANK,IND,IDAT)
        IF (STATUS .NE. YESUCC) THEN
	    IERR = 1
            GOTO 999
        END IF
C-------------------------------------
C MAKE SURE THE RIGHT STUB IS PRESENT
C-------------------------------------
	IF (TRIGGER.GE.1.AND.TRIGGER.LE.7) THEN
	   IF (.NOT.BTEST(IW(IDAT+MOSTYP),0)) GOTO 999
	END IF
	IF (TRIGGER.GE.8.AND.TRIGGER.LE.11) THEN
	   IF (.NOT.BTEST(IW(IDAT+MOSTYP),2)) GOTO 999
	END IF
C-------------------------------------------------------------------
C IF THIS IS THE SAME BANK AS THE PREVIOUS CALL, THERE IS
C NO NEED TO REPEAT THE CALL TO THE ROUTINE THAT DOES ALL OF THE WORK
C--------------------------------------------------------------------
	IF (OLDNRUN.EQ.NRUN.AND.OLDNEV.
	1	EQ.NEV.AND.OLDIBANK.EQ.IBANK) GOTO 500
	OLDNRUN  = NRUN
	OLDNEV   = NEV
	OLDIBANK = IBANK
	CALL MU_HARDW_TRIGGER(IBANK,L1HIGH,TRACK,E,
	1	    ETJET,CMUP,CMNP,ETAGAP,JERR)
C--------------------------------------
C NOW CHECK IT OUT
C---------------------------------------
500	CONTINUE
	IERR = JERR
	IF (IERR .NE. 0)  GOTO 999
	IF (.NOT.L1HIGH)  GOTO 999
	IF (.NOT.TRACK)   GOTO 999
	IF (TRIGGER.EQ.1.OR.TRIGGER.EQ.3.OR.TRIGGER.EQ.6) THEN
	   IF (.NOT.CMNP) GOTO 999
	END IF
	IF (TRIGGER.EQ.2.OR.TRIGGER.EQ.4.OR.TRIGGER.EQ.7) THEN
	    IF (.NOT.CMUP) GOTO 999
	END IF
ccccc	IF (TRIGGER.EQ.5.AND.(.NOT.ETAGAP)) GOTO 999
	IF (TRIGGER.EQ.3.OR.TRIGGER.EQ.4.OR.TRIGGER.EQ.5.OR.
	1   TRIGGER.EQ.9) THEN
	    IF (ETJET .LT. 14.9) GOTO 999
	END IF
	IF (TRIGGER.EQ.6.OR.TRIGGER.EQ.7.OR.TRIGGER.EQ.10) THEN
	    IF (E.GT.3.1) GOTO 999
	END IF
	IF (TRIGGER.EQ.11) THEN
	   IF (E.LT.0.1) GOTO 999
        END IF
C----------------------------------
C IF WE GOT HERE, THIS IS A WINNER
C----------------------------------
	PASS = .TRUE.
C---------------------------
C DONE
C---------------------------
999	CONTINUE
	RETURN
	END
