c ====================================================================
c  DILMORE.INC
C ====================================================================
c
c   This include file contains additional information about the dilepton 
c   selection other than that already kept in DILINFO.INC.
c   Each variable is discussed below.
c   The variables are filled by DIL_TOPOLOGY called from TOPFND.CDF.
c
c   Rob Roser, 23-Oct-1995
c ----------------------------------------------------------------------
c
c  Event Variables
c	
c	MUO1_PTR	=> Pointer to the MUOINFO banks for muon in the event
c	MUO2_PTR	
c
c			  note -- if muo*_ptr < 0, then muon is a cmio
c
c	ELE1_PTR	=> Pointer to the ELEINFO banks for muon in the event
c	ELE2_PTR	
c			  note -- if ele*_ptr < 0, then electron is a plug
c
c	JTELE1_BNK	=> bank number of jet corresponding to ele1/2_ptr elec.
c	JTELE2_BNK	   (ijetbnk)
c
c	DIL_WRD         => Bit packed word containing cut information
c
c                 Cut word with the following bits (1=failed,0=passed)
c                      bit                                  
c                        0.....Two leptons in event(If set,no other cuts tested)
c                        1.....Z Cut (1=this is a Z event)
c                        2.....Opposite Sign Cut
c                        3.....Cosmic Ray Filter
c                        4.....Met > 25 GeV
c                        5.....Lepton Angle for 25<MET<50
c                        6.....Jet Angle for 25<MET<50
c                        7.....Number of Jets >= 2
c
c  ============================================================================

      COMMON/DILMORE/ muo1_ptr,muo2_ptr,ele1_ptr,ele2_ptr,
     &          jtele1_bnk,jtele2_bnk,dil_wrd

      INTEGER JTELE1_BNK,JTELE2_BNK
      integer muo1_ptr,muo2_ptr
      integer ele1_ptr,ele2_ptr
      integer dil_wrd
      
