C=======================================================================
	Subroutine get_cor_imp_par(Zv,Itrk,Imp,ImpErr,Ierr)
C=======================================================================
C
C	Calculates corr imp parameter for trak Itrk (QTRK convention)
C	For primary located at Zv (supply Z0 of primary lepton)
C	returns Imp (corr imp par) 
C   	        Ierr error code 0 ok
C				1 no vtvz
C				2 no beam spot stored
C				3 Can't unpack TRKS for track Itrk
C
$$IMPLICIT NONE
C Global Declarations:
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:CTCALB.INC'
$$INCLUDE 'C$INC:CTCGEO.INC'
$$INCLUDE 'C$INC:CTCAUX.INC'
$$INCLUDE 'C$INC:VTCAUX.INC'	! VTCS event pointers
$$INCLUDE 'C$INC:TRKSCO.INC'
$$INCLUDE 'C$INC:ANACTL.INC'
$$INCLUDE 'C$INC:SIMH.INC'
$$INCLUDE 'C$INC:OBS203.INC'
C    External Declarations.
        INTEGER STATUS, TRKSUN
	REAL CDFPHI
C   temporary storage
	INTEGER NV,KCLASS
	REAL    ZV
	INTEGER SAVENA, VCODE, I, Itrk, Ierr
        REAL    ERRXY, TEMP, ERRPhi, ImpErr, Phi
        REAL    Imp, PAROUT(5), COVOUT(15), PARIN(5), COVIN(15)
        Real    PrVx(3),PrCv(6),PrChi2
        Real    PrVx_wo(3),PrCv_wo(6),PrChi2_wo
        Real    PrVx_ct(3),PrCv_ct(6),PrChi2_ct
        Integer Prim,PrNtr
        Integer Prim_wo,PrNtr_wo
        Integer Prim_ct,PrNtr_ct

        INTEGER OLDRUN,OLDEV
        DATA OLDRUN /-1/, OLDEV  /-1/
C-----------------------------------------------------------------------
C
C First step: Get beam position, for the given Zv.
C
	IF (NRUN.NE.OLDRUN .OR. NEV.NE.OLDEV) THEN    ! same event:
C		(once per event!!!)
	    OLDRUN   = NRUN
	    OLDEV    = NEV
C If this is Monte Carlo, then get info from SIMH
	    If (LMONTE) then
               call SMHBTC(ierr)
               if (ierr.eq.0) then
	         xbeam     = pinsim(shxave)
      	         Bmxlin    = pinsim(shxslp)
      	         ybeam     = pinsim(shyave)
      	         bmylin    = pinsim(shyslp)
      	         sigbmx    = pinsim(shxsig)
      	         sigbmy    = pinsim(shysig)
	         PrVx(1) = Xbeam + BMXLIN*ZV
	         PrVx(2) = Ybeam + BMYLIN*ZV
	         PrVx(3) = ZV
	         PrCv(1) = sigbmx**2
	         PrCv(2) = 0.0
	         PrCv(3) = 0.0
	         PrCv(4) = sigbmy**2
	         PrCv(5) = 0.0
	         PrCv(6) = 0.3**2
	         PrNtr   = -999
	         PrChi2  = -999
	         Prim = 0
               else
                 Call OBSBTC(ierr)
                 if(ierr.eq.0) then
                   PrVx(1) = pvobs(1,1)
                   PrVx(2) = pvobs(2,1)
                   PrVx(3) = Zv
                   PrCv(1) = 0.0035**2
                   PrCv(2) = 0.
                   PrCv(3) = 0.
                   PrCv(4) = 0.0035**2
                      PrCv(5)=0.
                   PrCv(6)=0.3**2
                  PrNtr   = -999
                  PrChi2  = -999
                  Prim = 0 
                 else
                  call erlogr('GETCORIMPPAR',ERWARn,0,0,
     &                 'cannot find MC primary vertex')
                 endif
               endif
	       Go To 777
	    Endif
C
	    SAVENA = CTCENA
      	    CTCENA = 4
      	    CALL CTEVIN(STATUS)
      	    CTCENA = SAVENA
C
C  determine vcode based on whether SVX or CTC beam position is used
C
      	   IF (IVTVZ.LE.0) THEN
C got no VTVZ bank
      	      vcode = 3.
      	   ELSEIF (IW(IVTVZ+3).EQ.3) THEN
C got an SVX beam spot
      	      vcode = 1.
      	   ELSEIF (IW(IVTVZ+3).EQ.0) THEN
C got no beam spot
      	      vcode = 4.
      	   ELSE
C got a CTC beam spot
      	      vcode = 2.
      	   ENDIF
C
	    Prim = VCODE
	    sigbmx = 0.0040	    ! 40 micron err's
	    sigbmy = 0.0040
c keepit also in triangular form for the various SVX types...
	    PrVx(1) = Xbeam + BMXLIN*ZV
	    PrVx(2) = Ybeam + BMYLIN*ZV
	    PrVx(3) = ZV
	    PrCv(1) = sigbmx**2
	    PrCv(2) = 0.0
	    PrCv(3) = 0.0
	    PrCv(4) = sigbmy**2
	    PrCv(5) = 0.0
	    PrCv(6) = 0.3**2
	    PrNtr   = -999
	    PrChi2  = -999
	    If (Vcode .eq. 3) Then
		Ierr = 1	    ! no VTVZ bank 
		PRINT *,' ************************************'
		PRINT *,' NO VTVZ BANK..ROUTINE GET_COR_IMP...'
		PRINT *,' RUN AND EVENT = ',NRUN,NEV
		PRINT *,' ************************************'
		Return
	    Else If (Vcode .eq. 4) Then
		Ierr = 2	    ! no beam spot stored
		PRINT *,' ************************************'
		PRINT *,' NO BEAM SPOT...ROUTINE GET_COR_IMP...'
		PRINT *,' RUN AND EVENT = ',NRUN,NEV
		PRINT *,' ************************************'
		Return
	    End If
777 	    Continue
	End If
C
C Second step: Unpack track info for track number Itrk. 
C
            STATUS = TRKSUN(Itrk,1,0)	
            IF (status.ne.0)                      Then
		Ierr = 3	    ! could not unpack track info
		PRINT *,' ************************************'
		PRINT *,' NO TRACK..ROUTINE GET_COR_IMP...'
		PRINT *,' TRACK NUMBER = ',ITRK
		PRINT *,' RUN AND EVENT = ',NRUN,NEV
		PRINT *,' ************************************'
		Return
	    End If
      	    DO I = 1, 5
      	      PARIN(I) = TRKSFP(I)
      	    END DO
      	    DO I = 1, 15
      	      COVIN(I) = TRKSCV(I)
      	    END DO
C
C Third step: Get correct impact parameter:
C
      	Call Trchor(PARIN,COVIN,PrVx,PAROUT,COVOUT)
      	Imp = PAROUT(4)
	Phi = Cdfphi(PAROUT(5))
      	If (covout(13).gt.0.0) then
      	   Imperr = Sqrt(covout(13))
      	   ERRXY  = COS(Phi)**2*PrCv(4) + SIN(Phi)**2*PrCv(1) -
     1		     2.*SIN(Phi)*COS(Phi)*PrCv(2)
      	   TEMP   = SIN(Phi)*PrVx(2) + COS(Phi)*PrVx(1)
      	   ERRPhi = TEMP**2*COVOUT(15) + 2.*TEMP*COVOUT(14)
      	   ImpErr = SQRT(Imperr**2 + ERRXY + ERRPhi)
      	Else
      	   Imperr = -999.0
      	Endif
	Ierr = 0		    ! all is well
C Done
	Return
	End
