C=======================================================================
	SUBROUTINE GET_SOFT_ELECTRON(ITRK,FLAG)
c=======================================================================
C Description:
C		Get soft electron information for Qtrk track number = ITRK
C		The information is then stored in the include file
C		SOFTELE.INC.
C			FLAG = 1	: ONLY DO TRACKING STUFF
C			FLAG = 2	: DO TRACKING AND TOWE STUFF
C			FLAG = 3	: DO TRACKING, TOWE AND CES/CPR STUFF
C
C  This is a cleaned up version of Avi's CESXC.FOR
C			Claudio
C				9-Mar-1992
C
C	***** NEW ONCE AGAIN, 1-FEB-1993 ***********
C
C   Added HXS and SUMP variable	      Baber 5-May-93
C
C   Renamed CESFT0 ---> CESSLT	      Claudio 13-April-1994
C
C   Fix bug in calculation of ZFID between towers 0 and 1
C   Also, implement additional correction on top of CESALG
c					Claudio 22-August-1994
C
C   Fix-up CPR z positions	        Claudio 30-August-1994
C
C	
C Implicit none declaration:
$$IMPLICIT NONE
C Global Declarations:
$$INCLUDE 'A_C$LIBRARY:ANCOMP_EXP_ID.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
$$INCLUDE 'C$INC:DSTOWE.INC'
$$INCLUDE 'C$INC:TREXPO.INC'
$$INCLUDE 'C$INC:DSELES.INC'
$$INCLUDE 'C$INC:CTCALB.INC'
$$INCLUDE 'C$INC:ELFPRM.INC'
$$INCLUDE 'C$INC:DSCMPB.INC'
$$INCLUDE 'C$INC:DSFITP.INC'
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:DSCALS.INC'
$$INCLUDE 'C$INC:CTCCOM.INC'
$$INCLUDE 'C$INC:TRKSCO.INC'
$$INCLUDE 'C$INC:STRKCO.INC'
$$INCLUDE 'C$INC:TRKAUX.INC'
$$INCLUDE 'C$INC:LOGUNI.INC'
$$INCLUDE 'C$INC:DSJETS.INC' 
$$INCLUDE 'C$INC:BTMASK.INC'
$$INCLUDE 'C$INC:CPRCOM.INC'
$$INCLUDE 'C$INC:DSVTXS.INC'
$$INCLUDE 'C$INC:SOFTELE.INC'
$$INCLUDE 'C$INC:ANACTL.INC'
C    External Declarations.
	INTEGER BLOCAT,ANPTRG,SLDE1A,SLDE1B
        LOGICAL SVXACC
C External function     
	INTEGER	UIGTLU
        INTEGER TRKSUN
        INTEGER QTRLUN
        INTEGER GETENE
	REAL	CDFPHI
	REAL	PROB
C   storage
	INTEGER NCLSMX,JTCLST,N_JETS,N_TRKS
	PARAMETER (NCLSMX=20)
	DIMENSION JTCLST(NCLSMX)
C   counters
	INTEGER	ii,I,J,K,K1,K2,IPE,IP,NCON,III
        INTEGER ISL,NSTER
	INTEGER	IM
C   temporary storage
	INTEGER	STATUS
        INTEGER TOWE_IND 
        INTEGER TOWE_INDT, EDTE, EDBE, Num_towers
	INTEGER BELSE, BELSM, IELSE, IELSM
	INTEGER	IPHI,IETA,NTOWER,IEAST
	INTEGER	IPHIT,IETAT,NTOWERT,IEASTT
	INTEGER FLAG
        INTEGER ITRK,BEAMF
        INTEGER Tow_Num,WEDGE
	INTEGER INB,iopt,isvx, Jsvx
	REAL DZ1,DZ2
	INTEGER IETANB
        REAL    PK,PTK,CTHK,PHI,CONE
        REAL    BORENE,BORTOW,smt
          CHARACTER*60  Correction_File, Array_File
          DATA  Correction_File /'C$QFL:CORRECTION_DEC1.DAB'/
          DATA  Array_File /'C$QFL:ARRAY2.DAB'/
          Logical LOWELE(2)
          Logical First,Align 
	  Logical Want_Svx/.false./ ! you don't need to do it if you have 
				    ! PREPAD in front... 
          DATA  First/.True./
          Real    R_CES,sumcov
	INTEGER NRHITS/4/
	REAL    ZTOL/1.5/    
	INTEGER OLD_RUN /-1/
	INTEGER OLD_EVENT /-1/  
        DATA  r_ces/183.9/
	data iopt/2/,align/.true./
	INTEGER IERR_CPR
          REAL          View_Value, Cos_Theta, CosTh, xoff
          COMMON /VWSET/        View_Value, Cos_Theta
        REAL    Imperr, ERRXY, TEMP, ERRPhi
        REAL    XMAX,EXMAX,ZMAX,EZMAX 
        REAL    SRES, VRES, S, TDIFF, RT, PHIM, MASSM, xgam(20)
	real    bound(11),zfidt,zfids
	logical cprset
	REAL    EEM2,ETEM2,EHAD2,ETHAD2
	REAL	P,PT,ET
	REAL	Q
        REAL    X2
        REAL    X3,z3,ex3,ez3
	REAL    CPRSHIFT(48)
	REAL    PARAM(5),XYZ(6),DXYZ(6),PARSVX(5)
	REAL	PAROUT(5), COVOUT(15), PARIN(5), COVIN(15), XNEW(3)
        REAL    GLOPHI,RADIUS   
	REAL    SUM_WIRE_E, SUM_STRIP_E
	REAL    ESTPMX, EWIRMX, EI
        INTEGER STPI, WIRI,    CUT
	Real    Strip_Chan_width, Wire_Chan_width 
	Real    sig10, sig2, arg, args 
	Real    Diff_s, Diff_w, Diff_ss, Diff_ws 
	Real    ch_sum 
	Real    XDIF,ZDIF,CHI2S,CHI2W,x2s,x2w
	Logical PH, MATCH
C Arguments                                      
        Real    x1list(25),x2list(25),plist(25)
        Real    x0s,q0s,xrawss,qrawss,xchisqs,cfitvs(25),widths
        Real    x0w,q0w,xrawsw,qrawsw,xchisqw,cfitvw(25),widthw

	Real    Dxctc, Dzctc
	
        INTEGER DUMMY1,DUMMY2                    
	REAL DUMMY,OLD
        INTEGER CHARGE,HITLAY,CTCSN,SELECT,IERR,FITQ 
        INTEGER CHARGEK,HITLAYK,CTCSNK,SELECTK,IERRK,FITQK
        LOGICAL FLAG3DK,SECVTXK,VTPCK,CTCK,VTXCONK
        REAL PXK,PYK,PZK,ZVK,IMPACTK    
        REAL PX,PY,PZ,ZV,IMPACT                  
        LOGICAL FLAG3D,SECVTX,VTPC,CTC,VTXCON
        REAL    XSTP(3),DXSTP(3),CHSTP(2),ESTP(2),CHI2(2)
C
        Integer Nstrip, Nwire  !Strip/Wire # of CES to center the cluster
	Integer Channels	   !Number of CES channels per CES cluster
	Integer Num_Strip_Clusts   !Number of strip clusts found and put in bank
	Integer Num_Wire_Clusts    !Number of wire  clusts found and put in bank
	Real Wire_Clust_Energy(0:63) !Saved energy of wire clusters
	Real Clust_X(0:63)            !Saved position of wire clusters
	Real Strip_Clust_Energy(0:127) !Saved energy of strip clusters
	Real Clust_Z(0:127)            !Saved position of strip clusters
c
c	Prof:		 (wiri,1,chan)- wire Energy
c			 (wiri,2,chan)- wire Position
        Real Wire_Prof ( 63,2,20) ! Wire Profile, and coordinate.
        Real Strip_Prof(127,2,20) ! Strip Profile, and coordinate.
        Real St_Chan(127,2)       ! Strip clust # chan: 1=min_i, 2=max_i
        Real Wi_Chan(63,2)        ! Wire  clust # chan: 1=min_i, 2=max_i
        integer N_Wi_Chan         ! # of chan in Wire  clust 
        integer N_St_Chan         ! # of chan in Strip clust 

	Real    Shower_Center,Chan_Hi_Edge,Chan_Lo_Edge,Pulse_Height
	Real    Derivative
	Integer Chan_View
C   Ybos pointers 
        INTEGER   QTRKFD,INQTRK,IDQTRK
        INTEGER   INDDAT,JELES,JDELES  
        INTEGER   INDS,INDDATS,BLKIND,VERIND,BASIND
	INTEGER   Inddat_CALL, Ind_CALL
	REAL FIXCSE
        CHARACTER*8  CHCON(200), CHCES(200)
        CHARACTER*32 FILE_NAME,TITLE                         
        REAL XCPR0,ZCPR0
        COMMON /CLA/XCPR0,ZCPR0


c 
c
        DATA BOUND/0.00,24.16,48.32,72.48,96.64,120.8,144.97,169.12,
     +	           193.28,217.45,245.96/
        REal Rces/184.15/,Rcpr/168.29/   ! Radii
	data cprset /.false./
C-----------------------------------------------------------------------
C
C---------------------------------------------------------------
C  INITIALIZE
C---------------------------------------------------------------
	CEM_SOFT    = .FALSE.
	ETA_SOFT    = -999
	PHI_SOFT    = -999
	XCTC 	    = -999.
	ZCTC 	    = -999.
	ZCTC 	    = -999.
	ZFID 	    = -999.
	EEM  	    = -999.
	EHAD 	    = -999.
	ETEM 	    = -999.
	ETHAD       = -999.
	FRAC_EEM    = 1.0
	FRAC_EHAD   = 1.0
	FRAC_ETEM   = 1.0
	FRAC_ETHAD  = 1.0
	MYCONT_FLAG = -999
	PAIR_MASS   = -999.
	EBORDER     = -999.
	SUMTK       = -999.
	NUMTK       = -999
	GASGAIN     = -999.
	HXS         = 0.0
	SUMP        = 0.0
	DO I=1,5
	 ESTRIP_SOFT(I)  = -999.
	 EWIRE_SOFT(I)   = -999.
	 ZEW_STRIP(I)  = -999.
	 ZF_STRIP(I) = -999.
	 XEW_WIRE(I)   = -999.
	 XF_WIRE(I)  = -999.
	 CHISTRIP(I)= -999.
	 CHIWIRE(I) = -999.
	 WIDTH_STRIP(I) = -999.
	 WIDTH_WIRE(I)  = -999.
	 ETOTSTRIP(I)   = 0.0
	 ETOTWIRE(I)    = 0.0
	END DO
	if (.not.cprset) then
	   CPRSET = .TRUE.
	   CPRSHIFT(1)  =   120.1000
	   CPRSHIFT(2)  =   120.2000
	   CPRSHIFT(3)  =   120.7000
	   CPRSHIFT(4)  =   121.0000
	   CPRSHIFT(5)  =   120.9000
	   CPRSHIFT(6)  =   121.2000
	   CPRSHIFT(7)  =   119.5000
	   CPRSHIFT(8)  =   119.0000
	   CPRSHIFT(9)  =   119.3000
	   CPRSHIFT(10) =   120.5000
	   CPRSHIFT(11) =   119.9000
	   CPRSHIFT(12) =   119.3000
	   CPRSHIFT(13) =   120.7000
	   CPRSHIFT(14) =   119.6000
	   CPRSHIFT(15) =   119.7000
	   CPRSHIFT(16) =   120.1000
	   CPRSHIFT(17) =   119.4000
	   CPRSHIFT(18) =   120.4000
	   CPRSHIFT(19) =   119.0000
	   CPRSHIFT(20) =   119.0000
	   CPRSHIFT(21) =   119.1000
	   CPRSHIFT(22) =   119.6000
	   CPRSHIFT(23) =   119.8000
	   CPRSHIFT(24) =   120.6000
	   CPRSHIFT(25) =   119.9000
	   CPRSHIFT(26) =   119.8000
	   CPRSHIFT(27) =   119.7000
	   CPRSHIFT(28) =   120.9000
	   CPRSHIFT(29) =   120.8000
	   CPRSHIFT(30) =   120.0000
	   CPRSHIFT(31) =   120.0000
	   CPRSHIFT(32) =   119.3000
	   CPRSHIFT(33) =   119.0000
	   CPRSHIFT(34) =   119.0000
	   CPRSHIFT(35) =   119.0000
	   CPRSHIFT(36) =   119.9000
	   CPRSHIFT(37) =   119.0000
	   CPRSHIFT(38) =   119.3000
	   CPRSHIFT(39) =   119.1000
	   CPRSHIFT(40) =   119.8000
	   CPRSHIFT(41) =   119.1000
	   CPRSHIFT(42) =   119.0000
	   CPRSHIFT(43) =   120.5000
	   CPRSHIFT(44) =   121.2000
	   CPRSHIFT(45) =   120.0000
	   CPRSHIFT(46) =   120.5000
	   CPRSHIFT(47) =   120.1000
	   CPRSHIFT(48) =   119.8000
	END IF
C------------------------------------------------------
C check flag
C------------------------------------------------------
	if (flag .lt. 0 .or. flag .gt. 3) then
	   print *,' illegal call to get_soft_electron..run,ev=',nrun,nev
	end if
C-----------------------------------------------------
C UNPACK QTRK BANK, APPLY TRKSEL, ASK FOR 3D AND CTC
C-------------------------------------------------------
            STATUS = TRKSUN(ITRK,1,0)
            IF (status.ne.0)                      GOTO 100
            PX = TRKSP4(1)
            PY = TRKSP4(2)
            PZ = TRKSP4(3)
            PT = SQRT (PX**2 + PY**2)
            P  = SQRT (PX**2 + PY**2 + PZ**2)
      	    IF (TRKSFP(CUFP).GT.0) THEN
      		Q = +1
      	    ELSE
      		Q = -1
      	    END IF
C--------------------------------------------------
C NOW EXTRAPOLATE THE TRACK TO THE EM CALORIMETER
C--------------------------------------------------
            PARAM(1) = TRKSFP(CUFP) ! CU
            PARAM(2) = TRKSFP(D0FP) ! D
            PARAM(3) = TRKSFP(P0FP) ! PHI0
            PARAM(4) = TRKSFP(CTFP) ! CTG
            PARAM(5) = TRKSFP(Z0FP) ! Z0
	    CALL TRPROP_AY(1,PARAM,TRPOEC,XYZ,DXYZ,IERR)
	    IF (IERR .NE. 0) GOTO 100
	    CALL XYZTOW(XYZ,IETA,IPHI,IERR)
	    IF (IERR .NE. 0) GOTO 100
	    IF (IETA .GT. 52 .OR. IETA .LT. 33) GOTO 100

C------------------------------------------------------
C TRACK IS IN CENTRAL, FILL TOWE ADDRESS VARIABLES
C------------------------------------------------------
	    CEM_SOFT = .TRUE.
	    ETA_SOFT = IETA
	    PHI_SOFT = IPHI
c------------------------------------------------------
c Use MYCONT to see if this track could be a conversion
c------------------------------------------------------
	    CUT = 1
	    call MYCONT(ITRK,CUT,
     +			  S,TDIFF,RT,PHIM,IM,MASSM,XGAM,VRES,SRES,IERR)
	    MYCONT_FLAG = IERR
	    PAIR_MASS   = MASSM
C---------------------------------------------
c FILL SUMTK VARIABLE
C---------------------------------------------
	     CALL GET_SUMTK(ITRK,SMT)
	     SUMTK = SMT
C---------------------------------------------
c FILL dE/dx VARIABLES....protect against Monte Carlo
C---------------------------------------------
        if (exptyp.eq.run1b) then
	  dEdx_Flag = slde1b(ITRK,Q_CTC,NCTHit,Q_SVX,NSVHit)
Cdk  TEMPORARY PATCH as told by Hovhannes
          if(nrun.gt.67390)Q_CTC=Q_CTC-5.5
        elseif(exptyp.eq.run1a) then
	  dEdx_Flag = slde1a(ITRK,Q_CTC,NCTHit,Q_SVX,NSVHit)
	end if
C---------------------------------------------
C UNPACK CPR and get SVX info (into C$INC:STRKCO.INC):
C (once per event)
C---------------------------------------------
        IF (LMONTE) GOTO 677
	IF (NRUN .NE. OLD_RUN .or. NEV .NE. OLD_EVENT) THEN
	    OLD_RUN   = NRUN
	    OLD_EVENT = NEV
	    CALL CPRBTC(IERR_CPR)
	END IF
c refill track common block with the current track:
 	STATUS = TRKSUN(ITRK,1,0)
C Fliporder of helix pars for SVX code, a beauty...
      	PARSVX(2) = PARAM(1)     ! CU
      	PARSVX(4) = PARAM(2)     ! D
      	PARSVX(5) = PARAM(3)     ! PHI0
      	PARSVX(1) = PARAM(4)     ! CTG
      	PARSVX(3) = PARAM(5)     ! Z0
c Is CTC track in SVX fid vol? (NRHITS = 4, ZTOL = 1.5 cm.)
	FID_SVX = SVXACC(PARSVX,NRHITS,ZTOL)
	svx_px = -999.
	svx_py = -999.
	svx_pz = -999.
	svx_p  = -999.
	svx_pt = -999.
	svx_im = -999.
	svx_p0 = -999. 
	svx_x2 = -999.
	svx_ht = -999.
	CALL VZERO(QSV_CH,4)
	Jsvx = -999
	Corr_Imp = -999.
	Err_Imp  = -999.
	sumcov = 0.0
	QSV_FAIL = 0
	do isvx = 1, nsvx
	    if (itrk .eq. STRKBN(isvx))	then
		do i = 1, 15
		  sumcov = sumcov + STRKCV(isvx,I) 
		end do
		if (sumcov .eq. 0) Then
		    QSV_FAIL = 1 
		    goto 555
		End if
 		svx_px = STRKP4(isvx,1)
		svx_py = STRKP4(isvx,2)
		svx_pz = STRKP4(isvx,3)
		svx_p  = STRKP4(isvx,4)
		svx_pt = STRKP4(isvx,5)
		svx_im = STRKFP(isvx,d0fp)
		svx_x2 = STRKFQ(isvx)
		svx_ht = STRKSV(isvx)
		QSV_CH(1) = STRKCQ(isvx,0)	! Cluster charge
		QSV_CH(2) = STRKCQ(isvx,1)	
		QSV_CH(3) = STRKCQ(isvx,2)	
		QSV_CH(4) = STRKCQ(isvx,3)	
		Jsvx = isvx
		goto 555
	    end if
	end do
555	continue
	soft_prim_flag = 0
	If (Jsvx .gt. 0) Then
	    svx_p0 = STRKFP(Jsvx,P0FP) 
	    STATUS = BLOCAT(IW,'VTXS',-1,INDS,INDDATS)
      	    IF (STATUS .EQ. YESUCC) Then
	      soft_prim_flag = 1
	      BASIND = INDDATS + DSHDCB
	      VERIND = BASIND  + IW(BASIND)
	      BLKIND = VERIND  + IW(BASIND+NWVHCB)
	      Xnew(1) = RW(BLKIND+X0VX)
	      Xnew(2) = RW(BLKIND+Y0VX)
	      Xnew(3) = RW(BLKIND+Z0VX)
	      DO I = 1, 5
		PARIN(I) = STRKFP(Jsvx,I)
	      END DO
	      DO I = 1, 15
		COVIN(I) = STRKCV(Jsvx,I)
	      END DO
	      Call TRCHOR(PARIN,COVIN,XNEW,PAROUT,COVOUT)
	      Corr_Imp = PAROUT(4)
              If (covout(13).gt.0.0) then
                Imperr = Sqrt(covout(13))
                Errxy    = COS(svx_p0)**2*RW(BLKIND+DY02VX) +
     1                     SIN(svx_p0)**2*RW(BLKIND+DX02VX) -
     2			   2.*SIN(svx_p0)*COS(svx_p0)*RW(BLKIND+DX02VX+1)
                TEMP   = SIN(svx_p0)*Xnew(2) + COS(svx_p0)*Xnew(1)
                ERRPhi = TEMP**2*COVOUT(15) + 2.*TEMP*COVOUT(14)
                Err_Imp = SQRT(Imperr**2 + ERRXY + ERRPhi)
              Else
                Err_Imp = 1.0
              Endif
	    End If	
	End If	
C--------------------------------------
C NOW DO CES prop.
C--------------------------------------
677	If( IEta .gt. 42)Then
	    Tow_Num = IEta-43
	    IEAST = 1
	Else 
	    Tow_Num = 42-IEta
	    IEAST = 0
	End If
	zv = TRKSFP(Z0FP) 
	call CESALG(PARAM,IEAST,IPHI,ZV,XCTC,ZCTC,DXCTC,DZCTC,
     2			IERR)
	IF (IERR .NE. 0) GOTO 100
        IF (EXPTYP.EQ.RUN1A) THEN
	   XCTC = XCTC + DXCTC
	   ZCTC = ZCTC + DZCTC
	ELSE
	  CALL CES_CORRECTION(IETA,IPHI,XCTC,ZCTC)
	END IF
	ZFID = bound(Tow_num+1) - ZCTC
C-----------------------------------------------------------
C NOW do CPR prop.
C----------------------------------------------------------
           CALL CPREXT(PARAM,CPR_WEDGE,XCPR,ZCPR,IERR)
	   XCPR0 = XCPR
	   ZCPR0 = ZCPR
           IF (EXPTYP.EQ.RUN1B) THEN 
	       ZCPR = ZCPR - (CPRSHIFT(CPR_WEDGE+1)-121.6)
	   END IF
	   XYZ(1) = XCPR
	   XYZ(2) = 0.0
	   XYZ(3) = ZCPR
	   IF (IERR .EQ. 0) THEN
	     CALL CPRWIR(CPR_WEDGE,XYZ,CPR_WIRE,CPR_FID)
C- IN CASE YOU ARE LINKED TO A CPRWIR THAT DOES NOT INCLUDE THE
C- CHIMNEY CUT (E.G. VERSION 7_11), WE ADD THE CUT HERE.....
             IF (CPR_WEDGE.EQ.29.AND.ABS(XYZ(3)).GT.119.7) THEN
                CPR_WIRE=-1
                CPR_FID=1
             END IF
	   ELSE
	     CPR_FID = -999
	   END IF
C--------------------------------------------------------------------
C... compute the sum P of all tracks excluding the electron track
C... in a cone of 0.2 around the electron.
C--------------------------------------------------------------------
	CONE = 0.2
	CALL CALC_SUMP(ITRK,SUMP,CONE)
C------------------------------------
C FILL THE TOWE VARIABLES
C------------------------------------
	IF (FLAG .EQ. 1) GOTO 100
        IERR = GETENE(IPHI,IETA,EEM,EHAD,ETEM,ETHAD)
	IF (IERR .NE. 0) GOTO 100
C-- add the energy of the neighboring tower if needed
	IF (ZFID .LT. -2.0 .AND. ZFID .GT. -22.) GOTO 875
	IETANB = -999
	IF (ZFID .GT. -2.0) THEN	   
	   IF (IETA .GE.43) THEN
	       IETANB = IETA - 1
	   ELSE	            
	       IETANB = IETA + 1
	   END IF
	END IF
	IF (ZFID .LT. -22.0) THEN	   
	   IF (IETA .GE.43) THEN
	       IETANB = IETA + 1
	   ELSE	            
	       IETANB = IETA - 1
	   END IF
	END IF
C- correct tower 0 mistake
	IF (IETA.EQ.43.AND.IETANB.EQ.42) IETANB=-999
	IF (IETA.EQ.42.AND.IETANB.EQ.43) IETANB=-999
C- correct tower 9 mistake
	IF (IETA.EQ.52.AND.IETANB.EQ.53) IETANB=-999
	IF (IETA.EQ.33.AND.IETANB.EQ.32) IETANB=-999

	   IF (IETANB .NE. -999) THEN
      	       IERR = GETENE(IPHI,IETANB,EEM2,EHAD2,ETEM2,ETHAD2)
	       IF (IERR .EQ. 0 .AND. EEM2 .GT. 0.0) THEN
		    IF ( (EEM2+EEM)   .GT. 0.0)  FRAC_EEM = EEM/(EEM2+EEM)
		    IF ( (EHAD2+EHAD) .GT. 0.0)  FRAC_EHAD = EHAD/(EHAD2+EHAD)
		    IF ( (ETEM2+ETEM) .GT. 0.0)  FRAC_ETEM = ETEM/(ETEM2+ETEM)
		    IF ( (ETHAD2+ETHAD).GT.0.0)  FRAC_ETHAD = ETHAD/(ETHAD2+ETHAD)
		    IF (FRAC_EEM .GT. 0)   EEM    = EEM    / FRAC_EEM
		    IF (FRAC_ETEM .GT. 0)  ETEM   = ETEM   / FRAC_ETEM
		    IF (FRAC_EHAD .GT. 0)  EHAD   = EHAD   / FRAC_EHAD
		    IF (FRAC_ETHAD .GT. 0) ETHAD  = ETHAD  / FRAC_ETHAD
	       END IF
	   END IF
875	CONTINUE

C----------------------------------------------------------
C... Compute Hxs = hadronic energy - 0.05*Electromagnetic E
C...                                 (leakage)
C----------------------------------------------------------
	HXS = EHAD - 0.05*EEM

C---------------------------------------------------
C  FIND GAS GAIN FACTOR FOR THIS RUN
C---------------------------------------------
	IF (FLAG .EQ. 2) GOTO 100
	IF (IETA .LE. 42) THEN
	   WEDGE = IPHI + 1
	ELSE
	   WEDGE = IPHI + 25
	END IF
	DUMMY = 10.
	OLD     = DUMMY
	GASGAIN = DUMMY/OLD 
C----------------------------------------------
C DO THE CPR STUFF....fix up the cpr x position after clustering
c	(1) the sign is flipped by the clustering
c	(2) the position returned by the clustering is at CES assuming
c	    straight line propagation
C----------------------------------------------
	IF (IERR_CPR .EQ.0) THEN
	   IF (CPR_FID .EQ. 0) THEN
	      ECPR_SOFT(1) = CPRCHG(CPR_WEDGE,CPR_WIRE)
	      XCPR_SOFT(1) = CPRX(CPR_WEDGE,CPR_WIRE)
	      CHANNELS = 2
	      CALL CPRCLS(CPR_WEDGE,CPR_WIRE,CHANNELS,
	1		    ECPR_SOFT(2),XCPR_SOFT(2))
	      CHANNELS = 3
	      CALL CPRCLS(CPR_WEDGE,CPR_WIRE,CHANNELS,
	1		    ECPR_SOFT(3),XCPR_SOFT(3))
	      CHANNELS = 5
	      CALL CPRCLS(CPR_WEDGE,CPR_WIRE,CHANNELS,
	1		    ECPR_SOFT(4),XCPR_SOFT(4))
	      XCPR_SOFT(2) = - (RCPR/RCES) * XCPR_SOFT(2)
	      XCPR_SOFT(3) = - (RCPR/RCES) * XCPR_SOFT(3)
	      XCPR_SOFT(4) = - (RCPR/RCES) * XCPR_SOFT(4)
	  ELSE
	      
	      DO I=1,4
	         ECPR_SOFT(I) = -999.
	         XCPR_SOFT(I) = -999.
	      END DO
	   END IF
	ELSE
	    PRINT *,' NO CPR BANK...RUN,EVENT = ',NRUN,NEV
	END IF
C---------------------------------------------
C  Find wire and strip for this track
c---------------------------------------------
678	Nwire=(XCTC+23.27744)/1.45484
	IF(Nwire.LT.0)Nwire=0
	IF(Nwire.GT.31)Nwire=31
	IF ( Tow_num .ge. 5 ) Nwire = Nwire +32
	IF(ZCTC .GE. 121.183) THEN 
	      NSTRIP=(ZCTC-121.183)/2.007+69.0
	ELSE 
   	      NSTRIP=(ZCTC-6.16)/1.667
	END IF
	NSTRIP=MAX0(NSTRIP,0)
	NSTRIP=MIN0(NSTRIP,127)
C---------------------------------------------------------------
C FIND THE TOTAL ENERGHY IN THE STRIPS AND WIRES IN THIS TOWER
C ...THIS IS DONE IN A VERY CUMBERSOME FASHION, HOWEVER IT MAY
C    BE USEFUL TO HAVE THE INFORMATION ON INDIVIDUAL CLUSTERS IN
C    THE COMMON BLOCK EVENTUALLY.................
C-----------------------------------------------------
	 DO I=1,5
C
            Channels = 2*I + 1
            CALL PHCLUS(Iphi,Ieta,Channels,
     +                    Num_Strip_Clusts,Clust_Z,Strip_Clust_Energy,
     +                    Num_Wire_Clusts, Clust_X,Wire_Clust_Energy,
     +                    Strip_Prof,Wire_Prof)
c
            ETOTSTRIP(I) = 0.0 
	    ETOTWIRE(I)  = 0.0
            DO J = 1, Num_Strip_Clusts
                  ETOTSTRIP(I) = ETOTSTRIP(I) + Strip_Clust_Energy(J)
            END DO
            DO J = 1, Num_Wire_Clusts
                  ETOTWIRE(I)  = ETOTWIRE(I)  + Wire_Clust_Energy(J)
            END DO
	    ETOTSTRIP(I) = GASGAIN * ETOTSTRIP(I)
	    ETOTWIRE(I)  = GASGAIN * ETOTWIRE(I)
	END DO
C------------------------------------------
C Now cluster around the right channel
C-------------------------------------------
	DO 102 III=1,5
	    channels = 2*III + 1
      	    Call PHCLUSC(Iphi,Ieta,Nstrip,Nwire,Channels,
     +                    Num_Strip_Clusts,Clust_Z,Strip_Clust_Energy,
     +                    Num_Wire_Clusts, Clust_X,Wire_Clust_Energy,
     +                    St_Chan,Strip_Prof,Wi_Chan,Wire_Prof)
C
                 STPI   = 1 
                 WIRI   = 1 
            N_St_Chan = St_Chan(STPI,2) - St_Chan(STPI,1) + 1
            N_Wi_Chan = Wi_Chan(WIRI,2) - Wi_Chan(WIRI,1) + 1
	    ESTRIP_SOFT(III) = GASGAIN * STRIP_CLUST_ENERGY(1)
	    EWIRE_SOFT(III)  = GASGAIN * WIRE_CLUST_ENERGY(1)
	    XEW_WIRE(III)  = CLUST_X(1)
	    ZEW_STRIP(III) = CLUST_Z(1)
c

	    If (Wire_Clust_Energy(1) .le. 0.0)  goto 101
	    If (Strip_Clust_Energy(1) .le. 0.0) goto 101
	    If (N_St_Chan .lt. 3)		goto 101
	    If (N_Wi_Chan .lt. 3)		goto 101
c...
	    Strip_Chan_width = abs(Strip_Prof(STPI,2,3) 
     *			         - Strip_Prof(STPI,2,2))

	    I = 0
	    CALL VZERO(PLIST,25)
	    CALL VZERO(X1LIST,25)
	    CALL VZERO(X2LIST,25)
	    Shower_center = Clust_Z(STPI)	   
            CosTh = R_CES/Sqrt(Shower_center**2+R_CES**2)  !actually Sine theta
	    xoff = -0.135			    ! z>0
	    if (ieast .eq. 0) xoff = 0.105	    ! z<0
	    do ii = St_Chan(STPI,1), St_Chan(STPI,2)
	      I = I + 1
              Chan_Hi_Edge = Strip_Prof(STPI,2,I) +  Strip_Chan_Width
              Chan_Lo_Edge = Strip_Prof(STPI,2,I)
              x1list(i) = (xoff+Chan_Lo_Edge-nstrip)*10.0*CosTh
              x2list(i) = (xoff+Chan_Hi_Edge-nstrip)*10.0*CosTh
              plist(i)  = Strip_Prof(STPI,1,I)
            end do
c
            View_Value = 2.          !Strip View
            Cos_Theta = sqrt(1.0-CosTh**2)
 	    call CESSLT(X1LIST,X2LIST,PLIST,N_St_Chan,X0s,Q0s,XRAWSs,QRAWSs,
     *                  xCHISQs,cFITVs,WIDTHs)
	    x0s = x0s/(10.0*CosTh)+nstrip
	    xrawss = xrawss/(10.0*CosTh)+nstrip
	    x2s = xCHISQs / (10/p)**0.747
c
	    Wire_Chan_width  = 1.45484
	    I = 0
	    CALL VZERO(PLIST,25)
	    CALL VZERO(X1LIST,25)
	    CALL VZERO(X2LIST,25)
	    do ii = Wi_Chan(WIRI,1), Wi_Chan(WIRI,2)
	      I = I + 1
              Chan_Hi_Edge = Wire_Prof(WIRI,2,I) +  Wire_Chan_Width
              Chan_Lo_Edge = Wire_Prof(WIRI,2,I)
              x1list(i) = (Chan_Lo_Edge-nwire)*10.0
              x2list(i) = (Chan_Hi_Edge-nwire)*10.0
              plist(i)  = Wire_Prof(WIRI,1,I)
            end do
c
            View_Value = 1.          !Wire View
            Cos_Theta = 0.           !Cos Theta not used for wires
	    call CESSLT(X1LIST,X2LIST,PLIST,N_WI_CHAN,X0w,Q0w,XRAWSw,QRAWSw,
     *                  xCHISQw,cFITVw,WIDTHw)
	    xrawsw = xrawsw/10.0+nwire
	    x0w = x0w/10.0+nwire
	    x2w = xCHISQw / (10/p)**0.747
c
	    ZF_STRIP(III)     = X0S
	    XF_WIRE(III)      = X0W
	    WIDTH_STRIP(III) = WIDTHS
	    WIDTH_WIRE(III)  = WIDTHW
	    CHISTRIP(III)    = X2S
	    CHIWIRE(III)     = X2W
	    
101 	    CONTINUE
102 	CONTINUE
C-----------------------------------------------
C DONE
C-------------------------------------------------
100     CONTINUE
	RETURN
	END
C

	SUBROUTINE CES_CORRECTION(IETA,IPHI,XCTC,ZCTC)

C 	Impose a correction similar to CESALG for run Ib
$$IMPLICIT 
        character*80 file_name
        integer file_len,sistle,ierr
	INTEGER IETA,IPHI
	REAL XCTC,ZCTC
	integer status,uigtlu,lun
	logical first
	REAL JUNK1,JUNK2
	REAL DX(2,0:23),DZ(2,0:23)
	INTEGER I,INDEX

	DATA FIRST /.TRUE./

	IF (FIRST) THEN
	   FIRST = .FALSE.
           STATUS=UIGTLU(LUN)          
           CALL CHKLOG('CESFIL','C$TOP:CESPAR.DBT',
     &        FILE_NAME,IERR)
           FILE_LEN=SISTLE(FILE_NAME)
$$IF VAX
           OPEN(UNIT=LUN,FILE=FILE_NAME(1:FILE_LEN),FORM='FORMATTED',
     &        STATUS='OLD',READONLY,SHARED)
$$ELSE 
	   OPEN(UNIT=LUN,FILE=FILE_NAME(1:FILE_LEN),FORM='FORMATTED',
	1	STATUS='OLD')
$$ENDIF
	   DO I=0,23
	      READ(LUN,*)JUNK1,DX(1,I),JUNK2
	      READ(LUN,*)JUNK1,DX(2,I),JUNK2
	   END DO
	   DO I=0,23
	      READ(LUN,*)JUNK1,DZ(1,I),JUNK2
	      READ(LUN,*)JUNK1,DZ(2,I),JUNK2
	   END DO
	   CLOSE(LUN)
	END IF

	INDEX = 1
	IF (IETA.GE.43) INDEX=2
	XCTC = XCTC + DX(INDEX,IPHI)
	ZCTC = ZCTC + DZ(INDEX,IPHI)


	RETURN
	END
C===========================================================
