C======================================================================
C  File:  JETFND.CDF
C======================================================================
C
C===Description: This routine fills a common block (JETINFO) and
C                does some simple jet counting.  The common block
c                is filled for the most part by JETINFO.CDF.
C
C===Author:
c
C       Brian Winer  7-Nov-1994                  Initial Creation
C
C======================================================================

C========================================================
      SUBROUTINE JETFND
C========================================================
C
C
$$IMPLICIT 
      SAVE    !FOR ACP
C
C===Global Declarations:
C
$$INCLUDE 'c$inc:JETINFO.INC'
$$INCLUDE 'c$inc:ELEINFO.INC'
$$INCLUDE 'C$INC:EVTINFO.INC'

       INTEGER I,J
       INTEGER CPNUM/2/           !Code for Cone Size (1=0.7,2=0.4,3=1.0)
       INTEGER SGL_ISO/1/         !Bit for single isolation.
       LOGICAL ELE_JET            !Whether jet belongs to good electron
       REAL DETAJCUT/2.0/         !Eta cut on Jets


c Fill the Common block with most varialbes (use a cone of 0.4)
c -------------------------------------------------------------
       CALL JETINFO(CPNUM)

c Loop over all jets and count.
c -----------------------------
       NJET_10 = 0
       NJET_15 = 0
       NJET_20 = 0
       NJET_25 = 0
       DO I=1,ICLUS

           IJET_GOOD(I) = .FALSE.

C Veto electron jets associated with electrons. NOTE: Only vetos
c ISOLATED electrons.
c
C  REMOVE THE VETO ON ELECTRON JET.  This must be done after
c  considering other leptons in the events.  It is done properly
c  when making the TOPS bank and is stored in that bank.
c ---------------------------------------------------------------
           ELE_JET = .FALSE.
c           DO J=1,NUM_HPTE
c               IF(IJETBNK(I).EQ.JTS_ELE(IND_HPTE(J)).AND.
c     &            IAND(CEM_ISO(IND_HPTE(J)),SGL_ISO).EQ.0) 
c     &                  ELE_JET = .TRUE.
c           ENDDO
c
c           IF(ABS(IJET_DETA(I)).LT.DETAJCUT.AND.(.NOT.ELE_JET)) THEN

           IF(ABS(IJET_DETA(I)).LT.DETAJCUT) THEN

C Count up the jets above a certain threshold
c -------------------------------------------
              IF(IJET_ET(I).GT.10.) NJET_10 = NJET_10 + 1
              IF(IJET_ET(I).GT.15.) NJET_15 = NJET_15 + 1
              IF(IJET_ET(I).GT.20.) NJET_20 = NJET_20 + 1
              IF(IJET_ET(I).GT.25.) NJET_25 = NJET_25 + 1

              IJET_GOOD(I) = .TRUE.

           ENDIF


       ENDDO

       RETURN
       END
