C =======================================================================
C   TFZINFO.INC
C =======================================================================
C
C
C    Common block for Z information from the TOPFND routines: ELEZEE and
C    MUOZEE.
C
c
C         LAST_RUN....Run number for last time routine was called     
C         LAST_EVT....Evt number for last time routine was called     
C         LZFLAG......Loose Z Boson Flag (TRUE = Loose Z Found)
C         TZFLAG......Tight Z Boson Flag (TRUE = Tight Z Found)
C         ZCNT........Number of Tight or Loose Z's found
C	  MASSZ(3)....Z mass from lepton pair 
C         LEGZ(2,3)...Index to Leg of Z
C         ZTYPE(3)....Type of Z (1=loose ee, 2=tight ee)
C                     (-1=loose mu mu, -2=tight mu mu)
C         LTYPE(2,3)..Type of Leg (For electrons 0=central,
C                     1=plug, 2=forward; For Muons, it is the
C                     CMUO type 1=cmu,2=CMP,3=CMU/CMP,4=CMX, CMIO type =10)
c
c =======================================================================
c
      INTEGER LAST_RUN,LAST_EVT
      LOGICAL LZFLAG,TZFLAG
      INTEGER ZCNT
      REAL MASSZ(3)
      INTEGER LEGZ(2,3)
      INTEGER ZTYPE(3)
      INTEGER LTYPE(2,3)

      COMMON/TFZINFO/ LZFLAG,TZFLAG,ZCNT,MASSZ,LEGZ,ZTYPE,LTYPE,
     &                LAST_RUN,LAST_EVT

C =======================================================================
