c  TMCORR_AA.CDF  15-Dec-93  jlys
cjl Corrections a function of jet PT, not ET  05-Jul-95
c  Called by tmass6 if want alessandra-avi corrections to jets
      subroutine tmcorr_aa(index,pspmin,output1,output2,
     &    output3)
c
c  index = 0 for initialization - read numbers from file
c      file is ALEAVIDAT so that MUST be defined properly
c      output1 = 1. for success, 0. for failure     
c  index = 1-4 to get corrected mom and mom error
c      output1 = shifted momentum (note not E or ET)
c      output2 = sigma on momentum (again note, not E or ET)
c      output3 = shifted mass (assuming it should be shifted)
c  index tells A or B or C or D in AA table
c
$$implicit
c
      character*80 file_name
      integer file_len,sistle,ierr
      integer index
      real*8 pspmin(4),output1,output2,output3
c
      integer i,j
      real*4 p1aa(4),p2aa(4),p3aa(4),p4aa(4),p5aa(4),p6aa(4)
      real*8 cosdip,et,ptpart,delta,rmspt,ptjet
      real*4 etcheck(4),deltach(4),rmsch(4)
c
      data etcheck/10.,20.,40.,80./
c
      if(index.eq.0) then
        output1=1.
        CALL CHKLOG('ALEAVIDAT','top$fnd:aleavi_170.dbt',
     &   FILE_NAME,IERR)
         FILE_LEN=SISTLE(FILE_NAME)
$$IF VAX
        OPEN(UNIT=48,FILE=FILE_NAME(1:FILE_LEN),STATUS='OLD',
     &    READONLY,SHARED)
$$ELSE
        OPEN(UNIT=48,FILE=FILE_NAME(1:FILE_LEN),STATUS='OLD')
$$ENDIF
cjl_15-dec, for ale-avi corr terms; p1 p2 p3 = mean, p4 p5 p6 = rms
        read (48,4800,err=4802) (p1aa(i),i=1,4)
        write (6,4801) (p1aa(i),i=1,4)
        read (48,4800,err=4802) (p2aa(i),i=1,4)
        write (6,4801) (p2aa(i),i=1,4)
        read (48,4800,err=4802) (p3aa(i),i=1,4)
        write (6,4801) (p3aa(i),i=1,4)
        read (48,4800,err=4802) (p4aa(i),i=1,4)
        write (6,4801) (p4aa(i),i=1,4)
        read (48,4800,err=4802) (p5aa(i),i=1,4)
        write (6,4801) (p5aa(i),i=1,4)
        read (48,4800,err=4802) (p6aa(i),i=1,4)
        write (6,4801) (p6aa(i),i=1,4)
4800    format (4f12.6)
4801    format (' aleavi terms, PiAA 1-4',4f12.6)
c  checks
        write (6,4888)
4888    format ('  Checking AleAvi params'/,5x,' ET     delta    rms',
     &      '    delta    rms    delta    rms    delta    rms ')   
        do j=1,4
          do i=1,4 
            deltach(i)=exp(p1aa(i)+p2aa(i)*etcheck(j))+p3aa(i)
            rmsch(i)=exp(p4aa(i)+p5aa(i)*etcheck(j))+p6aa(i)
          end do
          write (6,4890) etcheck(j),(deltach(i),rmsch(i),i=1,4)
4890      format (2x,f7.0,4(2x,2f7.3))
        end do
        goto 4810
4802    write (6,4804)
4804    format (' NOTE: ERROR in reading ALEAVI terms, turn off')
        output1=0.
4810    continue
        close (48)
      else
        cosdip=1./sqrt(1.+pspmin(2)**2)
c        et=sqrt(pspmin(3)**2+pspmin(4)**2)*cosdip
        ptjet=pspmin(3)*cosdip
        if(index.ge.1.and.index.le.4) then
          delta=exp(p1aa(index)+p2aa(index)*ptjet)+p3aa(index)
          ptpart=(1.+delta)*ptjet
          output1=ptpart/cosdip
          rmspt=(exp(p4aa(index)+p5aa(index)*ptjet)+
     &        p6aa(index))*ptjet
          output2=rmspt/cosdip
          output3=(1.+delta)*pspmin(4)
        end if
      end if
c
      return
      end
