      SUBROUTINE TOPSBTC(PRINT_LVL)
C =====================================================================
C    This routine fills a common from the TOPS bank
C
C    Brian Winer             Sep 12, 1995
c ======================================================================
C
$$IMPLICIT
C
C    Global declarations.
$$INCLUDE 'C$INC:JOBSTA.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'YBOS$LIBRARY:BNKTYP.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'top$fnd:TOPSCOM.INC'
$$INCLUDE 'top$fnd:DSTOPS.INC'

C
C Local Variables
C
      INTEGER I,J
      INTEGER JTOPS,JDTOPS
      INTEGER PRINT_LVL
C
C    External declarations.
C
      INTEGER BLOCAT,STATUS

      STATUS=BLOCAT(IW,'TOPS',1,JTOPS,JDTOPS)
      IF(STATUS.NE.YESUCC) THEN
          CALL ERLOGR('TOPSCR',ERWARN,0,STATUS,
     +                'Unable to find TOPS bank.')
          RETURN
      ENDIF
         
c Fill the information (Global Event Info first)
c ----------------------------------------------
      TS_VERSION = IW(JDTOPS+1)
      TS_CODE    = IW(JDTOPS+2)
      TS_MET     = RW(JDTOPS+3)
      TS_METPHI  = RW(JDTOPS+4)
      TS_HT      = RW(JDTOPS+5)
      TS_BRCODE  = IW(JDTOPS+6)
      TS_TRIG    = IW(JDTOPS+7)
      TS_ZFLAG   = IW(JDTOPS+8)
      TS_DILCD   = IW(JDTOPS+9)


      TS_NHPTE   = IW(JDTOPS+10)
      TS_NIHPTE  = IW(JDTOPS+11)
      TS_NITHPTE = IW(JDTOPS+12)
      TS_NHPTM   = IW(JDTOPS+13)
      TS_NIHPTM  = IW(JDTOPS+14)
      TS_NITHPTM = IW(JDTOPS+15)


C Lepton Information
c ------------------
      TS_L1_ET =   RW(JDTOPS+OFFSETL+0)
      TS_L1_PX =   RW(JDTOPS+OFFSETL+1)
      TS_L1_PY =   RW(JDTOPS+OFFSETL+2)  
      TS_L1_PZ =   RW(JDTOPS+OFFSETL+3)  
      TS_L1_E  =   RW(JDTOPS+OFFSETL+4)  
      TS_L1_I  =   RW(JDTOPS+OFFSETL+5)  
      TS_L1_TY =   IW(JDTOPS+OFFSETL+6)  
      TS_L1_IN =   IW(JDTOPS+OFFSETL+7)  
      TS_L1_BK =   IW(JDTOPS+OFFSETL+8)  
      TS_L1_LK =   IW(JDTOPS+OFFSETL+9)  
      TS_L1_TG =   IW(JDTOPS+OFFSETL+10) 

      TS_L2_ET =   RW(JDTOPS+OFFSETL2+0)
      TS_L2_PX =   RW(JDTOPS+OFFSETL2+1)
      TS_L2_PY =   RW(JDTOPS+OFFSETL2+2)  
      TS_L2_PZ =   RW(JDTOPS+OFFSETL2+3)  
      TS_L2_E  =   RW(JDTOPS+OFFSETL2+4)  
      TS_L2_I  =   RW(JDTOPS+OFFSETL2+5)  
      TS_L2_TY =   IW(JDTOPS+OFFSETL2+6)  
      TS_L2_IN =   IW(JDTOPS+OFFSETL2+7)  
      TS_L2_BK =   IW(JDTOPS+OFFSETL2+8)  
      TS_L2_LK =   IW(JDTOPS+OFFSETL2+9)  
      TS_L2_TG =   IW(JDTOPS+OFFSETL2+10) 

      TS_NJ15  =   IW(JDTOPS+OFFSET15)
      TS_NJ8   =   IW(JDTOPS+OFFSET8) 


c Store All Jets which pass conditions (These can be the electron jet)
c --------------------------------------------------------------------
      DO I=1,MIN(TS_NJ15,10)
          TS_NJ15_BNK(I) = IW(JDTOPS+OFFSET15+I) 
      ENDDO
      DO I=MIN(TS_NJ15,10)+1,10
          TS_NJ15_BNK(I) = 0
      ENDDO

      DO I=1,MIN(TS_NJ8,5)
          TS_NJ8_BNK(I) = IW(JDTOPS+OFFSET8+I) 
      ENDDO
      DO I=MIN(TS_NJ8,5)+1,5
          TS_NJ8_BNK(I) = 0
      ENDDO

      TS_NJ_SGL = IW(JDTOPS+OFFSET8+6)
      TS_NJ_DIL = IW(JDTOPS+OFFSET8+7)
      TS_NJ_Z   = IW(JDTOPS+OFFSET8+8)


C Print out the information if requested
c --------------------------------------
      IF(PRINT_LVL.GT.0) THEN

          WRITE(PRINT_LVL,106)
106       FORMAT(' ================================================',
     &           '============================')
C Start with general event information
c ------------------------------------
          WRITE(PRINT_LVL,100) NRUN,NEV,TS_VERSION,TS_CODE,TS_MET,
     &      TS_METPHI,TS_HT,TS_BRCODE,TS_TRIG,TS_ZFLAG,TS_DILCD
100       FORMAT(' Run #',I6, '   Event #',I7,'    TOPS Version:',I4,
     &           '    TOPS Code:',I2,/,
     &           ' MET:',F7.2,'   MET Phi:',F5.2,'   H:',F8.2,/,
     &           ' Bad Run Code:',I3,'   Trig Flg:',I2,'   Z Flag:',I2,
     &           '   Dilepton Flg:',I2,/)

c Now the lepton information
c --------------------------
          WRITE(PRINT_LVL,101) TS_NHPTE,TS_NIHPTE,TS_NITHPTE,TS_NHPTM,
     &      TS_NIHPTM,TS_NITHPTM 
101       FORMAT(' # High Pt Ele (All, Isol, Isol+Trig):',3I4,/
     &           ' # High Pt Muo (All, Isol, Isol+Trig):',3I4,/)

          WRITE(PRINT_LVL,102) TS_L1_ET,TS_L1_PX,TS_L1_PY,TS_L1_PZ,
     &      TS_L1_E,TS_L1_I,TS_L1_TY,TS_L1_IN,TS_L1_BK,TS_L1_LK,
     &      TS_L1_TG    
102       FORMAT(' Primary Lepton:',/,
     &           ' Et:',F7.2,'      Px:',F7.2,'      Py:',F7.2,
     &           '      Pz:',F7.2,'      E:', F7.2,/
     &           ' Isol:',F7.4,'    Type:',I3,'    Index:',I3,
     &           '    BNK#:',I3,
     &           '    LNK#:',I3,'    Trig:',I3,/)

          WRITE(PRINT_LVL,103) TS_L2_ET,TS_L2_PX,TS_L2_PY,TS_L2_PZ,
     &      TS_L2_E,TS_L2_I,TS_L2_TY,TS_L2_IN,TS_L2_BK,TS_L2_LK,
     &      TS_L2_TG
103       FORMAT(' Secondary Lepton:',/,
     &           ' Et:',F7.2,'      Px:',F7.2,'      Py:',F7.2,
     &           '      Pz:',F7.2,'      E:', F7.2,/
     &           ' Isol:',F7.4,'    Type:',I3,'    Index:',I3,
     &           '    BNK#:',I3,
     &           '    LNK#:',I3,'    Trig:',I3,/)


c Jet Information
c ---------------
          WRITE(PRINT_LVL,104) TS_NJ15,TS_NJ15_BNK,TS_NJ8,TS_NJ8_BNK
104       FORMAT(' Number of Jets w/ Et>15, |eta|<2.0:',I4,/
     &           ' JETS BNK#:',10I4,/,
     &           ' Number of OTHER Jets w/ Et>8 and |eta|<2.4:',I4,/ 
     &           ' JETS BNK#:',5I4,/)

          WRITE(PRINT_LVL,105) TS_NJ_SGL,TS_NJ_DIL,TS_NJ_Z
105       FORMAT(' Jet Mult for Single Lepton Evt:',I3,/
     &           ' Jet Mult for Dilepton Evt     :',I3,/
     &           ' Jet Mult for Z Evt            :',I3,/)

          WRITE(PRINT_LVL,106)

      ENDIF

      RETURN
      END
