c  Include File: TOPSCOM.INC
c ===============================================================================
C
C  This common block is filled by TOPSBTC.  It contains the information
c  found in the TOPS bank.
c
c      Brian Winer, 13-Sep-1995
c =============================================================================


c Fill the information (Global Event Info first)
c ----------------------------------------------
      INTEGER TS_VERSION          ! Version of the TOPS Bank
      INTEGER TS_CODE             ! Code for filling (see TOPSCR.CDF)
      REAL TS_MET                 ! MET for the event
      REAL TS_METPHI              ! METPHI for the event
      INTEGER TS_BRCODE           ! Badrun Code
      INTEGER TS_TRIG             ! Trigger Flag for event
      INTEGER TS_ZFLAG            ! Z Flag for event (0=No Z, 1=Loose Z,2=Tight Z)
      INTEGER TS_DILCD            ! Dilepton Flag (Passes DIL_TOPOLOGY)

c Lepton Count information
c ------------------------
      INTEGER TS_NHPTE            ! Number of High Pt electrons
      INTEGER TS_NIHPTE           ! Number of Isolated High Pt electrons
      INTEGER TS_NITHPTE          ! Number of Isolated and Trigger Satisfying Electrons
      INTEGER TS_NHPTM            ! Number of High Pt muons
      INTEGER TS_NIHPTM           ! Number of Isolated High Pt muons
      INTEGER TS_NITHPTM          ! Number of Isolated and Trigger Sat. Muons

C First Lepton Information
c ------------------------
      REAL TS_L1_ET               ! Et of primary lepton
      REAL TS_L1_PX               ! Px of primary lepton
      REAL TS_L1_PY               ! Py of primary lepton
      REAL TS_L1_PZ               ! Pz of primary lepton
      REAL TS_L1_E                ! E of primary lepton
      REAL TS_L1_I                ! Isolation of primary lepton
      INTEGER TS_L1_TY            ! Type of primary lepton(20=centrl_e,21=plug_e
C                                 !  31=CMU,32=CMP,33=CMU/CMP,34=CMX,40=CMIO)
      INTEGER TS_L1_IN            ! Index pointer of primary lepton to ELEINFO,MUOINFO include files
      INTEGER TS_L1_BK            ! ELES/CMUO bank number of primary lepton
      INTEGER TS_L1_LK            ! JETS or TRKS bank number of primary lepton
      INTEGER TS_L1_TG            ! Trigger flag for primary lepton (1=Satisfied)

C Second Lepton Information
c -------------------------
      REAL TS_L2_ET               ! Et of primary lepton
      REAL TS_L2_PX               ! Px of primary lepton
      REAL TS_L2_PY               ! Py of primary lepton
      REAL TS_L2_PZ               ! Pz of primary lepton
      REAL TS_L2_E                ! E of primary lepton
      REAL TS_L2_I                ! Isolation of primary lepton
      INTEGER TS_L2_TY            ! Type of primary lepton(20=centrl_e,21=plug_e
C                                 !  31=CMU,32=CMP,33=CMU/CMP,34=CMX,40=CMIO)
      INTEGER TS_L2_IN            ! Index pointer of primary lepton to ELEINFO,MUOINFO include files
      INTEGER TS_L2_BK            ! ELES/CMUO bank number of primary lepton
      INTEGER TS_L2_LK            ! JETS or TRKS bank number of primary lepton
      INTEGER TS_L2_TG            ! Trigger flag for primary lepton (1=Satisfied)

c Jet and Jet Count Information (PLEASE READ THE COMMENTS CAREFULLY )
c -------------------------------------------------------------------
      INTEGER TS_NJ15             ! Number of Jets with Et>15 and Eta<2.0
c                                 ! IMPORTANT: This counting WILL include
c                                 ! the electron jet.  To exclude the lepton
c                                 ! in the jet counting use TS_NJ_SGL
c                                 !  or TS_NJ_DIL or TS_NJ_Z
      INTEGER TS_NJ8              ! Number of Jets with Et>8 and Eta<2.4 and
c                                 ! NOT having Et> and Eta<2.0 (Important:
c                                 ! these are only jets which are NOT counted
c                                 ! in TS_NJ15.)
c                                 !
      INTEGER TS_NJ15_BNK(10)     ! JETS bank numbers for TS_NJ15 Jets
      INTEGER TS_NJ8_BNK(5)       ! JETS bank numbers for TS_NJ8 Jets
c
      INTEGER TS_NJ_SGL           ! Jet multiplicity for Single Lepton Case
c                                 !     (This removes the primary lep from the
c                                 !      count if the primary is an electron.)
      INTEGER TS_NJ_DIL           ! Jet multiplicity for Dilepton Case
c                                 !      (This removes the dileptons from the 
c                                 !       jet counting.)
      INTEGER TS_NJ_Z             ! Jet multiplicity for Z case
c                                 !      (This variable removes the two legs 
c                                 !       of the Z from the jet counting.)
      REAL    TS_HT               ! H of Event

c Common Block
c ------------
      COMMON/TOPCOM/ TS_VERSION,TS_CODE,TS_MET,TS_METPHI,TS_BRCODE,
     &  TS_TRIG,TS_ZFLAG,TS_DILCD,TS_NHPTE,TS_NIHPTE,TS_NITHPTE,
     &  TS_NHPTM,TS_NIHPTM,TS_NITHPTM,TS_L1_ET,TS_L1_PX,TS_L1_PY,
     &  TS_L1_PZ,TS_L1_E,TS_L1_I,TS_L1_TY,TS_L1_IN,TS_L1_BK,TS_L1_LK,
     &  TS_L1_TG,TS_L2_ET,TS_L2_PX,TS_L2_PY,TS_L2_PZ,TS_L2_E,TS_L2_I,
     &  TS_L2_TY,TS_L2_IN,TS_L2_BK,TS_L2_LK,TS_L2_TG,TS_NJ15,TS_NJ8,
     &  TS_NJ15_BNK,TS_NJ8_BNK,TS_NJ_SGL,TS_NJ_DIL,TS_NJ_Z,TS_HT

c ============================================================================
