      INTEGER FUNCTION ANSTUP(MODE,INLUN,OUTLUN,DEVICE)
C     =================================================
C
C       Description:-
C       =============
C       This Function is used by Analysis_Control
C       to setup and allocate work space for the
C       standard Utilities used by this program.
C       These standard utilities are:-
C
C       Analysis_Control Configuration
C       UIPack Configuration
C       Database Work Area
C       Primary YBOS Array
C       Primary YHIST Array
C       HBOOK Blank Common Array
C
C       where only those utilities used in this program
C       are initialised.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C       Declarations:-
C       ==============
C
$$If VAX
      Implicit None
$$Endif
      INTEGER MODE, INLUN,OUTLUN,DEVICE
C
      COMMON/ANCOMM/ANPKI4
      INTEGER       ANPKI4
      DIMENSION     ANPKI4(     16384)
      COMMON/MENUCO/MENUI4
      INTEGER       MENUI4
$$If Acp_node
$$Else
      DIMENSION     MENUI4(    131072)
$$Endif
      COMMON/KALI  /CALII4
      INTEGER       CALII4
      DIMENSION     CALII4(    300000)
      INTEGER HDINIT
      COMMON/BCS   /YBOSI4
      INTEGER       YBOSI4
      DIMENSION     YBOSI4(   1000000)
$$If Acp_Host
      COMMON/ANINPU/ANINPU
      INTEGER       ANINPU
      DIMENSION     ANINPU(   1000000)
$$Endif
      INTEGER NKW,KW
      PARAMETER (NKW=50000)
      COMMON/DETECT/KW(NKW)
      COMMON/HBCS  /HISTI4
      INTEGER       HISTI4
      DIMENSION     HISTI4(    800000)
$$If Acp_host
      COMMON/HSINPU/HSINPU
      INTEGER       HSINPU
      DIMENSION     HSINPU(    800000)
$$Endif
      INTEGER     BOSAR
      INTEGER    UIINIT
      INTEGER     BOS77
$$If Acp_Host
      INTEGER    BLVERM
$$Endif
      INTEGER    HINIT,YHINIT
C
      INTEGER     DBINIT
$$If Acp_host
      INTEGER DBIACP
$$Endif
C
$$Include 'Cdfdb$Library:Errcod.Inc'
C
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'UIPack$Library:UIError.Inc'
$$Include 'YBOS$Library:ErrCod.Inc'
$$Include 'YHist$Library:HistErr.Inc'
$$Include 'C$Inc:Erlevl.Inc'
      EXTERNAL ANFIN
C
C       Executable Code:-
C       =================
C
      ANSTUP = ANSUCC
C
C
C       Initialise Analysis_Control
C       ===========================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = BOSAR(ANPKI4,     16384,'/ANCOMM/', 128)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise UIPack
C       =================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
$$If Acp_node
$$Else
         ANSTUP = UIINIT(MODE,INLUN,OUTLUN,DEVICE,    131072, 356)
$$Endif
         IF (ANSTUP .EQ. UISUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Calibration Database YBOS Array
C       ==========================================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = BOSAR(CALII4,    300000,'/KALI  /',128)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Primary YBOS Array
C       =============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = BOS77(   1000000, 256)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
$$If Acp_Host
C
C        Setup for no Logical Record Verification
C        ========================================
C
         IF (ANSTUP .EQ. ANSUCC) THEN
            ANSTUP = BLVERM(YBOSI4,0)
            IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
         ENDIF
C
C        Copy YBOS header to input array
C        ===============================
C
         CALL UCOPY(YBOSI4,ANINPU,YBOSI4(23)-1)
$$Endif
      ENDIF
C
C       Initialise YHIST Histogram Package
C       ==================================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = HINIT(    800000)
         IF (ANSTUP .EQ. HESUCC) ANSTUP = ANSUCC
$$If Acp_host
         ANSTUP = YHINIT(HSINPU,    800000)
         IF (ANSTUP .EQ. HESUCC) ANSTUP = ANSUCC
$$Endif
      ENDIF
C
C       Initialise    CALIB Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','CALIB')
$$If Acp_host
         ANSTUP = DBIACP(CALII4,'CALIB')
$$Endif
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise GEOMETRY Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','GEOMETRY')
$$If Acp_host
         ANSTUP = DBIACP(CALII4,'GEOMETRY')
$$Endif
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise RUN_COND Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','RUN_COND')
$$If Acp_host
         ANSTUP = DBIACP(CALII4,'RUN_COND')
$$Endif
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise CDF_COND Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','CDF_COND')
$$If Acp_host
         ANSTUP = DBIACP(CALII4,'CDF_COND')
$$Endif
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Histogram Display
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = HDINIT(DEVICE)
         IF (ANSTUP .EQ. HESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Offline Commons
C       ==========================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
$$If Acp_node
C
C       Initialize geometry data base YBOS array:
C       =========================================
          ANSTUP = BOSAR(KW,NKW,'/DETECT/',128)
          IF (ANSTUP .NE. YESUCC) THEN
	          CALL ERLOGR('ANSTUP',ERSEVR,0,ANSTUP,
     1      'Cant initialize Geometry YBOS array')
          ELSE
             ANSTUP = ANSUCC
          ENDIF
$$Else
         CALL ANOFFI
$$Endif
      ENDIF
C
C       Return to Caller
C       ================
C
      IF(ANSTUP.NE.ANSUCC)   CALL ANEROR(ANSTUP)
      RETURN
      END
      INTEGER FUNCTION ANFIN(DUMMY)
C     =============================
C
C       Description:-
C       =============
C       This Function is used by Analysis_Control
C       to close the standard  databases upon program
C       termination
C       These standard database are:-
C
C       Calibration Database
C       Geometry Database
C       Run Conditions Database
C       Cdf Conditions Database
C
C       where only those databases used in this program
C       are closed.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C       Declarations:-
C       ==============
C
$$If VAX
      Implicit None
$$Endif
      INTEGER DUMMY
C
C
      INTEGER DBTERM
C
$$Include 'Cdfdb$Library:ErrCod.Inc'
C
      INTEGER HDFINI
C
$$Include 'Yhist$Library:HistErr.Inc'
C
$$Include 'Analysis_Control$Library:ANError.Inc'
C
C       Executable Code:-
C       =================
C
      ANFIN = ANSUCC
C
C
C       Close Calibration databases
C       ===========================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('CALIB')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close Geometry databases
C       ===========================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('GEOMETRY')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close Run Conditions databases
C       ===========================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('RUN_COND')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close CDF Conditions databases
C       ===========================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('CDF_COND')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Terminate Histogram Display
C       ==========================================
C
      IF (ANFIN .EQ. ANSUCC) THEN
         ANFIN = HDFINI()
         IF (ANFIN .EQ. HESUCC) ANFIN = ANSUCC
      ENDIF
C
C       Return to Caller
C       ================
C
      IF(ANFIN.NE.ANSUCC)   CALL ANEROR(ANFIN)
      RETURN
      END
      INTEGER FUNCTION ANMDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Subprogram is called by Analysis_Control to
C       declare the Modules in the current Executable
C       Program
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C       Declarations:-
C       ==============
C
$$If VAX
      Implicit None
$$Endif
      INTEGER DUMMY
$$Include 'Analysis_Control$Library:ANError.Inc'
C
      INTEGER TRGVDE
      INTEGER BBDECL
      INTEGER LUMDEC
      INTEGER VTVDEC
      INTEGER VZDECL
      INTEGER DECALO
      INTEGER HFDECL
      INTEGER NCDECL
      INTEGER QDFDCL
      INTEGER TRGSDE
      INTEGER NAIDCL
      INTEGER QDJCDL
      INTEGER CMUDEC
      INTEGER FMDTED
      INTEGER FMTRKD
      INTEGER FMOCRD
      INTEGER EMCLDC
      INTEGER STDECL
      INTEGER ELEDEC
      INTEGER ELFDEC
      INTEGER EWKDEC
      INTEGER TRCTDC
      INTEGER YHDECL
      INTEGER ANHDDE
      INTEGER YDDECL
C
C       Executable Code:-
C       =================
C
      ANMDEC = ANSUCC
C
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = TRGVDE(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = BBDECL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = LUMDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = VTVDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = VZDECL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = DECALO(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = HFDECL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = NCDECL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = QDFDCL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = TRGSDE(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = NAIDCL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = QDJCDL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = CMUDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = FMDTED(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = FMTRKD(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = FMOCRD(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = EMCLDC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = STDECL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = ELEDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = ELFDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = EWKDEC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = TRCTDC(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = YHDECL(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = ANHDDE(DUMMY)
      ENDIF
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = YDDECL(DUMMY)
      ENDIF
C
C      Perform offline initialisation 
C      ============================== 
$$If Acp_node
      CALL ANOFFI
$$Endif
C
C       Return to Caller
C       ================
      IF(ANMDEC.NE.ANSUCC)   CALL ANEROR(ANMDEC)
C
      RETURN
      END
      SUBROUTINE ANSSYB
C     =================
C
C     Description:-
C     ==============
C     When downloading any secondary YBOS arrays to
C     the ACP nodes, it is necessary to save the
C     YBOS header so as to retain any information 
C     about work banks.  This routine is used to 
C     store this information and to place this
C     information back in the correct YBOS array 
C     The secondary arrays BUILD_JOB knows about are:
C          
C       Analysis_Control Configuration
C       UIPack Configuration
C       Database Work Area
C       YHIST Array
C	Simulation Geometry Database
C          
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C     Call Parameters:-
C     =================
C     None
C	
C     Return Parameters:-
C     ===================
C     None
C	
C     Global Declarations:-
C     =====================
$$If Vax
      IMPLICIT NONE
$$Endif
$$Include 'YBOS$Library:ErrCod.Inc'
C 
C     External Functions:-

C     =====================
      INTEGER YBRSTO, YBSAVE
C
C     Local Variables
C     ===============
      INTEGER NWORDS
      PARAMETER (NWORDS=200)
      INTEGER STATUS
C
      SAVE
      COMMON/ANCOMM/ANPKI4
      INTEGER       ANPKI4
      DIMENSION     ANPKI4(1)
      INTEGER       SAVANP
      DIMENSION     SAVANP(NWORDS)
      COMMON/KALI  /CALII4
      INTEGER       CALII4
      DIMENSION     CALII4(1)
      INTEGER       SAVCAL
      DIMENSION     SAVCAL(NWORDS)
      COMMON/HBCS  /HISTI4
      INTEGER       HISTI4
      DIMENSION     HISTI4(1)
      INTEGER       SAVHIS
      DIMENSION     SAVHIS(NWORDS)
      COMMON/DETECT/KW
      INTEGER       KW
      DIMENSION     KW(1)
      INTEGER       SAVDET
      DIMENSION     SAVDET(NWORDS)
C
C     Save Statements
C     ===============
      SAVE SAVANP
      SAVE SAVCAL
      SAVE SAVHIS
      SAVE SAVDET
C
C
C       Executable Code:-
C       =================
C
      STATUS = YESUCC
C
C
C       Save Analysis_Control Header
C       ===========================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBSAVE(ANPKI4,SAVANP)
      ENDIF
C
C       Save Calibraion Array Header
C       ============================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBSAVE(CALII4,SAVCAL)
      ENDIF
C
C       Save YHIST Header
C       =================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBSAVE(HISTI4,SAVHIS)
      ENDIF
C
C       Save Geomentry Dbs Header
C       ===========================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBSAVE(KW,SAVDET)
      ENDIF
C
C     Return to Caller:-
C     ==================
      IF(STATUS.NE.YESUCC)   CALL ANEROR(STATUS)
      RETURN
C
      ENTRY ANRSYB
C     ============
C          
C
C       Restore Analysis_Control Header
C       ===============================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBRSTO(ANPKI4,SAVANP)
      ENDIF
C
C       Restore Calibration Array Header
C       ================================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBRSTO(CALII4,SAVCAL)
      ENDIF
C
C       Restore YHIST Header
C       ====================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBRSTO(HISTI4,SAVHIS)
      ENDIF
C
C       Restore Geometry Dbs Header
C       ===============================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBRSTO(KW,SAVDET)
      ENDIF
C
C       Return to Caller
C       ================
C
      IF(STATUS.NE.YESUCC)   CALL ANEROR(STATUS)
      RETURN
      END
$$If Acp_Host
      SUBROUTINE ANDWNS
C     =================
C
C     Description:-
C     ==============
C     This routine is used to download all
C     secondary YBOS arrays to the nodes
C     The secondary arrays BUILD_JOB knows about are:
C          
C       Block 2: Analysis_Control Configuration
C       Block 3: Database Work Area
C       Block 4: YHIST Array
C       Block 5: Sim Geom database Array
C          
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C     Call Parameters:-
C     =================
C     None
C	
C     Return Parameters:-
C     ===================
C     None
C	
C     Global Declarations:-
C     =====================
$$If Vax
      IMPLICIT NONE
$$Endif
$$Include 'Analysis_Control$Library:Anerror.Inc'
$$Include 'YBOS$Library:ErrCod.Inc'
$$Include 'YBOS$SOURCE:YPARAM.INC'

$$Include 'ACP$AREA:USER_COMMON.INC'
C 
C     External Functions:-
C     =====================
      INTEGER YBRSTO, YBSAVE
C
C     Local Variables
C     ===============
      INTEGER STATUS
      COMMON/ANCOMM/ANPKI4
      INTEGER       ANPKI4
      DIMENSION     ANPKI4(1)
      COMMON/KALI  /CALII4
      INTEGER       CALII4
      DIMENSION     CALII4(1)
      COMMON/HBCS  /HISTI4
      INTEGER       HISTI4
      DIMENSION     HISTI4(1)
      COMMON/DETECT/KW
      INTEGER       KW
      DIMENSION     KW(1)
C
C
C       Executable Code:-
C       =================
C
      STATUS = YESUCC
C
C
C     Download Analysis_Control Array
C     ===============================
C
      STATUS = ACP_GBROADCAST (2,
     &    ANPKI4, ANPKI4(IYGAP), ACP$ALL_CLASSES,
     &     ACP_UNCONVERTED)
C
C     Download Calibration Array
C     ==========================
C
      STATUS = ACP_GBROADCAST (3,
     &    CALII4, CALII4(IYGAP), ACP$ALL_CLASSES,
     &     ACP_UNCONVERTED)
C
C     Download YHIST Array
C     ====================
C
      STATUS = ACP_GBROADCAST (4,
     &    HISTI4, HISTI4(IYGAP), ACP$ALL_CLASSES,
     &     ACP_UNCONVERTED)
C
C     Download Sim Geometry Array
C     ===============================
C
      STATUS = ACP_GBROADCAST (5,
     &    KW, KW(IYGAP), ACP$ALL_CLASSES,
     &     ACP_UNCONVERTED)
C
C       Return to Caller
C       ================
C
      RETURN
      END
$$Endif
      INTEGER FUNCTION HFDECL(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module HATFLT. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C       Declarations:-
C       ==============
C
$$If VAX
      Implicit None
$$Endif
      INTEGER DUMMY
C
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'Analysis_Control$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL HFGINI
      EXTERNAL HFRINI
      EXTERNAL HTFEVT
$$If Acp_node
$$Else
      EXTERNAL HFRFIN
$$Endif
$$If Acp_node
$$Else
      EXTERNAL HFTALK
$$Endif
$$If Acp_node
$$Else
      EXTERNAL HFBOOK
$$Endif
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      HFDECL = ANSUCC
C
      IF (HFDECL .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            HFDECL = ANDMOD('HATFLT','Filter for HADRON TDC events')
            DONE = .TRUE.
         ELSE
            HFDECL = ANUMOD('HATFLT')
         ENDIF
      ENDIF
      IF (HFDECL .EQ. ANSUCC) THEN
         HFDECL = ANDFIL(DUMMY)
      ENDIF
      IF (HFDECL .EQ. ANSUCC) THEN
         HFDECL = ANDENT(HFGINI,ANMEIN)
      ENDIF
      IF (HFDECL .EQ. ANSUCC) THEN
         HFDECL = ANDENT(HFRINI,ANMERI)
      ENDIF
      IF (HFDECL .EQ. ANSUCC) THEN
         HFDECL = ANDENT(HTFEVT,ANMEEV)
      ENDIF
$$If Acp_node
$$Else
      IF (HFDECL .EQ. ANSUCC) THEN
         HFDECL = ANDENT(HFRFIN,ANMERF)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (HFDECL .EQ. ANSUCC) THEN
         HFDECL = ANDENT(HFTALK,ANMETA)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (HFDECL .EQ. ANSUCC) THEN
         HFDECL = ANDBOO(HFBOOK,  1800,  1900)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (HFDECL .EQ. ANSUCC) THEN
         HFDECL = ANDHLP(
     &   'C$CAL:HATFLT.UIH')
      ENDIF
$$Endif
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION NCDECL(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module NCABLE. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C       Declarations:-
C       ==============
C
$$If VAX
      Implicit None
$$Endif
      INTEGER DUMMY
C
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'Analysis_Control$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL NCABIN
      EXTERNAL NCABBR
      EXTERNAL NCABEV
$$If Acp_node
$$Else
      EXTERNAL NCABER
$$Endif
$$If Acp_node
$$Else
      EXTERNAL NCABTK
$$Endif
$$If Acp_node
$$Else
      EXTERNAL NCABHI
$$Endif
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      NCDECL = ANSUCC
C
      IF (NCDECL .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            NCDECL = ANDMOD('NCABLE',
     &      'Remove PHA cable noise from TOWE')
            DONE = .TRUE.
         ELSE
            NCDECL = ANUMOD('NCABLE')
         ENDIF
      ENDIF
      IF (NCDECL .EQ. ANSUCC) THEN
         NCDECL = ANDENT(NCABIN,ANMEIN)
      ENDIF
      IF (NCDECL .EQ. ANSUCC) THEN
         NCDECL = ANDENT(NCABBR,ANMERI)
      ENDIF
      IF (NCDECL .EQ. ANSUCC) THEN
         NCDECL = ANDENT(NCABEV,ANMEEV)
      ENDIF
$$If Acp_node
$$Else
      IF (NCDECL .EQ. ANSUCC) THEN
         NCDECL = ANDENT(NCABER,ANMERF)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (NCDECL .EQ. ANSUCC) THEN
         NCDECL = ANDENT(NCABTK,ANMETA)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (NCDECL .EQ. ANSUCC) THEN
         NCDECL = ANDBOO(NCABHI,     0,     0)
      ENDIF
$$Endif
      IF (NCDECL .EQ. ANSUCC) THEN
         NCDECL = ANDMPA(  3)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION QDFDCL(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module FILT_GAS. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C       Declarations:-
C       ==============
C
$$If VAX
      Implicit None
$$Endif
      INTEGER DUMMY
C
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'Analysis_Control$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL QDFGIN
      EXTERNAL QDFGRI
      EXTERNAL QDFGEV
$$If Acp_node
$$Else
      EXTERNAL QDFGRF
$$Endif
$$If Acp_node
$$Else
      EXTERNAL QDFGTA
$$Endif
$$If Acp_node
$$Else
      EXTERNAL QDFGBK
$$Endif
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      QDFDCL = ANSUCC
C
      IF (QDFDCL .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            QDFDCL = ANDMOD('FILT_GAS',
     &      'Filter bad gas towers from TOWE')
            DONE = .TRUE.
         ELSE
            QDFDCL = ANUMOD('FILT_GAS')
         ENDIF
      ENDIF
      IF (QDFDCL .EQ. ANSUCC) THEN
         QDFDCL = ANDFIL(DUMMY)
      ENDIF
      IF (QDFDCL .EQ. ANSUCC) THEN
         QDFDCL = ANDENT(QDFGIN,ANMEIN)
      ENDIF
      IF (QDFDCL .EQ. ANSUCC) THEN
         QDFDCL = ANDENT(QDFGRI,ANMERI)
      ENDIF
      IF (QDFDCL .EQ. ANSUCC) THEN
         QDFDCL = ANDENT(QDFGEV,ANMEEV)
      ENDIF
$$If Acp_node
$$Else
      IF (QDFDCL .EQ. ANSUCC) THEN
         QDFDCL = ANDENT(QDFGRF,ANMERF)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (QDFDCL .EQ. ANSUCC) THEN
         QDFDCL = ANDENT(QDFGTA,ANMETA)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (QDFDCL .EQ. ANSUCC) THEN
         QDFDCL = ANDBOO(QDFGBK,   100,   110)
      ENDIF
$$Endif
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION TRGSDE(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module TRGSEL. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C       Declarations:-
C       ==============
C
$$If VAX
      Implicit None
$$Endif
      INTEGER DUMMY
C
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'Analysis_Control$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL TRGSIN
      EXTERNAL TRGSRI
      EXTERNAL TRGSEV
$$If Acp_node
$$Else
      EXTERNAL TRGSTA
$$Endif
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      TRGSDE = ANSUCC
C
      IF (TRGSDE .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            TRGSDE = ANDMOD('TRGSEL','Trigger selection module')
            DONE = .TRUE.
         ELSE
            TRGSDE = ANUMOD('TRGSEL')
         ENDIF
      ENDIF
      IF (TRGSDE .EQ. ANSUCC) THEN
         TRGSDE = ANDFIL(DUMMY)
      ENDIF
      IF (TRGSDE .EQ. ANSUCC) THEN
         TRGSDE = ANDENT(TRGSIN,ANMEIN)
      ENDIF
      IF (TRGSDE .EQ. ANSUCC) THEN
         TRGSDE = ANDENT(TRGSRI,ANMERI)
      ENDIF
      IF (TRGSDE .EQ. ANSUCC) THEN
         TRGSDE = ANDENT(TRGSEV,ANMEEV)
      ENDIF
$$If Acp_node
$$Else
      IF (TRGSDE .EQ. ANSUCC) THEN
         TRGSDE = ANDENT(TRGSTA,ANMETA)
      ENDIF
$$Endif
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION CMUDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module CENMUO. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C       Declarations:-
C       ==============
C
$$If VAX
      Implicit None
$$Endif
      INTEGER DUMMY
C
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'Analysis_Control$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL CMMUOI
      EXTERNAL CMMUBE
      EXTERNAL CMMUOA
$$If Acp_node
$$Else
      EXTERNAL CMMUOE
$$Endif
$$If Acp_node
$$Else
      EXTERNAL CMMUOF
$$Endif
$$If Acp_node
$$Else
      EXTERNAL CMMUOT
$$Endif
$$If Acp_node
$$Else
      EXTERNAL CMMUBO
$$Endif
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      CMUDEC = ANSUCC
C
      IF (CMUDEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            CMUDEC = ANDMOD('CENMUO','Finds Central Muons')
            DONE = .TRUE.
         ELSE
            CMUDEC = ANUMOD('CENMUO')
         ENDIF
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOI,ANMEIN)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUBE,ANMERI)
      ENDIF
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOA,ANMEEV)
      ENDIF
$$If Acp_node
$$Else
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOE,ANMERF)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOF,ANMEFI)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOT,ANMETA)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDENT(CMMUOF,ANMETE)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (CMUDEC .EQ. ANSUCC) THEN
         CMUDEC = ANDBOO(CMMUBO, 28001, 28200)
      ENDIF
$$Endif
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION ELFDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module ELEFLT. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C       Declarations:-
C       ==============
C
$$If VAX
      Implicit None
$$Endif
      INTEGER DUMMY
C
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'Analysis_Control$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL ELFINT
      EXTERNAL ELFEVT
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      ELFDEC = ANSUCC
C
      IF (ELFDEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            ELFDEC = ANDMOD('ELEFLT',
     &      'Electron/Photon Filter Module')
            DONE = .TRUE.
         ELSE
            ELFDEC = ANUMOD('ELEFLT')
         ENDIF
      ENDIF
      IF (ELFDEC .EQ. ANSUCC) THEN
         ELFDEC = ANDFIL(DUMMY)
      ENDIF
      IF (ELFDEC .EQ. ANSUCC) THEN
         ELFDEC = ANDENT(ELFINT,ANMEIN)
      ENDIF
      IF (ELFDEC .EQ. ANSUCC) THEN
         ELFDEC = ANDENT(ELFEVT,ANMEEV)
      ENDIF
      IF (ELFDEC .EQ. ANSUCC) THEN
         ELFDEC = ANDMPA( 10)
      ENDIF
C
C       Return to Caller
C       ================
C
      RETURN
      END
      INTEGER FUNCTION EWKDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module EWKFLT. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.17
C
C       Declarations:-
C       ==============
C
$$If VAX
      Implicit None
$$Endif
      INTEGER DUMMY
C
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'Analysis_Control$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL EWKGIN
      EXTERNAL EWKRIN
      EXTERNAL EWKEVT
$$If Acp_node
$$Else
      EXTERNAL EWKRFN
$$Endif
$$If Acp_node
$$Else
      EXTERNAL EWKTLK
$$Endif
$$If Acp_node
$$Else
      EXTERNAL EWKBOO
$$Endif
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      EWKDEC = ANSUCC
C
      IF (EWKDEC .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            EWKDEC = ANDMOD('EWKFLT','Filter for EWK events')
            DONE = .TRUE.
         ELSE
            EWKDEC = ANUMOD('EWKFLT')
         ENDIF
      ENDIF
      IF (EWKDEC .EQ. ANSUCC) THEN
         EWKDEC = ANDFIL(DUMMY)
      ENDIF
      IF (EWKDEC .EQ. ANSUCC) THEN
         EWKDEC = ANDENT(EWKGIN,ANMEIN)
      ENDIF
      IF (EWKDEC .EQ. ANSUCC) THEN
         EWKDEC = ANDENT(EWKRIN,ANMERI)
      ENDIF
      IF (EWKDEC .EQ. ANSUCC) THEN
         EWKDEC = ANDENT(EWKEVT,ANMEEV)
      ENDIF
$$If Acp_node
$$Else
      IF (EWKDEC .EQ. ANSUCC) THEN
         EWKDEC = ANDENT(EWKRFN,ANMERF)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (EWKDEC .EQ. ANSUCC) THEN
         EWKDEC = ANDENT(EWKRFN,ANMEFI)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (EWKDEC .EQ. ANSUCC) THEN
         EWKDEC = ANDENT(EWKTLK,ANMETA)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (EWKDEC .EQ. ANSUCC) THEN
         EWKDEC = ANDENT(EWKRFN,ANMETE)
      ENDIF
$$Endif
$$If Acp_node
$$Else
      IF (EWKDEC .EQ. ANSUCC) THEN
         EWKDEC = ANDBOO(EWKBOO,  7501,  7541)
      ENDIF
$$Endif
C
C       Return to Caller
C       ================
C
      RETURN
      END
