C DEC/CMS REPLACEMENT HISTORY, Element CESALG.CDF
C *2    17-MAY-1989 03:44:49 PEKKA "Change subroutine name TRPROP2 to TRPRP2."
C *1    17-MAY-1989 03:40:37 PEKKA "Barry Wicklund's code to implement the CES offsets."
C DEC/CMS REPLACEMENT HISTORY, Element CESALG.CDF
      SUBROUTINE CESALG( PARIN,IEAST,IPHI,ZVTA,  XCTC,ZCTC,DXCTC,DZCTC,
     2 IERR)
      REAL ZDIST
      DIMENSION PARIN(5)
      DIMENSION AVAL(0:1),BVAL(0:1)
      DATA AVAL/ -.45, -.67/
      DATA BVAL/.00047, -.00021/
      DATA ZDIST/5./
C
C    PARIN(1)=CRV
C    PARIN(2)=DVX
C    PARIN(3)=PHI
C    PARIN(4)=CTH (COT THETA)
C    PARIN(5)=ZVX
C
C    PARIN ARE THE SAME ARGUMENTS THAT ARE PASSED TO TREXRT
C    BY THE ELESCR CODE IN ELECTRON MODULE.  THEY ARE GLOBAL
C    TRACK PARAMETERS AND SHOULD NOT BE VERTEX CONSTRAINED
C    AT THIS POINT !!!
C
C   IEAST=0 (WEST), 1 (EAST)
C   IPHI= 0..23 GIVES THE WEDGE NUMBER
C
C   ZVTA= THE OVERALL EVENT Z VERTEX FROM, EG, EVTA BANK.
C
C  OUTPUT ARGUMENTS ARE AS FOLLOWS:
C
C  IERR=0 FOR SUCCESSFUL COMPUTATION (1 FOR ERROR)
C
C   XCTC= LOCAL X COORDINATE IN CES FOR PROJECTED TRACK
C   ZCTC= LOCAL Z COORDINATE IN CES FOR PROJECTED TRACK
C   DXCTC= CORRECTION TO XCTC DUE TO CES ALIGNMENT
C   DZCTC= CORRECTION TO ZCTC DUE TO CES ALIGNMENT
C
C   THEN   ZCES = ZCTC + DZCTC,
C          XCES = XCTC + DXCTC,
C
C   WHERE XCES, ZCES ARE THE LOCAL CES SHOWER COORDINATES
C
C   ELECTRON CUTS SHOULD BE MADE ON (ZCES- ZCTC-DZCTC),
C                                   (XCES- XCTC-DXCTC).
C
C============== EXECUTABLE CODE FOLLOWS=================
C
      RAD1=149.1
      RAD2=184.15
      CALL TRPRP2(PARIN,RAD1,RAD2,IPHI,IEAST,XCTC,ZCTC,IERR1)
      IF(IERR1.NE.0)GO TO 1000
C
C   XCTC AND ZCTC ARE LOCAL PROJECTED COORDINATES FOR CES PLANE
C
      CALL CES_OFFSET(IEAST,IPHI,OFFX,OFFZ,IERR2)
      IF(IERR2.NE.0)GO TO 1000
C
C  OFFX, OFFZ ARE WEDGE-TO-WEDGE OFFSETS
C
      SINTH=1./SQRT(1.+PARIN(4)**2)
C
C  If track z - Zvert distance is not large (wrong Zvert?), calculate 
C  correction to z position as a function of this distance
C
      IF ((PARIN(5) - ZVTA) .LT. ZDIST) THEN
        PULL= 0.8 * (PARIN(5) - ZVTA)
      ELSE
        PULL = 0
      ENDIF
      IF(IEAST.EQ.0)PULL=-PULL
C
C  PULL IS PULL ON Z IN LOCAL COORDINATES
C
      COTH=PARIN(4)
      IF(IEAST.EQ.0)COTH=-COTH
      OFFZ_GLOBAL= AVAL(IEAST) + BVAL(IEAST)*RAD2 *COTH
      DXCTC=OFFX
      DZCTC=OFFZ + PULL + OFFZ_GLOBAL
C
      IERR=0
      RETURN
 1000 IERR=1
      RETURN
      END
 
 
 
 
      SUBROUTINE TRPRP2(PARIN,RAD1,RAD2,IPHI_WED,IEAST,XLOCAL,ZLOCAL,
     2 IERR)
      PARAMETER (PI=3.141592653)  ! value of PI
      PARAMETER (TWOPI=2.0*PI)    ! 2pi
      PARAMETER (HALFPI=0.5*PI)   ! pi/2
      PARAMETER (RADDEG= 180./PI) ! conversion from radians to degrees
      PARAMETER (DEGRAD= PI/180.) ! conversion from degrees to radians
      DIMENSION XEX(6), PARIN(5)
C
C==============Executable Code Follows=========================
c
C  The following code is taken from P. Berge's TRPROP.CDF,
c  and applies to 3D CTC tracks only
c  The input arguments are Parin(1..5) (standard input vector)
c                          Rad1= Solenoid radius
c                          Rad2=CES "radius" (Distance to CES plane)
c                          IPHI_WED= 0..23 wedge number
c                          IEAST= 0 (west, Z<0), 1 (East, Z>0)
c  The Output Values are:
c                          Xlocal= local R Phi coordinates [-23 cm
c                              [ -Rad2 Tan(7.5) < X < Rad2 Tan(7.5)  ]
c                          Zlocal =local Z  coordinate (0< Z < 240 cm)
c
c  Note that we could "calculate" the arguments IPHI_WED, IEAST,
c  by seeing which wedge the track extrapolates to.  However, this
c  is NOT what we want to do, to compare with CES shower coordinate.
c  It can happen that Xlocal, Zlocal do NOT lie in the expected wedge,
c  but they will be referenced to the CES plane for that wedge.
c
c
      IERR = 0
      DO 1 J=1,6
    1 XEX(J)=0.
C
        CRV=PARIN(1)
        DVX=PARIN(2)
        PHI=PARIN(3)
        CTH=PARIN(4)
        ZVX=PARIN(5)
C
      A1 = 1.0+CRV*DVX
      A2 = A1+A1-1.0
C
          RADIUS=RAD1
          PSI = (RAD1+DVX)*(RAD1-DVX)
          IF (PSI.LT.0.0) THEN
            IERR = 2
            GO TO 100
          END IF
          ARGP = PSI/A2
          IF(ARGP.GE.0.) THEN
            PSI    = CRV*SQRT(PSI/A2)
          ELSE
            IERR = 2
            GOTO 100
          ENDIF
C
      IF (ABS(PSI).GT.0.999999) THEN       ! track cannot attain Radius
        IERR = 2
        GO TO 100
      ENDIF
      XEX(3) = ZVX +CTH*ASIN(PSI)/CRV
      PSI = (CRV*RADIUS +A1*DVX/RADIUS)/A2
      IF (ABS(PSI).GT.0.999999) THEN       ! track cannot attain Radius
        IERR = 2
        GO TO 100
      END IF
      PSI=PHI+ASIN(PSI)
      XEX(1) = RADIUS*COS(PSI)
      XEX(2) = RADIUS*SIN(PSI)
 
C   direction vector (NOT Px,Py,Pz)
 
      A1 = 0.5/CRV
      A2 = SIGN(1.0,CRV)
      A3 = A2*(A1+DVX)
      PSI= PHI + A2*HALFPI
      A1 = XEX(1) - A3*COS(PSI)
      A3 = XEX(2) - A3*SIN(PSI)
      PSI= ATAN2(A3,A1) + A2*HALFPI
      A1 = 1.0/SQRT(1.0+CTH**2)
      XEX(4) = COS(PSI)*A1
      XEX(5) = SIN(PSI)*A1
      XEX(6) = CTH*A1
C
C===========NOW EXTRAPOLATE FROM SOLENOID RADIUS TO CES PLANE=====
C           Using Trigenometry etc, to go to a flat CES Plane.
C
      R1=SQRT(XEX(1)**2+XEX(2)**2)
      PHICOIL=ATAN2(XEX(2),XEX(1))
      PHISLOPE=ATAN2(XEX(5),XEX(4))
      DELTA=PHISLOPE-PHICOIL
      SIN2=SIN(DELTA)*R1/RAD2
      ANG2=ASIN(SIN2)
      DR=R1*SIN(DELTA-ANG2)/SIN2
      PHIS=PHICOIL+DELTA-ANG2
      IF(PHIS.LT.0.)PHIS=PHIS+2.*PI
      IF(PHIS.LT.0.)PHIS=PHIS+2.*PI
      IF(PHIS.GT.2.*PI)PHIS=PHIS-2.*PI
      IF(PHIS.GT.2.*PI)PHIS=PHIS-2.*PI
      PHICEN=(FLOAT(IPHI_WED+1)-.5)*PI/12.
      PSI=PHIS-PHICEN
      XLOCAL=RAD2*SIN(PSI)
C ADD FLAT PLANE EXTRAPOLATION
      TY=RAD2*(1.-COS(PSI))
      TX=TY*TAN(PSI+ANG2)
      XLOCAL=XLOCAL+TX
      DR=DR+SQRT(TX**2+TY**2)
      ZLOCAL=XEX(3)+DR*XEX(6)/SQRT(XEX(4)**2+XEX(5)**2)
      IF(IEAST.EQ.0)ZLOCAL=-ZLOCAL
  100 CONTINUE
      RETURN
      END
 
 
 
 
 
 
 
      SUBROUTINE CES_OFFSET(IEAST,IPHI,OFFWIR,OFFSTR,IERROR)
      DIMENSION AVER(0:1,0:47)
      DATA AVER/
     # 0.262,  -0.314,   0.283,  -0.264,   0.170,  -0.103,
     # 0.139,  -0.197,   0.064,  -0.169,  -0.059,  -0.009,
     #-0.251,  -0.133,  -0.275,  -0.246,  -0.099,  -0.059,
     # 0.185,  -0.058,   0.380,   0.186,   0.506,   0.269,
     # 0.121,  -0.284,   0.150,  -0.250,   0.233,  -0.025,
     # 0.376,   0.098,   0.412,   0.156,   0.311,   0.030,
     # 0.137,  -0.160,   0.266,  -0.219,   0.497,  -0.111,
     # 0.701,   0.020,   0.782,   0.132,   0.846,   0.221,
     #-0.113,   0.054,   0.327,   0.152,   0.089,   0.025,
     #-0.155,   0.066,  -0.193,   0.111,  -0.039,  -0.134,
     # 0.197,   0.067,   0.183,   0.144,   0.078,  -0.075,
     # 0.015,   0.112,  -0.242,   0.280,  -0.059,   0.013,
     #-0.051,   0.195,  -0.202,   0.419,  -0.108,   0.278,
     #-0.335,   0.337,  -0.566,   0.422,  -0.729,   0.196,
     # 1.045,  -0.429,   0.505,  -0.234,   0.512,  -0.190,
     # 0.685,   0.026,   0.550,   0.078,   0.326,  -0.003
     2 /
C
C ---- AVER (0:1,0:23) ARE WIRE OFFSETS, (0:1,24:47) ARE STRIP OFFSETS
C      Defined such that  dx= (Xces - X ctc - offset)
C                         dz= (Zces - Z ctc -offset )
C
C   Input= ieast (0=west,1= east)
C          iphi  (0:23)
C   Output=offwir, offstr, ierror=0 (success),1 (incorrect input args)
C
      IF(IEAST.LT.0.OR.IEAST.GT.1)GO TO 1000
      IF(IPHI.LT.0.OR.IPHI.GT.23) GO TO 1000
 
      OFFWIR=AVER(IEAST,IPHI)
      OFFSTR=AVER(IEAST,IPHI+24)
      IERROR=0
      RETURN
 
 1000 CONTINUE
      IERROR=1
      RETURN
      END
