C====================================================
C
C INCLUDE FILE FOR VARIABLES IN THE CMIO BANK
C
C	FILLED BY CMIBTC.CDF
C
C NB variables are NOT reset at the beginning
C    of each event, so make use of NCMU to avoid
C    using values from previous event
C
C====================================================
C
C  CARLA, 10 JUNE 1990     copied from cmucm
C  Changed for 1992 formats 3-march-1992
C====================================================
C
C 
C
C
C
	INTEGER MAXCMI
	PARAMETER (MAXCMI=30)	! Maximum allowed number of central muons
c
	INTEGER NCMI		! Number of central muons
	INTEGER CMIVER(MAXCMI)  ! Version number of CMIO bank
	INTEGER CIINDX(MAXCMI)  ! Index into CMI bank
	INTEGER TIBANK(MAXCMI)	! Bits 0-7 CTCS bank # , 8-15 TRKS, 16-23 CMTS
	INTEGER TIBLCK(MAXCMI)  ! Block # of TRKS bank
	INTEGER VTIBNK(MAXCMI)   ! Version # of TRKS bank
	REAL PXCMI(MAXCMI)	! PX 
        REAL PYCMI(MAXCMI)	! PY 
	REAL PZCMI(MAXCMI)	! PZ 
	REAL ENCMI(MAXCMI)	! Energy 
	REAL PTCMI(MAXCMI)	! Pt
	REAL XCIDEC(MAXCMI)	! X of decay vertex
	REAL YCIDEC(MAXCMI)	! Y
	REAL ZCIDEC(MAXCMI)	! Z
	REAL CEMIEN(MAXCMI)	! Energy deposited in CEM
	REAL CHAIEN(MAXCMI)	! Energy deposited in CHA
	REAL NCIEN(MAXCMI)	! Energy deposited in neighboring 8 towers
	REAL DCISXY(MAXCMI)	! Difference in xy slope
	REAL DCISZY(MAXCMI)	! Difference in zy slope
	REAL DCIIXY(MAXCMI)	! Difference in xy intercept
	REAL DCIIZY(MAXCMI)	! Difference in zy intercept
	REAL ETMI04(MAXCMI)	! Et(0.4) - Et(0.13)
	REAL ETMI07(MAXCMI)	! Et(0.7) - Et(0.13)
c
c The next four variables are defined only for 1988-89 banks, and 
C are set to -999 for 1992 banks
c
	REAL PCICOV(7,MAXCMI)	! Covariance matrix elements for mom/energy
	REAL VCICOV(4,MAXCMI)	! Covariance matrix elements for vertex
	REAL PTCIER(MAXCMI)	! PT error
	REAL FITQCI(MAXCMI)	! Fit quality of (vertex?) match
c**********************************************************************
c The following quantities are defined only for 1992 banks.  They are
C set to -999 for 1988-89 banks
C********************************************************************8
	INTEGER QCMIO(MAXCMI)	! charge 
	INTEGER MITOWE(MAXCMI)  ! towe address 
	INTEGER MICES(MAXCMI)   ! pointer to ces/cpr information (?)
	INTEGER MICOSM(MAXCMI)  ! cosmic filter
	REAL CMI_HADTDC(MAXCMI) ! Hadron tdc information
	REAL CMI_EMFR04(MAXCMI) ! EM fraction in ETMI04
	REAL CMI_EMFR07(MAXCMI) ! "     "     "  ETMI07
	REAL CMI_EMFRBR(MAXCMI) ! "     "     "  NCIEN


	COMMON/CIIOBK/NCMI,CIINDX,TIBANK,TIBLCK,VTIBNK,
	1	PXCMI,PYCMI,PZCMI,ENCMI,PTCMI,XCIDEC,
	1	YCIDEC,ZCIDEC,CEMIEN,CHAIEN,NCIEN,DCISXY,DCISZY,
	2	DCIIXY,DCIIZY,PCICOV,VCICOV,PTCIER,FITQCI,ETMI04,ETMI07,
	3	qcmio,mitowe,mices,micosm,cmi_hadtdc,cmi_emfr04,
	3	CMI_EMFR07,CMI_EMFRBR
