C====================================================
C
C INCLUDE FILE FOR VARIABLES IN THE CMUO BANK
C
C	FILLED BY CMUBTC.CDF
C
C NB variables are NOT reset at the beginning
C    of each event, so make use of NCMU to avoid
C    using values from previous event
C
C====================================================
C
C  CLAUDIO, 13 SEPTEMBER 1988
C
C added cone energies  24-apr-90
C MODIFICATIONS FOR 1992 FORMAT  3-MARCH-1992
C====================================================
C
C 
C
C
C
	INTEGER MAXCMU
	PARAMETER (MAXCMU=20)	! Maximum allowed number of central muons
c
	INTEGER NCMU		! Number of central muons
	INTEGER CMUVER(MAXCMU)  ! Version number of the bank
	INTEGER CMINDX(MAXCMU)  ! Index into CMU bank
	INTEGER TBANK(MAXCMU)	! Bits 0-7 CTCS bank # , 8-15 TRKS, 16-23 CMTS
	INTEGER TBLOCK(MAXCMU)  ! Block # of TRKS bank
	INTEGER VTBNK(MAXCMU)   ! Version # of TRKS bank
	REAL PXCMU(MAXCMU)	! PX of central muon
	REAL PYCMU(MAXCMU)	! PY 
	REAL PZCMU(MAXCMU)	! PZ 
	REAL ENCMU(MAXCMU)	! Energy 
	REAL PTCMU(MAXCMU)	! Pt
	REAL XDECAY(MAXCMU)	! X of decay vertex
	REAL YDECAY(MAXCMU)	! Y
	REAL ZDECAY(MAXCMU)	! Z
	REAL CEMENE(MAXCMU)	! Energy deposited in CEM
	REAL CHAENE(MAXCMU)	! Energy deposited in CHA
	REAL NEAREN(MAXCMU)	! Energy deposited in neighboring 8 towers
	REAL DELSXY(MAXCMU)	! Difference in xy slope
	REAL DELSZY(MAXCMU)	! Difference in zy slope
	REAL DELIXY(MAXCMU)	! Difference in xy intercept
	REAL DELIZY(MAXCMU)	! Difference in zy intercept
	REAL ETMU04(MAXCMU)	! Et(0.4) - Et(0.13)
	REAL ETMU07(MAXCMU)	! Et(0.7) - Et(0.13)
C
C  The following quantities are defined only for the 1988-89 
C  version of the bank.  They are set to -999 for 1992 banks
C
	REAL PCOV(7,MAXCMU)	! Covariance matrix elements for mom/energy
	REAL VERCOV(4,MAXCMU)	! Covariance matrix elements for vertex
	REAL PTERR(MAXCMU)	! PT error
	REAL FITQUA(MAXCMU)	! Fit quality of (vertex?) match
C********************************************************************
C The following quantities are defined only for the 1992 version of
C the bank.  They are set to -999 for 1988-89 banks, except for CMUDPHI,
C CMUDX, CMUDZ, CMUDTHETA, which are filled correctly
C**********************************************************************
C- CMUS stuff
	INTEGER CMUSTY(MAXCMU)	   ! CMUS type bit_0=cmu bit_1=cmp bit_2=cmx
	INTEGER CMUSMU(MAXCMU)     ! CMUS from CMU
	INTEGER CMUSMP(MAXCMU)     !  "     "  CMP
	INTEGER CMUSMX(MAXCMU)     !  "     "  CMX
	INTEGER CMUTOW(MAXCMU)     ! CMU tower = 144*side + 6*wedge + tower
	INTEGER CMPTOW(MAXCMU)     ! CMP tower = 128*region + stack
	INTEGER CMXTOW(MAXCMU)     ! CMX tower = 144*side + 6*wedge + tower
	INTEGER CMUADC(MAXCMU)     ! Number of ADC hits in stub (CMU)
	INTEGER CMUTDC(MAXCMU)     !    "   "  TDC  "   "   "   (CMU)
	INTEGER CMPTDC(MAXCMU)     !    "   "   "   "   "   "   (CMP)
	INTEGER CMXTDC(MAXCMU)     !    "   "   "   "   "   "   (CMX)
        INTEGER CMTDWE(MAXCMU)     !    "   "   '   "   " wedge (CMU)
        INTEGER CXTDWE(MAXCMU)     !    "   "   '   "   " wedge (CMX)
	REAL CMU_CHI_ADC(MAXCMU)   ! Chi_squared of ADC fit (CMU)
	REAL CMU_CHI_TDC(MAXCMU)   !     "       "  TDC  "  (CMU)
	REAL CMP_CHI_TDC(MAXCMU)   !     "       "   "   "  (CMP)
	REAL CMX_CHI_TDC(MAXCMU)   !     "       "   "   "  (CMX)
C- Track/Stub matching stuff
	REAL CMU_CHI_Z_FULL(MAXCMU)   ! Chi2 of z and zprime match (CMU)
	REAL CMU_CHI_X_FULL(MAXCMU)   !  "   "  x  "  xprime   "   (CMU)
	REAL CMP_CHI_X_FULL(MAXCMU)   !  "   "  x  "  xprime   "   (CMP)
	REAL CMX_CHI_Z_FULL(MAXCMU)   !  "   "  z  "  zprime   "   (CMX)
	REAL CMX_CHI_X_FULL(MAXCMU)   !  "   "  x  "  xprime   "   (CMX)
	REAL CMU_CHI_Z(MAXCMU)        ! Chi2 of z match (CMU)
	REAL CMU_CHI_X(MAXCMU)        !  "   "  x  "    (CMU)
	REAL CMP_CHI_X(MAXCMU)        !  "   "  x  "    (CMP)
	REAL CMX_CHI_Z(MAXCMU)        !  "   "  z  "    (CMX)
	REAL CMX_CHI_X(MAXCMU)        !  "   "  x  "    (CMX)
	REAL CMUDPHI(MAXCMU)	      ! Delta-phi   (CMU) (same as DELSXY)	
	REAL CMUDX(MAXCMU)	      ! Delta-X     (CMU) (same as DELIXY)
	REAL CMUDTHETA(MAXCMU)	      ! Delta-theta (CMU) (same as DELSZY)	
	REAL CMUDZ(MAXCMU)	      ! Delta-z     (CMU) (same as DELIZY)
	REAL CMPDPHI(MAXCMU)	      ! Delta-phi   (CMP) 	
	REAL CMPDX(MAXCMU)	      ! Delta-X     (CMP) 
	REAL CMXDPHI(MAXCMU)	      ! Delta-phi   (CMX) 	
	REAL CMXDX(MAXCMU)	      ! Delta-X     (CMX) 
	REAL CMXDTHETA(MAXCMU)	      ! Delta-theta (CMX) 	
	REAL CMXDZ(MAXCMU)	      ! Delta-Z     (CMX) 
C- Fiducial flags
	INTEGER CMU_FIDCMU(MAXCMU)    ! Fidcmu for CMU
	INTEGER CMP_FIDCMU(MAXCMU)    !   "     "  CMP
	INTEGER CMX_FIDCMU(MAXCMU)    !   "     "  CMX
C- Miscelleaneous
	INTEGER QMUON(MAXCMU)	! charge
	INTEGER MUTOWE(MAXCMU)  ! Towe address
	INTEGER MUCES(MAXCMU)   ! Pointer to Ces/Cpr information (?)
	INTEGER MUCOSM(MAXCMU)  ! Cosmic ray filter status
	REAL HADTDC(MAXCMU)	! Hadron TDC information
	REAL EMFR04(MAXCMU)	! Fraction of ETMU04 in EM calorimeter
	REAL EMFR07(MAXCMU)	! Fraction of ETMU07 in EM calorimeter
	REAL EMFRBR(MAXCMU)	! Fraction of NEAREN in EM calorimeter



	COMMON/CMUOBK/NCMU,CMINDX,TBANK,TBLOCK,VTBNK,
	1	PXCMU,PYCMU,PZCMU,ENCMU,PTCMU,XDECAY,
	1	YDECAY,ZDECAY,CEMENE,CHAENE,NEAREN,DELSXY,DELSZY,
	2	DELIXY,DELIZY,PCOV,VERCOV,PTERR,FITQUA,ETMU04,ETMU07,
	3	CMUVER,QMUON,CMUSTY,CMUSMU,CMUSMP,CMUSMX,CMUTOW,
	3	CMPTOW,CMXTOW,CMUADC,CMUTDC,CMPTDC,CMXTDC,CMTDWE,CXTDWE,
	4       CMU_CHI_ADC,CMU_CHI_TDC,CMP_CHI_TDC,CMX_CHI_TDC,
	4	CMU_CHI_Z_FULL,CMU_CHI_X_FULL,CMP_CHI_X_FULL,CMX_CHI_Z_FULL,
	5	CMX_CHI_X_FULL,CMU_CHI_Z,CMU_CHI_X,CMP_CHI_X,CMX_CHI_Z,
	5	CMX_CHI_X,CMUDPHI,CMUDX,CMUDTHETA,CMUDZ,CMPDPHI,CMPDX,
	6	CMXDTHETA,CMXDZ,CMXDPHI,CMXDX,CMU_FIDCMU,CMP_FIDCMU,
	6	CMX_FIDCMU,MUTOWE,MUCES,MUCOSM,HADTDC,EMFR04,EMFR07,
	7	EMFRBR



