C====================================================
C
C   this include files takes cmuo and cmio varibles and puts them
C   into a common array, with a flag indicating cmio or cmuo
C
C       FILLED BY cmuoaio
C
C NB variables are NOT reset at the beginning
C    of each event, so make use of NCMU to avoid
C    using values from previous event
C
C====================================================
C
C SCE 13-jun-90
C
C====================================================
C
C
C
C
C
      INTEGER MAXMB
      PARAMETER (MAXMB=40)    ! Maximum allowed number of central muons
c
      INTEGER NCMB            ! Number of central muons
      LOGICAL CMUO(MAXMB)    ! true for cmuo; false for cmio
      INTEGER CMBINX(MAXMB)  ! Index into CMU bank
      INTEGER TBNKMB(MAXMB)  ! Bits 0-7 CTCS bank # , 8-15 TRKS, 16-23 CMTS
      INTEGER TBLKMB(MAXMB)  ! Block # of TRKS bank
      INTEGER VBNKMB(MAXMB)   ! Version # of TRKS bank
      REAL PXCMB(MAXMB)      ! PX of central muon
      REAL PYCMB(MAXMB)      ! PY
      REAL PZCMB(MAXMB)      ! PZ
      REAL ENCMB(MAXMB)      ! Energy
      REAL PTCMB(MAXMB)      ! Pt
      REAL XDECMB(MAXMB)     ! X of decay vertex
      REAL YDECMB(MAXMB)     ! Y
      REAL ZDECMB(MAXMB)     ! Z
      REAL CEMEMB(MAXMB)     ! Energy deposited in CEM
      REAL CHAEMB(MAXMB)     ! Energy deposited in CHA
      REAL NRENMB(MAXMB)     ! Energy deposited in neighboring 8 towers
      REAL DMBSXY(MAXMB)     ! Difference in xy slope
      REAL DMBSZY(MAXMB)     ! Difference in zy slope
      REAL DMBIXY(MAXMB)     ! Difference in xy intercept
      REAL DMBIZY(MAXMB)     ! Difference in zy intercept
      REAL PCOVMB(7,MAXMB)   ! Covariance matrix elements for mom/energy
      REAL VRCVMB(4,MAXMB)   ! Covariance matrix elements for vertex
      REAL PTERMB(MAXMB)     ! PT error
      REAL FTQAMB(MAXMB)     ! Fit quality of (vertex?) match
      REAL ETMB04(MAXMB)     ! Et(0.4) - Et(0.13)
      REAL ETMB07(MAXMB)     ! Et(0.7) - Et(0.13)
C
      COMMON/CMUOBKAI/NCMB,CMBINX,TBNKMB,TBLKMB,VBNKMB,
     &          PXCMB,PYCMB,PZCMB,ENCMB,PTCMB,XDECMB,
     &          YDECMB,ZDECMB,CEMEMB,CHAEMB,NRENMB,DMBSXY,DMBSZY,
     &          DMBIXY,DMBIZY,PCOVMB,VRCVMB,PTERMB,FTQAMB,
     &          ETMB04,ETMB07,CMUO
