	SUBROUTINE CORJET
C-
C-  THIS SUBROUTINE CORRECTS THE JETS IN UC$ANA:JETSCM.INC USING
C-  QDJSCO.  THE CORRECTION FACTORS GO IN THE COMMON BLOCK 
C-  UC$ANA:JCORCM.INC.  THE CONE SIZE COMES FROM THE COMMON BLOCK
C-  UC$ANA:UNFLAGS.INC AND DEFAULTS TO 0.7 (IT CAN BE CHANGED VIA
C-  THE TALK_TO)
C-
C-  *********************************************************************
C-  ******  THIS SUBROUTINE USES C$JET:QDJSCO/JTC90S AND MAKES A   ******
C-  ******  VALIANT ATTEMPT NOT TO CREATE OR OVERWRITE BANKS       ******
C-  *********************************************************************
C-
C- Set all correction factors to 1.0 for pt<1  21 oct 1994
c-
	IMPLICIT NONE
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:DSJETS.INC'
$$INCLUDE 'UC$ANA:UNFLAGS.INC'
$$INCLUDE 'UC$ANA:JETSCM.INC'
$$INCLUDE 'UC$ANA:JCORCM.INC'

	INTEGER I,QDJSCO,J,STATUS,INDAT1,INDAT2,JTC90S
	REAL THIS_CONE
	CHARACTER*2 CODE,ERRORS
	LOGICAL FIRST

	DATA FIRST /.TRUE./

C===================================
C INITIALIZE
C===================================
	DO J=1,NJET
	 DO I=1,50
	    JCOR(I,J) = 1.0
	 END DO
	END DO
C================================
C  DECIDE ON CONE SIZE
C================================
	THIS_CONE = USER_CONE
C===============================================================
C  TELL THE USER WHAT THE CONE SIZE IS THE FIRST TIME AROUND
C===============================================================
	IF (FIRST) THEN
	   FIRST = .FALSE.
	   PRINT *,' ************************************** '
	   PRINT *,'  CONE SIZE FED TO QDJSCO IS ',THIS_CONE
	   PRINT *,' ************************************** '
	END IF
C===============================================
C  NOW LOOP OVER JETS AND ALGORITHM......
C===============================================
	ERRORS(1:1) = 'D'
	DO I=1,NJET

	   if (sqrt(pxjet(i)**2+pyjet(i)**2) .lt. 1.0) then
	      do j=1,12
	         jcor(j,i) = 1.0
	      end do
	      goto 800
	   end if

	   DO J=1,12
	      IF (J.EQ.1.OR.J.EQ.2.OR.J.EQ.5.OR.J.EQ.6
	1	        .OR.J.EQ.9.OR.J.EQ.10) CODE(1:1)='Y'

	      IF (J.EQ.3.OR.J.EQ.4.OR.J.EQ.7.OR.J.EQ.8
	1	        .OR.J.EQ.11.OR.J.EQ.12) CODE(1:1)='N'

	      IF (J.EQ.1.OR.J.EQ.3.OR.J.EQ.5.OR.J.EQ.7
	1	        .OR.J.EQ.9.OR.J.EQ.11) CODE(2:2)='Y'

	      IF (J.EQ.2.OR.J.EQ.4.OR.J.EQ.6.OR.J.EQ.8
	1	        .OR.J.EQ.10.OR.J.EQ.12) CODE(2:2)='N'

	      IF (J.LE.4) 		ERRORS(2:2) = 'D'
	      IF (J.GT.4.AND.J.LE.8) 	ERRORS(2:2) = 'P'
	      IF (J.GT.8.AND.J.LE.12) 	ERRORS(2:2) = 'M'

	      INDAT1 = JTINDX(I)
	      INDAT2 = INDAT1
	      IF (OFF_VERSION .EQ. -1) THEN
	          STATUS = QDJSCO(INDAT1,INDAT2,THIS_CONE,CODE,ERRORS)
	      ELSE
                  STATUS = JTC90S(INDAT1,INDAT2,THIS_CONE,CODE,ERRORS,
	1						OFF_VERSION)
	      END IF
	      IF (STATUS .EQ. 0) THEN
		  IF (EJET(I) .GT. 0.000001) THEN
		      JCOR(J,I) = RW(INDAT2+HDSJET+E__JET)/EJET(I)
		  END IF
C - RESET THE BANK THAT QDJSCO MESSED UP
	          INDAT1 = JTINDX(I)			! paranoia ?
        	  RW(INDAT1+HDSJET+PX_JET) = PXJET(I)
        	  RW(INDAT1+HDSJET+PY_JET) = PYJET(I)
        	  RW(INDAT1+HDSJET+PZ_JET) = PZJET(I)
        	  RW(INDAT1+HDSJET+E__JET) = EJET(I)
        	  RW(INDAT1+HDSJET+EEMJET) = SHPJET(1,I)
        	  RW(INDAT1+HDSJET+PPMJET) = SHPJET(2,I)
        	  RW(INDAT1+HDSJET+EPMJET) = SHPJET(3,I)
	     END IF
	   END DO
800	   continue
	END DO
                                                    
C===================================
C  DONE
C====================================
	RETURN
	END
