C DEC/CMS REPLACEMENT HISTORY, Element CTRSEL.CDF
C *2    18-AUG-1987 09:42:07 PARA "Protect fraction cut for 2d tracks"
C *1     3-AUG-1987 16:30:02 PARA "Single track acceptance routine"
C DEC/CMS REPLACEMENT HISTORY, Element CTRSEL.CDF
C
	SUBROUTINE CTRSEL2(ICTCS,Z0V,IERR)
C
C===Description:
C
C	CTRSEL2 is called for each track to determine track quality
C
C===Author
C
C	AESOOK BYON
C	PURDUE UNIVERSITY
C
$$IF VAX
	IMPLICIT NONE
$$ENDIF
C
C===Global Declarations:
C
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:BCS   .INC'
$$INCLUDE 'C$INC:DSCMPB.INC'
$$INCLUDE 'C$INC:DSFITP.INC'
$$INCLUDE 'C$INC:DSCTCS.INC'
$$INCLUDE 'C$INC:CTCGEO.INC'
$$INCLUDE 'C$INC:TRFITC.INC'
$$INCLUDE 'C$INC:CTCCOM.INC'
C
C===Local Declarations:
C
	CHARACTER*80 MESSAG
	INTEGER IERR,STATUS
	INTEGER ICTCS
	INTEGER VERSN
	INTEGER FITCOD
	INTEGER I
	LOGICAL FLAG
        REAL Z0V
C
C===Data
C
C===External Function Declarations:
C
C===Start of Code:
	
	IERR = 0
C
	VERSN = -1
	FITCOD = -1
  	CALL CTSDAT(ICTCS,VERSN,FITCOD,IERR)
C
	IF (.NOT.FMDFY) THEN

	   IF(FITCOD.NE.CT06FC) THEN	! cut on 2D tracks
		IERR = 1
		GO TO 900
	   ELSE 
C Cut on impact parameter
C	      	IF (ABS(DC).GT.DCUT) THEN
C		   IERR = 2
C		   GO TO 900
C		END IF
C Cut on Ztrack - Zvertex
C	      	IF (ABS(ZC-Z0V).GT.ZCUT) THEN
C		   IERR = 3
C		   GO TO 900
C		END IF
C Cut on eta
C	       	IF (ABS(ETAC).GT.ECUT) THEN
C		   IERR = 4
C		   GO TO 900
C		END IF
C Cut on fraction of hits
	      	CALL CTCUFR(FITCOD,FLAG)
	      	IF (FLAG) THEN
		   IERR = 5
		   GO TO 900
		END IF
C Cut on number of segments
	      	CALL CTCSEG(FITCOD,FLAG)
	      	IF (FLAG) THEN
		   IERR = 6
		   GO TO 900
		END IF
	   END IF
C
	ELSE
	   DO 100 I=1,NMDFY
		IF (MODSEL(I).EQ.1) THEN
	   	   IF(FITCOD.NE.CT06FC) THEN
			IERR = 1
		   	GO TO 900
		   END IF
		   GO TO 100
		END IF
C
		IF (MODSEL(I).EQ.2) THEN
	      	   IF (ABS(DC).GT.DCUT) THEN
			IERR = 2
		   	GO TO 900
		   END IF
		   GO TO 100
		END IF
C
		IF (MODSEL(I).EQ.3) THEN
C
	   	   IF(FITCOD.NE.CT06FC) THEN
			IERR = 0
			GO TO 100
		   END IF
C
	      	   IF (ABS(ZC-VERTZ).GT.ZCUT) THEN
			IERR = 3
		    	GO TO 900
		   END IF
		   GO TO 100
		END IF
C
		IF (MODSEL(I).EQ.4) THEN
C
	   	   IF(FITCOD.NE.CT06FC) THEN
			IERR = 0
			GO TO 100
		   END IF
CC
	      	   IF (ABS(ETAC).GT.ECUT) THEN
			IERR = 4
		   	GO TO 900
		   END IF
		   GO TO 100
		END IF
C
		IF (MODSEL(I).EQ.5) THEN
		   CALL CTCUFR(FITCOD,FLAG)
		   IF (FLAG) THEN
			IERR = 5
			GO TO 900
		   END IF
		   GO TO 100
		END IF
C
		IF (MODSEL(I).EQ.6) THEN
		   CALL CTCSEG(FITCOD,FLAG)
		   IF (FLAG) THEN
			IERR = 6
			GO TO 900
		   END IF
		   GO TO 100
		END IF

100	   CONTINUE
	END IF
900     CONTINUE

	RETURN 
	END
C****************************************************************


C*******************************************************************
	SUBROUTINE CTCUFR(FITCOD,FLAG)
C
C===Description:
C
C	CTCUFR checks fracton of hits' been used by track
C
C===Author
C
C	AESOOK BYON
C	PURDUE UNIVERSITY
$$IF VAX
	IMPLICIT NONE
$$ENDIF
C
C===Global Declarations:
C
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:DSCMPB.INC'
$$INCLUDE 'C$INC:DSFITP.INC'
$$INCLUDE 'C$INC:DSCTCS.INC'
$$INCLUDE 'C$INC:CTCGEO.INC'
$$INCLUDE 'C$INC:TRFITC.INC'
$$INCLUDE 'C$INC:CTCCOM.INC'
C
C===Local Declarations:
C
	INTEGER FITCOD
	REAL	FRACTN

	INTEGER MODE
	REAL	DDP,DPHI,TPHI

	INTEGER I,J
C

	INTEGER LAYER,LAYERL,LAYERH,LAYAX
	REAL PARIN(5),XYZ(6),DXYZ(6),R,DOUT
	REAL	ARG

	INTEGER IERR
	LOGICAL FLAG
C
	FLAG = .FALSE.
C Calculate expected track length for 3D track
C
	   IF(FITCOD.NE.CT06FC) THEN
		R = RUPC
		GO TO 333
	   END IF
C
	   PARIN(1)=CUC
	   PARIN(2)=DC
	   PARIN(3)=PHIC*DEGRAD
	   PARIN(4)=CTHC
	   PARIN(5)=ZC
C
	   DOUT = RZ0(83)
	   MODE = 1
	   CALL TRPROP(MODE,PARIN,DOUT,XYZ,DXYZ,IERR)
	   IF (ABS(XYZ(3)).GT.ZMAXO) THEN
		MODE = 2
		ARG = ZMAXO
		IF(PARIN(4).LT.0) ARG = -ZMAXO
		CALL TRPROP(MODE,PARIN,ARG,XYZ,DXYZ,IERR)
	   END IF
C
	   IF (XYZ(1).NE.0.OR.XYZ(2).NE.0) 
	1	DOUT = SQRT(XYZ(1)**2+XYZ(2)**2)
C	 
	   IF (ABS(PARIN(1)).GT.1/DOUT) DOUT = 0.98/ABS(PARIN(1))
	   R = DOUT
C
C  Correction for layer 8 sector A
	   IF (R.GT.RZ0(71)) THEN	! go thru layer 8
		DOUT = RZ0(71)
	   	MODE = 1
	   	CALL TRPROP(MODE,PARIN,DOUT,XYZ,DXYZ,IERR)
C
	   	TPHI=ASIN(XYZ(2)/SQRT(XYZ(1)**2+XYZ(2)**2))
C
	   	IF (XYZ(1).LT.0.0) TPHI=PI-TPHI
	   	IF (XYZ(1).GT.0.0.AND.XYZ(2).LT.0.0) TPHI=2*PI+TPHI
C
	   	IF (TPHI.GT.0.0.AND.TPHI.LT.PI/2) R = DOUT
C
	   END IF
333 	CONTINUE
	   REXITC = R
C Binary search + rounding for wire layer
	   LAYERL = 0
	   LAYERH = NWR-1
	   LAYER = LAYERH / 2
110	   IF (R.LE.RZ0(LAYER)) THEN 
	    	LAYERH = LAYER
	   ELSE
	    	LAYERL = LAYER
	   ENDIF
	   LAYER = (LAYERL + LAYERH) / 2
	   IF (LAYERH-LAYERL.GT.1) GO TO 110
	   IF (R-RZ0(LAYER).GT.RZ0(LAYER+1)-R) LAYER = LAYER + 1

	   I = LAYER/18
	   LAYAX = LAYER-6*I
	   LAYER = LAYER + 1
C
	   IF(FITCOD.NE.CT06FC) THEN
		FRACTN = FLOAT(NHAXC)/FLOAT(LAYAX)
		GO TO 332
	   END IF
C
	   FRACTN = FLOAT(NHSTC+NHAXC)/FLOAT(LAYER)
C Cut on fraction of hits used
332	CONTINUE
C
	   IF (ABS(FRACTN).LT.FCUT) FLAG = .TRUE.
	RETURN 
	END
C****************************************************************


	SUBROUTINE CTCSEG(FITCOD,FLAG)

C	Description
C	===========
C	Finds number of good segments in the given track
C
C	Author
C	======
C
C	AESOOK BYON
C	PURDUE UNIVERSITY
C
C	Arguments
C	===============
C	FLAG

C	Global Declarations
C	===================
$$IF VAX
	IMPLICIT NONE
$$ENDIF

C	Local Declarations
C	==================
	INTEGER FITCOD
	LOGICAL FLAG

	INTEGER I,J,K
	INTEGER ILAYER(9)
	INTEGER AXGOOD, STGOOD

	INTEGER  NX, IXW(32), NXW(84)
	
C	Include files
C	=============
$$INCLUDE 'C$INC:DSCMPB.INC'		! Required for DSCTCS.INC
$$INCLUDE 'C$INC:DSFITP.INC'		! Ditto
$$INCLUDE 'C$INC:DSCTCS.INC'		! Parameters for CTCS bank
$$INCLUDE 'C$INC:BCS   .INC'
$$INCLUDE 'C$INC:TRFITC.INC'
$$INCLUDE 'C$INC:CTCCOM.INC'

C	Executable code
C	==================================================================

C
	FLAG = .TRUE.
	K = 0
C
	DO 600 I=1,9
	   FLAYER(I) = 0
	   ILAYER(I) = 0
600	CONTINUE
C
	DO 100 I=1,3
	   CALL UBITS(MAPC(I),32,IXW,NX)
C
	   DO 200 J=1,NX
		K=K+1
		NXW(K) = IXW(J)+(I-1)*32
200 	   CONTINUE
100	CONTINUE
C
	DO 300 J=1,K
	      IF (NXW(J).LE.12) THEN
		ILAYER(1) = ILAYER(1)+1
		GO TO 9999
	      ELSE IF (NXW(J).LE.18) THEN
		ILAYER(2) = ILAYER(2)+1
	  	GO TO 9999
	      ELSE IF (NXW(J).LE.30) THEN
		ILAYER(3) = ILAYER(3)+1
		GO TO 9999
	      ELSE IF (NXW(J).LE.36) THEN
		ILAYER(4) = ILAYER(4)+1
		GO TO 9999	
	      ELSE IF (NXW(J).LE.48) THEN
		ILAYER(5) = ILAYER(5)+1
		GO TO 9999	
	      ELSE IF (NXW(J).LE.54) THEN
		ILAYER(6) = ILAYER(6)+1
		GO TO 9999	
	      ELSE IF (NXW(J).LE.66) THEN
		ILAYER(7) = ILAYER(7)+1
		GO TO 9999	
	      ELSE IF (NXW(J).LE.72) THEN
		ILAYER(8) = ILAYER(8)+1
		GO TO 9999	
	      ELSE IF (NXW(J).LE.84) THEN
		ILAYER(9) = ILAYER(9)+1
	      END IF
9999	      CONTINUE		   
300	CONTINUE
C
C Check how many good segments are
	AXGOOD = 0
	STGOOD = 0
	DO 400 I=1,9,2
	   IF (ILAYER(I).GE.NREQAX) THEN
		FLAYER(I) = 1
		AXGOOD = AXGOOD + 1
	   END IF
400	CONTINUE
C
	IF(FITCOD.NE.CT06FC) THEN
	   IF (AXGOOD.GE.MINAXS) FLAG = .FALSE.
	   GO TO 333
	END IF
C
	DO 500 I=2,8,2
	   IF (ILAYER(I).GE.NREQST) THEN
		FLAYER(I) = 1
		STGOOD = STGOOD + 1
	   END IF
500	CONTINUE
C
	IF (AXGOOD.GE.MINAXS.AND.STGOOD.GE.MINSTS) FLAG = .FALSE.
C
333	CONTINUE
	RETURN
	END

C***********************************************************

	SUBROUTINE CTSDAT(ICTCS,VERSN,FITCOD,IERR)

C	Description
C	===========
C	Extracts information from CTCS bank into a common block
C
C	Arguments
C	===============
C	ICTCS		Pointer to the track in CTCS bank
C	VERSN		Version number of segment (default version if < 0)
C	FITCOD		Fit code desired (highest fit code if < 0)
C	VERSN and FITCOD will get modified if they are < 0
C	IERR            Error flag, 0 if succesful operation

C	Global Declarations
C	===================
$$IF VAX
	IMPLICIT NONE
$$ENDIF

C	Local Declarations
C	==================
	INTEGER ICTCS
	INTEGER VERSN
	INTEGER FITCOD

	INTEGER I,J,K
	INTEGER INDDAT
	CHARACTER*80 MESSAG
	INTEGER BASINS,VERINS,BLKINS	! CTCS indices
	INTEGER NVERSN
	INTEGER VERNXT
	INTEGER LENDAT
	INTEGER NBLCKS
	INTEGER CODE,FLAG
	INTEGER LCODE,IERR
	REAL BMAG,CONVPT

C	Include files
C	=============
$$INCLUDE 'C$INC:DSCMPB.INC'		! Required for DSCTCS.INC
$$INCLUDE 'C$INC:DSFITP.INC'		! Ditto
$$INCLUDE 'C$INC:DSCTCS.INC'		! Parameters for CTCS bank
$$INCLUDE 'C$INC:TRFITC.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:BCS   .INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:LOGUNI.INC'
$$INCLUDE 'C$INC:CTCCOM.INC'

C	Executable code
C	==================================================================

	IERR = 1
	LCODE = 0

C---Calculate base index to start of DAIS header:

	BASINS = ICTCS+DSHDCB

C---Check that the bank structure version number is one we know about

	IF(IW(BASINS+DSVNCB).NE.VNUCTS) THEN
	   WRITE(MESSAG,20) IW(BASINS+DSVNCB)
20	   FORMAT('Unknown bank structure version number: ',I5)
	   CALL ERLOGR('CTSDAT',EREROR,0,0,MESSAG)
	   GO TO 9999
	ENDIF

C-- Get the default version number if necessary


	IF(VERSN.LT.0) THEN
	  VERSN = IW(BASINS+DVNCTS)
	ENDIF

C---Loop over all versions of this track segment until we find the version
C    we want

	NVERSN = 0
	VERINS = BASINS+IW(BASINS)

300	CONTINUE

C---Have we dumped all versions?

	IF(NVERSN.NE.IW(BASINS+NVNSCB)) THEN
	  NVERSN = NVERSN+1
C
C-- Do we have the desired version?

	  IF(IW(VERINS+VNUMCB).EQ.VERSN) THEN

C-- Get the TOWE index

	    TOWINC = IW(VERINS+TOWECT)

C---Loop over all fits performed for this version

	    NBLCKS = 0
	    BLKINS = VERINS+IW(BASINS+NWVHCB)

350	    CONTINUE
C
C---Have we dumped all fits?

	    IF(NBLCKS.NE.IW(VERINS+NBLKCB)) THEN
	      NBLCKS = NBLCKS+1

	      FLAG=IAND(IW(BLKINS+FitcCT+1),CTFLFC)
	      CODE = ISHFT(FLAG,-CTSHFC)

	      IF(CODE.EQ.FITCOD) THEN		! Do we have the right fit code?

	        CHISQ = RW(BLKINS+FITQCT)
	        CHIAXC = RW(BLKINS+FITQCT+1)
	        CHISTC = RW(BLKINS+FITQCT+2)
	        NDOF = IW(BLKINS+NDOFCT)
	        NHAXC = IW(BLKINS+NDOFCT+1)
	        NHSTC = IW(BLKINS+NDOFCT+2)

	        CUC = RW(BLKINS+CUCT)
	        PHIC = RW(BLKINS+P0CT)
	        DC = RW(BLKINS+D0CT)
	        CTHC = RW(BLKINS+CTCT)
	        ZC = RW(BLKINS+Z0CT)

		BMAG = 15.0
		CONVPT=1.49898E-4*BMAG

		PTC=CONVPT/ABS(CUC)

		PXC=PTC*COS(PHIC)
		PYC=PTC*SIN(PHIC)
		PZC=PTC*CTHC

		ETAC=1./(SQRT(1.+CTHC**2)+CTHC)
		ETAC=-ALOG(ETAC)
		
		RLOWC=RW(VERINS+D2CT)
		RUPC=RW(VERINS+D3CT)

		SIGNC=SIGN(1.,CUC)

		DPTC=PTC*SQRT(RW(BLKINS+DCU2CT))/ABS(CUC)
		DPHIC=SQRT(RW(BLKINS+DP02CT))*RADDEG
		DCTHC=SQRT(RW(BLKINS+DCT2CT))

		PHIC = PHIC*RADDEG

		FITC(1) = IW(BLKINS+FITCCT)
		FITC(2) = IW(BLKINS+FITCCT+1)
		FITC(3) = IW(BLKINS+FITCCT+2)

		MAPC(1) = IW(VERINS+BITMCT)
		MAPC(2) = IW(VERINS+BITMCT+1)
		MAPC(3) = IW(VERINS+BITMCT+2)

	        LCODE=CODE

	        IERR=0
	        GOTO 400			! Done

	      ELSEIF(FITCOD.LT.0) THEN		! Get the highest numbered code
	        IF(CODE.GT.LCODE) THEN

	        CHISQ = RW(BLKINS+FITQCT)
	        CHIAXC = RW(BLKINS+FITQCT+1)
	        CHISTC = RW(BLKINS+FITQCT+2)
	        NDOF = IW(BLKINS+NDOFCT)
	        NHAXC = IW(BLKINS+NDOFCT+1)
	        NHSTC = IW(BLKINS+NDOFCT+2)

	        CUC = RW(BLKINS+CUCT)
	        PHIC = RW(BLKINS+P0CT)
	        DC = RW(BLKINS+D0CT)
	        CTHC = RW(BLKINS+CTCT)
	        ZC = RW(BLKINS+Z0CT)

		BMAG = 15.0
		CONVPT=1.49898E-4*BMAG

		PTC=CONVPT/ABS(CUC)

		PXC=PTC*COS(PHIC)
		PYC=PTC*SIN(PHIC)
		PZC=PTC*CTHC

		ETAC=1./(SQRT(1.+CTHC**2)+CTHC)
		ETAC=-ALOG(ETAC)
		
		RLOWC=RW(VERINS+D2CT)
		RUPC=RW(VERINS+D3CT)

		SIGNC=SIGN(1.,CUC)

		DPTC=PTC*SQRT(RW(BLKINS+DCU2CT))/ABS(CUC)
		DPHIC=SQRT(RW(BLKINS+DP02CT))*RADDEG
		DCTHC=SQRT(RW(BLKINS+DCT2CT))

C		CALL UCOPY(FITC,IW(BLKINS+FITCCT),3)

		FITC(1) = IW(BLKINS+FITCCT)
		FITC(2) = IW(BLKINS+FITCCT+1)
		FITC(3) = IW(BLKINS+FITCCT+2)

		MAPC(1) = IW(VERINS+BITMCT)
		MAPC(2) = IW(VERINS+BITMCT+1)
		MAPC(3) = IW(VERINS+BITMCT+2)

		PHIC = PHIC*RADDEG

	          LCODE=CODE

	          IERR=0

	        ENDIF

	      ENDIF

C---See if there is another fit for this version:

	      BLKINS = BLKINS+IW(BASINS+NWBLCB)
	      GOTO 350
	    END IF

	  ELSE

C---See if there is another version:

	    VERINS = VERNXT
	    GOTO 300

	  END IF

	ENDIF

C-- Here when we have found what we want

400	CONTINUE

	FITCOD=LCODE

9999	RETURN
	END
C***********************************************************
