      INTEGER FUNCTION ANSTUP(MODE,INLUN,OUTLUN,DEVICE)
C     =================================================
C
C       Description:-
C       =============
C       This Function is used by Analysis_Control
C       to setup and allocate work space for the
C       standard Utilities used by this program.
C       These standard utilities are:-
C
C       Analysis_Control Configuration
C       UIPack Configuration
C       Database Work Area
C       Primary YBOS Array
C       Primary YHIST Array
C       HBOOK Blank Common Array
C
C       where only those utilities used in this program
C       are initialised.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.30
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER MODE, INLUN,OUTLUN,DEVICE
C
      COMMON/ANCOMM/ANPKI4
      INTEGER       ANPKI4
      DIMENSION     ANPKI4(    131072)
      COMMON/MENUCO/MENUI4
      INTEGER       MENUI4
$$If Acp_node
$$Else
      DIMENSION     MENUI4(    131072)
$$Endif
      COMMON/KALI  /CALII4
      INTEGER       CALII4
      DIMENSION     CALII4(    100000)
      INTEGER       HDINIT
      COMMON/BCS   /YBOSI4
      INTEGER       YBOSI4
      DIMENSION     YBOSI4(   1500000)
$$If Acp_Host
      COMMON/ANINPU/ANINPU
      INTEGER       ANINPU
      DIMENSION     ANINPU(   1500000)
$$Endif
      INTEGER NKW,KW
      PARAMETER (NKW=50000)
      COMMON/DETECT/KW(NKW)
      INTEGER       ANPKIN
      INTEGER       UIINIT
      INTEGER       BOSAR
      INTEGER       DBKAIN
      INTEGER       BOS77
$$If Acp_Host
      INTEGER       BLVERM
$$Endif
C
      INTEGER       DBINIT
$$If Acp_host
      INTEGER       DBIACP
$$Endif
C
$$Include 'Cdfdb$Library:Errcod.Inc'
C
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'UIPack$Library:UIError.Inc'
$$Include 'YBOS$Library:ErrCod.Inc'
$$Include 'YHist$Library:HistErr.Inc'
$$Include 'C$Inc:Erlevl.Inc'
      EXTERNAL ANFIN
C
C       Executable Code:-
C       =================
C
      ANSTUP = ANSUCC
C
C
C       Initialise Analysis_Control
C       ===========================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = ANPKIN(ANPKI4,    131072,'/ANCOMM/', 128)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise UIPack
C       =================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
$$If Acp_node
$$Else
         ANSTUP = UIINIT(MODE,INLUN,OUTLUN,DEVICE,    131072, 256)
$$Endif
         IF (ANSTUP .EQ. UISUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Calibration Database YBOS Array
C       ==========================================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBKAIN(CALII4,    100000,'/KALI  /',128)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Primary YBOS Array
C       =============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = BOS77(   1500000, 256)
         IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
$$If Acp_Host
C
C        Setup for no Logical Record Verification
C        ========================================
C
         IF (ANSTUP .EQ. ANSUCC) THEN
            ANSTUP = BLVERM(YBOSI4,0)
            IF (ANSTUP .EQ. YESUCC) ANSTUP = ANSUCC
         ENDIF
C
C        Copy YBOS header to input array
C        ===============================
C
         CALL UCOPY(YBOSI4,ANINPU,YBOSI4(23)-1)
$$Endif
      ENDIF
C
C       Initialise    CALIB Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','CALIB')
$$If Acp_host
         ANSTUP = DBIACP(CALII4,'CALIB')
$$Endif
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise GEOMETRY Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','GEOMETRY')
$$If Acp_host
         ANSTUP = DBIACP(CALII4,'GEOMETRY')
$$Endif
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise RUN_COND Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','RUN_COND')
$$If Acp_host
         ANSTUP = DBIACP(CALII4,'RUN_COND')
$$Endif
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise CDF_COND Database
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = DBINIT('READ','CDF_COND')
$$If Acp_host
         ANSTUP = DBIACP(CALII4,'CDF_COND')
$$Endif
         IF (ANSTUP .EQ. CESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Histogram Display
C       ============================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
         ANSTUP = HDINIT(DEVICE)
         IF (ANSTUP .EQ. HESUCC) ANSTUP = ANSUCC
      ENDIF
C
C       Initialise Offline Commons
C       ==========================
C
      IF (ANSTUP .EQ. ANSUCC) THEN
$$If Acp_node
C
C       Initialize geometry data base YBOS array:
C       =========================================
          ANSTUP = BOSAR(KW,NKW,'/DETECT/',128)
          IF (ANSTUP .NE. YESUCC) THEN
	          CALL ERLOGR('ANSTUP',ERSEVR,0,ANSTUP,
     1      'Cant initialize Geometry YBOS array')
          ELSE
             ANSTUP = ANSUCC
          ENDIF
$$Else
         CALL ANOFFI
$$Endif
      ENDIF
C
C       Return to Caller
C       ================
C
      IF(ANSTUP.NE.ANSUCC)   CALL ANEROR(ANSTUP)
      RETURN
      END
      INTEGER FUNCTION ANFIN(DUMMY)
C     =============================
C
C       Description:-
C       =============
C       This Function is used by Analysis_Control
C       to close the standard  databases upon program
C       termination
C       These standard database are:-
C
C       Calibration Database
C       Geometry Database
C       Run Conditions Database
C       Cdf Conditions Database
C
C       where only those databases used in this program
C       are closed.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.30
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
C
      INTEGER DBTERM
C
$$Include 'Cdfdb$Library:ErrCod.Inc'
C
      INTEGER HDFINI
C
$$IF UNIX
$$ELSE
$$Include 'Yhist$Library:HistErr.Inc'
$$ENDIF
C
$$Include 'Analysis_Control$Library:ANError.Inc'
C
C       Executable Code:-
C       =================
C
      ANFIN = ANSUCC
C
C
C       Close Calibration databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('CALIB')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close Geometry databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('GEOMETRY')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close Run Conditions databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('RUN_COND')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Close CDF Conditions databases
C       =====================
      IF(ANFIN.EQ.ANSUCC)   THEN
         ANFIN = DBTERM('CDF_COND')
         IF(ANFIN.EQ.CESUCC)   ANFIN=ANSUCC
      ENDIF
C
C       Terminate Histogram Display
C       ===========================
C
      IF (ANFIN .EQ. ANSUCC) THEN
         ANFIN = HDFINI()
         IF (ANFIN .EQ. HESUCC) ANFIN = ANSUCC
      ENDIF
C
C       Return to Caller
C       ================
C
      IF(ANFIN.NE.ANSUCC)   CALL ANEROR(ANFIN)
      RETURN
      END
      INTEGER FUNCTION ANH4FI(STREAM)
C     ===============================
C
C     Description:-
C     ==============
C     This routine is called by ANHCCL.  For HBOOK4
C     users it lists and closes the requested HBOOK4
C     stream.  For non-HBOOK4 users it is dummied.
C
C     Author:-
C     ========
C     BUILD_JOB Program Version  1.30
C
C     Call Parameters:-
C     =================
C     STREAM
C
C     Return Parameters:-
C     ===================
C     ANH4FI  (Integer)       ANSUCC  Success
C                             ANNOBK  no HROPEN parameters
C 
C     Global Declarations:-
C     =====================
$$IMPLICIT
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'C$Inc:Erlevl.Inc'
      INTEGER STREAM
      ANH4FI = ANSUCC
C     Return to Caller:-
C     ==================
      RETURN
      END
      INTEGER FUNCTION ANH4IN(STREAM)
C     ===============================
C
C     Description:-
C     ==============
C     This routine is called by A_C when the user
C     types HISTOGRAM OPEN.  It performs necessary
C     initialization for HBOOK4 users who want to
C     use HBOOK4's direct access paging file.  If
C     HBOOK4 is not enabled this routine is dummied.
C     ANH4IN is written by BUILD_JOB so that non-
C     HBOOK4 users are not forced to link to it.
C
C     Author:-
C     ========
C     BUILD_JOB Program Version  1.30
C
C     Call Parameters:-
C     =================
C     STREAM  (Integer)    Choses which histogram Stream
C                          to OPEN.
C 
C     Return Parameters:-
C     ===================
C     ANH4IN  (Integer)    ANSUCC  Success
C                          ANEFOP  Error Opening file
C                          ANNOLU  No free logical units
C                          ANNOBK  no HROPEN parameters
C
C     Global Declarations:-
C     =====================
$$IMPLICIT
$$Include 'Analysis_Control$Library:ANError.Inc'
      INTEGER STREAM
C
C     Executable Code:-
C     =================
      ANH4IN = ANSUCC
C
C     Return to Caller:-
C     ==================
      IF(ANH4IN.NE.ANSUCC)   CALL ANEROR(ANH4IN)
      RETURN
      END
      INTEGER FUNCTION ANHBWR(STREAM,MODNAM,IDLIST,NVALUS,WRFLAG)
C     ===========================================================
C
C     Description:-
C     ==============
C     This routine is called by A_C when the user
C     types HISTOGRAM STORE or WRITE. If HBOOK4 is not
C     enabled this routine is uses HUPDDI or HWRITV.
C     Otherwise it calls HROUT to output the requested
C     histograms. ANHBWR is written by BUILD_JOB so
C     that non-HBOOK4 users are not forced to link to it.
C
C     Author:-
C     ========
C     BUILD_JOB Program Version  1.30
C
C     Call Parameters:-
C     =================
C     STREAM  (Integer)       Choses which histogram
C                             Stream to write to.
C     MODNAM  (Character*(*)) Write histograms from module MODNAM
C     IDLIST  (Integer(*))    List of histogam ID's to write
C     NVALUS  (Integer)       Number of values in IDLIST
C 
C     Return Parameters:-
C     ===================
C     ANHBWR  (Integer)       ANSUCC  Success
C                             ANEFOP  Error Opening file
C                             ANNOLU  No free logical units
C                             ANNOBK  no HROPEN parameters
C
C     Global Declarations:-
C     =====================
$$IMPLICIT
      CHARACTER*(*)      MODNAM
      INTEGER IDLIST(*), STREAM, NVALUS, WRFLAG
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'Analysis_Control$Source:ANPack.Inc'
$$Include 'UIPack$Library:UIParam.Inc'
$$If UNIX
$$Include 'System_Interface$Library:Noarginc.Inc'
$$Endif
C
C     External Functions:-
C     ====================
      INTEGER ANMDNU
      INTEGER HUPDDI, HWRITV, YHWRTC
      INTEGER UIGTFI, UIGTTX, UIOUTX
C
C     Local Variables
C     ===============
      INTEGER STATUS, TXTLEN, MODID
      LOGICAL EXISTS
      CHARACTER*80  VOLNAM, FOLNAM
      CHARACTER*132 TXTBUF
C
C     Executable Code:-
C     =================
      ANHBWR = ANSUCC
      IF (MODNAM.EQ.'ALL') THEN
         IF (WRFLAG.EQ.HBSTOR) THEN
            VOLNAM = 'ANA_VOLUME'
            FOLNAM = 'ANA_FOLDER'
            STATUS = UIGTTX('Volume Name:',VOLNAM,TXTLEN,1,80)
            STATUS = UIGTTX('Folder Name:',FOLNAM,TXTLEN,1,80)
            ANHBWR = HUPDDI(VOLNAM,FOLNAM)
         ELSEIF (WRFLAG.EQ.HBWRIT) THEN
            VOLNAM = 'ANHIST'
            STATUS = UIGTFI('Filename: ',VOLNAM,TXTLEN,EXISTS)
            STATUS = HWRITV(VOLNAM)
         ENDIF
      ELSE IF(MODNAM.EQ.'NONE') THEN
      ELSE
         IF (WRFLAG.EQ.HBSTOR) THEN
C
C	          Module name qualifier is not allowed for HBOOK3
C           ===============================================
            WRITE(TXTBUF,100)
$$If UNIX
            STATUS = UIOUTX(TXTBUF,UIINPT,N$A,N$A)
$$Else
            STATUS = UIOUTX(TXTBUF,UIINPT)
$$Endif
            WRITE(TXTBUF,101)
$$If UNIX
            STATUS = UIOUTX(TXTBUF,UIINPT,N$A,N$A)
$$Else
            STATUS = UIOUTX(TXTBUF,UIINPT)
$$Endif
            ANHBWR = ANSUCC
         ELSEIF (WRFLAG.EQ.HBWRIT) THEN
            VOLNAM = 'ANHIST'
            STATUS = UIGTFI('Filename: ',VOLNAM,TXTLEN,EXISTS)
C
C           Get the chapter for this module (same as modid)
C           ===============================================
            ANHBWR = ANMDNU(MODNAM,MODID)
            STATUS = YHWRTC(MODID,VOLNAM)
            ANHBWR = ANSUCC
         ENDIF
      ENDIF
 100  FORMAT(' Not yet implemented: Please retype without qualifier')
 101  FORMAT(' No histograms have been written')
C
C     Return to Caller:-
C     ==================
      RETURN
      END
      INTEGER FUNCTION ANH4AT(DUMMY)
C     ==============================
C
C     Description:-
C     ==============
C     This routine is called when the application
C     abnormally terminates.  It dumps all histograms
C     and Ntuples in memeory to the HBOOK4 direct
C     access paging file if the file is currently open.
C     If HBOOK4 is not enabled this routine is dummied.
C     ANH4AT is written by BUILD_JOB so that non-
C     HBOOK4 users are not forced to link to it.
C
C     Author:-
C     ========
C     BUILD_JOB Program Version  1.30
C
C     Call Parameters:-
C     =================
C     DUMMY   (Integer)
C 
C     Return Parameters:-
C     ===================
C     ANH4AT  (Integer)    ANSUCC  Success
C                          ANNOBK  no HROPEN parameters
C
C     Global Declarations:-
C     =====================
$$IMPLICIT
$$Include 'Analysis_Control$Library:ANError.Inc'
      INTEGER DUMMY
C
C     Executable Code:-
C     =================
      ANH4AT = ANSUCC
C
C     Return to Caller:-
C     ==================
      RETURN
      END
      INTEGER FUNCTION ANH4CD(STREAM)
C     ===============================
C
C     Description:-
C     ==============
C     This routine is called by A_C before the user's
C     module's booking and event entry points. It is
C     used to change HBOOK4 directory to the module
C     subdirectory.  If HBOOK4 is not enabled this 
C     routine is dummied.  ANH4CD is written by 
C     BUILD_JOB so that non-HBOOK4 users are not 
C     forced to link to it.
C
C     Author:-
C     ========
C     BUILD_JOB Program Version  1.30
C
C     Call Parameters:-
C     =================
C     STREAM  (Integer)    Choses which histogram Stream
C                          to use for the TOPDIR
C 
C     Return Parameters:-
C     ===================
C     ANH4CD  (Integer)    ANSUCC  Success
C                          ANNOBK  no HROPEN parameters
C
C     Global Declarations:-
C     =====================
$$IMPLICIT
$$Include 'Analysis_Control$Library:ANError.Inc'
      INTEGER STREAM
C
C     Executable Code:-
C     =================
      ANH4CD = ANSUCC
C
C     Return to Caller:-
C     ==================
      IF(ANH4CD.NE.ANSUCC)   CALL ANEROR(ANH4CD)
      RETURN
      END
      INTEGER FUNCTION ANH4MD(STREAM)
C     ===============================
C
C     Description:-
C     ==============
C     This routine is called by A_C before the user's
C     module's booking and event entry points. It is
C     used to change HBOOK4 directory to the module
C     subdirectory.  If HBOOK4 is not enabled this 
C     routine is dummied.  ANH4MD is written by 
C     BUILD_JOB so that non-HBOOK4 users are not 
C     forced to link to it.
C
C     Author:-
C     ========
C     BUILD_JOB Program Version  1.30
C
C     Call Parameters:-
C     =================
C     STREAM  (Integer)    Choses which histogram Stream
C                          to use for the TOPDIR
C 
C     Return Parameters:-
C     ===================
C     ANH4MD  (Integer)    ANSUCC  Success
C                          ANNOBK  no HROPEN parameters
C
C     Global Declarations:-
C     =====================
$$IMPLICIT
$$Include 'Analysis_Control$Library:ANError.Inc'
      INTEGER STREAM
C
C     Executable Code:-
C     =================
      ANH4MD = ANSUCC
C
C     Return to Caller:-
C     ==================
      IF(ANH4MD.NE.ANSUCC)   CALL ANEROR(ANH4MD)
      RETURN
      END
      INTEGER FUNCTION ANH4DR(STREAM,MODNAM)
C     ======================================
C
C     Description:-
C     ==============
C     This routine is called by A_C when the user
C     issues a HISTOGRAM DIRECTORY.If HBOOK4 is not
C     enabled this routine is dummied.  ANH4DR is
C     written by BUILD_JOB so that non-HBOOK4 users
C     are not forced to link to it.
C
C     Author:-
C     ========
C     BUILD_JOB Program Version  1.30
C
C     Call Parameters:-
C     =================
C     STREAM  (Integer)    Choses which histogram Stream
C                          to use for the TOPDIR
C     MODNAM  (Character)  Module name to do dir for
C 
C     Return Parameters:-
C     ===================
C     ANH4DR  (Integer)    ANSUCC  Success
C                          ANNOBK  no HROPEN parameters
C
C     Global Declarations:-
C     =====================
$$IMPLICIT
$$Include 'Analysis_Control$Library:ANError.Inc'
      INTEGER STREAM
      CHARACTER*(*) MODNAM
C
C     Executable Code:-
C     =================
      ANH4DR = ANSUCC
C
C     Return to Caller:-
C     ==================
      IF(ANH4DR.NE.ANSUCC)   CALL ANEROR(ANH4DR)
      RETURN
      END
      INTEGER FUNCTION ANMDEC(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Subprogram is called by Analysis_Control to
C       declare the Modules in the current Executable
C       Program
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.30
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
$$Include 'Analysis_Control$Library:ANError.Inc'
C
      INTEGER ewunpk
C
C       Executable Code:-
C       =================
C
      ANMDEC = ANSUCC
C
      IF (ANMDEC .EQ. ANSUCC) THEN
         ANMDEC = ewunpk(DUMMY)
      ENDIF
C
C      Perform offline initialisation 
C      ============================== 
$$If Acp_node
      CALL ANOFFI
$$Endif
C
C       Return to Caller
C       ================
      IF(ANMDEC.NE.ANSUCC)   CALL ANEROR(ANMDEC)
C
      RETURN
      END
$$If UNIX
$$Else
      SUBROUTINE ANSSYB
C     =================
C
C     Description:-
C     ==============
C     When downloading any secondary YBOS arrays to
C     the ACP nodes, it is necessary to save the
C     YBOS header so as to retain any information 
C     about work banks.  This routine is used to 
C     store this information and to place this
C     information back in the correct YBOS array 
C     The secondary arrays BUILD_JOB knows about are:
C          
C       Analysis_Control Configuration
C       UIPack Configuration
C       Database Work Area
C       YHIST Array
C       Simulation Geometry Database
C          
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.30
C
C     Call Parameters:-
C     =================
C     None
C 
C     Return Parameters:-
C     ===================
C     None
C 
C     Global Declarations:-
C     =====================
$$IMPLICIT
$$Include 'YBOS$Library:ErrCod.Inc'
C 
C     External Functions:-

C     =====================
      INTEGER YBRSTO, YBSAVE
C
C     Local Variables
C     ===============
      INTEGER NWORDS
      PARAMETER (NWORDS=200)
      INTEGER STATUS
C
      SAVE
      COMMON/ANCOMM/ANPKI4
      INTEGER       ANPKI4
      DIMENSION     ANPKI4(1)
      INTEGER       SAVANP
      DIMENSION     SAVANP(NWORDS)
      COMMON/KALI  /CALII4
      INTEGER       CALII4
      DIMENSION     CALII4(1)
      INTEGER       SAVCAL
      DIMENSION     SAVCAL(NWORDS)
      COMMON/DETECT/KW
      INTEGER       KW
      DIMENSION     KW(1)
      INTEGER       SAVDET
      DIMENSION     SAVDET(NWORDS)
C
C     Save Statements
C     ===============
      SAVE SAVANP
      SAVE SAVCAL
      SAVE SAVDET
C
C
C       Executable Code:-
C       =================
C
      STATUS = YESUCC
C
C
C       Save Analysis_Control Header
C       ===========================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBSAVE(ANPKI4,SAVANP)
      ENDIF
C
C       Save Calibraion Array Header
C       ============================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBSAVE(CALII4,SAVCAL)
      ENDIF
C
C       Save Geomentry Dbs Header
C       ===========================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBSAVE(KW,SAVDET)
      ENDIF
C
C     Return to Caller:-
C     ==================
      IF(STATUS.NE.YESUCC)   CALL ANEROR(STATUS)
      RETURN
C
      ENTRY ANRSYB
C     ============
C          
C
C       Restore Analysis_Control Header
C       ===============================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBRSTO(ANPKI4,SAVANP)
      ENDIF
C
C       Restore Calibration Array Header
C       ================================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBRSTO(CALII4,SAVCAL)
      ENDIF
C
C       Restore Geometry Dbs Header
C       ===============================
C
      IF (STATUS .EQ. YESUCC) THEN
         STATUS = YBRSTO(KW,SAVDET)
      ENDIF
C
C       Return to Caller
C       ================
C
      IF(STATUS.NE.YESUCC)   CALL ANEROR(STATUS)
      RETURN
      END
$$If Acp_Host
      SUBROUTINE ANDWNS
C     =================
C
C     Description:-
C     ==============
C     This routine is used to download all
C     secondary YBOS arrays to the nodes
C     The secondary arrays BUILD_JOB knows about are:
C          
C       Block 2: Analysis_Control Configuration
C       Block 3: Database Work Area
C       Block 4: YHIST Array
C       Block 5: Sim Geom database Array
C          
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.30
C
C     Call Parameters:-
C     =================
C     None
C 
C     Return Parameters:-
C     ===================
C     None
C 
C     Global Declarations:-
C     =====================
$$IMPLICIT
$$Include 'Analysis_Control$Library:Anerror.Inc'
$$Include 'YBOS$Library:ErrCod.Inc'
$$Include 'YBOS$SOURCE:YPARAM.INC'

$$Include 'ACP$AREA:USER_COMMON.INC'
C 
C     External Functions:-
C     =====================
      INTEGER YBRSTO, YBSAVE
C
C     Local Variables
C     ===============
      INTEGER STATUS
      COMMON/ANCOMM/ANPKI4
      INTEGER       ANPKI4
      DIMENSION     ANPKI4(1)
      COMMON/KALI  /CALII4
      INTEGER       CALII4
      DIMENSION     CALII4(1)
      COMMON/DETECT/KW
      INTEGER       KW
      DIMENSION     KW(1)
C
C
C       Executable Code:-
C       =================
C
      STATUS = YESUCC
C
C
C     Download Analysis_Control Array
C     ===============================
C
      STATUS = ACP_GBROADCAST (2,
     &    ANPKI4, ANPKI4(IYGAP), ACP$ALL_CLASSES,
     &     ACP_UNCONVERTED)
C
C     Download Calibration Array
C     ==========================
C
      STATUS = ACP_GBROADCAST (3,
     &    CALII4, CALII4(IYGAP), ACP$ALL_CLASSES,
     &     ACP_UNCONVERTED)
C
C     Download Sim Geometry Array
C     ===============================
C
      STATUS = ACP_GBROADCAST (5,
     &    KW, KW(IYGAP), ACP$ALL_CLASSES,
     &     ACP_UNCONVERTED)
C
C       Return to Caller
C       ================
C
      RETURN
      END
$$Endif
$$Endif
      INTEGER FUNCTION ewunpk(DUMMY)
C     ==============================
C
C       Description:-
C       =============
C       This Function is the Module Declaration
C       Subprogram for Module EWUNPK. It defines
C       the Module Entrypoints and Characteristics.
C
C       Author:-
C       ========
C       BUILD_JOB Program Version  1.30
C
C       Declarations:-
C       ==============
C
$$Implicit
      INTEGER DUMMY
C
$$Include 'Analysis_Control$Library:ANError.Inc'
$$Include 'Analysis_Control$Library:ANParam.Inc'
C
      INTEGER ANDMOD,ANDENT,ANDBOO,ANDBSO
      INTEGER ANDINP,ANDOUT,ANDMPA,ANDFIL,ANDSPN
      INTEGER ANDDBK,ANDRBK,ANDPBK,ANDHLP,ANUMOD
C
      LOGICAL DONE
C
      EXTERNAL unpevt
$$If Acp_node
$$Else
      EXTERNAL unptlk
$$Endif
      SAVE DONE
      DATA DONE/.FALSE./ 
C
C       Executable Code:-
C       =================
C
      ewunpk = ANSUCC
C
      IF (ewunpk .EQ. ANSUCC) THEN
         IF(.NOT.DONE)   THEN
            ewunpk = ANDMOD('EWUNPK','UNPACK INTO COMMON BLOCKS')
            DONE = .TRUE.
         ELSE
            ewunpk = ANUMOD('EWUNPK')
         ENDIF
      ENDIF
      IF (ewunpk .EQ. ANSUCC) THEN
         ewunpk = ANDENT(unpevt,ANMEEV)
      ENDIF
$$If Acp_node
$$Else
      IF (ewunpk .EQ. ANSUCC) THEN
         ewunpk = ANDENT(unptlk,ANMETA)
      ENDIF
$$Endif
C
C       Return to Caller
C       ================
C
      RETURN
      END
