	SUBROUTINE ELE_ET(IELES,PXELEC,PYELEC,PXHAD,PYHAD,JERR)
C------------------------------------------------------------------
C GIVEN CENTRAL ELECTRON IN ELESCM, CALCULATE PX AND PY FROM
C ELEC INFORMATION
C INPUT  : 	IELES  :== INDEX OF ELECTRON IN ELESCM
C OUTPUT :	PXELEC :== PX (HAD+EM)
C		PYELEC :== PY (HAD+EM)
C		PXHAD  :== PX (HAD ONLY)
C		PYHAD  :== PY (HAD ONLY)
C		JERR   :== ERROR FLAG ( = 0) IF OK
C-------------------------------------------------------------------
C
C CLAUDIO, LAST REVISED SEPTEMBER 22, 1989
C--------------------------------------------------------------------

	IMPLICIT NONE
$$INCLUDE 'UC$ANA:ELESCM.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:BTMASK.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'C$INC:DSCALS.INC'
$$INCLUDE 'C$INC:DSTOWE.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:CALORIMETRY.INC'
C
C  	Argument Declarations:-
C  	=======================
	INTEGER IELES,JERR
	REAL	PXELEC,PYELEC
C
C	External Function Declarations:-
C	================================
	INTEGER BLOCAT, GTIETA
C
C  	Local Declarations:-
C  	====================
	INTEGER JELEC,JDELEC,INDEX,NTOW,QDSETA
	INTEGER THIS_ETA,THIS_WEDGE,THIS_TOWE
	INTEGER	STATUS, INDBNK, INTOWE, INSETA, INCALS, MINETA, MAXETA
	INTEGER	IELOOP, IADDR,  INEXT,  ICODE,  IPHI,   IETA,   TOWTYP
	INTEGER	LENBLK, PHITMP, REGETA, REGION, PHI1
	INTEGER I,J,K,TYPE
	REAL PHI_EM,PHI_HAD,PXHAD,PYHAD
	REAL	ETAMIN, ETAMAX, ETEMEX, ETHAEX
	REAL	ETEM, ETHAD, ETAE, ETAH, PHIT, PHIE, DETAE
	REAL	DPHIE, RADE, EEM, EHAD
	REAL	COGE, COGAVE, COGH, EPCOG, HPCOG
	REAL PI12
	PARAMETER (PI12=PI/12.) ! 2pi/24
	REAL PI36
	PARAMETER (PI36=PI/36.) ! 2pi/72
	LOGICAL CLUSTT
C
C	Executable Code:
C  	================
C
C	Zero stuff
C
	PXELEC = 0.0
	PYELEC = 0.0
	PXHAD = 0.0
	PYHAD = 0.0
	INDEX  = 1
C
C	Make sure electron is central
C
	IF (WHERE(IELES) .NE. 0) THEN
	   JERR = 1
	   RETURN
	END IF
C
C	Locate ELEC bank
C
	STATUS = BLOCAT(IW,'ELEC',CALSBN(IELES),JELEC,JDELEC)
	IF (STATUS .NE. YESUCC) THEN
	   JERR = 2
	   RETURN
	END IF
C
C	Locate SETA bank.  If not present, make it.
C
	STATUS = BLOCAT(IW,'SETA',1,INDBNK,INSETA)
	IF (STATUS .NE. YESUCC) THEN
	   CALL ZETCOR(K)
	   STATUS = BLOCAT(IW,'SETA',1,INDBNK,INSETA)
	END IF
C
C	Find number of towers in the cluster
C
	NTOW = IW(JDELEC)
	IF (NTOW .EQ. 0) THEN
	   JERR = 3
	END IF
C
C	Get eta and phi of seed tower
C
	THIS_TOWE = TOWEAD(IELES)
	THIS_ETA  = IAND(ISHFT(THIS_TOWE,-7),MASK7)
	THIS_WEDGE  = IAND(THIS_TOWE,MASK7)
C
C	Loop over towers, get energy
C
	DO I=1,NTOW
	   IETA  = IAND(ISHFT(IW(JDELEC+INDEX),-7),MASK7)
	   TYPE  = TETTYP(IETA)
	   EEM   = RW(JDELEC+INDEX+TETEME(TYPE))
	   EHAD  = RW(JDELEC+INDEX+TETHAE(TYPE))
	   ETEM  = EEM  * RW(INSETA+IETA)
	   ETHAD = EHAD * RW(INSETA+IETA+TENETA)
	   EPCOG = RW(JDELEC+INDEX+TETEMP(TYPE))
	   HPCOG = RW(JDELEC+INDEX+TETHAP(TYPE))
	   PHI_EM  = (FLOAT(THIS_WEDGE) + EPCOG) * PI12
	   PHI_HAD = (FLOAT(THIS_WEDGE) + HPCOG) * PI12
	   PXELEC = PXELEC + ETEM*COS(PHI_EM)  + ETHAD*COS(PHI_HAD)
	   PYELEC = PYELEC + ETEM*SIN(PHI_EM)  + ETHAD*SIN(PHI_HAD)
	   PXHAD  = PXHAD  + ETHAD*COS(PHI_HAD)
	   PYHAD  = PYHAD  + ETHAD*SIN(PHI_HAD)
	   INDEX  = INDEX + TETBLK(TYPE)
	END DO
C
C	Return to caller
C
	JERR = 0
	RETURN
	END
