C DEC/CMS REPLACEMENT HISTORY, Element ELENCR.CDF
C *10   23-FEB-1990 13:05:50 BLOCKER "IBITS is doesn't work on IBM."
C *9    14-FEB-1990 09:58:45 BLOCKER "Get correct EPFIX calls into correct version of ELENCR."
C *8    10-FEB-1990 13:10:11 MMILLER "Include E/p corrections"
C *7    17-JAN-1990 09:39:16 BLOCKER "Fix logic calling ELECOR"
C *6    18-DEC-1989 11:51:29 BLOCKER "Change to FEM nonlinearities calculation."
C *5    19-MAY-1989 09:34:43 BLOCKER "Call PEMDLI for each run."
C *4     7-APR-1989 11:57:00 BLOCKER "Kim's changes to handle dead layers correctly."
C *3     7-MAR-1989 14:10:42 BLOCKER "Add FEM nonlinearity corrections."
C *2    13-FEB-1989 18:50:05 BLOCKER "Add PEM nonlinearity corrections and dead layer corrections."
C *1    31-JAN-1989 10:06:22 BLOCKER "ROUTINE TO DO ENERGY CORRECTIONS."
C DEC/CMS REPLACEMENT HISTORY, Element ELENCR.CDF
      SUBROUTINE ELENCR(JCAL,ITYPE,ECOR,DECOR,IFLAG)
C
C    This routine returns the corrected energy ECOR for EM cluster
C    JCAL.  If the routine cannot locate the ELES bank number JCAL,
C    ECOR is set to 0 and DECOR to 999.
C
C    INPUT:
C            JCAL          ELES bank number.
C            ITYPE         Determines which correction are done.  If
C                             ITYPE is 0, then the current default set
C                             of corrections are done.  If ITYPE is
C                             'FFFFFFFF'X, then all available corrections
C                             will be done.
C			   ITYPE=1: CEMMAP and PEMMAP correction
C			   ITYPE=2: non-linearity correction
C			   ITYPE=4: dead layer correction
C			   ITYPE=0: default correction, all above three
C
C    OUTPUT:
C            ECOR          Corrected energy (GeV).
C            DECOR         Error on corrected energy (GeV).
C            IFLAG         Bit pattern giving which corrections
C                              were done.  For now, the following bits
C                              are defined:
C                                  Bit 0      Response map
C                                  Bit 1      Nonlinearity (saturation,
C                                                                leakage).
C                                  Bit 2      Dead layer corrections in
C                                                gas calorimetry (the default
C                                                is not to do this).
C
C    Craig Blocker                                  January 30, 1989
C
$$IMPLICIT
C
C    Argument declarations.
      INTEGER JCAL,ITYPE,IFLAG
      REAL ECOR,DECOR
C
C    Global declarations.
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'C$INC:BCS.INC'
$$INCLUDE 'C$INC:JOBSTA.INC'	! Job Status/ NRUN, NEV, ...
$$INCLUDE 'C$INC:DSELES.INC'
C
C    Local declarations.
      INTEGER STATUS,JELES,JDELES,REGION,JFLG,IQUAD
      INTEGER DLCVRN
      INTEGER SEEDTW		! Seed tower information in ELES bank
      INTEGER JPHI, JETA, JEW	! Variables for CEM tower gain correction
      INTEGER JDUMMY 	 	! Variables for CEM tower gain correction
      REAL    EP1, EP2, EP3	! variable for CEM tower gain correction
      REAL    KFACTR		! CEM K factor for final energy scale
      INTEGER OLDRUN		! Previous run number
      LOGICAL FSTCAL		! First call
      REAL CORR,A(3),CORRDL,CORRNL,EEMDL,ECORNL,DLCORR
C
C    External declarations.
      INTEGER BLOCAT,DLGAS
      REAL PEMDLC, FEMQQ
C
C    Data statements.
      DATA A/.14,.2,.25/
      DATA DLCVRN/0/
      DATA KFACTR/1.0174/	! CDF 1081
      DATA FSTCAL/.TRUE./
C
C
C    Initialize default return values.
C
      ECOR=0.
      IFLAG=0
      DECOR=999.
C
C    Locate ELES bank.
C
      STATUS=BLOCAT(IW,'ELES',JCAL,JELES,JDELES)
      IF(STATUS.NE.YESUCC) RETURN
      REGION=IW(JDELES+REGELE)
      ECOR=RW(JDELES+E__ELE)
      CORR=1.
C
C    Do corrections.
C
      IF(ITYPE.EQ.0 .OR. IAND(ITYPE,1).NE.0) THEN
C
C        Do response map correction.
C
          IF(REGION.EQ.0 .OR. REGION.EQ.1) THEN
             CALL ELECOR(JCAL,ECOR,CORR,JFLG)
             IF(ECOR.EQ.0.) THEN
                ECOR=RW(JDELES+E__ELE)
                JFLG=0
             ENDIF
             IF(JFLG.GE.0) IFLAG=IOR(IFLAG,1)
          ELSE IF(REGION.EQ.2) THEN
             IQUAD= IAND(IW(JDELES+STWELE),'7F'X)/18
             IF (IAND(ISHFT(IW(JDELES+STWELE),-7),'7F'X) .GE. 42) 
     &          IQUAD = IQUAD + 4	! Check which side ieta is on
             ECOR = ECOR*FEMQQ(IQUAD)
             IFLAG=IOR(IFLAG,1)
          END IF
      ENDIF

      IF(ITYPE.EQ.0 .OR. IAND(ITYPE,4).NE.0) THEN
C
C        Dead layer corrections in gas calorimetry.
C
          IF(REGION.EQ.1 .OR. REGION.EQ.2) THEN

	    IF(DLCVRN.EQ.0) THEN
		IF(FSTCAL) THEN
			OLDRUN = NRUN	! Begin-run number
			CALL PEMDLI	! PEM Dead Layer correction Initialize
			FSTCAL = .FALSE.
		END IF
C
C		If begin-run number .NE. the present run, call PEMDLI for 
C		initialization of dead layer information.
C
		IF(OLDRUN .NE. NRUN) THEN
			OLDRUN = NRUN
			CALL PEMDLI
		END IF

	      	CORRDL = PEMDLC(JCAL)

	    ELSE IF(DLCVRN.EQ.1) THEN

              	STATUS = DLGAS(JCAL,EEMDL,DLCORR)
	      	CORRDL = 1./DLCORR

	    ELSE

	      	CORRDL = 1.

	    ENDIF

            CORR  = CORR/CORRDL
            ECOR  = ECOR*CORRDL
            IFLAG = IOR(IFLAG,4)

          ENDIF
      ENDIF

      IF(ITYPE.EQ.0 .OR. IAND(ITYPE,2).NE.0) THEN
C
C        Nonlinearity corrections.
C
          IF(REGION.EQ.1) THEN
C            PEM
              CALL ECONV(ECOR,RW(JDELES+EDTELE),ECORNL)
              CORRNL=ECOR/ECORNL
              CORR=CORR*CORRNL
              ECOR=ECORNL
              IFLAG=IOR(IFLAG,2)
          ELSE IF(REGION.EQ.2) THEN
C            FEM
              CALL FEMNL(ECOR,CORRNL)
              CORR=CORR/CORRNL
              ECOR=ECOR*CORRNL
              IFLAG=IOR(IFLAG,2)
          ENDIF
      ENDIF
C
C
      IF(ITYPE.EQ.0 .OR. IAND(ITYPE,8).NE.0) THEN
C
C    Do tower-by-tower gain correction and E/P correction for CEM
C
		IF(REGION.EQ.0) THEN
C
C.......................... Decode tower number (0-9) and phi number (0-23).
C.......................... Also check if the tower is bad or crack.
C

			SEEDTW = IW(JDELES+STWELE)

			JPHI   = IAND(SEEDTW,'7F'X)	! decode TOWE Phi
			JDUMMY = IAND(ISHFT(SEEDTW,-7),'7F'X) ! decode TOWE Eta

			IF (JDUMMY .GT. 42) THEN
	      			JETA = JDUMMY - 43		! 0,1,,9
	      			JEW       = 1			! East
			ELSE
				JETA = 42 - JDUMMY		! 0,1,,9
				JEW       = 0			! West
			ENDIF

		   	IF(JETA.LE.8) THEN	! Towers 0 - 8
C
C			Barry's definition : JEW = 0 is West !
C
			        CALL EPFIX( JEW, JPHI, JETA+1, 
     &						EP1, EP2, EP3)	! in C$CAL
			        IF(EP3.GT.0.) THEN
					ECOR  = KFACTR*ECOR/EP3
					CORR  = CORR*EP3/KFACTR
					IFLAG = IOR(IFLAG,8)
				END IF
			END IF
		END IF	! IF(REGION.EQ.0) THEN

      ENDIF		! IF(ITYPE.EQ.0 .OR. IAND(ITYPE,8).NE.0) THEN
C
C    Set energy error to nominal value.
C
      DECOR=A(REGION+1)*SQRT(ECOR)
C
      RETURN
      END
