C====================================================
C
C INCLUDE FILE FOR VARIABLES IN THE ELES BANK
C
C	FILLED BY ELEBTC.CDF 
C
C NB variables are NOT reset at the beginning
C    of each event, so make use of NELE to avoid
C    using values from previous event
C
C====================================================
C
C  CLAUDIO, 6 SEPTEMBER 1988
C
C add cals bank number	11-Oct-1988
C 	31-May-1989	PFD	Add correction factor and flag
C	18-Jun-1989	CC	more 5_1 modifications
C	17-Jun-1992	CC	modifications for 1992 formats
C====================================================
C
C 
C
C
C
	INTEGER MAXELE
	PARAMETER (MAXELE=20)	! Maximum allowed number of electrons
c
	INTEGER NELE		! Number of electrons
	INTEGER CALSBN(MAXELE)  ! CALS and ELES bank number
	INTEGER ELINDX(MAXELE)  ! Pointer in ELES bank
	INTEGER VNUM(MAXELE)	! Version number of bank structure
	INTEGER CODEWR(MAXELE)	! Code Word (?)
	INTEGER CLSLNM(MAXELE)	! CLSL bank number
	INTEGER TOWEAD(MAXELE)	! TOWE address of seed tower
	INTEGER WHERE(MAXELE)	! Region number 0-1-2 :== CEM PEM FEM
	INTEGER FLAG(MAXELE)	! Flag..Bit 0 on ==> accepted by ELEFLT
	INTEGER JETNUM(MAXELE)	! CALS bank # of jet containing this cluster
	INTEGER N3DTR(MAXELE)	! # of 3-dim tracks in cluster
	INTEGER N2DTR(MAXELE)	! Number of two dim. track in cluster
	INTEGER HIMOTK(MAXELE)	! Number of highest momentum track
	INTEGER BEMATK(MAXELE)	! Number of track with best cluster match
	INTEGER TPCINF(MAXELE)	! VTPC hit information
	INTEGER NSTRCL(MAXELE)	! Number of "best" strip cluster
	INTEGER NWIRCL(MAXELE)	! Number of "best" wire cluster
	INTEGER HIPELE(MAXELE)	! Name of highest mom. track (?)
	INTEGER BESCLU(MAXELE)	! Name of track with best cluster match (?)
	REAL ZVELE(MAXELE)	! Z vertex this track
	REAL PXELE(MAXELE)	! X-component of momentum (from calorimetry)
	REAL PYELE(MAXELE)	! Y-component of momentum (from calorimetry)
	REAL PZELE(MAXELE)	! Z-component of momentum (from calorimetry)
	REAL ETELE(MAXELE)	! Et from calorimetry
	REAL ENELE(MAXELE)	! Total energy
	REAL ETCN04(MAXELE)	! Et in cone with R=0.4
	REAL ETCN07(MAXELE)	! Et in cone with R=0.7
	REAL ETAEVN(MAXELE)	! Mean eta, event coordinates
	REAL ETADET(MAXELE)	! Mean eta, detector coordinates
	REAL PHI(MAXELE)		! Mean phi
	REAL ETAWDT(MAXELE)	! Eta width of cluster
	REAL PHIWDT(MAXELE)	! Phi width of cluster
	REAL ERATIO(MAXELE)	! Had/em for energy in cluster
	REAL XELE(MAXELE)		! Extrapolated X of track
	REAL YELE(MAXELE)		! Extrapolated Y of track
	REAL ZELE(MAXELE)		! Extrapolated Z of track
	REAL PELE(MAXELE)		! Momentum of track
	REAL PTELE(MAXELE)	! Transverse momentum of track
	REAL CHARGE(MAXELE)	! Charge of track (=999. if undetermined ?)
c
c the following are CEM and PEM quantities..if electron in FEM set to -999.
c
	REAL PSTRIP(MAXELE)	! Phi-position from strip chambers
	REAL ESTRIP(MAXELE)	! Energy of strip cluster

C
C the following are CEM quantities...if electron not in CEM set to -999.
C
	REAL TRSPRO(MAXELE)	! Transverse profile (LSHR) (???)
	REAL ZSTRIP(MAXELE)	! Z-position from strip chambers
	REAL EWIRE(MAXELE)	! Energy of wire cluster
	REAL CHISTR(MAXELE)	! Chi-square of strip profile
	REAL CHIWIR(MAXELE)	! Chi-square of wire profile
	REAL ETBORD(MAXELE)	! Border transverse energy
C
C the following are PEM quantities...if electron not in PEM set to -999.
C
	REAL CHI3EL(MAXELE)	! 3x3 chi-square of transverse profile
	REAL CHI5EL(MAXELE)	! 5x5 chi-square of transverse profile
	REAL CHITRP(MAXELE)	! Chi-squared of transverse profile from
c				  phi strips
	REAL CHITRT(MAXELE)	! Chi-squared of transverse profile from
c				  theta strips
	REAL ETASTR(MAXELE)	! Eta from strips (if available) (?)
	REAL SRATIO(MAXELE)	! Energy ratio of two strip views
	REAL WTHEST(MAXELE)	! Width of theta strip cluster
	REAL WPHIST(MAXELE)	! Width of phi strip cluster
	REAL CHIDEP(MAXELE)	! Chi-squared of depth profile
c
c the following are PEM and FEM quantities...if electron in CEM set to -999.
c
	REAL ENESEG(3,MAXELE)	! Energy in three depth segments
c				  NB ENESEG(3,I)=0. for FEM
c
c  the following are for 5.1 and following - the energy correction factors 
c   and an associated flag
c
	REAL CORFAC(MAXELE)	! Energy Correction Factor  (multiplicative)
	INTEGER FLAGC(MAXELE)	! Flag as to what the correction was based on
c
c the following are for 1992 data only..they are set to -999 otherwise
c
	REAL CPRQ2(MAXELE)	! 2 channel charge from CPR
	REAL CPRX2(MAXELE)	! 2 channel position from CPR
	REAL CPRQ5(MAXELE)	! 5 channel charge from CPR
	REAL PXTREL(MAXELE)	! Px of track	
	REAL PYTREL(MAXELE)	! Py of track	
	REAL PZTREL(MAXELE)	! Pz of track
	REAL XLOCAL(MAXELE)	! X of track at CES (local coordinates)
	REAL XCESLC(MAXELE)	! X of closest CES wire cluster
	REAL XCESBG(MAXELE)	! X of biggest CES wire cluster
	REAL ZCESBG(MAXELE)	! Z of biggest CES strip cluster
	REAL ETCALO(MAXELE)	! Et from TOWE and SETA
	REAL ETZ0(MAXELE)	! Et from Z=0 abd CES
	REAL ERAT3(MAXELE)	! Had/em for energy in cluster (3 towers)
	REAL EPHOTON(MAXELE)	! Cal energy, corrected, for photon
	REAL TRSPR2(MAXELE)	! LSHARE, 2 towers only
	REAL XCORRE(MAXELE)	! X of track at CES (local, corrected)
	REAL ZCORRE(MAXELE)	! X of track at CES (local, corrected)
c
	COMMON /ELESBK/ NELE,ELINDX,VNUM,CODEWR,
	1 CLSLNM,TOWEAD,WHERE,FLAG,
	1 JETNUM,N3DTR,N2DTR,HIMOTK,ZVELE,
	1 BEMATK,TPCINF,NSTRCL,NWIRCL,
	1 HIPELE,BESCLU,PXELE,PYELE,PZELE,ETELE,ENELE,ETCN04,ETCN07,
	1 ETAEVN,ETADET,PHI,ETAWDT,PHIWDT,ERATIO,XELE,YELE,
	1 ZELE,PELE,PTELE,CHARGE,PSTRIP,ESTRIP,TRSPRO,ZSTRIP,
	1 EWIRE,CHISTR,CHIWIR,ETBORD,CHI3EL,CHI5EL,
	1 CHITRP,CHITRT,ETASTR,SRATIO,WTHEST,WPHIST,CHIDEP,ENESEG,CALSBN,
	1 CORFAC,FLAGC,CPRQ2,CPRX2,CPRQ5,PXTREL,PYTREL,PZTREL,
	1 XLOCAL,XCESBG,ZCESBG,ETCALO,ETZ0,ERAT3,EPHOTON,TRSPR2,XCORRE,
	1 ZCORRE,XCESLC
