C---------------------------------------------------------
	SUBROUTINE GET_CHI(CHIRPHI,CHIZ,I)
C---------------------------------------------------------
C RETURNS CHI-SQUARED OF CENTRAL MUON ACCORDING TO CDF1430
C	INPUT  : I 	 = INDEX OF MUON IN CMUCM
C	OUTPUT : CHIRPHI = CHI-SQUARED IN R-PHI VIEW
C		 CHIZ    = CHI-SQUARED IN Z VIEW
C PREREQUISITES :   CMUCM AND TRAKCM FILLED
C
C					CLAUDIO 1-JUN-1991
C----------------------------------------------------------
	IMPLICIT NONE
	INCLUDE 'C$INC:JOBSTA.INC'
	INCLUDE 'UC$ANA:TRAKCM.INC'
	INCLUDE 'UC$ANA:CMUCM.INC'
	INTEGER I
	REAL CHIRPHI,CHIZ
	REAL DIXY,DSXY,DIZY,DSZY
	REAL SIGMA2_IX
	REAL SIGMA2_SX
	REAL SIGMA2_IZ
	REAL SIGMA2_SZ
	REAL GAMMA
	REAL STHETA
	REAL SIGN
	INTEGER J,JCTCS
C-----------------------------
C INITIALIZE
C-----------------------------
	CHIRPHI = 999.
	CHIZ = 999.
	IF (I.GT.NCMU) THEN
	   PRINT *,' ILLEGAL MUON NUMBER ...RUN,EV=',NRUN,NEV
	   RETURN
	END IF
C-----------------------------
C FIRST FIND THE SIGN
C-----------------------------
	SIGN  = 0.0
	JCTCS = TBANK(I) .AND. 255
	DO J=1,N_TRACK
	   IF (CTCSBNK(J) .EQ. JCTCS) THEN
		SIGN = FLOAT(CHTR(J))
	   END IF
	END DO
	IF (ABS(SIGN) .LT. 0.001) THEN
	   PRINT *,' CANNOT FIND THE TRACK ...RUN,EV=',NRUN,NEV
	END IF
C------------------------
C NOW SET UP CONSTANTS
C------------------------
	DIXY = DELIXY(I) + 2.9*SIGN/PTCMU(I)
	DSXY = DELSXY(I)
	DIZY = DELIZY(I)
	DSZY = DELSZY(I)
	STHETA = 1.0/SQRT(1 + (PZCMU(I)/PTCMU(I))**2)
	SIGMA2_IX = (13.8/PTCMU(I))**2 * (0.59+0.41/STHETA)/
	1		(1.0-0.71/PTCMU(I)) + (0.3)**2
	SIGMA2_SX = (0.131/PTCMU(I))**2 * (0.27 + 0.73/STHETA)/
	1		(1.0-1.43/PTCMU(I)) + (0.0062)**2
	SIGMA2_IZ = (13.8/PTCMU(I))**2 * (1.0/STHETA)**2 * 
	1		(0.59+0.41/STHETA)/(1.0-0.71/PTCMU(I)) + (1.5)**2
	SIGMA2_SZ = (0.131/PTCMU(I))**2 * STHETA**2 * 
	1		(0.27 + 0.73/STHETA)/(1.0-1.43/PTCMU(I)) + (0.14)**2
	GAMMA = (1.54/PTCMU(I)**2) * (0.46+0.54/STHETA)/
	1		(1.0-1.0/PTCMU(I))
C---------------------------------
C NOW CALCULATE THE CHI SQUAREDS
C---------------------------------
	CHIRPHI = SIGMA2_SX*DIXY**2 - 2.*GAMMA*DIXY*DSXY + SIGMA2_IX*DSXY**2
	CHIRPHI = CHIRPHI / (SIGMA2_IX*SIGMA2_SX - GAMMA**2)
	CHIZ    = SIGMA2_SZ*DIZY**2 - 2.*GAMMA*DIZY*DSZY + SIGMA2_IZ*DSZY**2
	CHIZ    = CHIZ / (SIGMA2_IZ*SIGMA2_SZ - GAMMA**2)
C--------------------------------
C DONE
C--------------------------------
	RETURN
	END
