C========================================================================
	SUBROUTINE GET_TOWE_INDEX(C,D,PHI,COTE,Z0,TOWE,IERR)
C========================================================================
C
C===Description:
C
C	Kludge of CTTOCA
C	Find eta,phi tower indices for a track.
C
C       bank address
C
C===Input Arguments:
C
C	C    == curvature
C	D    == impact parameter
C	PHI  == az. angle
C	COTE == cotangent
C	Z0   == Z of closest approach
C
C===Output Arguments:
C
C	TOWE	TOWE index
C       IERR Integer error flag
C                0 - succesful progpagetion 
C                2 - error code from trkpar not 0
C                3 - error code = 9 from trprop
C
C===Function Return Value:
C
C		None
C
C===Author:
C
C	A. Para, Fermilab
C	30-June-1985
C
C===Kludger:
C
C	CLAUDIO  12-MAY-1989
C
C===Implicit None Declaration:
$$If VAX
	IMPLICIT NONE
$$Else
C	Implicit None is not implemented on this machine/compiler
$$Endif
C
C===Global Declarations:
C
$$INCLUDE 'C$INC:DSCMPB.INC'
$$INCLUDE 'C$INC:DSFITP.INC'
$$INCLUDE 'C$INC:DSCTCS.INC'
$$INCLUDE 'C$INC:TRFITC.INC'
$$INCLUDE 'C$INC:BCS   .INC'
C
C===Local Declarations:
C
	INTEGER INDXDT,IETA,IPHI,IERR,TOWE
	INTEGER FITCOD,K,IERR1,NT,MODE
	LOGICAL DEBUG
C
	REAL RCAL,ZCALP,ZCALF
	REAL D,PHI,C,Z0,COTE,RHO,X0,Y0,ARG,TANTH
        REAL PARIN(5),XYZ(6),DXYZ(6)
C
C===External Functions Referenced:
C
C		None
C
C===Data Statements:
C
	DATA RCAL / 172.7 /, ZCALP /172.7/, ZCALF / 640. /
	DATA DEBUG / .FALSE. /
C
C===Start of Code:
C
C
C
	IETA=0
	IPHI=0
	TOWE = -1
C
	PARIN(1)=C
     	PARIN(2)=D      
     	PARIN(3)=PHI   
     	PARIN(4)=COTE     
     	PARIN(5)=Z0      
	XYZ(1)=0.
	XYZ(2)=0.
	XYZ(3)=0.

C   ---   first propagate towards R=RCAL
C
	MODE=1
	ARG=RCAL
	CALL TRPROP(MODE,PARIN,ARG,XYZ,DXYZ,IERR1)
		IF(IERR1.NE.0) THEN
		IERR=3
		GO TO 999
		ENDIF
C
C
	IF(ABS(XYZ(3)).GT.ZCALP) THEN
C
		MODE=2
		ARG=ZCALP
		IF(COTE.LT.0) ARG=-ZCALP
		CALL TRPROP(MODE,PARIN,ARG,XYZ,DXYZ,IERR1)
			IF(IERR1.EQ.9) THEN
			IERR=3
			GO TO 999
			ENDIF
	END IF
C
C
	IF(ABS(XYZ(1))+ABS(XYZ(2)).GT.0)
     $ 			CALL XYZTOW(XYZ,IETA,IPHI,IERR1)
		IF(IERR1.NE.0) THEN
		IERR=4
		GO TO 999
		ENDIF
C
	IERR=0
	TOWE = 128*IETA+IPHI
C
  999   RETURN
	END


