	SUBROUTINE GETIMP(RUN,IMP,Q,Z,PHI,IMPCORR)
C==================================================
C SUBROUTINE TO CORRECT IMPACT PARAMETER
C INPUTS:
C	  RUN 		=	RUN NUMBER
C	  IMP		=	UNCORRECTED IMPACT PARAMETER
C	  Q 		=	CHARGE (+1 OR -1)
C	  Z		=	Z OF TRACK AT BEAMLINE
C	  PHI 		=	PHI AT THE BEAMLINE
C OUTPUT:
C	  IMPCORR	=	CORRECTED IMPACT PARAMETER
C======================================================
	IMPLICIT NONE
	INCLUDE 'UC$ANA:STBK.INC'
	INTEGER RUN,Q
	REAL IMP,Z,IMPCORR,PHI
	INTEGER INDEX
	REAL XBEAM,YBEAM,OFFSET
C=======================================================
C FIGURE OUT WHAT STORE IT IS AND FILL STBK.INC 
C=======================================================
	IMPCORR = 100.
	CALL STORE(RUN,INDEX)
	IF (INDEX .LT. 0) THEN
	   PRINT *,' NO STORE INFORMATION..RUN = ',RUN
	   GOTO 999
	END IF
C=================================================
C NOW CORRECT THE IMPACT PARAMETER
C================================================
	IF (Q.GT.0) THEN
	   XBEAM = PLUS_PAR(1,INDEX) + PLUS_PAR(3,INDEX)*Z
	   YBEAM = PLUS_PAR(2,INDEX) + PLUS_PAR(4,INDEX)*Z
	   OFFSET = PLUS_PAR(5,INDEX)
	ELSE
	   XBEAM = MINUS_PAR(1,INDEX) + MINUS_PAR(3,INDEX)*Z
	   YBEAM = MINUS_PAR(2,INDEX) + MINUS_PAR(4,INDEX)*Z
	   OFFSET = MINUS_PAR(5,INDEX)
	END IF
	IMPCORR = IMP - YBEAM*COS(PHI) + XBEAM*SIN(PHI) - OFFSET
C===========================================
C DONE
C===========================================
999	CONTINUE
	RETURN
	END
