	SUBROUTINE MET_CORR(MISSET_CORR,METPHI_CORR)
C
C This subroutine recalculates the missing Et after the 
C energies of central electrons have been corrected
C
C	Output :	MISSET_CORR = corrected missing Et
C			METPHI_CORR = corrected phi of MET
C
	implicit none
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'UC$ANA:METSCM.INC'
$$INCLUDE 'UC$ANA:ELESCM.INC'

	REAL MISSET_CORR,METPHI_CORR
	INTEGER I,JERR
	REAL PXELEC,PYELEC		! Px,Py of electron from ELEC bank
	REAL PXHAD,PYHAD		! Hadronic Px,Py from ELEC
	REAL METX,METY			! X-Y components of MET

C-----------------------------------------------------------
C Calculate METX,METY
C-----------------------------------------------------------
	METX = MISSET*COS(METPHI)
	METY = MISSET*SIN(METPHI)
C-----------------------------------------------------------
C Loop over central electrons
C-----------------------------------------------------------
	DO 100 I=1,NELE
	   IF (WHERE(I) .NE. 0) GOTO 100
	   IF (CORFAC(I) .LE. 0.) GOTO 100
C-----------------------------------------------------------
C Find energies from ELEC bank
C-----------------------------------------------------------
	   CALL ELE_ET(I,PXELEC,PYELEC,PXHAD,PYHAD,JERR)
	   IF (JERR.NE.0) GOTO 100
C-----------------------------------------------------------
C Correct the missing et
C-----------------------------------------------------------
	   METX = METX + (1.-CORFAC(I))*(PXELEC-PXHAD)
	   METY = METY + (1.-CORFAC(I))*(PYELEC-PYHAD)
C-----------------------------------------------------------
C Next electron
C-----------------------------------------------------------
100	CONTINUE
C-----------------------------------------------------------
C Now calulate new missing et
C-----------------------------------------------------------
	MISSET_CORR = SQRT(METX**2+METY**2)
	IF (MISSET.EQ.0.0) THEN
	   METPHI_CORR = 0.0
	ELSE
	   METPHI_CORR = ATAN2(METY,METX)
	   IF (METPHI_CORR .LT. 0.) THEN
	      METPHI_CORR = METPHI_CORR + TWOPI	   	
	   END IF
	END IF
C---------------------------------------------------------------
C Done
C---------------------------------------------------------------
	RETURN
	END
