	Subroutine My_Getxyz(ZINIT,Beam,Xyzpos,Xyzcov,vqual,Ierr)
c
C IF ZINIT < -1000 AND BEAM=.TRUE. RETURN THE FIRST VTVZ VERTEX
C IF ZINIT > -1000 AND BEAM=.TRUE. RETURN THE CLOSEST VTVZ VERTEX
C
$$IMPLICIT
c
$$INCLUDE 'C$INC:DSCMPB.INC'
$$INCLUDE 'C$INC:DSVTXS.INC'		! BANK OFFSET DEFS
$$INCLUDE 'C$INC:BCS.INC'		! YBOS ARRAYS
$$INCLUDE 'C$INC:SVXBPO.INC'		! SVX BEAM POS
$$INCLUDE 'C$INC:CTCALB.INC'		! SVX BEAM POS
$$INCLUDE 'C$INC:JOBSTA.INC'		! jobs stats
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'	! YBOS ERROR CODES
$$INCLUDE 'ERROR_LOGGER$LIBRARY:ERLEVL.INC'
$$INCLUDE 'C$INC:OBS203.INC'
$$INCLUDE 'C$INC:SIMH.INC'
c
c Input/output parameters
	Logical Beam
	Real	Xyzpos(3),Xyzcov(6),vqual(2)
	Integer Ierr
	REAL ZINIT
c
c  Locals
	integer		bank_number
	integer		status
	integer		bank_index, bank_data_index	! YBOS pointers
	integer		version_index		! Pointer to version block
	integer		data_block_index	! Pointer to data block
	integer		i
	integer nmessage
        Integer MY_Kcl(20)
        Integer Npv,Kcl
        Real MY_Xvrt(20),MY_Yvrt(20),MY_Zvrt(20)
        Real Xvrt,Yvrt,Zvrt
	Real	Xmc,Ymc,Gauprb
	Real	Chi,DZ
	INTEGER K1,K2
	Integer Ndof
	Integer Oldrun
	Data Oldrun /-1/
	Integer Oldierr
	Data Oldierr /-1/
	Logical Obsthere
	data nmessage /0/
	Data Obsthere /.true./

c  Routines
	integer		blocat
C
C Save info
	Save
C
C Initialization
	Ierr = -1
C
	IF (BEAM.AND.ZINIT.GT.-1000) THEN
           Call vtgzzt(20,npv,MY_kcl,MY_zvrt,MY_xvrt,MY_yvrt)
	   DZ = 99999.
	   DO I=1,NPV
	      IF (ABS(MY_ZVRT(I)-ZINIT) .LT. DZ) THEN
		 DZ = ABS(MY_ZVRT(I)-ZINIT)
		 XVRT = MY_XVRT(I)
		 YVRT = MY_YVRT(I)
		 ZVRT = MY_ZVRT(I)
	      END IF
	    END DO
	ELSE
           Call vtgzzt(1,npv,kcl,zvrt,xvrt,yvrt)
	END IF
C
C Do we want to use the beam position of VXPRIM?
	If (Beam) then
C
C	   Call Update_vtvz
C           Call vtgzzt(1,npv,kcl,zvrt,xvrt,yvrt)
C
C Use BEAM info
	   If (Nrun .ne. 1) then
C
C Update the VTVZ bank with BPO info
	      Ierr = 0
C
C Init common elements
	      Xyzpos(1) = Xvrt
	      Xyzpos(2) = Yvrt
	      Xyzpos(3) = Zvrt
	      Xyzcov(1) = 0.0035**2
	      Xyzcov(2) = 0.0
	      Xyzcov(3) = 0.0
	      Xyzcov(4) = 0.0035**2
	      Xyzcov(5) = 0.0
	      Xyzcov(6) = 0.3**2
	   Endif
C
C If this is MC data, and someone asked for the beam:
C Use SIMH.  If SIMH is not there fail it.....
	   If (Nrun .eq. 1) then
	      STATUS = BLOCAT(IW,'SIMH',-1,K1,K2)
	      if (status .ne. yesucc) then
		 ierr = 10
		 return
	      end if
              CALL UZERO(PINSIM,1,NPINSM)
	      Call Smhbtc(ierr)
	      If (ierr .ne. 0) return
	      Xmc = pinsim(shxave) + pinsim(shxslp)*Zvrt
	      Ymc = pinsim(shyave) + pinsim(shyslp)*Zvrt
	      Xyzpos(1) = Xmc
	      Xyzpos(2) = Ymc
	      Xyzpos(3) = Zvrt
	      Xyzcov(1) = pinsim(shxsig)**2
	      Xyzcov(2) = 0.0
	      Xyzcov(3) = 0.0
	      Xyzcov(4) = pinsim(shysig)**2
	      Xyzcov(5) = 0.0
	      Xyzcov(6) = 0.3**2
	   end if
C
C Otherwise, use VXPRIM
	Else
c
c  First job, try and find the bank
	   bank_number = 1
	   status = blocat (iw, 'VTXS', bank_number, bank_index,
     &		bank_data_index)
	   if (status .ne. YESUCC) then
	      Ierr = 10
	      Return
	   endif
c
c  Setup pointers to the various blocks
	   version_index = bank_data_index + iw(bank_data_index+dshdcb)
	   data_block_index = version_index+ iw(bank_data_index+nwvhcb)
c
c  Right -- now we have a ybos bank.  Make sure we know about this version
c  or else we might trounce on some info stuff here!
	   if (iw(bank_data_index+dsvncb) .ne. VnuVXS) then
	     call erlogr ('my_getxyz', ERWARN, 0, 0,
     &		'Unknown version of VTXS!')
	     Ierr = 11
	     status = 1
	   endif
c
c Set error code
	   ierr = 0
c
c  Get the x,y, and z position
	   Xyzpos(1) = rw(data_block_index+X0VX)
	   Xyzpos(2) = rw(data_block_index+Y0VX)
	   Xyzpos(3) = rw(data_block_index+Z0VX)
c
c  And the errors

	   Xyzcov(1) = rw(data_block_index+Dx02VX)
	   Xyzcov(2) = rw(data_block_index+DX02VX+1)
	   Xyzcov(3) = rw(data_block_index+DX02VX+2)
	   Xyzcov(4) = rw(data_block_index+Dy02VX)
	   Xyzcov(5) = rw(data_block_index+Dy02VX+1)
	   Xyzcov(6) = rw(data_block_index+Dz02VX)

c  And chi square
	   vqual(1)=rw(data_block_index+fitqvx)
	   vqual(2)=rw(data_block_index+ndofvx) 

C
	end if
	return
	end
