c
c STNTUPLE Version 4_1, 07/25/96 (Alexis Amadon):
c
c   - added the raw muon pt (murawpt(nmu)) in the list of ntuple variables
c   - fixed METJET to take into account the JTC96S corrections
c
C=======================================================================
      SUBROUTINE FILL_stntuple
C=======================================================================
c
C Description:
C
C Implicit none declaration:
      IMPLICIT NONE
C
C Production variables...
C
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'    ! YBOS error codes
$$INCLUDE 'YBOS$LIBRARY:BNKTYP.INC'    ! bank type codes
$$INCLUDE 'UIPACK$LIBRARY:UINAMES.INC' ! UIPACK declarations
$$INCLUDE 'UIPACK$LIBRARY:UIERROR.INC'
$$INCLUDE 'UIPACK$LIBRARY:UIPARAM.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'           ! error severity levels for error logger
$$INCLUDE 'C$INC:JOBSTA.INC'           ! job status parameter
$$INCLUDE 'C$INC:BCS.INC'              ! primary YBOS array
$$INCLUDE 'C$INC:PIVALU.INC'           ! easy as...
C common blocks filled by TOPFND
$$INCLUDE 'C$INC:ELEINFO.INC'          ! ELES banks
$$INCLUDE 'C$INC:MUOINFO.INC'          ! CMUO information
$$INCLUDE 'C$INC:MIOINFO.INC'          ! CMIO information
$$INCLUDE 'NTUPLE$SOURCE:JETINFO.INC'  ! JETS information
$$INCLUDE 'C$INC:EVTINFO.INC'       ! cuts on leptons for dilep,lep+jets
$$INCLUDE 'C$INC:DILINFO.INC'       ! dilepton search topology cuts
$$INCLUDE 'C$INC:DILMORE.INC'       ! more dilepton info
$$include 'c$inc:cmuo92.inc'
C common block filled by SECVTX
$$INCLUDE 'C$INC:SECVTX.INC'
C common block filled by JPBTAG
$$INCLUDE 'C$INC:JPBTAG.INC'
C common block filled by BTGSMK
$$INCLUDE 'C$INC:BTGSCM.INC'
C common block filled by TAUFND
$$INCLUDE 'NTUPLE$SOURCE:TAUFND.INC'
C common block filled by METBTC
$$INCLUDE 'NTUPLE$SOURCE:METSCM.INC'
C ELES bank pointers
$$INCLUDE 'C$INC:DSELES.INC'
C my own variables
$$INCLUDE 'ntuple$source:STNTUPLE.INC'
$$INCLUDE 'ntuple$source:NTUPLE_v4_1.INC'
$$INCLUDE 'ntuple$source:stntuple_talk.inc'
$$INCLUDE 'ntuple$source:exo_phoinfo.inc'
c QTRK common filled by qtrkun
$$include 'c$inc:trksco.inc'
C VTVZ BANK OVERHEAD
$$INCLUDE 'C$INC:VTCAUX.INC'
$$INCLUDE 'C$INC:VXPVIN.INC'
$$include 'C$inc:tfzinfo.inc'
$$include 'ntuple$source:trigger_stuff.inc'

        INTEGER ANPTRG                    ! A_C Filter Decision
        INTEGER I,J,K,IJ,JJ,KK,L,TEMP     ! Used as counters
C
C Setup for making NTUPLES.... 
C
        INTEGER ANGHAC                    !A_C histo stuff
        INTEGER ANGHBO                    !A_C histo stuff
        INTEGER ANGTH4                    !A_C histo stuff
C
        INTEGER NID, phoind(10),eleind(maxeles),muoind(15),tauind(10)  
        INTEGER BUFSIZ, br_code
        CHARACTER*32 TOPDIR
        CHARACTER*32 FILE_NAME        
        CHARACTER*1 OPNOPT


C LOCAL VARIABLES
        INTEGER BLOCAT,INDBNK,INDELE,istat
        integer bnknum,sindx,sdindx
        REAL VTXOCC1,VTXOCC2,VTOCCP,VTXOCC,genp_vtxocc(maxeles)
        real jt4eta(5),jt4phi(5),dimass,delta_r
        INTEGER VTXWORD,trkflag,ind,inddat
        integer aa_index,qtrkun,jetword,JETS_TRKS,JETMATCH
        integer minjet
        real*8 
     &   pspm(4),! array of jet var. required as input to AA correc. routine
               ! (1) phi, (2) tan(dip), (3) QDJSCO-corrected momentum, (4) mass
     &  pcor,   ! AA corrected jet momentum
     &  sigpcor,! associated error
     &  dummy
        integer phostub,stream
        REAL ETADIFF,PHIDIFF,CONE_SIZE,THETA
        integer dcorindex,mcorindex,nt_version,bnk_version
        logical blinfo
        real xseed(5,3),cvseed(5,6),qint(5),dz0cut
        REAL HELIM,DPHIMIN,DPHI_JETS,CORFAC_PHO,CORFAC(10)

        integer indbtgs
        INTEGER CEM_ELE,CEM_LOOSE,CMU_MUON,TAG,TAG_WRD,TOP,TOP_WRD
        INTEGER HPTE_HPTE,HPTE_LCEM,HPTE_PEM,HPTE_CMU,HPTE_CMX,HPTE_CMIO
        INTEGER HPTM_HPTE,HPTM_LCEM,HPTM_PEM,HPTM_CMU,HPTM_CMX,HPTM_CMIO
        DATA CEM_ELE /'3FF'X/
        DATA CEM_LOOSE /'F33'X/
        DATA CMU_MUON /'DFE'X/
        DATA HPTE_HPTE/1/
        DATA HPTE_LCEM/2/
        DATA HPTE_PEM/3/
        DATA HPTE_CMU/4/
        DATA HPTE_CMX/5/
        DATA HPTE_CMIO/6/
        DATA HPTM_HPTE/7/
        DATA HPTM_LCEM/8/
        DATA HPTM_PEM/9/
        DATA HPTM_CMU/10/
        DATA HPTM_CMX/11/
        DATA HPTM_CMIO/12/
           
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C   First we check to see if the histograming is open if so, then initialize
C       all the variables. Note the names of these variables are given by
C       STNTUPLE_BOOK.
C
        IF (ANGHAC().AND.ANGHBO()) THEN
C
C   First clear out all old values...
C
        dcorindex = 2*jtc_version+1
        mcorindex = 2*jtc_version+2
        IJ = 1
        CALL VZERO(STAT_ELES,MAXELES)
        CALL VZERO(STAT_CMUO,MAXCMUO)
        CALL VZERO(STAT_CMIO,MAXCMIO)
        CALL VZERO(STAT_TAUO,50)
        CALL VZERO(STAT_PHO,10)

        do k = 1,10
          corfac(k) = 1.0
        enddo
        cone_size = 0.4


C Now execute a series of subroutines which fill the variables in the
C common blocks for various physics objects.        

C calling TOPFND will fill the following common blocks:
C                 EVTINFO.INC
C                 ELEINFO.INC
C                 JETINFO.INC
C                 MUOINFO.INC
C                 MIOINFO.INC
C                 DILINFO.INC

         CALL TOPFND(.TRUE.,.TRUE.,.TRUE.)
         CALL JETINFO(2)
         CALL TAUFND
         CALL METBTC
         CALL MY_ELEINFO
         CALL MY_MUOINFO
         CALL MY_MIOINFO
c         CALL PHOVAL
c         CALL PHOFND
         call exo_pho
         call ntuple_trigger_stuff

c   Implement VTX occupancy for MC

        if (nrun.lt.1000) call egamma_genp_match(genp_vtxocc)

C Start with filling the ntuple...

               version= 4100000 +jet_filter*100 +big_cone*10+jtc_version
               run = NRUN     ! Run number
               event = NEV    ! Event number

C loop over photon candidates and determine their status:
C              1 something there
C              2 passes loose ID cuts
C              3 passes loose ID and loose isolation cuts
C              4 passes loose ID cuts and tight isolation cuts
C              5 passes tight ID cuts and tight isolation cuts

          numphoid = 0
          numphoiso = 0
          numphoidL = 0
          numphoisoL = 0
          npho = MIN(NCENCL+NPLUGCL,10)
          DO J = 1,npho
             IF (PHOET(J).GT.0.0) THEN
              STAT_PHO(J) = PHOET(J) +1000.0
              IF (PHOIDL(J)) THEN
                numphoidL = numphoidL + 1
                STAT_PHO(J) = PHOET(J) + 2000.0
                IF (PHOISOL(J)) THEN
                  numphoisoL = numphoisoL + 1
                  STAT_PHO(J) = PHOET(J) + 3000.0
                IF (PHOISO(J)) THEN
                  numphoiso = numphoiso + 1
                  STAT_PHO(J) = PHOET(J) + 4000.0
                IF (PHOID(J)) THEN
                  numphoiD = numphoID + 1
                  STAT_PHO(J) = PHOET(J) + 5000.0
                ENDIF
                ENDIF
                ENDIF
              ENDIF
             ENDIF
          ENDDO

c   Sort photons according to stat_pho descending order

        call sortzv(stat_pho,phoind,npho,1,1,0)

        CALL COSMIC_STUBS(phoind(1),NCMUS,costub,phostub)

C       get info for photons

        NPHOIDL = numphoidl
        nphoisol = NUMPHOISOL
        nphoid = NUMPHOID
        nphoiso = NUMPHOISO
   
        DO J = 1,npho
          JJ = PHOIND(J)
          pdetect(j) = PHODETECT(JJ)
          pzv(j) = PHOZV(JJ)
          pet(j) = PHOET(JJ)
          petc(j) = PHOET(JJ)/phocor(jj)
          call ucopy(pho_p4(1,jj),pp4(1,j),4)
          pco4(j) = PHOCO4(JJ)
          pcesx(j) = PHOCESX(JJ)
          pcesz(j) = PHOCESZ(JJ)
          pcpr5ph(j) = PHOCPR5PH(JJ)
          pcpr5ps(j) = PHOCPR5PS(JJ)
          pdteta(j) = PHODETA(JJ)
          peveta(j) = PHOETA(JJ)
          pcese(j) = PHOCESE(JJ)
          pphi(j) = PHOPHI(JJ)
          pco7(j) = PHOCO7(JJ)
          phadem(j) = PHOHADEM(JJ)
          plshr(j) = PHOLSHR(JJ)
          pstr2(j) = PHOSTR2(JJ)
          pstre2(j) = PHOSTRE2(JJ)
          pwir2(j) = PHOWIR2(JJ)
          pwire2(j) = PHOWIRE2(JJ)
          psumpt4(j) = PHOSUMPT4(JJ)
          pvtxocc(j) = PHOVTX(JJ)
          ppt(j) = phopt(jj)
          pn3d(j) = phon3d(jj)
          pchistr(j) = phochistr(jj)
          pchiwir(j) = phochiwir(jj)
          pchi(j) = phochi(jj)
          pchi3x3(j) = PHO3X3(JJ)
          pchieta(j) = PHOCHIE(JJ)
          pchiphi(j) = PHOCHIP(JJ)
          pstat(j) = STAT_PHO(JJ)
          pboxiso(j) = phoboxiso(jj)
          pcesflg(j) = iand(phowrd(jj),2**16).eq.0
          pe(j) = phoe(jj)
          pceswht(j) = phoceswht(jj)
          pcprwht(j) = phoceswht(jj)
          pcesslide(j) = phocesslide(jj)
          pwrd(j) = phowrd(jj)
          psth(j) = phosth(jj)
          pcessig(j) = phocessig(jj)
        ENDDO

C  EVTINFO variables...see C$TOP:TOPFND.CDF for definitions and cuts
          
	dilwrd = DIL_WRD

C  flag for this event being on the good run list

c       BR_CODE         a four bit word that indicates if the run is good
c                       or bad.  The bits in OK are defined as follows:
c
c                       Note:   OK is set to -1 if the run is not found.
c                               If this happens, please send mail to 
c                               FNALD::SACHA.  
c
c                       Bit 0:  Indicates the run is suitable for analyses
c                               that do not require the muon systems (the
c                               following detectors are in working order:
c                               CTC,all calorimeters,Trigger,BBC,DAQ,CES)
c                       Bit 1:  CMU is in working order
c                       Bit 2:  CMP is in working order
c                       Bit 3:  CMX is in working order

       STREAM = 2
       CALL BADRUN(NRUN,STREAM,BR_CODE)
       BRCODE = br_code
       goodrun = good_run

C  flag for following proper lepton trigger path

        goodtrig = GOOD_TRIG
        trigword = TRWRD    !bit packed trigger information
                            ! (see C$TOP:GET_TRIG_INFO.CDF)
        njet10 = NJET_10    !# of jets > 10 GeV
        njet15 = NJET_15    !# of jets > 15 GeV
        njet20 = NJET_20    !# of jets > 20 GeV
        njet25 = NJET_25    !# of jets > 25 GeV
        nhpte  = NUM_HPTE    !# of high pt electrons
        nlcent = NUM_LOOSE_E !# of loose central electrons
        nlplug = NUM_PEM     !# of plug electrons
        nhptm  = NUM_HPTM    !# of high pt muons
        ncmio  = NUM_CMIO    !# of CMIO's
        ngtau  = NUMGOLDTAU  !# of gold tau's
        nlepton = NUM_LOOSE_E + NUM_PEM +
     &                   NUM_HPTM + NUM_CMIO + NUMGOLDTAU

C DILINFO variables...see C$TOP:DIL_TOPOLOGY.CDF for definitions and cuts

C       MET used for dilepton cuts (with jet corrections, and corrected
C       for hi-pt cmuo's,cmio's,and loose cmuo's with pt > 10 GeV)

        metdilep = MET_DIL  
        njtdilep = NJETMET_DIL    ! number of jets passing dilepton cuts
          
C       difference in phi between MET vector used for dilepton cuts and  

        DPHIMINJ = 360.0
        DO J = 1,NJETMET_DIL
           IF (DPHIJ_DIL(J).LT.DPHIMINJ) DPHIMINJ = DPHIJ_DIL(J)
        ENDDO
        dphiminl = MIN(DPHIL1_DIL,DPHIL2_DIL)
        dilmode = DIL_MODE    ! 1=ee,2=emu,3=mumu,4=etau,5=mutau

C 4-vectors,charge, and et of the leptons which pass dilepton cuts,along with a
C classification code.  For now I'm going to accomodate up to 3 leptons
C and up to 3 dilepton combinations.

C                           DILEPTON CLASSIFICATION CODE                     
C                    ----------------------------------------
c                                    HPTE_HPTE =1
c                                    HPTE_LCEM=2
c                                    HPTE_PEM=3
c                                    HPTE_CMU=4
c                                    HPTE_CMX=5
c                                    HPTE_CMIO=6
c                                    HPTM_HPTE=7
c                                    HPTM_LCEM=8
c                                    HPTM_PEM=9
c                                    HPTM_CMU=10
c                                    HPTM_CMX=11
c                                    HPTM_CMIO=12

        diltype1 = DIL_TYPE(1,1)  !code of 1st dilepton combo

C loop over ELES banks and compute their status

        nel = MIN(MAXELES,NUMELES)
        DO J = 1,nel          

C determine the status of the ELES bank STATUS= rank*1000+Et
C       ELES ranking
C       1  something there
C       2  central, with Et .gt. 10
C       3  plug,central,forward, passes loose R paper cuts
C       5  plug or central, passes loose dilepton cuts
C       6  central, passes tight R paper cuts
C       7  central, passes tight dilepton cuts except fiducial cut
C       8  central, passes tight dilepton cuts
C       9  central, passes tight dilepton cuts, isolated

C  if there's a bank, you get 1000 points....

             CALL GET_CORFAC(BNK_ELE(J),CORFAC(J))
             STAT_ELES(J) = 1000.0 + ET_ELE(J)/CORFAC(J)

C  central with Et .gt. 10 gets 2000....

       IF (DET_ELE(J).EQ.0.AND.ET_ELE(J)/CORFAC(J).GT.10.0)
     &         STAT_ELES(J) = 2000.0 + ET_ELE(J)/CORFAC(J)

C  satisfying loose R paper cuts gets 3000...           

             IF (DET_ELE(J) .EQ. 0) THEN
               IF (ET_ELE(J)/CORFAC(J).GT.20.0) THEN
                 IF (CON_ELE(J).EQ.0) THEN
                   IF (EP_ELE(J).LE.2.0) THEN
                     IF (HADEM_ELE(J).LE.0.1) THEN
C                      IF (ISOL_ELE(J) .LE. 0.1) THEN
                       IF (FID_ELE(J).EQ.0) THEN
                       STAT_ELES(J)=3000.0+ET_ELE(J)/CORFAC(J)
                       ENDIF
C                       ENDIF
                     ENDIF
                   ENDIF
                 ENDIF
               ENDIF
             ENDIF

C            Plug electrons...
             IF (DET_ELE(J) .EQ. 1) THEN
               IF (ET_ELE(J)/CORFAC(J) .GE. 15.0) THEN
C                 IF (ISOL_ELE(J) .LE. 0.1) THEN
                   IF (CHI3_ELE(J) .LE. 3.0) THEN
                     IF (HADEM_ELE(J) .LE. 0.1) THEN
                       IF (FID_ELE(J).EQ.0) THEN
                       IF (CON_ELE(J).EQ.0) THEN
                       STAT_ELES(J)=3000.0+ET_ELE(J)/CORFAC(J)
                       ENDIF
                       ENDIF
                     ENDIF
                   ENDIF
C                 ENDIF
               ENDIF
             ENDIF

C            Forward electrons...
             IF (DET_ELE(J) .EQ. 2) THEN
               IF (ET_ELE(J)/CORFAC(J) .GT. 10.0) THEN
                 IF (HADEM_ELE(J) .LT. 0.1) THEN
C                   IF (ISOL_ELE(J) .LT. 0.1) THEN
                   STAT_ELES(J) =3000.0+ET_ELE(J)/CORFAC(J)
C                   ENDIF
                 ENDIF
               ENDIF
             ENDIF

C  loose central and plug events get 5000....
             DO K = 1,MIN(MAXELES,NUM_PEM)
                IF (IND_PEM(K).EQ.J)
     &        STAT_ELES(J)=5000.0+ET_ELE(J)/CORFAC(J)
             ENDDO !NUM_PEM
             DO K = 1,MIN(MAXELES,NUM_LOOSE_E)
                IF (IND_LOOSE_E(K).EQ.J)
     &            STAT_ELES(J) =5000.0+ET_ELE(J)/CORFAC(J)
             ENDDO  !NUM_LOOSE_E
C   satisfying tight R paper cuts gets 6000....
          IF (DET_ELE(J) .EQ. 0) THEN
             HELIM=0.045+0.055*P4E_ELE(4,J)/CORFAC(J)/100.0
             IF (ET_ELE(J)/CORFAC(J) .GT. 20.0) THEN
               IF (EP_ELE(J) .LT. 2.0 .AND. EP_ELE(J) .GT. 0.5) THEN
                 IF (LSHR_ELE(J) .LE. 0.2) THEN
                   IF (CHIS_ELE(J) .LE. 10.0) THEN
                     IF (ABS(DELX_ELE(J)) .LE. 1.5) THEN
                       IF (ABS(DELZ_ELE(J)) .LE. 3.0) THEN
                         IF (ABS(EZV_ELE(J)) .LE. 60.0) THEN
                           IF (HADEM_ELE(J) .LE. HELIM) THEN
C                             IF (ISOL_ELE(J) .LE. 0.1) THEN
                               IF (FID_ELE(J).EQ.0) THEN
                                IF (CON_ELE(J).EQ.0) THEN
                       STAT_ELES(J)=6000.0+ET_ELE(J)/CORFAC(J)
                                ENDIF
                               ENDIF
C                             ENDIF
                           ENDIF
                         ENDIF
                       ENDIF
                     ENDIF
                   ENDIF
                 ENDIF
               ENDIF
             ENDIF
           ENDIF
                  
C   tight central nonfiducial get 7000....
           IF (DET_ELE(J).EQ.0) THEN
              IF (IAND(CEM_WRD(J),CEM_ELE).EQ.512)
     &           STAT_ELES(J)=7000.0+ET_ELE(J)/CORFAC(J)
           ENDIF  !DET_ELE
C    tight central fiducial get 8000....
           DO K = 1, MIN(MAXELES,NUM_HPTE)
              IF (IND_HPTE(K).EQ.J) THEN
                 STAT_ELES(J) = 8000.0 + ET_ELE(J)/CORFAC(J)
C     tight central fiducial isolated get 9000....
                 IF (IAND(CEM_ISO(IND_HPTE(K)),2).EQ.0)
     &           STAT_ELES(J) = 9000.0 + ET_ELE(J)/CORFAC(J)
              ENDIF !IND_HPTE
           ENDDO !NUM_HPTE
       ENDDO !Nel

C loop over CMUO banks and compute their status
C      1   something there
C      2   pt .gt. 10
C      3
C      4
C      5   passes tight dilepton cuts except fiducial cut
C      6   passes tight dilepton cuts
C      7   passes tight dilepton cuts plus isolation cut

        DO J = 1, MIN(15,NUMCMUO) 
C      if it's there the bank gets 1000 pts...
          STAT_CMUO(J) = 1000.0 + PT_CMUO(J)
          IF (PT_CMUO(J).GT.999.0) STAT_CMUO(J)=1999.0
C      pt .gt. 10 gets 2000....
          IF (PT_CMUO(J).GT.10.0)
     &      STAT_CMUO(J) = 2000.0 + PT_CMUO(J)
          IF (PT_CMUO(J).GT.999.0) STAT_CMUO(J)=2999.0
C      passes tight dilepton cuts except for fiducial cut gets 5000....
          IF (IAND(MUO_WRD(J),CMU_MUON).EQ.0)
     &      STAT_CMUO(J) = 5000.0 + PT_CMUO(J)
          IF (IAND(MUO_WRD(J),CMU_MUON).EQ.0.AND.PT_CMUO(J).GT.999.0)
     &      STAT_CMUO(J) = 5999.0
C      passes tight dilepton cuts gets 6000....
          DO K = 1, MIN(15,NUM_HPTM)
            IF (IND_HPTM(K).EQ.J) THEN
              STAT_CMUO(J) = 6000.0 + PT_CMUO(J)
              IF (PT_CMUO(J).GT.999.0) STAT_CMUO(J) = 6999.0
C      passes tight dilepton cuts + isolation cut gets 7000....
              IF (IAND(MUO_ISO(IND_HPTM(K)),2).EQ.0)
     &          STAT_CMUO(J) = 7000.0 + PT_CMUO(J)
              IF (IAND(MUO_ISO(IND_HPTM(K)),2).EQ.0
     &  .AND.PT_CMUO(J).GT.999.0) STAT_CMUO(J) = 7999.0
            ENDIF !IND_HPTM
          ENDDO !NUM_HPTM

        ENDDO !NUMCMUO

C loop over CMIO banks and compute their status
C      1 something there
C      2 pt .gt. 10
C      3 passes dilepton cuts
C      4

        DO J = 1, MIN(15,NUMCMIO)
C      if it's there the bank gets 1000 pts....
          STAT_CMIO(J) = 1000.0 + PT_CMIO(J)
          IF (PT_CMIO(J).GT.999.0) STAT_CMIO(J)=999.0
C      pt .gt. 10 gets 2000....
          IF (PT_CMIO(J).GT.10.0) 
     &      STAT_CMIO(J) = 2000.0 + PT_CMIO(J)
            IF (PT_CMIO(J).GT.999.0) STAT_CMIO(J)=2999.0
C      passes dilepton cuts gets 3000....
          DO K = 1, MIN(15,NUM_CMIO)
            IF (IND_CMIO(K).EQ.J)
     &        STAT_CMIO(J) = 3000.0 + PT_CMIO(J)
            IF (PT_CMIO(J).GT.999.0) STAT_CMIO(J)=3999.0
          ENDDO !IND_CMIO

        ENDDO !NUMCMIO

C loop over TAUO banks and compute their status....
C      1 something there
C      2 loose tau
C      3 golden tau  
C      4 loose tau and golden tau
       
        ntau = MIN(10,NUMTAU)
        DO J = 1,ntau
C      if it's there the bank gets 1000 pts....
          STAT_TAUO(J) = 1000.0 + TAU_ET(J)
C      loose tau gets 2000 pts....
          IF (loosetau(j).eq.1.0)
     &        STAT_TAUO(J) = 2000.0 + TAU_ET(J)
C      golden taus get 3000....
          IF (GOLDTAU(J).EQ.1.0) 
     &      STAT_TAUO(J) = 3000.0 + TAU_ET(J)
C       'double tagged' taus get 4000
          if (loosetau(j).eq.1.0.and.GOLDTAU(J).EQ.1.0)
     &      STAT_TAUO(J) = 4000.0 + TAU_ET(J)
        ENDDO !NUMTAU

C  get the three best electrons and fill the 4-vector, charge,
C  et, detector eta, phi, status

c   Sort electrons according to stat_eles descending order

        call sortzv(stat_eles,eleind,nel,1,1,0)

        DO J = 1,nel
           JJ = ELEIND(J)
           call vscale(P4E_ELE(1,JJ),1./corfac(jj),ep4(1,j),4)
           eetcor(j) = ET_ELE(JJ)/CORFAC(JJ)
           eet(j) = ET_ELE(JJ)
           eq(j) = CHG_ELE(JJ)
           edteta(j) = DTETA_ELE(JJ)
           eeveta(j) = EVETA_ELE(JJ)
           ephi(j) = PHI_ELE(JJ)
           ept(j) = PTELE_ELE(JJ)
           estat(j) = STAT_ELES(JJ)
           ezv(j) = EZV_ELE(JJ)
           eep(j) = EP_ELE(JJ)
           ehadem(j) = HADEM_ELE(JJ)
           exces(j) = Xces_ELE(JJ)
           edelx(j) = DELX_ELE(JJ)
           ezces(j) = Zces_ELE(JJ)
           edelz(j) = DELZ_ELE(JJ)
           echis(j) = CHIS_ELE(JJ)
           echiw(j) = CHIW_ELE(JJ)
           eiso(j)  = ISOL_ELE(JJ)
           etiso(j) = SUMPT_ELE(JJ)
           eptrk(j) = PELE_ELE(JJ)
           elshr2(j) = lshr2_ele(jj)
           echi3(j) = CHI3_ELE(JJ)
           echid(j) = CHID_ELE(JJ)

           if (nrun.lt.1000) then
              evtxocc(j) = genp_vtxocc(jj)
           else
              VTXOCC = 0.0
              ISTAT = BLOCAT(IW,'ELES',BNK_ELE(JJ),INDBNK,INDELE)
              IF (ISTAT.NE.YESUCC) THEN
                 CALL ERLOGR ('JEFF',ERWARN,0,ISTAT,'CANNOT FIND ELES')
              ELSE
                 VTXWORD = IW(INDELE+VTPELE)  !Encoded word with VTX info
                 bnk_VERSION = IW(INDELE+VRDELE)  !Version # of bank structure
                 VTXOCC = VTOCCP(VTXWORD,bnk_VERSION)
              ENDIF
	      evtxocc(j) = vtxocc
	   endif
           IF (DET_ELE(JJ).EQ.0) eidwrd(j) = CEM_WRD(JJ)
           IF (DET_ELE(JJ).EQ.1) eidwrd(j) = PEM_WRD(JJ)
           IF (DET_ELE(JJ).EQ.0) eiswrd(j) = CEM_ISO(JJ)
           IF (DET_ELE(JJ).EQ.1) eiswrd(j) = PEM_ISO(JJ)
           econwrd(j) = CON_ELE(JJ)
           eztrk(j) = z0_ele(jj)   !  z of electron track at origin
           efid(j)  = fid_ele(jj)  !  bit-packed word telling how fiducial
C                                     the electron is; 0 = fiducial, other-
C                                     wise, the following bits are set:
C                             bit 0     CEM failed phi crack cut
C                                 1     CEM failed 90 crack cut
C                                 2     CEM failed tower 9 cut
C                                 3     CEM failed Zprime tower 9 cut
C                                 4     CEM Failed tower 7 chimney
C                                 5     PEM outer eta annuli
C                                 6     PEM inner eta annuli
C                                 7     PEM phi cut
C                                 8     PEM dead channel
C                                 9     FEM inner eta annuli
C                                10     FEM phi cut
           edet(j)  = det_ele(jj)  !  0 = central, 1 = plug, 2 = forward
           ebte(j)  = bte_ele(jj)  !  border tower energy
           enasl(j) = nasl(jj)     ! nb of axial superlayers hit by electron
           enssl(j) = nssl(jj)     ! nb of stereo superlayers
         ENDDO     

c    "Match" photons to electrons and fill photon VTX occupancy for MC

         do j=1,Npho
            jj = 1
            do while (phobnk(phoind(j)).ne.bnk_ele(jj))
               jj = jj + 1
            end do
            pelind(j) = eleind(jj)
            if (nrun.lt.1000) pvtxocc(j) = genp_vtxocc(jj) 
         end do 

C get the muons and fill the 4-vector,charge,et,detector eta, phi, status

        nmu = min(15,NUMCMUO+NUMCMIO)
        numcmuo = min(numcmuo,15)
        numcmio = min(numcmio,nmu-numcmuo)       

c  Sort muons, but take CMIOs into consideration: append CMIO list to
c  CMUO array first, then sort according to STAT_CMUO descending order:

        call ucopy(stat_cmio,stat_cmuo(numcmuo+1),numcmio)
        call sortzv(stat_cmuo,muoind,nmu,1,1,0)

        DO J = 1,nmu
           JJ = MUOIND(J) ! CMU bnk number

C   fill data for CMUOs
 
           IF (JJ.le.numcmuo) THEN
	      if (blocat(iw,'CMUO',jj,ind,inddat).eq.yesucc) then
	         murawpt(j) = rw(inddat+mopt)
              else
                 murawpt(j) = -999.
	      endif
              call ucopy(P4M_CMUO(1,JJ),mup4(1,j),4)
              mupt(j) = PT_CMUO(JJ)
              muq(j) = CHRG_CMUO(JJ)
              muhad(j) = HAD_CMUO(JJ)
              muem(j) = EM_CMUO(JJ)
                
C   do it yourself eta

              mueveta(j) = 999.0
              IF (P4M_CMUO(4,JJ).GT.0.0) THEN
                 IF (P4M_CMUO(3,JJ)/P4M_CMUO(4,JJ).LE.1.0) THEN
                    mueveta(j) = -1.0*LOG(TAN(0.5*ACOS(
     &                           P4M_CMUO(3,JJ)/P4M_CMUO(4,JJ))))
                 ELSE
                    WRITE (6,*)
     &              'This 4-vector sucks! Cannot calculate eta'
                 ENDIF
              ENDIF

C   do it yourself phi

              muPHI(j) = 360.0
              IF (P4M_CMUO(2,JJ).NE.0.0.OR.
     &            P4M_CMUO(1,JJ).NE.0.0) THEN
                 muPHI(j) = PI + ATAN2(-P4M_CMUO(2,JJ),-P4M_CMUO
     &                      (1,JJ))
              ELSE
                 WRITE (6,*)
     &           'This 4-vector sucks! Cannot calculate phi'
              ENDIF
              mustat(j) = STAT_CMUO(JJ)
              muzv(j) = MUZV_CMUO(JJ)
              mud0(j) = D0_CMUO(JJ)
              mudelz(j) = MUZV_CMUO(JJ) - Z0_CMUO(JJ)
              mudelx(j) = 0.0
              IF (DET_CMUO(JJ).EQ.1.OR.
     &            DET_CMUO(JJ).EQ.3) mudelx(j) = DX_CMU(JJ)
              IF (DET_CMUO(JJ).EQ.2) mudelx(j) = DX_CMP(JJ)
              IF (DET_CMUO(JJ).EQ.4) mudelx(j) = DX_CMX(JJ)
              muiso(j) = ISOL_CMUO(JJ)                
              mutiso(j) = SUMPT_CMUO(JJ)
              mucray(j) = COS_CMUO(JJ)
              muidwrd(j) = MUO_WRD(JJ)
              muiswrd(j) = MUO_ISO(JJ)
              muztrk(j) = z0_cmuo(jj)   ! z of muon track at origin
              mufid(j)  = fid_cmuo(jj)  ! word telling how fiducial mu is
C            = -1: Error in propagation
C            =  0: Muon in good CMU region
C            =  1: Muon falls in 90 degree crack
C            =  2: Muon fall into phi crack in central region
C            =  3: Muon in Chimney
C            =  4: Muon not in central region but still in good CTC region
C            =  5: Muon falls into phi crack in good, non-central CTC region
C            =  6: Muon detector eta too high for good CTC region
              mudet(j)  = det_cmuo(jj)  ! 1=CMU,2=CMP,3=CMU/CMP,4=CMX,5=CMIO
              mubte(j)  = bte_cmuo(jj)  ! border tower energy
              munasl(j) = nasl_cmuo(jj) ! nb of axial superlayers hit by mu
              munssl(j) = nssl_cmuo(jj) ! nb of stereo superlayers 

C    fill data for CMIOs
 
           ELSE  !MIOINDEX
              jj = jj - numcmuo
	      if (blocat(iw,'CMIO',jj,ind,inddat).eq.yesucc) then
                 murawpt(j) = rw(inddat+mopt)
              else
                 murawpt(j) = -999.
              endif
              call ucopy(P4M_CMIO(1,JJ),mup4(1,j),4)
              mupt(j) = PT_CMIO(JJ)
              muq(j) = CHRG_CMIO(JJ)
              muhad(j) = HAD_CMIO(JJ)
              muem(j) = EM_CMIO(JJ)
                                 
C    do it yourself EVENT eta
     
              muevETA(j) = 99.0
              IF (P4M_CMIO(4,JJ).GT.0.0) THEN
                 IF (P4M_CMIO(3,JJ)/P4M_CMIO(4,JJ).LE.1.0) THEN
                     muevETA(j) = -1.0*LOG(TAN(0.5*
     &               ACOS(P4M_CMIO(3,JJ)/P4M_CMIO(4,JJ))))
                 ELSE
                WRITE (6,*) 'This 4-vector sucks! Cannot calculate eta'
                 ENDIF
              ENDIF

C    do it yourself phi

              muPHI(j) = 360.0
              IF (P4M_CMIO(2,JJ).NE.0.0.OR.
     &            P4M_CMIO(1,JJ).NE.0.0) THEN
                 muPHI(j) = PI + ATAN2(-P4M_CMIO(2,JJ),-P4M_CMIO
     &                      (1,JJ))
              ELSE
                WRITE (6,*) 'This 4-vector sucks! Cannot calculate phi'
              ENDIF
              mustat(j) = STAT_CMIO(JJ)
              muzv(j) = MUZV_CMIO(JJ)
              mud0(j) = D0_CMIO(JJ)
              mudelz(j) = MUZV_CMIO(JJ) - Z0_CMIO(JJ)
              mudelx(j) = 0.0
              muiso(j) = ISOL_CMIO(JJ)                
              mutiso(j) = SUMPT_CMIO(JJ)
              mucray(j) = COS_CMIO(JJ)
              muidwrd(j) = MIO_WRD(JJ)
              muiswrd(j) = MIO_ISO(JJ)          
              muztrk(j) = z0_cmio(jj)   ! z of electron track at origin
              mufid(j)  = fid_cmio(jj)  ! word telling how fiducial mu is
C            = -1: Error in propagation
C            =  0: Muon in good CMU region
C            =  1: Muon falls in 90 degree crack
C            =  2: Muon fall into phi crack in central region
C            =  3: Muon in Chimney
C            =  4: Muon not in central region but still in good CTC region
C            =  5: Muon falls into phi crack in good, non-central CTC region
C            =  6: Muon detector eta too high for good CTC region
              mudet(j)  = 5  ! 1=CMU,2=CMP,3=CMU/CMP, 4=CMX, 5=CMIO
              mubte(j)  = bte_cmio(jj)  ! border tower energy
              munasl(j) = nasl_cmio(jj) ! nb of axial superlayers hit by mu
              munssl(j) = nssl_cmio(jj) ! nb of stereo superlayers 
           ENDIF  !MIOINDEX
        ENDDO   !J

C  get the taus and fill the 4-vector,charge,et,detector eta,phi, status

        call sortzv(stat_tauo,tauind,ntau,1,1,0)

        DO J = 1,ntau
           JJ = TAUIND(J)
           tp4(1,j) = TAU_EX(JJ)
           tp4(2,j) = TAU_EY(JJ)
           tp4(3,j) = TAU_EZ(JJ)
           tp4(4,j) = TAU_E(JJ)
           tet(j) = TAU_ET(JJ)
           tq(j) = TAU_CHRG(JJ)
           tzv(j) = TAU_ZVERT(JJ)
           tdteta(j) = TAU_DETA(JJ)
           teveta(j) = TAU_ETA(JJ)                       
           tphi(j) = TAU_PHI(JJ)
           tpt(j) = TAU_PT(JJ)
           tptvis(j) = TAU_PTVIS(JJ)
           tstat(j) = STAT_TAUO(JJ)
           tdelr(j) = TAU_DELR(JJ)
           temf(j) = 0.0
           IF (TAU_ET(JJ).GT.0.0) temf(j) = TAU_ETEM(JJ)/TAU_ET(JJ)
           tmass(j) = TAU_MASS(JJ)
        ENDDO
                                            
C   initialize jet counters

        JETNUM = 0
        DO J = 1, 20
           JETINDEX(J) = 20
        ENDDO  

C   index the good jet bank numbers

        NUMSKIP = 0
        JSKIP(1) = 20
        JSKIP(2) = 20
        DO J = 1, ICLUS
           GOODJET = .TRUE.
           IF (IJET_ET(J).LT.0.01) GOODJET = .FALSE. !Et cut

c   bit-packed input word jet_filter set in stntuple talk-to
c
c     bit 0 set => remove jets with |eta| > 2 from jet list
c         1        remove jets associated with isolated tight electrons
c         2         "      "        "      "   loose CEM
c         3         "      "        "      "   loose PEM
c         4         "      "        "      "   isolated tight photons
c         5         "      "        "      "   isolated loose photons
c         6         "      "        "     loosely isolated loose photons
c
c   by default, jet_filter is set to 18 (16+2), which causes to remove 
c   isolated tight electrons and photons only
  
c     Option 1/ reject jets with |eta| > 2 

           IF (iand(jet_filter,1).ne.0.and.ABS(IJET_DETA(J)).GT.2.0) 
     +         GOODJET = .FALSE.  !eta cut

           IF (GOODJET) THEN     !tight isolated electron cut
              DO K = 1, NUM_HPTE
                 etadiff = abs(ijet_deta(j)-dteta_ele(IND_HPTE(K)))
                 phidiff = abs(ijet_phi(j)-phi_ele(IND_HPTE(K)))
                 if (phidiff.gt.pi) phidiff = 2*pi - phidiff
                 if (sqrt(phidiff**2+etadiff**2).lt.cone_size .and.
     +              IAND(CEM_ISO(IND_HPTE(K)),1).EQ.0) then
                    
c Optional stuff:

c     Option 2/ remove tight isolated electrons from the jet list

                    if (iand(jet_filter,2).ne.0) goodjet = .false.
                    NUMSKIP = NUMSKIP + 1
                    IF (NUMSKIP.LE.2) JSKIP(NUMSKIP) =
     &                 JTS_ELE(IND_HPTE(K))
                 ENDIF
              ENDDO
           ENDIF

           IF (GOODJET.AND.TWO_LEPTON) THEN

c     Option 3/ veto loose CEM

              IF (DIL_TYPE(1,1).EQ.HPTE_LCEM.OR. 
     &            DIL_TYPE(1,1).EQ.HPTM_LCEM) THEN
                 K = IND_LOOSE_E(DIL_TYPE(3,1))
                 NUMSKIP = NUMSKIP + 1
                 IF (NUMSKIP.LE.2) JSKIP(NUMSKIP) = JTS_ELE(K)
                 etadiff = abs(ijet_deta(j)-dteta_ele(K))
                 phidiff = abs(ijet_phi(j)-phi_ele(K))
                 if (phidiff.gt.pi) phidiff = 2*pi - phidiff
                 if (sqrt(phidiff**2+etadiff**2).lt.cone_size.and.
     +               iand(jet_filter,4).ne.0) 
     +               goodjet = .false.
              ENDIF

C     Option 4/ veto loose PEM

              IF (DIL_TYPE(1,1).EQ.HPTE_PEM.OR.
     &            DIL_TYPE(1,1).EQ.HPTM_PEM) THEN
                 K = IND_PEM(DIL_TYPE(3,1))
                 NUMSKIP = NUMSKIP + 1
                 IF (NUMSKIP.LE.2) JSKIP(NUMSKIP) = JTS_ELE(K)
                 etadiff = abs(ijet_deta(j)-dteta_ele(K))
                 phidiff = abs(ijet_phi(j)-phi_ele(K))
                 if (phidiff.gt.pi) phidiff = 2*pi - phidiff
                 if (sqrt(phidiff**2+etadiff**2).lt.cone_size.and.
     +               iand(jet_filter,8).ne.0) 
     +               goodjet = .false.
              ENDIF
           ENDIF

c     Option 5/ remove isolated tight photons

           if (goodjet.and.jet_filter.ge.16) then
              k = 1
              do while(k.le.npho.and.pstat(k).gt.5000.)
                 if (delta_r(ijet_deta(j),ijet_phi(j),pdteta(k),pphi(k))
     +               .lt.cone_size.and.iand(jet_filter,16).ne.0) 
     +               goodjet = .false.
                 k = k + 1
              end do

c     Option 6/ remove isolated loose photons

              if (k.le.npho.and.jet_filter.ge.32) then
                 do while (k.le.npho.and.pstat(k).gt.4000.)
                    if (delta_r(ijet_deta(j),ijet_phi(j),
     +                  pdteta(k),pphi(k)).lt.cone_size.and.
     +                  iand(jet_filter,32).ne.0) goodjet = .false.
                    k = k + 1
                 end do

c     Option 7/ remove loosely isolated loose photons

                 if (k.le.npho.and.jet_filter.ge.64) then
                    do while (k.le.npho.and.pstat(k).gt.3000.)
                       if (delta_r(ijet_deta(j),ijet_phi(j),      
     +                     pdteta(k),pphi(k)).lt.cone_size.and.
     +                     iand(jet_filter,64).ne.0) goodjet = .false.
                       k = k + 1
                    end do 
                 endif
              endif
           endif 
                                            

C  End of jet selection cuts. Count it if it's good.

           IF (GOODJET) THEN
              JETNUM = JETNUM + 1
              JETINDEX(JETNUM) = J
           ENDIF
        ENDDO       !ICLUS

        njt = MIN(MAXJETS,JETNUM)
        CALL SORTZV(ijet_ET,JETINDEX,njt,1,1,1)

C          fill jet variables for the jets

        DO k = 1,njt
           jt4eta(k) = ijet_eta(jetindex(k))
           jt4phi(k) = ijet_phi(jetindex(k))
           JJ = JETINDEX(k)
           INDBTGS=0
           DO kk=1,BTNNJET
              IF(BTJETB(kk).EQ.IJETBNK(JJ)) INDBTGS=kk
           ENDDO
           IF (INDBTGS.EQ.0) THEN
              CALL ERLOGR('STNTUPLE',EREROR,0,0,
     1       'BTGS/JETINFO mismatch - tagging lost')
              INDBTGS=JJ ! just so that the following code doesn't crash
           ENDIF
           jtet(k) = IJET_ET(JJ)   ! jet Et
           jtm(k) = IJET_M(JJ)     ! jet mass
           call ucopy(IJET_P(1,JJ),jtp4(1,k),4) ! jet uncorrected 4-vector
           jteveta(k) = IJET_ETA(JJ)  ! jet event eta
           jtdteta(k) = IJET_DETA(JJ) ! jet detector eta
           jtphi(k) = IJET_PHI(JJ)  ! jet phi
           jtemf(k) = IJET_EMF(JJ)  ! jet electromagnetic fraction

C  do jet cluster/physics object correspondence (bit encoded)
C         0 =  no correspondence
C bit     0    MET
C         1    tau 3
C         2    tau 2
C         3    tau 1
C         4    muon 3
C         5    muon 2
C         6    muon 1
C         7    photon 2
C         8    photon 1
C         9    electron 3
C         10   electron 2
C         11   electron 1
         
           JTWORD(k) = 0
           if (ijet_et(jj).gt.0.01) then

C          electrons

             do j=1,min(3,nel)
                etadiff = abs(ijet_deta(jj)-dteta_ele(eleind(j)))
                phidiff = abs(ijet_phi(jj)-phi_ele(eleind(j)))
                if (phidiff.gt.pi) phidiff = 2*pi - phidiff
c               if (jts_ele(eleind(j)).eq.ijetbnk(jj))
                if (sqrt(phidiff**2+etadiff**2).lt.cone_size)
     &             jtword(k) = ibset(jtword(k),12-j)
             end do

C          photons

               do i = 1,min(2,npho)
                  etadiff = abs(ijet_deta(jj)-phodeta(phoind(i)))
                  phidiff = abs(ijet_phi(jj)-phophi(phoind(i)))
                  if (phidiff.gt.pi) phidiff = 2*pi - phidiff
                  if (sqrt(phidiff**2+etadiff**2).lt.cone_size)
     &                  jtword(k) = ibset(jtword(k),9-i)
               end do

C           muons

            do j=1,min(3,nmu)
               if (muoind(j).gt.numcmuo) then
                  trkflag = jets_trks(trks_cmio(muoind(j)-numcmuo),
     &                     ijetbnk(jj),cone_size,prim)
                  if (trkflag.eq.0) jtword(k) = ibset(jtword(k),7-j)
               else 
                  trkflag = jets_trks(trks_cmuo(muoind(j)),
     &                     ijetbnk(jj),cone_size,prim)
                  if (trkflag.eq.0) jtword(k) = ibset(jtword(k),7-j)
               endif
            end do

C     taus            

            do j = 1,min(3,ntau)
               if (tau_jetsbn(tauind(j)).eq.ijetbnk(jj))
     &            jtword(k) = ibset(jtword(k),4-j)
            end do

C      MET4 (within cone_size of phi)

             phidiff = abs(metphi(4) - ijet_phi(jj))
             if (phidiff.gt.pi) phidiff = 2*pi - phidiff
             if (phidiff.lt.cone_size) jtword(k) = ibset(jtword(k),0)
          endif
          jtcorfm(k) = JCORF(JJ,mcorindex)   ! jet energy correction factor
                                             ! for mass analysis
          jtcorfd(k) = JCORF(JJ,dcorindex)   ! jet energy correction factor

C        AA corrections....

c     Figure out what class index (aa_index) the jet belongs to :
c               1 : generic b-jet (default assumption)
c               2 : b-jet with SLT electron
c               3 : b-jet with SLT muon
c               4 : generic q-jet from W
               
C     tagger word for each jet
               
         TAG_WRD = 0
         aa_index = 1

C     1/ Find out now about SLT tag for each jet

         do j=1,5
            if (btnele(j).gt.0) then
               if (qtrkun(btnele(j),0).eq.0) then
                  etadiff = abs(trksp4(6) - IJET_ETA(JJ))
                  phidiff = abs(trksfp(5) - IJET_PHI(JJ))
                  if (phidiff.gt.pi) phidiff = 2*pi - phidiff

c    Jet tagged with electron!

                  if (sqrt(etadiff**2+phidiff**2).le.cone_size) THEN
                     tag_WRD = IBSET(TAG_WRD,1)
                     aa_index = 2
                  endif
               endif
            endif
            if (btnmuo(j).gt.0) then
               if (qtrkun(btnmuo(j),0).eq.0) then
                  etadiff = abs(trksp4(6) - IJET_ETA(JJ))
                  phidiff = abs(trksfp(5) - IJET_PHI(JJ))
                  if (phidiff.gt.pi) phidiff = 2*pi - phidiff
                                                                               
c    Jet tagged with muon!

                  if (sqrt(etadiff**2+phidiff**2).le.cone_size) THEN
                     tag_WRD = IBSET(TAG_WRD,2)
                     aa_index = 3
                  endif
               endif
            endif
         end do

C    Get AA correction factor

         pspm(1) = IJET_PHI(JJ)
         pspm(2) = (1. - exp(-2.*IJET_ETA(JJ))) / 2.
     +                   / exp(-IJET_ETA(JJ))
         pspm(3) = jcorf(jj,mcorindex) * sqrt(ijet_p(1,jj)**2 +
     +                   ijet_p(2,jj)**2 + ijet_p(3,jj)**2)
         pspm(4) = dummy
         call tmcorr_aa(aa_index,pspm,pcor,sigpcor,dummy)
         jtcorfa(k) = 1.0
         if (abs(pcor).lt.2000.0) jtcorfa(k) = pcor / pspm(3)
         jtntr(k) = IJET_NTR(JJ)  ! # of CTC tracks in jet
         jtntrp(k) = ngdpos(jj)   ! # of positive-impact-parameter SVX-tracks
         jtep(k) = IJET_EP(JJ)   !(jet energy)/(highest track p)
          
C tagger word for each jet

         IF (JVCALL) THEN
            TAG = JVTAG(indbtgs)   ! JETVTX tag flag
         ELSE 
            TAG = 0
         ENDIF
         IF (TAG.GT.0) TAG_WRD = IBSET(TAG_WRD,4)

         TAG = 0
         IF (JPCALL) THEN
            TAG = JPTAG(indbtgs)   ! JPBTAG tag flag
         ELSE
            TAG = 0
         ENDIF
         IF (TAG.GT.0) TAG_WRD = IBSET(TAG_WRD,3)
                
         TAG = 0
         IF (SCCALL) THEN
            TAG = SCTAG(indbtgs)   ! SECVTX TAG FLAG
         ELSE
            TAG = 0
         ENDIF
         IF (TAG.GT.0) TAG_WRD = IBSET(TAG_WRD,5)

C   test for SECVTX taggability

         IF (IJET_ET(JJ).GE.15.0 .and.
     &      ABS(IJET_DETA(JJ)).LE.2.0 .and.
     &      NJTRK0(JJ).GE.2) TAG_WRD = IBSET(TAG_WRD,0)
        
         jttag(k) = TAG_WRD
          
C background probabilities for each tagger
        
         IF (JVCALL) THEN
            jvbpb(k) = JVM1BG(indbtgs)   ! JETVTX bkg prob
         ELSE
            jvbpb(k) = -1
         ENDIF

         IF (JPCALL) THEN
            jpbpb(k) = JPM1BG(indbtgs)   ! JPBTAG bkg prob
         ELSE
            jpbpb(k) = -1
         ENDIF

         IF (SCCALL) THEN
            call scbg(indbtgs,scm1bg(indbtgs))
            scbpb(k) = SCM1BG(indbtgs)   ! SECVTX bkg prob
         ELSE
            scbpb(k) = -1
         ENDIF

C  pos/neg JPBTAG probabilities

         IF (JPCALL) THEN
            jpppb(k) = JPPRBP(indbtgs)   ! JPBTAG + prob
         ELSE
            jpppb(k) = -1
         ENDIF

         IF (JPCALL) THEN
            jpnpb(k) = JPPRBM(indbtgs)   ! JPBTAG - prob
         ELSE
            jpnpb(k) = -1
         ENDIF
      ENDDO  ! k jet index

C cone of 0.7 jets

      if (big_cone.eq.1) cone_size=0.7
      if (big_cone.eq.2) cone_size=0.4
      if (big_cone.eq.3) cone_size=1.0
      CALL JETINFO(big_cone)

C     initialize jet counters

      JETNUM = 0
      DO J = 1, 20
         JETINDEX(J) = 20
      ENDDO  

C     index the good jet bank numbers

      DO J = 1, ICLUS
         GOODJET = .TRUE.
         IF (IJET_ET(J).LT.1.0) GOODJET = .FALSE. !Et cut

C  End of jet selection cuts. Count it if it's good.

         IF (GOODJET) THEN
            JETNUM = JETNUM + 1
            JETINDEX(JETNUM) = J
         ENDIF
      ENDDO       !ICLUS

      nj1 = min(MAXJETS,JETNUM)
      CALL SORTZV(ijet_ET,JETINDEX,nj1,1,1,1)
      DO K = 1,nj1
         JJ = JETINDEX(K)
         j1et(k) = IJET_ET(JJ)   ! jet Et
         j1m(k)  = IJET_M(JJ)    ! jet mass
         call ucopy(IJET_P(1,JJ),j1p4(1,k),4)  ! jet 4-vector
         j1eveta(k) = IJET_ETA(JJ)  ! jet event eta
         j1dteta(k) = IJET_DETA(JJ) ! jet detector eta
         j1phi(k)   = IJET_PHI(JJ)  ! jet phi

C  do jet cluster/physics object correspondence (bit encoded)
C     0 =  no correspondence
C bit     0    MET
C         1    tau 3
C         2    tau 2
C         3    tau 1
C         4    muon 3
C         5    muon 2
C         6    muon 1
C         7    photon 2
C         8    photon 1
C         9    electron 3
C         10   electron 2
C         11   electron 1
       
         j1word(k) = 0
         if (ijet_et(jj).gt.0.01) then
         
C          electrons

            do j=1,min(3,nel)
               if (et_ele(eleind(j)).gt.0.0) then
                  etadiff = abs(ijet_deta(jj)-dteta_ele(eleind(j)))
                  phidiff = abs(ijet_phi(jj)-phi_ele(eleind(j)))
                  if (phidiff.gt.pi) phidiff = 2*pi - phidiff    
                  if (sqrt(etadiff**2+phidiff**2).lt.cone_size)
     &               j1word(k) = ibset(j1word(k),12-j)
               endif
            end do
              
C          photons

            do j = 1,nel
               do i=1,min(2,npho)
                  if (Phobnk(phoind(i)).eq.bnk_ele(j) .and.
     &               et_ele(j).gt.0.0) then
                     etadiff = abs(ijet_deta(jj)-dteta_ele(j))
                     phidiff = abs(ijet_phi(jj)-phi_ele(j))
                     if (phidiff.gt.pi) phidiff = 2*pi - phidiff
                     if (sqrt(etadiff**2+phidiff**2).lt.cone_size)
     &                  j1word(k) = ibset(j1word(k),9-i)
                  endif
               end do
            enddo

C           muons

            do j=1,min(3,nmu)
               if (muoind(j).gt.numcmuo) then
                  trkflag = jets_trks(trks_cmio(muoind(j)-numcmuo),
     &                      ijetbnk(jj),cone_size,prim)
                  if (trkflag.eq.0) j1word(k) = ibset(j1word(k),7-j)
               else
                  trkflag = jets_trks(trks_cmio(muoind(j)),ijetbnk(jj),
     &                   cone_size,prim)
                  if (trkflag.eq.0) j1word(k) = ibset(j1word(k),7-j)
               endif
            end do

C     taus 

            do j=1,min(3,ntau)
               if (tau_et(tauind(j)).gt.0.0) then
                  etadiff = abs(ijet_deta(jj)-tau_deta(tauind(j)))
                  phidiff = abs(ijet_phi(jj)-tau_phi(tauind(j)))
                  if (phidiff.gt.pi) phidiff = 2*pi - phidiff
                  if (sqrt(etadiff**2+phidiff**2).lt.cone_size)
     &               j1word(k) = ibset(j1word(k),4-j)
               endif
            end do        

C      MET4 (within cone_size of phi)

             phidiff = abs(metphi(4) - ijet_phi(jj))
             if (phidiff.gt.pi) phidiff = 2*pi - phidiff    
             if (phidiff.lt.cone_size) j1word(k) = ibset(j1word(k),0)
          endif   !j1word(k)

          J1JTS(K) = 0
          if (ijet_et(jj).gt.0.01) then

C          cone of 0.4 jets

             do j = 1,njt
                etadiff = abs(jt4eta(j)-ijet_eta(jj))
                phidiff = abs(jt4phi(j)-ijet_phi(jj))
                if (phidiff.gt.pi) phidiff = 2*pi - phidiff
                if (sqrt(etadiff**2 + phidiff**2).lt.cone_size)
     &             j1jts(k) = ibset(j1jts(k),j-1)
             end do
          endif

          j1corfm(k) = JCORF(JJ,mcorindex)   ! jet energy correction factor
                                             ! for mass analysis
          j1corfd(k) = JCORF(JJ,dcorindex)   ! jet energy correction factor
                                             ! for dilepton analysis
       ENDDO ! k jet1 index
       
      
C MISSING ET INFORMATION: Everything comes from EVTINFO.INC          
C      MET corrected for jets, muons, electrons from W's

c       call ucopy(met,miset,5)
c       call ucopy(metphi,misetphi,5)
       METX = MET(4)*COS(METPHI(4))
       METY = MET(4)*SIN(METPHI(4))
       MIN_ET = 10.0
       MAX_ETA = 2.0
       CALL METJET(JSKIP(1),JSKIP(2),MIN_ET,MAX_ETA,METX,METY,
     &             METJETX,METJETY,METPHI1,NJ,PARNUM,dcorindex)
       metjt = SQRT(MAX(0.0,METJETX**2+METJETY**2))
       metjtphi = METPHI1
          
C  make a track cluster near MET and find eta,phi,pt

      CALL FALSE_MET(ETATRKS,PHITRKS,PTTRKS,SEEDPT,5.0,0.6,0.4,METPHI1)
c      etamet = ETATRKS
c      phimet = PHITRKS
c      ptmet  = PTTRKS
c      ptseed = SEEDPT
 
C  SUMET, MET significance, Ht, out-of-time energy

      sumet = ETTOT
      sumetjet = 0.0            !sumet from jets
      DO J = 1,MIN(MAXJETS,JETNUM)
         sumetjet = sumetjet + IJET_ET(JETINDEX(J))
      ENDDO

      IF (ETTOT.GT.0.0) THEN
         metsig = SQRT(MAX(0.0,METX**2+METY**2))/SQRT(ETTOT)
      ELSE
         metsig = 0.0
      ENDIF
      etout = EOTIME
               
C  tagging summary word: from BTGSCM.INC
C  0   E SLT
C  1   MU SLT
C  2   JETVTX TAG
C  3   2 JETVTX TAGS
C  4   JPBTAG TAG
C  5   2 JPBTAG TAGS
C  6   DPHI TAG
C  7   2 DPHI TAGS
C  8   SECVTX TAG
C  9   2 SECVTX TAGS
           
      btgwrd = BTGSUM
          
C TAGGING INFORMATION: from SECVTX.INC
C              primary vertex location
             
      call ucopy(prim,vxprim,3)
      
      TAGNUM = 0
      DO J = 1,4
         IF (ABS(TAGSEC(J)).EQ.1) THEN
            TAGNUM = TAGNUM + 1
            lxy(tagnum) = LXYSEC(J)
            lxyerror(tagnum) = LXYERR(J)
            ctau(tagnum) = CTAUSEC(J)
            tagchi(tagnum) = CHI2SEC(J)
         ENDIF
      ENDDO   !J
      ntag = tagnum

C VTVZ bank information: class, zvert, and sum(abs(pttracks)) of primaries

      bnknum = 1
      istat = blocat(iw,'VTVZ',bnknum,sindx,sdindx)
      if (istat.ne.yesucc) then
         CALL ERLOGR('STNTUPLE',EREROR,0,0,
     &               'unable to find VTVZ bank')
      else
         dz0cut = zmatch
         call vxpest(xseed,cvseed,npvert,blinfo,qint,dz0cut)
         do j = 1,npvert
            IF (IW(SDINDX+1).GE.J) THEN
               vclass(j) = IW(SDINDX+(J-1)*LVTVZ+5)
               vz(j) = RW(SDINDX+(J-1)*LVTVZ+6)
               vq(j) = qint(j)
            ENDIF
         enddo
      endif

C    invariant mass of top two leptons for each species

      EEMASS = 0.0
      if (nel.ge.2) then
         EEMASS = EEMASS + (P4E_ELE(4,ELEIND(1))/ CORFAC(ELEIND(1))
     &          + P4E_ELE(4,ELEIND(2))/ CORFAC(ELEIND(2)))**2
         EEMASS = EEMASS - (P4E_ELE(3,ELEIND(1))/ CORFAC(ELEIND(1))
     &          + P4E_ELE(3,ELEIND(2))/ CORFAC(ELEIND(2)))**2
         EEMASS = EEMASS - (P4E_ELE(2,ELEIND(1))/ CORFAC(ELEIND(1))
     &          + P4E_ELE(2,ELEIND(2))/ CORFAC(ELEIND(2)))**2
         EEMASS = EEMASS - (P4E_ELE(1,ELEIND(1))/ CORFAC(ELEIND(1))
     &          + P4E_ELE(1,ELEIND(2))/ CORFAC(ELEIND(2)))**2
         eemass = SQRT(MAX(0.0,EEMASS))
      endif

      mumumass = 0.
      if (nmu.ge.2) then
         IF (MUOIND(1).le.numcmuo.AND.
     +              MUOIND(2).le.numcmuo) THEN
            i = MUOIND(1) 
            j = MUOIND(2)
            mumuMASS = dimass(P4M_CMUO(1,i),P4M_CMUO(1,j))
         else IF (MUOIND(1).le.numcmuo.AND.
     +         MUOIND(2).gt.numcmuo) THEN
            i = MUOIND(1) 
            j = MUOIND(2) - numcmuo
            mumuMASS = dimass(P4M_CMUO(1,i),P4M_CMIO(1,j))
         Else IF (MUOIND(1).gt.numcmuo.AND.
     +         MUOIND(2).le.numcmuo) THEN
            i = MUOIND(1) - numcmuo
            j = muoind(2) 
            mumuMASS = dimass(P4M_CMIO(1,i),P4M_CMUO(1,j))
         Else IF (MUOIND(1).gt.numcmuo.AND.
     +         MUOIND(2).gt.numcmuo) THEN
            i = MUOIND(1) - numcmuo
            j = muoind(2) - numcmuo
            mumumass = dimass(P4M_CMIO(1,i),P4M_CMIO(1,j))
         ENDIF
      endif

      TAUMASS = 0.0 
      if (ntau.ge.2) then
      TAUMASS = TAUMASS + (TAU_E(TAUIND(1))+
     &                              TAU_E(TAUIND(2)))**2
      TAUMASS = TAUMASS - (TAU_EZ(TAUIND(1))+
     &                              TAU_EZ(TAUIND(2)))**2
      TAUMASS = TAUMASS - (TAU_EY(TAUIND(1))+
     &                              TAU_EY(TAUIND(2)))**2
      TAUMASS = TAUMASS - (TAU_EX(TAUIND(1))+
     &                              TAU_EX(TAUIND(2)))**2
      tauMASS = SQRT(MAX(0.0,TAUMASS))
      endif

C              translate phoinfo indices into eleinfo indices
C              calculate diphoton invariant mass

      phomass = 0.
      if (npho.ge.2) 
     + phoMASS = dimass(pho_p4(1,phoind(1)),pho_p4(1,phoind(2)))

      CALL HFNT(1)  ! fills CWN

      ENDIF ! ANGBO STUFF...
C
      RETURN
      END


C=======================================================================
      SUBROUTINE BOOK_STNTUPLE
C=======================================================================
      IMPLICIT NONE
C
$$INCLUDE 'ntuple$source:exo_phoinfo.inc'
$$INCLUDE 'C$INC:EVTINFO.INC'         
$$INCLUDE 'ntuple$source:STNTUPLE.INC'
$$INCLUDE 'c$inc:eleinfo.inc'
$$INCLUDE 'c$inc:mioinfo.inc'
$$INCLUDE 'ntuple$source:NTUPLE_v4_1.INC'
$$include 'C$inc:tfzinfo.inc'
$$include 'ntuple$source:trigger_stuff.inc'

        INTEGER ANGHAC                    !A_C HISTO STUFF
        INTEGER ANGHBO                    !A_C HISTO STUFF
        INTEGER ANGTH4                    !A_C HISTO STUFF
C
C       LOCAL VARIABLES
C
        INTEGER NID
        INTEGER BUFSIZ
        CHARACTER*32 TOPDIR
        CHARACTER*32 FILE_NAME
        CHARACTER*32 TITLE     !TITLE FOR NTUPLE
        CHARACTER*1 OPNOPT
        INTEGER STATUS
C 
        INTEGER I               ! Used to increment ntuples...
        integer ier
C
        STATUS=ANGTH4(1,TOPDIR,FILE_NAME,OPNOPT)
        BUFSIZ=40000
        MAXJETS = 20

C   Calling HBOOK to construct the ntuple with the array of variables
C    VAR matched with the array of ntuple field names CHAR, for 1 event

        NID  = 1
        TITLE = 'Kinematic Ntuple Version 4.0'
        call hbnt(nid,title,' ')
        call hbset('BSIZE',4095,ier)   ! best if BSIZE > # of events
c                                      ! but BSIZE * # of ntuple var. < NWPAWC
c
c  General event info
c     
        call hbname(nid,'general',version,
     +'VERSION:i,RUN:i,EVENT:i')
        call hbname(nid,'general',trigbits,'TRIGBITS:i')
c
c  Photons
c
        call hbname(nid,'photons',npho,'NPHO[0,10]:i')
        call hbname(nid,'photons',ncencl,'NCENCL')
        call hbname(nid,'photons',nplugcl,'NPLUGCL')
        call hbname(nid,'photons',nphoidl,
     +'NPHOIDL,NPHOISOL,NPHOID,NPHOISO,NCMUS')
        call hbname(nid,'photons',costub,
     +'COSTUB:i,PDETECT(NPHO):i,PZV(NPHO),PET(NPHO),PETC(NPHO),'//
     +'PP4(4,NPHO)')
        call hbname(nid,'photons',pco4,
     +'PCO4(NPHO),PCESX(NPHO),PCESZ(NPHO),PCPR5PH(NPHO),'//
     +'PCPR5PS(NPHO)')
        call hbname(nid,'photons',pdteta,
     +'PDTETA(NPHO),PEVETA(NPHO),PCESE(NPHO),PPHI(NPHO),'//
     +'PCO7(NPHO),PHADEM(NPHO)')
        call hbname(nid,'photons',plshr,
     +'PLSHR(NPHO),PSTR2(NPHO),PSTRE2(NPHO),PWIR2(NPHO),'//
     +'PWIRE2(NPHO),PSUMPT4(NPHO)')
        call hbname(nid,'photons',pvtxocc,
     +'PVTXOCC(NPHO),PPT(NPHO),PN3D(NPHO):i,PCHI(NPHO),'//
     +'PCHI3X3(NPHO),PCHIETA(NPHO),PCHIPHI(NPHO),PSTAT(NPHO)')
        call hbname(nid,'photons',pboxiso,
     +'pboxiso(npho),pcesflg(npho):l,pe(npho),pceswht(npho),'//
     +'pcprwht(npho),pcesslide(npho),pwrd(npho):i,psth(npho)')
        call hbname(nid,'photons',pelind,
     +'pelind(npho):i,pchistr(npho),pchiwir(npho),pcessig(npho)')
c
c  Dilepton analysis
c     
        call hbname(nid,'dilepton',ndil,'NDIL')
        call hbname(nid,'dilepton',tzflag,'TZFLAG:l')
        call hbname(nid,'dilepton',dilwrd,
     +'DILWRD:i,GOODRUN:l,BRCODE:i,GOODTRIG:l,TRIGWORD:i,NJET10,NJET15')
        call hbname(nid,'dilepton',njet20,
     +'NJET20,NJET25,NHPTE,NLCENT,NLPLUG,NHPTM')
        call hbname(nid,'dilepton',ncmio,
     +'NCMIO,NGTAU,NLEPTON,METDILEP:r,NJTDILEP,DPHIMINJ')
        call hbname(nid,'dilepton',dphiminl,
     +'DPHIMINL,DILMODE:i,DILTYPE1:i')
c
c  Electrons
c
       call hbname(nid,'electron',nel,'NEL[0,10]:i')
       call hbname(nid,'electron',ep4,
     +'EP4(4,NEL),EETCOR(NEL),EET(NEL),EQ(NEL),EDTETA(NEL),'//
     +'EEVETA(NEL)')
       call hbname(nid,'electron',ephi,
     +'EPHI(NEL),EPT(NEL),ESTAT(NEL),EZV(NEL),EEP(NEL),EHADEM(NEL)')
        call hbname(nid,'electron',exces,
     +'EXCES(NEL),EDELX(NEL),EZCES(NEL),EDELZ(NEL),ECHIS(NEL),'//
     +'ECHIW(NEL)')
        call hbname(nid,'electron',eiso,
     +'EISO(NEL),ETISO(NEL),EIDWRD(NEL):i,EISWRD(NEL):i,'//
     +'ECONWRD(NEL):i')
        call hbname(nid,'electron',eztrk,
     +'EZTRK(NEL),EFID(NEL):i,EDET(NEL):i,EBTE(NEL),ENASL(NEL):i,'//
     +'ENSSL(NEL):i')
        call hbname(nid,'electron',eptrk,
     +'eptrk(nel),elshr2(nel),echi3(nel),echid(nel),evtxocc(nel)')
c
c  Muons
c
       call hbname(nid,'muons',nmu,'NMU[0,15]:i')
       call hbname(nid,'muons',murawpt,'MURAWPT(NMU):r')
       call hbname(nid,'muons',mup4,
     +'MUP4(4,NMU):r,MUPT(NMU):r,MUQ(NMU):r,MUHAD(NMU):r,MUEM(NMU):r')
       call hbname(nid,'muons',mueveta,
     +'MUEVETA(NMU):r,MUPHI(NMU):r,MUSTAT(NMU):r,MUZV(NMU):r,'//
     +'MUD0(NMU):r')
       call hbname(nid,'muons',mudelz,
     +'MUDELZ(NMU):r,MUDELX(NMU):r,MUISO(NMU):r,MUTISO(NMU):r,'//
     +'MUCRAY(NMU):i')
       call hbname(nid,'muons',muidwrd,
     +'MUIDWRD(NMU):i,MUISWRD(NMU):i')
       call hbname(nid,'muons',muztrk,
     +'MUZTRK(NMU):r,MUFID(NMU):i,MUDET(NMU):i,MUBTE(NMU):r,'//
     +'MUNASL(NMU):i,MUNSSL(NMU):i')
c
c  Taus
c
       call hbname(nid,'taus',ntau,'NTAU[0,10]:i')
       call hbname(nid,'taus',tp4,
     +'TP4(4,NTAU),TET(NTAU),TQ(NTAU),TZV(NTAU),TDTETA(NTAU),'//
     +'TEVETA(NTAU)')
        call hbname(nid,'taus',tphi,
     +'TPHI(NTAU),TPT(NTAU),TPTVIS(NTAU),TSTAT(NTAU),TDELR(NTAU),'//
     +'TEMF(NTAU),TMASS(NTAU)')
c
c  Jets, cone of 0.4
c
       call hbname(nid,'jets',njt,'NJT[0,20]:i')
       call hbname(nid,'jets',jtet,
     +'JTET(NJT):r,JTM(NJT):r,JTP4(4,NJT):r,JTEVETA(NJT):r,'//
     +'JTDTETA(NJT):r')
        call hbname(nid,'jets',jtphi,
     +'JTPHI(NJT):r,JTEMF(NJT):r,JTWORD(NJT):i,JTCORFM(NJT):r,'//
     +'JTCORFD(NJT):r')
        call hbname(nid,'jets',jtcorfa,
     +'JTCORFA(NJT):r,JTNTR(NJT):i,JTNTRP(NJT):i,JTEP(NJT):r,'//
     +'JTTAG(NJT):i')
        call hbname(nid,'jets',jvbpb,
     +'JVBPB(NJT):r,JPBPB(NJT):r,SCBPB(NJT):r,JPPPB(NJT):r,'//
     +'JPNPB(NJT):r')
c
c  Jets, cone of 1.0 or 0.7
c
       call hbname(nid,'jt1s',nj1,'NJ1[0,20]:i')
       call hbname(nid,'jt1s',j1et,
     +'J1ET(NJ1):r,J1M(NJ1):r,J1P4(4,NJ1):r,J1EVETA(NJ1):r,'//
     +'J1DTETA(NJ1):r')
        call hbname(nid,'jt1s',j1phi,
     +'J1PHI(NJ1):r,J1WORD(NJ1):i,J1JTS(NJ1):i,J1CORFM(NJ1):r,'//
     +'J1CORFD(NJ1):r')
c
c     MET
c
      call hbname(nid,'met',met,'MET(5):r')
      call hbname(nid,'met',metphi,'METPHI(5):r')
      call hbname(nid,'met',metjt,'METJT:r,METJTPHI:r')
      call hbname(nid,'met',etatrks,'ETATRKS,PHITRKS,PTTRKS,SEEDPT')
      call hbname(nid,'met',sumet,'SUMET,SUMETJET,METSIG:r,ETOUT')
c
c  Tagging
c
       call hbname(nid,'tagging',ntag,'NTAG[0,4]:i')
       call hbname(nid,'tagging',btgwrd,
     +'BTGWRD:i,LXY(NTAG):r,LXYERR(NTAG):r,CTAU(NTAG),TAGCHI(NTAG)')
c
c  Vertex
c
       call hbname(nid,'vertex',npvert,'NPVERT[0,5]:i')
       call hbname(nid,'vertex',vxprim,
     +'VXPRIM(3),VCLASS(NPVERT):i,VZ(NPVERT),VQ(NPVERT)')
c
c  Lepton/photon pair masses
c
       call hbname(nid,'masses',eemass,
     +'EEMASS,MUMUMASS:r,TAUMASS,PHOMASS')
      
      call hprnt(1)

c     CALL HBOOKN(NID,TITLE,NVAR1,TOPDIR,BUFSIZ,CHAR1)

      RETURN
      END

**********************************************************************
 
      real function mass(x4)   ! computes mass from 4-momentum vector
      implicit none
      real x4(4) ! 4-vector px,py,pz,E

      mass = sqrt(max(0.,x4(4)**2 - x4(1)**2 - x4(2)**2 - x4(3)**2))
      end

**********************************************************************

      real function dimass(x,y) ! computes mass of 2 objects combined
      implicit none
      real x(4),y(4),z(4),mass 

      call vadd(x,y,z,4)
      dimass = mass(z)
      end

**********************************************************************

      real function delta_r(eta1,phi1,eta2,phi2)
$$INCLUDE 'C$INC:PIVALU.INC'           ! easy as...
      etadiff = abs(eta1-eta2)
      phidiff = abs(phi1-phi2)
      if (phidiff.gt.pi) phidiff = 2*pi - phidiff
      delta_r = sqrt(phidiff**2+etadiff**2)
      end
      
