C======================================================================
	SUBROUTINE TAGBTC(NBANK)
C======================================================================
C
C  Description:
C  ============
C  Unpacks the TAGC bank number NBANK into the common block /TAGCBK/
C
C  Revision History:
C  =================
C  13-Mar-1989 - Original creation from Drew's TRGGER.CDF
C  17-Mar-1989 - Output error messages only the first ten times
C  30-Jan-1991 - Added NBANK
C
C======================================================================
$$IF VAX
	IMPLICIT NONE
$$ENDIF
C
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'C$INC:JOBSTA.INC'
$$INCLUDE 'C$INC:BCS   .INC'
$$INCLUDE 'C$INC:BTMASK.INC'
$$INCLUDE 'C$INC:PIVALU.INC'
$$INCLUDE 'C$INC:LOGUNI.INC'
$$INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
$$INCLUDE 'UC$ANA:TAGCCM.INC/LIST'		! Common block to be filled


C External Declarations:
C =====================
	INTEGER BLOCAT			! Find a bank
	INTEGER BDLEN			! Get banks length
	INTEGER UICYAC			! Convert bank to character string
	INTEGER UIUPCA			! Convert to upper case

C Local Declarations:
C ==================
	INTEGER IND				! Bank pointer
	INTEGER INDDAT				! Data pointer
	INTEGER STATUS				! Ybosserie
	INTEGER NWORD				! Number of words in bank
	INTEGER I				! Misc index
	INTEGER OFFSET				! offset from the start of data 
	CHARACTER*32 NAME			! temporary name storage
	INTEGER IBAD				! Bad event counter
	INTEGER NBANK
C
C Start of Code
C =============
C
C----------------------------------------------------------------------------
C	get the TAGC bank
C----------------------------------------------------------------------------
	TAGC_NTRIG = 0
	STATUS = BLOCAT(IW,'TAGC',NBANK,IND,INDDAT)
	IF (STATUS.NE.YESUCC) THEN
	  IBAD = IBAD + 1
	  IF (IBAD.LE.10) THEN
	     WRITE(LUTTYO,'('' TAGBTC:  No TAGC bank for Run '',I5,
	1	'' Event '',I6,
	1	'' Message repeated up to ten times'')') NRUN,NEV
	  END IF
	  RETURN
	ENDIF
C
C----------------------------------------------------------------------------
C	Figure out how many triggers are present
C----------------------------------------------------------------------------
	STATUS = BDLEN(IW,IND,NWORD)
	TAGC_NTRIG = NWORD/14
C----------------------------------------------------------------------------
C	Loop over triggers 
C----------------------------------------------------------------------------
	OFFSET = INDDAT
	DO I = 1, TAGC_NTRIG
	  TAGC_LEVEL(I) = IW(OFFSET)
	  STATUS  = UICYAC(IW(OFFSET+1),32,NAME) ! YBOS array to string
	  STATUS  = UIUPCA(NAME,NAME)		 ! Upper case
	  TAGC_NAME(I) = NAME
	  TAGC_PASS(I)  = IW(OFFSET+13)
	  OFFSET  = OFFSET + 14
	END DO                
	RETURN
	END
