C
C       COMMON BLOCK TO STORE TRACKS
C
C  variables with comment NQ88   are NOT unpacked by QTRK, 88 version
C  variables with comment   NQ   are NOT unpacked by QTRK, any version
C  variables with comment NCTC88 qre NOT unpacked by CTCS, 88 version
C  variables with comment  N92   are NOT filled in 92 version
C
C  always unpacks non-beam-constrained values for tracking parameters, except
C  where specified
C
C  DANGER,DANGER WILL ROBINSON:  when looping over tracks, don't look at ones
C  that don't have iperft = true unless you are very careful
C  or you could get divide by zero errors, etc
C
C       SCE 24-jul-1990
C       SCE + CC modified 2-Oct-1990
C---------------------------------------------------------------------
C	CC  June 1992		many modifications for 1992 tracks
c----------------------------------------------------------------------
C       CC  August 10, 1992     Added the full covariance matrix
C
      INTEGER MAX_TRACK
      PARAMETER (MAX_TRACK=500)       ! MAX ALLOWED NUMBER OF TRACKS
      REAL PT_MIN                     ! PT CUT FOR UNPACKING
      real zvcut                      !vertex cut
      real vattch                     !vertex attach cut
c
c
c
c
c

      INTEGER N_TRACK                 ! # OF TRACKS
      LOGICAL CTCSTR		      !true means unpacked from ctcs
c                                     !false means from qtrk  
c
c
c
c
c
      LOGICAL IPERFT(MAX_TRACK)	      ! Eno's favorite selection to use
				      ! trksel = good AND attaches to
				      ! a vertex with abs(z_vertex)<zvcut and
				      ! corrected impact parameter < 0.15 

      LOGICAL IPERFT_NOVTX(MAX_TRACK) ! same as iperft, but no abs(z_vertex)
				      ! requirement

      INTEGER IGDA(MAX_TRACK)	      !ctcsel selection results (0=good) NQ

      INTEGER IGOOD(MAX_TRACK)        !trksel selection results for trk 
                                      ! (0=good) 

      INTEGER VTTRA(MAX_TRACK)        !vertex aesook would associate
                                      ! with track (0 if no vertex) 
				      ! (does not include abs(z) cut on vertex)

      INTEGER IGOODV(MAX_TRACK)       !associate with vertex 
                                      ! and beam-pos by berge (0=good)   NQ
c
c
c
c
c
c
      REAL PXTR(MAX_TRACK)            ! PX
      REAL PYTR(MAX_TRACK)            ! PY
      REAL PZTR(MAX_TRACK)            ! PZ
      REAL PTR(MAX_TRACK)             ! P
      REAL PTTR(MAX_TRACK)            ! Pt
      INTEGER CHTR(MAX_TRACK)         ! CHARGE (-1 OR 1)
      REAL CTANTR(MAX_TRACK)          ! COTANGENT
      REAL CURVTR(MAX_TRACK)          ! HALF CURVATURE (CM**-1)
      REAL Z0TR(MAX_TRACK)            ! Z OF CLOSEST APPROACH
      REAL IMPTR(MAX_TRACK)           ! IMPACT PARAMETER
      REAL IMPTRR(MAX_TRACK)	      !beam-position adjusted impact
      REAL PHITR(MAX_TRACK)           ! PHI
      INTEGER TOWETR(MAX_TRACK)       ! TOWE INDEX OF TOWER TO WHICH TRACK
      REAL thettr(max_track)          !theta of track
      REAL etatr(max_track)           !eta of track
      REAL chiaxtr(max_track)         !chi sq for axial   NQ
      REAL chisttr(max_track)         !chi sq for stereo  NQ
      INTEGER naxhtr(max_track)       !#axial hits used in fit  NQ
      INTEGER nsthtr(max_track)       !#stero hits used in fit  NQ
      REAL rlowtr(max_track)          !radius of lowest hit used in fit  NQ88
      REAL ruptr(max_track)           !radiums of highest hit used in fit  NQ88
      INTEGER fittr(3,max_track)      !fit code for track  NQ88, #3 is N92
      INTEGER mptr(3,max_track)       !bit map of layers used  NQ
      real dcurv(max_track)           ! eroor on curvature
      REAL dpttr(max_track)           !error on Pt  NQ88
      REAL dphitr(max_track)          !error in phi  NQ88
      REAL dcthtr(max_track)          !error in cot  NQ88
      REAL rexttr(max_track)          !expected exit radius of track NQ88,N92
      INTEGER ALGORTR(MAX_TRACK)      ! algorithm which reconstructs the trk.
      ! =1 ==>Berge's code, =2 ==>Aseet's code NCTC88
      INTEGER NDOFTR(MAX_TRACK)       ! # DEGREES OF FREEDOM NQ88
      REAL CHI2TR(MAX_TRACK)          ! CHI-SQUARED   NQ88
      REAL utsttr(max_track)          !utest from tvdist NQ
      REAL ztsttr(max_track)          !ztest from tvdist  NQ
      INTEGER VTXTR(MAX_TRACK)        !pointer in array from vtgzzt to
c                                     ! vertex associated with track by
c                                     ! by tvdist          NQ
      INTEGER CTCSBNK(MAX_TRACK)      ! CTCS BANK NUMBER
      INTEGER QTRKBNK(MAX_TRACK)      ! QTRK BANK NUMBER
      INTEGER SVXSBNK(MAX_TRACK)      ! SVXS BANK NUMBER
      INTEGER HITMASK(MAX_TRACK)      ! MASK OF SUPERLAYER USAGE
      LOGICAL SVX_USED(MAX_TRACK)     !	SVX information in the fit
      INTEGER NSVX_HIT(MAX_TRACK)         ! Number of svx hits 
      INTEGER SVX_LAY_FOUND(MAX_TRACK)    ! Bit mask of found SVX hits
      INTEGER SVX_LAY_EXPEC(MAX_TRACK)    ! Bit mask of expected SVX hits
      REAL SVX_CHI(MAX_TRACK)		  ! SVX chi^2 contribution
      REAL COVTR(15,MAX_TRACK)		  ! Covariance matrix  N88 
      integer nbc(max_track)        !non-beam-const tracking exit?  NQ88 N92
      integer bc(max_track)         !beam-const tracking exist?  NQ88 N92
      real pxbc(max_track)          !NQ88 N92
      real pybc(max_track)          !NQ88 N92
      real pzbc(max_track)          !NQ88 N92
      real ptbc(max_track)          !NQ88 N92
      real pbc(max_track)           !NQ88 N92
      real imptrbc(max_track)       !NQ88 N92
      real imptrrbc(max_track)      !NQ88 N92
      real z0bc(max_track)          !NQ88 N92
C
      COMMON/TRACKCM/N_TRACK,PT_MIN,PXTR,PYTR,PZTR,PTR,PTTR,CTANTR,
     &          CURVTR,Z0TR,IMPTR,PHITR,TOWETR,NDOFTR,CHI2TR,CHTR,
     &          ALGORTR,CTCSBNK,HITMASK,
     &          vtxtr,thettr,etatr,chiaxtr,chisttr,naxhtr,nsthtr,rlowtr,
     &          ruptr,fittr,mptr,dpttr,dphitr,dcthtr,rexttr,igood,
     &          igoodv,utsttr,ztsttr,ctcstr,zvcut,vattch,igda,vttra,
     &          imptrr,bc,pxbc,pybc,pzbc,ptbc,pbc,imptrbc,imptrrbc,
     &          z0bc,nbc,dcurv,iperft,iperft_novtx,QTRKBNK,SVXSBNK,
     &          SVX_USED,NSVX_HIT,SVX_LAY_FOUND,SVX_LAY_EXPEC,SVX_CHI,
     &          COVTR


 	DATA PT_MIN   /0.3/
	DATA ZVCUT    /60./
	DATA VATTCH   /5./
