 	SUBROUTINE UNP_PRIMARY(ZINIT)
C-----------------------------------------------------------------------
C Unpack information from VTXS and VTXT banks into UC$ANA:PRVERT.INC
C				Claudio, 27-Aug-1992
C
C Modifications by DavidK : unpacks best of VXPRIM and Beam position
C
C  If filled with VXPRIM information then : VXPRIM_FLAG=.TRUE.
c
C  If filled with BPO then :		    VXPRIM_FLAG=.FALSE.
C					    VERTEX_CHI=-888.
C					    VERTEX_DOF=-888.
C
C  If both failed then			    VXPRIM_FLAG=.FALSE.
C					    VERTEX_CHI=-999.
C					    VERTEX_DOF=-999.
C-----------------------------------------------------------------------
	IMPLICIT NONE
	INCLUDE 'C$INC:JOBSTA.INC'
        INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
	INCLUDE 'UC$ANA:PRVERT.INC'
        INCLUDE 'C$INC:BCS.INC'
        INCLUDE 'C$INC:DSCMPB.INC'
        INCLUDE 'C$INC:DSVTXS.INC'
        INCLUDE 'C$INC:DSVTXT.INC'
        INTEGER STATUS,BLOCAT,INDS,INDDATS,IND,INDDAT
        INTEGER BASIND,VERIND,BLKIND
	INTEGER I,INDEX,vxerr,bmerr
	CHARACTER*4 BINTCH
	real xprim1(3),cvprim1(6),xprim2(3),cvprim2(6),vtqual1(2)
	real vtqual2(2)
	logical beam,use_vxprim
	REAL ZINIT

	DATA VXPRIM_FLAG /.FALSE./
	DATA VERTEX_CHI  /-999./
	DATA VERTEX_DOF  /-999./

C--------------------------
C Initialize
C--------------------------
	VXPRIM_FLAG = .FALSE.
	N_VTXT      = 0
	N_VTXT_USED = 0
	do i=1,3
	   pr_vertex(i)=-999.
	enddo
	do i=1,6
	   vertex_cov(i)=-999.
	enddo
	vertex_chi=-999.
	vertex_dof=-999.

C---------------------------------------------------
c First get primary vertex, try both BPO and VXPRIM
c---------------------------------------------------

           Beam = .false.
           Call My_Getxyz(ZINIT,Beam,Xprim1,Cvprim1,vtqual1,Vxerr)
           Beam = .true.
           Call My_Getxyz(ZINIT,Beam,Xprim2,Cvprim2,vtqual2,Bmerr)

c-------------------------------------------------------------------
C If both the BPO and VXPRIM calls were successful, then use the one
C with the smaller error otherwise use the one that was successful
c-------------------------------------------------------------------

           If ((Vxerr .eq. 0) .and. (Bmerr .eq. 0)) then
              use_vxprim= ( (Sqrt(Cvprim1(1)) .le. Sqrt(Cvprim2(1)))
     &                .and. (Sqrt(Cvprim1(4)) .le. Sqrt(Cvprim2(4))) ) 
           Else If (Vxerr .eq. 0) then
	      use_vxprim=.true.
           Else if (Bmerr .eq. 0) then
	      use_vxprim=.false.
           Else					!neither algorithm successful
	      return	      
	   Endif


	   If(use_vxprim)then
                 Do I = 1, 3
                    PR_VERTEX(I) = Xprim1(I)
                 Enddo
                 Do I = 1, 6
                    VERTEX_COV(I) = Cvprim1(I)
                 Enddo
	         Do I = 1, 2
		    vertex_chi=vtqual1(1)
		    vertex_dof=vtqual1(2)
		 Enddo
            Else		!used beam-line
                 Do I = 1, 3
                    PR_VERTEX(I) = Xprim2(I)
                 Enddo
                 Do I = 1, 6
                    VERTEX_COV(I) = Cvprim2(I)
                 Enddo
	         vertex_chi=-888.		!-888. flags that we used
		 vertex_dof=-888.		!the beam position
            Endif


C-----------------------------
C If no VTXT bank quit
C-----------------------------
        STATUS = BLOCAT(IW,'VTXT',-1,IND,INDDAT)
	VXPRIM_FLAG = .TRUE.
	IF (STATUS .NE. YESUCC) RETURN

C--------------------------------------
C Now unpack VTXT
C--------------------------------------
        N_VTXT = IW(INDDAT+NTVTXT)
        IF (N_VTXT .GT. MAX_VTXT) THEN
           I = MAX_VTXT
           PRINT *,' ************************************'
           PRINT *,' WARNING....TOO MANY TRACKS IN VTXT'
           PRINT *,' ONLY THE FIRST ',I
           PRINT *,' WILL BE UNPACKED'
           PRINT *,' SUBROUTINE UNP_PRIMARY...RUN,EVENT=',NRUN,NEV
           PRINT *,' ******************************************'
           N_VTXT = MAX_VTXT
        END IF
        INDEX = INDDAT
        DO 100 I=1,N_VTXT
           BANK_NAME(I)   = BINTCH(IW(INDEX+NAVTXT))
           BANK_NUMBER(I) = IW(INDEX+NUVTXT)
           USED_FLAG(I)   = IW(INDEX+UPVTXT)
	   IF (USED_FLAG(I) .NE.  0) N_VTXT_USED=N_VTXT_USED+1
           INDEX          = INDEX + NWVTXT
100     CONTINUE
C--------------------------------------------
C Done
C--------------------------------------------

	RETURN
	END
