	SUBROUTINE UNPTLK
C
C===Description:
C
C	Talk_to routine for the unpacking module
C

C=== Global declarations

$$IMPLICIT

$$INCLUDE 'UIPACK$LIBRARY:UIPARAM.INC'
$$INCLUDE 'UIPACK$LIBRARY:UIERROR.INC'
$$INCLUDE 'C$INC:ERLEVL.INC'
$$INCLUDE 'UC$ANA:TRAKCM.INC'
$$INCLUDE 'UC$ANA:UNFLAGS.INC'

C=== Local declarations

	REAL PTCUT,ETCUT
	COMMON /UNPKCUT/ PTCUT,ETCUT
	INTEGER STATUS
	INTEGER GROUP
	INTEGER MENUID
	CHARACTER*80 VERB
	INTEGER NVALUE

C=== External declarations

	INTEGER UIASGP,UIASME
	INTEGER UIDFFI,UIUSGP,UIACME,UIGTTX
	INTEGER UIGTFI
	INTEGER UIGTIN,UIGTLO,UIGTRE

C=== Data statements

	DATA GROUP/0/
	DATA MENUID/0/
	DATA NVALUE /1/
	DATA PARBNK /'$CLP'/
	DATA PNUM /1/

C=== Start of code

C-- Construct the talk_to menu upon first entering this routine

	IF(GROUP.EQ.0) THEN
	  STATUS = UIASGP(GROUP)	! Get a free verb group
	  IF(STATUS.NE.UISUCC) THEN
	    CALL ERLOGR('UNPTLK',EREROR,0,STATUS,
	1	'Unable to get free verb group')
	    RETURN
	  ENDIF

	  STATUS = UIASME(MENUID)	! Get a free menu ID
	  IF(STATUS.NE.UISUCC) THEN
	    CALL ERLOGR('UNPTLK',EREROR,0,STATUS,
	1	'Unable to get free menu ID')
	    RETURN
	  ENDIF

	  STATUS = UIDFFI('UC$ANA:UNPTLK.UID',GROUP,MENUID)
					! Read the menu definition file
	  IF(STATUS.NE.UISUCC) THEN
	    CALL ERLOGR('UNPTLK',EREROR,0,STATUS,
	1	'Unable to read menu definition file')
	    RETURN
	  ENDIF

	ENDIF

C-- Tell UIpack what verb group we are using

	STATUS = UIUSGP(GROUP)
	IF(STATUS.NE.UISUCC) THEN
	  CALL ERLOGR('UNPTLK',EREROR,0,STATUS,
	1	'Unable to tell UIpack what verb group we are using')
	  RETURN
	ENDIF

C-- Display the menu and prompt the user for input

1000	CONTINUE
	STATUS = UIACME(MENUID,VERB)
	IF(STATUS.EQ.UIABRT) 	RETURN
C
C  PT_CUT
C
	IF(VERB(1:2).EQ.'PT') THEN
	  STATUS = UIGTRE(' Minimum Pt for unpacking tracks ?'
	1			,PT_MIN)
C
C  CMUO
C
	ELSE IF(VERB(1:2).EQ.'CM') THEN
	  STATUS = UIGTLO(' Unpack CMUO bank ?'
	1			,CMU_FLAG)
C
C  ELES
C
	ELSE IF(VERB(1:2).EQ.'EL') THEN
	  STATUS = UIGTLO(' Unpack ELES bank ?'
	1			,ELE_FLAG)
C
C  FMU
C
	ELSE IF(VERB(1:1).EQ.'F') THEN
	  STATUS = UIGTLO(' Unpack FMU bank ?'
	1			,FMU_FLAG)
C
C  JETS
C
	ELSE IF(VERB(1:5).EQ.'JET_U') THEN
	  STATUS = UIGTLO(' Unpack JETS bank ?'
	1			,JET_FLAG)
	ELSE IF(VERB(1:5).EQ.'JET_P') THEN
	  STATUS = UIGTTX(' Parameter bank name ?'
	1			,PARBNK)
	ELSE IF(VERB(1:5).EQ.'JET_B') THEN
	  STATUS = UIGTIN(' Number of jet parameter bank ?'
	1			,PNUM)
	ELSE IF(VERB(1:2).EQ.'JC') THEN
	  STATUS = UIGTLO(' Get Qdjsco information ?'
	1			,JCOR_FLAG)
	ELSE IF(VERB(1:2).EQ.'CO') THEN
	  STATUS = UIGTRE(' Over-write default cone size ?',
	1			USER_CONE)
C
C  METS
C
	ELSE IF(VERB(1:1).EQ.'M') THEN
	  STATUS = UIGTLO(' Unpack METS bank ?'
	1			,MET_FLAG)
C
C  TAGC
C
	ELSE IF(VERB(1:2).EQ.'TA') THEN
	  STATUS = UIGTLO(' Unpack TAGC bank ?'
	1			,TAGC_FLAG)
C
C  VERTEX
C
	ELSE IF(VERB(1:2).EQ.'VE') THEN
	  STATUS = UIGTLO(' Unpack EVTA bank ?'
	1			,VER_FLAG)
C
C  CTCS/QTRK
C
	ELSE IF(VERB(1:2).EQ.'TR') THEN
	  STATUS = UIGTLO(' Unpack CTCS/QTRK bank ?'
	1			,TRK_FLAG)
C
C ZVERTEX CUT
C
	ELSE IF(VERB(1:1).EQ.'Z') THEN
	  STATUS = UIGTRE(' ABS(Z) vertex cut ?'
	1			,ZVCUT)
C
C ATTACHING TO VERTEX CUT
C
	ELSE IF(VERB(1:2).EQ.'VA') THEN
	  STATUS = UIGTRE(' Delta Z track vertex ?'
	1			,VATTCH)

C
C PICK CTCS OR QTRK
C
	ELSE IF(VERB(1:2).EQ.'TB') THEN
77	  PRINT *,' This flag is used to determine how the tracking '
	  print *,' common block is  supposed to be unpacked.'
	  print *,' If bit 0 is set, then the SVXS information is used' 
	  print *,' wherever possible.  For those tracks that have no '
	  print *,' SVXS information, or for all tracks if bit 0 is not' 
	  print *,' set, we will use TRKS, if TRKS is present.'
	  print *,' If TRKS is not present, but there is CTCS, then we'
	  print *,' will make TRKS using CTCS.  And if there is no CTCS' 
	  print *,' either, then we will use QTRK.  It is possible to '
	  print *,' FORCE the use of QTRK by setting bit 1 = 1.  The default'
	  print *,' is that both bits are off.'
	  print *,' NB This assumes that you have TRKS banks and QTRK'
	  print *,' banks made without SVX information.  If this is not'
	  print *,' the case, then you are on your own'
	  STATUS = UIGTIN(' Pick your favorite combination',ctcs_qtrk)
C
C BANK NUMBER FOR TAGC
C
	ELSE IF(VERB(1:1).EQ.'N') THEN
	  STATUS = UIGTIN(' Enter TAGC bank number to unpack'
	1			,TAGC_NUMBER)
C
C VTXX/VTXT
C
	ELSE IF(VERB(1:2).EQ.'PR') THEN
	  STATUS = UIGTLO(' Unpack VTXS and VTXT banks ?',PRIM_FLAG)
C
C DISABLE EVERYTING
C
	ELSE IF(VERB(1:1).EQ.'D') THEN
	   CMU_FLAG  = .FALSE.
	   ELE_FLAG  = .FALSE.
	   FMU_FLAG  = .FALSE.
	   JET_FLAG  = .FALSE.
	   MET_FLAG  = .FALSE.
	   TAGC_FLAG = .FALSE. 	
	   VER_FLAG  = .FALSE.
	   TRK_FLAG  = .FALSE.
	   JCOR_FLAG = .FALSE.	
	   PRIM_FLAG = .FALSE.
C
C ENABLE EVERYTHING
C
	ELSE IF(VERB(1:2).EQ.'EN') THEN
	   CMU_FLAG  = .TRUE.
	   ELE_FLAG  = .TRUE.
	   FMU_FLAG  = .TRUE.
	   JET_FLAG  = .TRUE.
	   MET_FLAG  = .TRUE.
	   TAGC_FLAG = .TRUE. 	
	   VER_FLAG  = .TRUE.
	   TRK_FLAG  = .TRUE.	
	   JCOR_FLAG = .TRUE.	
	   PRIM_FLAG = .TRUE.
C
C TRKSEL
C
	ELSE IF (VERB(1:1).EQ.'R') THEN
	  STATUS = UIGTLO(' Require TRKSEL to unpack ?'
	1			,ONLY_TRKSEL)
C
C EXIT
C
	ELSE IF (VERB(1:2).EQ.'EX') THEN
	  RETURN
	ENDIF
C
C-- Next command
C
	GO TO 1000
	END



