C 31-aug-1990 steal from c$mbs and make into ultimate unpacking routine
C must have CTCS or QTRK
C  VERSION THAT ONLY UNPACKS TRACKS PASSING TRKSEL IF SO DESIRED

C***********************************************************************
      SUBROUTINE UNPTRK(BANK_CHOICE)
C Description
C       UNPTRK is called for each event to  store
C       track informations in upgcm2.inc
C AUTHOR
C       AESOOK BYON
C       PURDUE UNIVERSITY
C   murdered by SCE, UC
C
C  Changed name to UNPTRK
C  added iperft_novtx variable
C  changed common block names
C  also remove abs(z) cut for VTTRA
C			Claudio  8-oct-1990
C  Protect against N_TRACK > MAX_TRACK  CC 15-oct-1990
C  Make Pt_min requirement work for CTCS	CC 27-nov-1990
C  BANK_CHOICE=1 ===>   CTCS (if possible)
C  (OTHERWISE USE QTRK)
C  ADD QTRK BANK NUMBER....17-JUN-1992
C.......................................................................
      IMPLICIT NONE
      INCLUDE 'C$INC:BCS.INC'
      INCLUDE 'C$INC:CTCCOM.INC'
      INCLUDE 'C$INC:JOBSTA.INC'
      INCLUDE 'YBOS$LIBRARY:ERRCOD.INC'
      INCLUDE 'C$INC:ERLEVL.INC'
      INCLUDE 'C$INC:PIVALU.INC'
C      INCLUDE 'C$INC:CTCALB.INC'              ! contains beam position info
C      INCLUDE 'c$INC:tvrtex.inc'              ! tvdist common
      INCLUDE 'C$INC:CTCALB.INC'              ! contains beam position info
      INCLUDE 'c$INC:tvrtex.inc'              ! tvdist common
      INCLUDE 'uc$ana:qhmcm.inc'  	      ! qtrk hitmask for ctcs
      INCLUDE 'uc$ana:trakcm.inc' 	      ! unpack trks into here
      INCLUDE 'uc$ana:vtvzcm.inc'
      INCLUDE 'UC$ANA:UNFLAGS.INC'
C Access to CTCS
      INTEGER INSBNK,ICTCS,BNKNUM
C Track selection
      INTEGER IERR,IERR2
      INTEGER TVDIST           !berge's vertex matching routine
      INTEGER TRKSEL           !berge's track selection routine
      INTEGER VERSN            !beamconstrain, non beanconstrin
C counter
      INTEGER IQCNT            !#times qtrk is called
Cvertex
      LOGICAL GVER(10)         !good vertex?
Cvariables for qtrk unpack
      REAL CTAN               ! cotangent theta
      REAL CURV               ! curvature in 1/cm
      REAL Z0                 ! Z of closest approach
      REAL DT                 ! inpact parameter
      REAL PHI                ! PHI of closest approacH
      real dcur
      INTEGER QTRKFD          !routine to unpack qtrk
      INTEGER TOWE            ! TOWE index to which track points
      INTEGER Q               ! charge
      INTEGER HITLAY          ! mask of superlayer usage
      INTEGER FITQ            ! fit quality code
      LOGICAL FLAG3D          ! 3D track
      LOGICAL SECVTX          ! from secondary vertex
      LOGICAL CTC
      LOGICAL FTC
      LOGICAL VTPC
      LOGICAL VTXCON          ! vertex constrained fit
      REAL PT,PX,PY,PZ,THETA
      INTEGER INQTRK,IDQTRK,NQTRK
C misc
      INTEGER BANK_CHOICE
      INTEGER I,J,K,STATUS
      INTEGER INDBNK,INCTCS,INDNXT,BLOCAT,BNEXT
      INTEGER BNUMB
      INTEGER DUMMY1,DUMMY2,IBEST,KK,II
      REAL DBEST
      INTEGER QTRKNUM(MAX_TRACK)
C
C.......................................................................
C start code.


C SVX JUNK
	DO I=1,MAX_TRACK
	   SVXSBNK(I)          = 0
	   SVX_USED(I)         = .FALSE.
	   NSVX_HIT(I)         = 0
	   SVX_LAY_FOUND(I)    = 0
	   SVX_LAY_EXPEC(I)    = 0
	   SVX_CHI(I)          = -1.
	END DO


C Zero event track counters
      N_TRACK = 0
      CTCSTR = .TRUE.                 !use ctcs tracking by default

C first get vertex information

      DO I=1,NVPRM
        IF(VCLAS(I).GT.0) THEN
          IF(ABS(ZVTV(I)).LT.ZVCUT) THEN
            GVER(I)=.TRUE.           !a good vertex
          ELSE
            GVER(I)=.FALSE.          !not a good vertex
          ENDIF
        ENDIF
      ENDDO
      IF(NVPRM.gt.10) THEN
        CALL ERLOGR('UNPTRK',ERWARN,0,STATUS,
     &        '# vertices gt 10: may loose some good tracks')
      ENDIF

C get true beam position

      CALL CTVTVZ

C adjust true beam position, if Monte Carlo

      if(nrun.lt.100) then
        xbeam=0.
        ybeam=0.
        bmxlin=0.
        bmylin=0.
      endif


C Loop over CTCS banks
      status= BLOCAT(IW,'CTCS',-1,INSBNK,ICTCS) ! get bank index, bank data index
      IF (STATUS .NE. YESUCC) GOTO 999    !try qtrk
      IF (BANK_CHOICE .NE. 1 .OR. BANK_CHOICE .NE. 3) GOTO 999


      PCUT = PT_MIN        !set pt cut for unpacking
      CALL QTRKHM(IERR2)          !get hit masks


      DO WHILE (INSBNK.GT.0)


        CALL BDATA(IW,INSBNK,ICTCS) !from bank index, get bank data index


        VERSN=1                          !non-beam-constr
        CALL SCECTRSEL(ICTCS,VERSN,dcur,IERR,IERR2) !fill common with info for
C                                              this track  with non beam-constr
C
        N_TRACK = N_TRACK+1
        IF(N_TRACK.GT.MAX_TRACK) THEN
          CALL ERLOGR('UNPTRK',ERWARN,0,STATUS,
     &    'too many tracks!!!')
	  N_TRACK = MAX_TRACK
          RETURN
        ENDIF
C
        CALL BNUMB(IW,INSBNK,BNKNUM) !from bank index, get bank #
        CTCSBNK(N_TRACK) = BNKNUM
c
        nbc(n_track)=ierr
        if(ierr.ne.0) then  !if there is no non-constrained bank, go 
          pxtr(n_track)=0.
          pytr(n_track)=0.
          pztr(n_track)=0.
          pttr(n_track)=0.
          ptr(n_track)=0.
          igda(n_track)=999
          igood(n_track)=999
          goto 996
        endif
C


C trksel selection
C Skip this track if below pt_min
        IGDA(N_TRACK)=IERR2              !ctcsel selection code
        IGOOD(N_TRACK)=TRKSEL('CTC',ICTCS)  !berges selection code
        PTTR(N_TRACK) = PTC             !pt of track
	IF (PTTR(N_TRACK) .LT.  PT_MIN) THEN
	   N_TRACK = N_TRACK - 1
	   GOTO 666
	END IF
        PXTR(N_TRACK) = PXC             !px of track
        PYTR(N_TRACK) = PYC             !py of track
        PZTR(N_TRACK) = PZC             !pz of track
        PTR(N_TRACK)=SQRT(PTTR(N_TRACK)**2+PZTR(N_TRACK)**2)
        PHITR(N_TRACK) = PHIC*degrad
        CTANTR(N_TRACK) = CTHC
        CURVTR(N_TRACK)=FLOAT(SIGNC)*1.49898E-4*BMAGNT/PTC
        THETTR(N_TRACK) = THETC
        ETATR(N_TRACK) = ETAC
        Z0TR(N_TRACK) = ZC
        IMPTR(N_TRACK) = DC
        CHI2TR(N_TRACK) = CHISQ
        CHTR(N_TRACK) = SIGNC
        NDOFTR(N_TRACK) = NDOF
        NAXHTR(N_TRACK) = NHAXC
        NSTHTR(N_TRACK) = NHSTC
        RLOWTR(N_TRACK) = RLOWC
        RUPTR(N_TRACK) = RUPC
        TOWETR(N_TRACK) = TOWINC
        REXTTR(N_TRACK) = REXITC
        CHIAXTR(N_TRACK)=CHIAXC
        CHISTTR(N_TRACK)=CHISTC
        FITTR(1,N_TRACK)=FITC(1)
        FITTR(2,N_TRACK)=FITC(2)
        FITTR(3,N_TRACK)=FITC(3)
        MPTR(1,N_TRACK)=MAPC(1)
        MPTR(2,N_TRACK)=MAPC(2)
        MPTR(3,N_TRACK)=MAPC(3)
        dcurv(n_track)=dcur
        DPTTR(N_TRACK)=DPTC
        DPHITR(N_TRACK)=DPHIC*degrad
        DCTHTR(N_TRACK)=DCTHC
Cbeam adjusted impact
        IMPTRR(N_TRACK) = IMPTR(N_TRACK) - (YBEAM + BMYLIN*
     &     Z0TR(N_TRACK))*COS(PHITR(N_TRACK)) +
     &     (XBEAM + BMXLIN*Z0TR(N_TRACK))*SIN(PHITR(N_TRACK))
Caesook's vertex
        IBEST=0
        DBEST=99999.
        DO J=1,NVPRM
c*******          IF(GVER(J)) THEN         !see if track attaches to good vertex
            IF(ABS(Z0TR(N_TRACK)-ZVTV(J)).LT.DBEST) THEN
              IBEST=J
              DBEST=ABS(Z0TR(N_TRACK)-ZVTV(J))
            ENDIF
c*******          ENDIF
        ENDDO
        IF(DBEST.LT.VATTCH) THEN
          VTTRA(N_TRACK)=IBEST
        ELSE
          VTTRA(N_TRACK)=0
        ENDIF
Ctvdist (berges vertex association)
        IGOODV(N_TRACK)=TVDIST(BNKNUM,VTXTR(N_TRACK))
        UTSTTR(N_TRACK)=UTEST(VTXTR(N_TRACK))
        ZTSTTR(N_TRACK)=ZDIST(VTXTR(N_TRACK))
Cqtrk hitmask
        DO J=1,NQTRACK
          IF(CBNKN(J).EQ.BNKNUM) THEN
            HITMASK(n_track)=HITM(J)
            GOTO 444
          ENDIF
        ENDDO
        CALL ERLOGR('UNPTRK',ERWARN,0,STATUS,
     &    'cant get hit mask from qhmcm')
  444   CONTINUE

C now get beam-constrained parameters, if possible

996     VERSN=2                          !non-beam-constr
        CALL SCECTRSEL(ICTCS,VERSN,dcur,IERR,IERR2) !fill common with info for
C                                         this track  with non beam-constr
        BC(N_TRACK)=IERR
        IF(IERR.EQ.0) THEN
          PTBC(N_TRACK) = PTC             !pt of track
          PXBC(N_TRACK) = PXC             !px of track
          PYBC(N_TRACK) = PYC             !py of track
          PZBC(N_TRACK) = PZC             !pz of track
          PBC(N_TRACK)=SQRT(PTBC(N_TRACK)**2+PZBC(N_TRACK)**2)
          IMPTRbc(N_TRACK) = DC
          z0bc(n_track)=zc
Cbeam adjusted impact
          IMPTRRbc(N_TRACK) = DC - (YBEAM + BMYLIN*
     &       ZC)*COS(PHIc*degrad) +
     &       (XBEAM + BMXLIN*ZC)*SIN(PHIC*degrad)
        ENDIF

C... select my favorite guys

        if(nbc(n_track).eq.0.and.igood(n_track).eq.0.and.
     &    abs(imptrr(n_track)).lt.0.15.and.vttra(n_track).NE.0) then
          iperft_novtx(n_track)=.true.
	  if (gver(vttra(n_track))) then
		iperft(n_track) = .true.
	  else
		iperft(n_track) = .false.
	  end if
        else
          iperft_novtx(n_track)=.false.
          iperft(n_track)=.false.
        endif

C -IF REQUIRED DELETE THIS TRACK FROM COMMON BLOCK IF IT HAS BAD TRKSEL

	IF (IGOOD(N_TRACK) .NE. 0 .AND. ONLY_TRKSEL) THEN
	   N_TRACK = N_TRACK - 1
	END IF


Cnext event
666     CALL BNEXT(IW,INSBNK,INSBNK)  !from bank index, get next bank index
      END DO                              !next ctcs bank

C-----------------------
C GET QTRK-BANK NUMBERS
C-----------------------
        STATUS = BLOCAT(IW,'QTRK',-1,KK,II)
        IF (STATUS .NE. YESUCC) THEN            
                    CALL CTCPAK
                    CALL QTRLCR
        END IF
        CALL GET_QTRK_NUMBER(QTRKNUM,IERR)
	DO II=1,N_TRACK
	   QTRKBNK(II) = QTRKNUM(II)
	END DO
        GOTO 1000                           !dont do qtrk stuff

C=======================================================================
C UNPACK QTRK...APPLY CUTS ON IMPACT PARAMETER AND Z-MATCH (AS IN CTRSEL)
C=======================================================================


  999 CONTINUE
      CTCSTR=.FALSE.            !couldn't use ctcs
      IQCNT=IQCNT+1
      IF(IQCNT.LE.10) THEN
        CALL ERLOGR('UNPTRK',ERWARN,0,STATUS,
     &    'using qtrk: message only comes 10x')
      ENDIF

      STATUS = QTRKFD(IW,-1,INQTRK,IDQTRK,NQTRK)
      IF (STATUS .NE. YESUCC) GOTO 1000



      DO J=1,NQTRK
        CALL QTRKUN(DUMMY1,DUMMY2,J,Q,PX,PY,PZ,Z0,DT,HITLAY,INCTCS,
     &          FLAG3D,SECVTX,FTC,VTPC,CTC,VTXCON,FITQ,IERR)
        IF (.NOT.CTC) GOTO 777
	if (.NOT.FLAG3D) GOTO 777
        PT = SQRT(PX**2+PY**2)
        IF (IERR.EQ.0.AND.CTC.AND.
     &       PT.GT.PT_MIN) THEN


          N_TRACK = N_TRACK + 1
          IF(N_TRACK.GT.MAX_TRACK) THEN
            CALL ERLOGR('UNPTRK',ERWARN,0,STATUS,
     &    'too many tracks!!!')
	    N_TRACK = MAX_TRACK
            RETURN
          ENDIF


          IGOOD(N_TRACK)=0      ! TRKSEL selection pass?
          IF(FTC.EQ.0.OR.FTC.EQ.2) THEN  !fails TRKSEL
            IGOOD(N_TRACK)=999
          ENDIF
	  QTRKBNK(N_TRACK) = J
          CTCSBNK(N_TRACK) = INCTCS
          HITMASK(N_TRACK) = HITLAY
          PXTR(N_TRACK)   = PX
          PYTR(N_TRACK)   = PY
          PZTR(N_TRACK)   = PZ
          PTTR(N_TRACK)   = SQRT(PX**2+PY**2)
          PTR(N_TRACK)    = SQRT(PX**2+PY**2+PZ**2)
          CHTR(N_TRACK)   = Q
          IMPTR(N_TRACK)  = DT
          NDOFTR(N_TRACK) = -1
          CHI2TR(N_TRACK) = -1
          CURVTR(N_TRACK) = 1.49898E-4 * BMAGNT * Q / PTTR(N_TRACK)
          PHITR(N_TRACK)  = ATAN2(PY,PX)
          IF (PHITR(N_TRACK) .LT. 0.0) THEN
            PHITR(N_TRACK) = PHITR(N_TRACK) + TWOPI
          END IF
          THETA = ACOS(PZ/PTR(N_TRACK))
          THETTR(N_TRACK)=THETA
          ETATR(N_TRACK)=-1.*LOG(TAN(THETA/2.))
          CTANTR(N_TRACK) = 1./MAX(0.000001,ABS(TAN(THETA)))
          IF (THETA .GT. PI/2.) CTANTR(N_TRACK) = - CTANTR(N_TRACK)
          Z0TR(N_TRACK) = Z0
          CURV = CURVTR(N_TRACK)
          PHI  = PHITR(N_TRACK)
          CTAN = CTANTR(N_TRACK)
          CALL GET_TOWE_INDEX(CURV,DT,PHI,CTAN,Z0,TOWE,IERR)
          TOWETR(N_TRACK) = TOWE
          IF (BTEST(FTC,1)) THEN
            ALGORTR(N_TRACK) = 2         !an "Aseet" track
          ELSE
            ALGORTR(N_TRACK) = 1         !a "Berge" track
          ENDIF
Cbeam adjusted impact parameter
          IMPTRR(N_TRACK) = IMPTR(N_TRACK) - (YBEAM + BMYLIN*
     &     Z0TR(N_TRACK))*COS(PHITR(N_TRACK)) +
     &     (XBEAM + BMXLIN*Z0TR(N_TRACK))*SIN(PHITR(N_TRACK))
Caesook's vertex
          IBEST=0
          DBEST=99999.
          DO K=1,NVPRM
c***            IF(GVER(K)) THEN         !see if track attaches to good vertex
              IF(ABS(Z0TR(N_TRACK)-ZVTV(K)).LT.DBEST) THEN
                IBEST=K
                DBEST=ABS(Z0TR(N_TRACK)-ZVTV(K))
              ENDIF
c***            ENDIF
          ENDDO
          IF(DBEST.LT.VATTCH) THEN
            VTTRA(N_TRACK)=IBEST
          ELSE
            VTTRA(N_TRACK)=0
          ENDIF
        END IF
        if(igood(n_track).eq.0.and.
     &    abs(imptrr(n_track)).lt.0.15.and.vttra(n_track).NE.0) then
          iperft_NOVTX(n_track)=.true.
	  if (gver(vttra(n_track))) then
	     iperft(n_track) = .true.
	  else
	     iperft(n_track) = .false.
	  end if
	else
          iperft(n_track)=.false.
          iperft(n_track)=.false.
        endif


C -IF REQUIRED DELETE THIS TRACK FROM COMMON BLOCK IF IT HAS BAD TRKSEL

	IF (IGOOD(N_TRACK) .NE. 0 .AND. ONLY_TRKSEL) THEN
	   N_TRACK = N_TRACK - 1
	END IF




  777 CONTINUE
  111 END DO
C=================================================
C DONE
C=================================================
 1000 CONTINUE
      RETURN

      END


C alter ctrsel so that have option about whether to get beam-constrained,
C non-beamconstrained  (other routines called by this routine are in
C c$mbs:ctrsel


C DEC/CMS REPLACEMENT HISTORY, Element CTRSEL.CDF
C *12   12-NOV-1989 16:55:19 MUKHERJEE "Fix CTCUFR"
C *11   27-MAY-1989 15:24:33 MUKHERJEE "Handle plug tracks (and clean up)"
C *10   23-MAY-1989 19:21:27 MUKHERJEE "Quick patch around plug tracks"
C *9     5-MAR-1989 17:40:32 BERGE "Fix CTC fit history usage"
C *8    12-JUL-1988 23:41:28 PARA "change d cut, make it pt dependent"
C *7    24-SEP-1987 01:46:24 KEPHART "CHANGE ORDER OF DATA STATEMENT AND EXTERNAL FUNCTION"
C *6    24-SEP-1987 01:21:20 KEPHART "GETTING VERTZ FOR GENERAL USE OF ROUTINE"
C *5    12-SEP-1987 11:56:24 KEPHART "correct data statements"
C *4     5-SEP-1987 04:45:33 KEPHART "fix block data form"
C *3    30-AUG-1987 04:00:23 KEPHART "Add Pt and vertex position cut"
C *2    18-AUG-1987 09:42:07 PARA "Protect fraction cut for 2d tracks"
C *1     3-AUG-1987 16:30:02 PARA "Single track acceptance routine"
C DEC/CMS REPLACEMENT HISTORY, Element CTRSEL.CDF
C***********************************************************************
      SUBROUTINE SCECTRSEL(ICTCS,VERSN,dcur,IERR,IERR2)
C Description:
C       CTRSEL is called for each track to determine track quality
C Input
C       ICTCS:  bank index for a CTCS bank
C Output
C       IERR2:   error return, zero if track passes cuts
C       IERR:  no problems unpacking banks = 0
C       Variables in CTCCOM.INC filled
C Author
C       Aesook Byon, Purdue University
C       Aseet Mukherjee, FNAL
C.......................................................................
      IMPLICIT NONE
      INCLUDE 'C$INC:ERLEVL.INC'
      INCLUDE 'C$INC:BCS.INC'
      INCLUDE 'C$INC:DSEVTA.INC'
      INCLUDE 'C$INC:CTCGEO.INC'
      INCLUDE 'C$INC:TRFITC.INC'
C      INCLUDE 'C$TRK:CTCGEO.INC'
C      INCLUDE 'C$TRK:TRFITC.INC'
      INCLUDE 'C$INC:CTCCOM.INC'
C Arguments
      INTEGER IERR,ICTCS,IERR2
      real dcur
C External functions
      INTEGER NAMIND
C EVTA access
      INTEGER WEVTA,HEVTA,IEVTA,OFFZ0
C CTCS access
      INTEGER VERSN,FITCOD
C Selection
      INTEGER IMDFY
      LOGICAL FAILED,THREED

      DATA WEVTA/-1/, OFFZ0/-1/
C.......................................................................
      IERR = 0
C Set up EVTA access
      IF (WEVTA.GT.0) THEN
        IF (ICTCS) 50,90,90
      END IF
      WEVTA = NAMIND(IW,'EVTA')
      IF (WEVTA.LE.0) THEN
        CALL ERLOGR('CTRSEL',ERSEVR,0,0,'NAMIND failed')
        RETURN
      END IF
C Set cut values
   50 FNOCUT = .FALSE.
      VCUT = 9999.
      PCUT = 0.0
      DCUT = 0.5
      ZCUT = 5.0
      FCUT = 0.5
      ECUT = 5.0
      DPCUT = 0.2
      DPHCUT = 2.0
      NREQAX = 8
      NREQST = 4
      MINAXS = 2
      MINSTS = 1
C Set order of cuts
      NMDFY = 7
      MODSEL(1) = 1
      MODSEL(2) = 8
      DO IMDFY = 3,NMDFY
        MODSEL(IMDFY) = IMDFY - 1
      END DO
   90 IF (ICTCS.LE.0) RETURN

C Vertex from EVTA
      HEVTA = IW(WEVTA)
      IF (WEVTA.LE.0) THEN
        VERTZ = 0.0
      ELSE
        IF (OFFZ0.LE.0) THEN
          CALL BDATA(IW,HEVTA,IEVTA)
          IEVTA = IEVTA + Z0EV
          OFFZ0 = IEVTA - HEVTA
        ELSE
          IEVTA = HEVTA + OFFZ0
        END IF
        VERTZ = RW(IEVTA)
      END IF
C Get track info
       fitcod=-1
       if(versn.eq.2) fitcod=-2
      VERSN = -1
      CALL CTSDATN(ICTCS,VERSN,FITCOD,dcur,IERR)
      IF (IERR.NE.0) RETURN
C Loop over cuts
      THREED = IAND(FITC(1),TPMFC).GE.TP02FC
      DO 190 IMDFY = 1,NMDFY
        IERR2 = MODSEL(IMDFY)
        GO TO (110,120,130,140,150,160,190,180) IERR2
        GO TO 190
C       Three dimensional
  110   IF(.NOT.THREED) RETURN
        GO TO 190
C       Cut on impact parameter
  120   IF (ABS(DC)-DCUT) 190,190,900
C       Cut on Ztrack - Zvertex
  130   IF (.NOT.THREED) GO TO 190
        IF (ABS(ZC-VERTZ)-ZCUT) 190,190,900
C       Cut on eta
  140   IF (.NOT.THREED) GO TO 190
        IF (ABS(ETAC)-ECUT) 190,190,900
C       Cut on fraction of hits
  150   CALL CTCUFR(FITCOD,FAILED)
        IF (FAILED) GO TO 900
        GO TO 190
C       Cut on number of segments
  160   CALL CTCSEG(FITCOD,FAILED)
        IF (FAILED) GO TO 900
        GO TO 190
C       Cut on Pt
  180   IF (PTC-PCUT) 900,190,190
  190 CONTINUE
      IERR2 = 0

  900 RETURN
      END
C***********************************************************
	SUBROUTINE CTSDATN(ICTCS,VERSN,FITCOD,dcur,IERR)
C Description
C	Unpack a CTCS bank into a common block
C Input
C	ICTCS		Pointer to the track in CTCS bank
C	VERSN		Version number of segment (default version if < 0)
C	FITCOD		Fit code desired (highest fit code if < 0)
C                       if =-2, get beam constrained fit
C Output
C	VERSN,FITCOD	If <0 on input, set to version and code for the
C			parameter set unpacked
C	IERR            Error flag, 0 if succesful operation
C	Variables in CTCCOM.INC filled
C Author
C	Aesook Byon, Purdue University
C	Aseet Mukherjee, FNAL
C.......................................................................
      Implicit none
      INCLUDE 'C$INC:DSCMPB.INC'
      INCLUDE 'C$INC:DSFITP.INC'
      INCLUDE 'C$INC:DSCTCS.INC'
C      INCLUDE 'C$TRK:TRFITC.INC'
      INCLUDE 'C$INC:TRFITC.INC'
      INCLUDE 'C$INC:ERLEVL.INC'
      INCLUDE 'C$INC:BCS.INC'
      INCLUDE 'C$INC:JOBSTA.INC'
      INCLUDE 'C$INC:PIVALU.INC'
      INCLUDE 'C$INC:CTCCOM.INC'
C Arguments
	INTEGER ICTCS,VERSN,FITCOD,IERR,vcode,bcfit
      real dcur
C Error message
	CHARACTER*8 MESSAG
C CTCS indices
	INTEGER BASINS,VERINS,BLKINS,HICINS
C Version and parameter set search
	INTEGER COUNT,CODE,LCODE
	REAL CONVPT
C.......................................................................
	IERR = 1
C Check that the bank structure version number is one we know about
	BASINS = ICTCS+DSHDCB
	IF(IW(BASINS+DSVNCB).NE.VNUCTS) THEN
	    WRITE(MESSAG,'(I5)') IW(BASINS+DSVNCB)
	    CALL ERLOGR('CTSDATN',EREROR,0,0,
     &	      'Unknown bank structure version number: '//MESSAG)
	    RETURN
	END IF
C Find the version we want (=default if VERSN<0)
	IF(VERSN.LT.0) VERSN = IW(BASINS+DVNCTS)
	VERINS = BASINS+IW(BASINS)
	DO COUNT = 1,IW(BASINS+NVNSCB)
	    IF(IW(VERINS+VNUMCB).EQ.VERSN) GO TO 10
	END DO
	RETURN
C Find the fit code we want (=highest if FITCOD<0)
10	LCODE = 0
         bcfit=0
         if(fitcod.eq.-2)  bcfit=2
	BLKINS = VERINS+IW(BASINS+NWVHCB)
	DO COUNT = 1,IW(VERINS+NBLKCB)
	    vCODE = ISHFT(IAND(IW(BLKINS+FITCCT+0),vfitfc),-vfSHFC)
   	     CODE = ISHFT(IAND(IW(BLKINS+FITCCT+1),CTFLFC),-CTSHFC)
	     IF (CODE.EQ.FITCOD.and.vcode.eq.bcfit) GO TO 20
	     IF (CODE.GT.LCODE.and.vcode.eq.bcfit) THEN
		HICINS = BLKINS
		LCODE = CODE
	     END IF
	     BLKINS = BLKINS + IW(BASINS+NWBLCB)
	END DO
	IF (LCODE.LE.0 .OR. FITCOD.GE.0) RETURN
	FITCOD = LCODE
	BLKINS = HICINS

C Load track parameters
20	TOWINC = IW(VERINS+TOWECT)

	CHISQ = RW(BLKINS+FITQCT)
	CHIAXC = RW(BLKINS+FITQCT+1)
	CHISTC = RW(BLKINS+FITQCT+2)
	NDOF = IW(BLKINS+NDOFCT)
	NHAXC = IW(BLKINS+NDOFCT+1)
	NHSTC = IW(BLKINS+NDOFCT+2)

	CUC = RW(BLKINS+CUCT)
        DCur = SQRT( MAX(0.,RW(BLKINS+DCU2CT)) )	! error in curvature
	PHIC = RW(BLKINS+P0CT)
	DC = RW(BLKINS+D0CT)
	CTHC = RW(BLKINS+CTCT)
	ZC = RW(BLKINS+Z0CT)

	CONVPT=1.49898E-4*BMAGNT
	PTC=CONVPT/ABS(CUC)
	PXC=PTC*COS(PHIC)
	PYC=PTC*SIN(PHIC)
	PZC=PTC*CTHC
	ETAC=ALOG(SQRT( MAX(0.,1.+CTHC**2) )+CTHC)
	RLOWC=RW(VERINS+D2CT)
	RUPC=RW(VERINS+D3CT)

	SIGNC=SIGN(1.,CUC)
	DPTC=PTC*SQRT( MAX(0.,RW(BLKINS+DCU2CT)) )/ABS(CUC)
	DPHIC=SQRT( MAX(0.,RW(BLKINS+DP02CT)) )*RADDEG
	DCTHC=SQRT( MAX(0.,RW(BLKINS+DCT2CT)) )
 

	PHIC = PHIC*RADDEG

	FITC(1) = IW(BLKINS+FITCCT)
	FITC(2) = IW(BLKINS+FITCCT+1)
	FITC(3) = IW(BLKINS+FITCCT+2)

	MAPC(1) = IW(VERINS+BITMCT)
	MAPC(2) = IW(VERINS+BITMCT+1)
	MAPC(3) = IW(VERINS+BITMCT+2)
	IERR=0
	
        end
