C DEC/CMS REPLACEMENT HISTORY, Element FEMQQ.CDF
C *1    18-DEC-1989 11:52:33 BLOCKER "FEM energy correction routine."
C DEC/CMS REPLACEMENT HISTORY, Element FEMQQ.CDF
	REAL FUNCTION FEMQQ(IQUAD)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c
c  Description:-
c  =============
c  This routine returns a multiplicative factor that corrects
c  the energy of an FEM cluster for quad-quad variation.
c  The correction factor was derived from Texas tower rates,
c  as documented in CDF-968 (J.Ng)
c
c  Call Parameters:-
c  =================
c	IQUAD   --- quadrant (0:7)
c
c  Return Parameters:-
c  ===================
c       EFACT   --- Multiplicative factor to be applied to the energy
c
c  Author:-
c  ========
c       Ed Kearns
c       Nov 16, 1989
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
$$IF VAX
        IMPLICIT NONE
$$ENDIF
      INTEGER IQUAD
      REAL QFACT(0:7)
      DATA QFACT/.007,-.045,.061,.016,-.004,-.009,-.051,.040/
C=======================================================================
C
C     I bet you can figure this out if you try!:
C     ==========================================
      IF ((IQUAD .GE. 0).AND.(IQUAD .LE. 7)) THEN
         FEMQQ = 1.0 + QFACT(IQUAD)
      ELSE
         FEMQQ = 1.0
      END IF
      RETURN
      END
